/* exportable.c generated by valac 0.56.11, the Vala compiler
 * generated from exportable.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2004,2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2012 Stefan Walter
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

typedef struct _Block2Data Block2Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _Block5Data Block5Data;

struct _Block2Data {
	int _ref_count_;
	GMainLoop* loop;
	GAsyncResult* _result_;
};

struct _Block3Data {
	int _ref_count_;
	GMainLoop* loop;
	GAsyncResult* _result_;
};

struct _Block4Data {
	int _ref_count_;
	GMainLoop* loop;
	GAsyncResult* _result_;
};

struct _Block5Data {
	int _ref_count_;
	GtkFileChooserNative* chooser;
	GHashTable* filters;
};

static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void ____lambda4_ (Block2Data* _data2_,
                   GObject* obj,
                   GAsyncResult* res);
static void _____lambda4__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void ___lambda5_ (Block3Data* _data3_,
                  GObject* obj,
                  GAsyncResult* res);
static void ____lambda5__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void ____lambda7_ (Block4Data* _data4_,
                   GObject* obj,
                   GAsyncResult* res);
static void _____lambda7__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static gchar* seahorse_exportable_calculate_basename (GFile* file,
                                               const gchar* extension);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda6_ (Block5Data* _data5_,
                 GObject* obj,
                 GParamSpec* prop);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static GType seahorse_exportable_get_type_once (void);

GList*
seahorse_exportable_create_exporters (SeahorseExportable* self,
                                      SeahorseExporterType type)
{
	SeahorseExportableIface* _iface_;
#line 26 "../common/exportable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../common/exportable.vala"
	_iface_ = SEAHORSE_EXPORTABLE_GET_INTERFACE (self);
#line 26 "../common/exportable.vala"
	if (_iface_->create_exporters) {
#line 26 "../common/exportable.vala"
		return _iface_->create_exporters (self, type);
#line 118 "exportable.c"
	}
#line 26 "../common/exportable.vala"
	return NULL;
#line 122 "exportable.c"
}

gboolean
seahorse_exportable_can_export (GObject* object)
{
	gboolean result;
#line 28 "../common/exportable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 29 "../common/exportable.vala"
	if (SEAHORSE_IS_EXPORTABLE (object)) {
#line 133 "exportable.c"
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 30 "../common/exportable.vala"
		_tmp0_ = seahorse_exportable_get_exportable (G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_EXPORTABLE, SeahorseExportable));
#line 30 "../common/exportable.vala"
		_tmp1_ = _tmp0_;
#line 30 "../common/exportable.vala"
		result = _tmp1_;
#line 30 "../common/exportable.vala"
		return result;
#line 144 "exportable.c"
	}
#line 31 "../common/exportable.vala"
	result = FALSE;
#line 31 "../common/exportable.vala"
	return result;
#line 150 "exportable.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 34 "../common/exportable.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 34 "../common/exportable.vala"
	return _data2_;
#line 160 "exportable.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 34 "../common/exportable.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 34 "../common/exportable.vala"
		_g_object_unref0 (_data2_->_result_);
#line 34 "../common/exportable.vala"
		_g_main_loop_unref0 (_data2_->loop);
#line 34 "../common/exportable.vala"
		g_slice_free (Block2Data, _data2_);
#line 176 "exportable.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 40 "../common/exportable.vala"
	return self ? g_object_ref (self) : NULL;
#line 185 "exportable.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 46 "../common/exportable.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 193 "exportable.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 46 "../common/exportable.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 201 "exportable.c"
}

static void
____lambda4_ (Block2Data* _data2_,
              GObject* obj,
              GAsyncResult* res)
{
	GAsyncResult* _tmp0_;
	GMainLoop* _tmp1_;
#line 52 "../common/exportable.vala"
	g_return_if_fail (res != NULL);
#line 53 "../common/exportable.vala"
	_tmp0_ = _g_object_ref0 (res);
#line 53 "../common/exportable.vala"
	_g_object_unref0 (_data2_->_result_);
#line 53 "../common/exportable.vala"
	_data2_->_result_ = _tmp0_;
#line 54 "../common/exportable.vala"
	_tmp1_ = _data2_->loop;
#line 54 "../common/exportable.vala"
	g_main_loop_quit (_tmp1_);
#line 223 "exportable.c"
}

static void
_____lambda4__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 52 "../common/exportable.vala"
	____lambda4_ (self, source_object, res);
#line 52 "../common/exportable.vala"
	block2_data_unref (self);
#line 235 "exportable.c"
}

gint
seahorse_exportable_export_to_directory_wait (GList* objects,
                                              const gchar* directory,
                                              GError** error)
{
	Block2Data* _data2_;
	GMainLoop* _tmp0_;
	gint count = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 34 "../common/exportable.vala"
	g_return_val_if_fail (directory != NULL, 0);
#line 34 "../common/exportable.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 34 "../common/exportable.vala"
	_data2_->_ref_count_ = 1;
#line 36 "../common/exportable.vala"
	_tmp0_ = g_main_loop_new (NULL, FALSE);
#line 36 "../common/exportable.vala"
	_data2_->loop = _tmp0_;
#line 37 "../common/exportable.vala"
	_data2_->_result_ = NULL;
#line 38 "../common/exportable.vala"
	count = 0;
#line 262 "exportable.c"
	{
		GList* object_collection = NULL;
		GList* object_it = NULL;
#line 40 "../common/exportable.vala"
		object_collection = objects;
#line 40 "../common/exportable.vala"
		for (object_it = object_collection; object_it != NULL; object_it = object_it->next) {
#line 270 "exportable.c"
			GObject* _tmp1_;
			GObject* object = NULL;
#line 40 "../common/exportable.vala"
			_tmp1_ = _g_object_ref0 ((GObject*) object_it->data);
#line 40 "../common/exportable.vala"
			object = _tmp1_;
#line 277 "exportable.c"
			{
				GObject* _tmp2_;
				GList* exporters = NULL;
				GObject* _tmp3_;
				GList* _tmp4_;
				GList* _tmp5_;
				SeahorseExporter* exporter = NULL;
				GList* _tmp6_;
				gconstpointer _tmp7_;
				SeahorseExporter* _tmp8_;
				gchar* filename = NULL;
				SeahorseExporter* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				GFile* file = NULL;
				const gchar* _tmp15_;
				GFile* _tmp16_;
				SeahorseExporter* _tmp17_;
				GFile* _tmp18_;
				GMainLoop* _tmp19_;
				SeahorseExporter* _tmp20_;
				GAsyncResult* _tmp21_;
				gint _tmp23_;
#line 41 "../common/exportable.vala"
				_tmp2_ = object;
#line 41 "../common/exportable.vala"
				if (!seahorse_exportable_can_export (_tmp2_)) {
#line 42 "../common/exportable.vala"
					_g_object_unref0 (object);
#line 42 "../common/exportable.vala"
					continue;
#line 312 "exportable.c"
				}
#line 44 "../common/exportable.vala"
				_tmp3_ = object;
#line 44 "../common/exportable.vala"
				_tmp4_ = seahorse_exportable_create_exporters (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, SEAHORSE_TYPE_EXPORTABLE, SeahorseExportable), SEAHORSE_EXPORTER_TYPE_ANY);
#line 44 "../common/exportable.vala"
				exporters = _tmp4_;
#line 45 "../common/exportable.vala"
				_tmp5_ = exporters;
#line 45 "../common/exportable.vala"
				if (_tmp5_ == NULL) {
#line 46 "../common/exportable.vala"
					(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 46 "../common/exportable.vala"
					_g_object_unref0 (object);
#line 46 "../common/exportable.vala"
					continue;
#line 330 "exportable.c"
				}
#line 48 "../common/exportable.vala"
				_tmp6_ = exporters;
#line 48 "../common/exportable.vala"
				_tmp7_ = _tmp6_->data;
#line 48 "../common/exportable.vala"
				_tmp8_ = _g_object_ref0 ((SeahorseExporter*) _tmp7_);
#line 48 "../common/exportable.vala"
				exporter = _tmp8_;
#line 49 "../common/exportable.vala"
				_tmp9_ = exporter;
#line 49 "../common/exportable.vala"
				_tmp10_ = seahorse_exporter_get_filename (_tmp9_);
#line 49 "../common/exportable.vala"
				_tmp11_ = _tmp10_;
#line 49 "../common/exportable.vala"
				_tmp12_ = _tmp11_;
#line 49 "../common/exportable.vala"
				_tmp13_ = g_build_filename (directory, _tmp12_, NULL, NULL);
#line 49 "../common/exportable.vala"
				_tmp14_ = _tmp13_;
#line 49 "../common/exportable.vala"
				_g_free0 (_tmp12_);
#line 49 "../common/exportable.vala"
				filename = _tmp14_;
#line 50 "../common/exportable.vala"
				_tmp15_ = filename;
#line 50 "../common/exportable.vala"
				_tmp16_ = g_file_new_for_uri (_tmp15_);
#line 50 "../common/exportable.vala"
				file = _tmp16_;
#line 52 "../common/exportable.vala"
				_tmp17_ = exporter;
#line 52 "../common/exportable.vala"
				_tmp18_ = file;
#line 52 "../common/exportable.vala"
				seahorse_exporter_export_to_file (_tmp17_, _tmp18_, FALSE, NULL, _____lambda4__gasync_ready_callback, block2_data_ref (_data2_));
#line 57 "../common/exportable.vala"
				_tmp19_ = _data2_->loop;
#line 57 "../common/exportable.vala"
				g_main_loop_run (_tmp19_);
#line 59 "../common/exportable.vala"
				_tmp20_ = exporter;
#line 59 "../common/exportable.vala"
				_tmp21_ = _data2_->_result_;
#line 59 "../common/exportable.vala"
				seahorse_exporter_export_to_file_finish (_tmp20_, _tmp21_, &_inner_error0_);
#line 59 "../common/exportable.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 380 "exportable.c"
					gint _tmp22_ = -1;
#line 59 "../common/exportable.vala"
					g_propagate_error (error, _inner_error0_);
#line 59 "../common/exportable.vala"
					_g_object_unref0 (file);
#line 59 "../common/exportable.vala"
					_g_free0 (filename);
#line 59 "../common/exportable.vala"
					_g_object_unref0 (exporter);
#line 59 "../common/exportable.vala"
					(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 59 "../common/exportable.vala"
					_g_object_unref0 (object);
#line 59 "../common/exportable.vala"
					block2_data_unref (_data2_);
#line 59 "../common/exportable.vala"
					_data2_ = NULL;
#line 59 "../common/exportable.vala"
					return _tmp22_;
#line 400 "exportable.c"
				}
#line 61 "../common/exportable.vala"
				_tmp23_ = count;
#line 61 "../common/exportable.vala"
				count = _tmp23_ + 1;
#line 40 "../common/exportable.vala"
				_g_object_unref0 (file);
#line 40 "../common/exportable.vala"
				_g_free0 (filename);
#line 40 "../common/exportable.vala"
				_g_object_unref0 (exporter);
#line 40 "../common/exportable.vala"
				(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 40 "../common/exportable.vala"
				_g_object_unref0 (object);
#line 416 "exportable.c"
			}
		}
	}
#line 64 "../common/exportable.vala"
	result = count;
#line 64 "../common/exportable.vala"
	block2_data_unref (_data2_);
#line 64 "../common/exportable.vala"
	_data2_ = NULL;
#line 64 "../common/exportable.vala"
	return result;
#line 428 "exportable.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 97 "../common/exportable.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 97 "../common/exportable.vala"
	return _data3_;
#line 438 "exportable.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 97 "../common/exportable.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 97 "../common/exportable.vala"
		_g_object_unref0 (_data3_->_result_);
#line 97 "../common/exportable.vala"
		_g_main_loop_unref0 (_data3_->loop);
#line 97 "../common/exportable.vala"
		g_slice_free (Block3Data, _data3_);
#line 454 "exportable.c"
	}
}

static void
___lambda5_ (Block3Data* _data3_,
             GObject* obj,
             GAsyncResult* res)
{
	GAsyncResult* _tmp0_;
	GMainLoop* _tmp1_;
#line 101 "../common/exportable.vala"
	g_return_if_fail (res != NULL);
#line 102 "../common/exportable.vala"
	_tmp0_ = _g_object_ref0 (res);
#line 102 "../common/exportable.vala"
	_g_object_unref0 (_data3_->_result_);
#line 102 "../common/exportable.vala"
	_data3_->_result_ = _tmp0_;
#line 103 "../common/exportable.vala"
	_tmp1_ = _data3_->loop;
#line 103 "../common/exportable.vala"
	g_main_loop_quit (_tmp1_);
#line 477 "exportable.c"
}

static void
____lambda5__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 101 "../common/exportable.vala"
	___lambda5_ (self, source_object, res);
#line 101 "../common/exportable.vala"
	block3_data_unref (self);
#line 489 "exportable.c"
}

guint
seahorse_exportable_export_to_text_wait (GList* objects,
                                         guint8** output,
                                         size_t* output_length1,
                                         GError** error)
{
	guint8* _vala_output = NULL;
	size_t _vala_output_length1 = 0;
	GList* exporters = NULL;
	SeahorseExporter* chosen = NULL;
	guint total = 0U;
	GList* _tmp9_;
	SeahorseExporter* _tmp15_;
	guint8* _tmp26_;
	GError* _inner_error0_ = NULL;
	guint result;
#line 69 "../common/exportable.vala"
	exporters = NULL;
#line 510 "exportable.c"
	{
		GList* object_collection = NULL;
		GList* object_it = NULL;
#line 71 "../common/exportable.vala"
		object_collection = objects;
#line 71 "../common/exportable.vala"
		for (object_it = object_collection; object_it != NULL; object_it = object_it->next) {
#line 518 "exportable.c"
			GObject* _tmp0_;
			GObject* object = NULL;
#line 71 "../common/exportable.vala"
			_tmp0_ = _g_object_ref0 ((GObject*) object_it->data);
#line 71 "../common/exportable.vala"
			object = _tmp0_;
#line 525 "exportable.c"
			{
				GObject* _tmp1_;
				GList* _tmp2_;
#line 72 "../common/exportable.vala"
				_tmp1_ = object;
#line 72 "../common/exportable.vala"
				if (!seahorse_exportable_can_export (_tmp1_)) {
#line 73 "../common/exportable.vala"
					_g_object_unref0 (object);
#line 73 "../common/exportable.vala"
					continue;
#line 537 "exportable.c"
				}
#line 76 "../common/exportable.vala"
				_tmp2_ = exporters;
#line 76 "../common/exportable.vala"
				if (_tmp2_ != NULL) {
#line 543 "exportable.c"
					GList* _tmp3_;
#line 77 "../common/exportable.vala"
					_tmp3_ = exporters;
#line 547 "exportable.c"
					{
						GList* exporter_collection = NULL;
						GList* exporter_it = NULL;
#line 77 "../common/exportable.vala"
						exporter_collection = _tmp3_;
#line 77 "../common/exportable.vala"
						for (exporter_it = exporter_collection; exporter_it != NULL; exporter_it = exporter_it->next) {
#line 555 "exportable.c"
							SeahorseExporter* _tmp4_;
							SeahorseExporter* exporter = NULL;
#line 77 "../common/exportable.vala"
							_tmp4_ = _g_object_ref0 ((SeahorseExporter*) exporter_it->data);
#line 77 "../common/exportable.vala"
							exporter = _tmp4_;
#line 562 "exportable.c"
							{
								SeahorseExporter* _tmp5_;
								GObject* _tmp6_;
#line 78 "../common/exportable.vala"
								_tmp5_ = exporter;
#line 78 "../common/exportable.vala"
								_tmp6_ = object;
#line 78 "../common/exportable.vala"
								seahorse_exporter_add_object (_tmp5_, _tmp6_);
#line 77 "../common/exportable.vala"
								_g_object_unref0 (exporter);
#line 574 "exportable.c"
							}
						}
					}
				} else {
					GObject* _tmp7_;
					GList* _tmp8_;
#line 82 "../common/exportable.vala"
					_tmp7_ = object;
#line 82 "../common/exportable.vala"
					_tmp8_ = seahorse_exportable_create_exporters (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, SEAHORSE_TYPE_EXPORTABLE, SeahorseExportable), SEAHORSE_EXPORTER_TYPE_TEXTUAL);
#line 82 "../common/exportable.vala"
					(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 82 "../common/exportable.vala"
					exporters = _tmp8_;
#line 589 "exportable.c"
				}
#line 71 "../common/exportable.vala"
				_g_object_unref0 (object);
#line 593 "exportable.c"
			}
		}
	}
#line 87 "../common/exportable.vala"
	chosen = NULL;
#line 88 "../common/exportable.vala"
	total = (guint) 0;
#line 89 "../common/exportable.vala"
	_tmp9_ = exporters;
#line 603 "exportable.c"
	{
		GList* exporter_collection = NULL;
		GList* exporter_it = NULL;
#line 89 "../common/exportable.vala"
		exporter_collection = _tmp9_;
#line 89 "../common/exportable.vala"
		for (exporter_it = exporter_collection; exporter_it != NULL; exporter_it = exporter_it->next) {
#line 611 "exportable.c"
			SeahorseExporter* _tmp10_;
			SeahorseExporter* exporter = NULL;
#line 89 "../common/exportable.vala"
			_tmp10_ = _g_object_ref0 ((SeahorseExporter*) exporter_it->data);
#line 89 "../common/exportable.vala"
			exporter = _tmp10_;
#line 618 "exportable.c"
			{
				guint count = 0U;
				SeahorseExporter* _tmp11_;
				GList* _tmp12_;
#line 90 "../common/exportable.vala"
				_tmp11_ = exporter;
#line 90 "../common/exportable.vala"
				_tmp12_ = seahorse_exporter_get_objects (_tmp11_);
#line 90 "../common/exportable.vala"
				count = g_list_length (_tmp12_);
#line 91 "../common/exportable.vala"
				if (count > total) {
#line 631 "exportable.c"
					SeahorseExporter* _tmp13_;
					SeahorseExporter* _tmp14_;
#line 92 "../common/exportable.vala"
					total = count;
#line 93 "../common/exportable.vala"
					_tmp13_ = exporter;
#line 93 "../common/exportable.vala"
					_tmp14_ = _g_object_ref0 (_tmp13_);
#line 93 "../common/exportable.vala"
					_g_object_unref0 (chosen);
#line 93 "../common/exportable.vala"
					chosen = _tmp14_;
#line 644 "exportable.c"
				}
#line 89 "../common/exportable.vala"
				_g_object_unref0 (exporter);
#line 648 "exportable.c"
			}
		}
	}
#line 97 "../common/exportable.vala"
	_tmp15_ = chosen;
#line 97 "../common/exportable.vala"
	if (_tmp15_ != NULL) {
#line 656 "exportable.c"
		Block3Data* _data3_;
		GMainLoop* _tmp16_;
		SeahorseExporter* _tmp17_;
		GMainLoop* _tmp18_;
		guint8* _tmp19_ = NULL;
		SeahorseExporter* _tmp20_;
		GAsyncResult* _tmp21_;
		size_t _tmp22_ = 0;
		guint8* _tmp23_;
		gint _tmp19__length1;
		gint __tmp19__size_;
		guint8* _tmp25_;
		gint _tmp25__length1;
#line 97 "../common/exportable.vala"
		_data3_ = g_slice_new0 (Block3Data);
#line 97 "../common/exportable.vala"
		_data3_->_ref_count_ = 1;
#line 98 "../common/exportable.vala"
		_tmp16_ = g_main_loop_new (NULL, FALSE);
#line 98 "../common/exportable.vala"
		_data3_->loop = _tmp16_;
#line 99 "../common/exportable.vala"
		_data3_->_result_ = NULL;
#line 101 "../common/exportable.vala"
		_tmp17_ = chosen;
#line 101 "../common/exportable.vala"
		seahorse_exporter_export (_tmp17_, NULL, ____lambda5__gasync_ready_callback, block3_data_ref (_data3_));
#line 106 "../common/exportable.vala"
		_tmp18_ = _data3_->loop;
#line 106 "../common/exportable.vala"
		g_main_loop_run (_tmp18_);
#line 108 "../common/exportable.vala"
		_tmp20_ = chosen;
#line 108 "../common/exportable.vala"
		_tmp21_ = _data3_->_result_;
#line 108 "../common/exportable.vala"
		_tmp23_ = seahorse_exporter_export_finish (_tmp20_, _tmp21_, &_tmp22_, &_inner_error0_);
#line 108 "../common/exportable.vala"
		_tmp19_ = _tmp23_;
#line 108 "../common/exportable.vala"
		_tmp19__length1 = _tmp22_;
#line 108 "../common/exportable.vala"
		__tmp19__size_ = _tmp19__length1;
#line 108 "../common/exportable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 702 "exportable.c"
			guint _tmp24_ = 0U;
#line 108 "../common/exportable.vala"
			g_propagate_error (error, _inner_error0_);
#line 108 "../common/exportable.vala"
			block3_data_unref (_data3_);
#line 108 "../common/exportable.vala"
			_data3_ = NULL;
#line 108 "../common/exportable.vala"
			_g_object_unref0 (chosen);
#line 108 "../common/exportable.vala"
			(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 108 "../common/exportable.vala"
			_vala_output = (g_free (_vala_output), NULL);
#line 108 "../common/exportable.vala"
			return _tmp24_;
#line 718 "exportable.c"
		}
#line 108 "../common/exportable.vala"
		_tmp25_ = _tmp19_;
#line 108 "../common/exportable.vala"
		_tmp25__length1 = _tmp19__length1;
#line 108 "../common/exportable.vala"
		_tmp19_ = NULL;
#line 108 "../common/exportable.vala"
		_tmp19__length1 = 0;
#line 108 "../common/exportable.vala"
		_vala_output = (g_free (_vala_output), NULL);
#line 108 "../common/exportable.vala"
		_vala_output = _tmp25_;
#line 108 "../common/exportable.vala"
		_vala_output_length1 = _tmp25__length1;
#line 109 "../common/exportable.vala"
		result = total;
#line 109 "../common/exportable.vala"
		_tmp19_ = (g_free (_tmp19_), NULL);
#line 109 "../common/exportable.vala"
		block3_data_unref (_data3_);
#line 109 "../common/exportable.vala"
		_data3_ = NULL;
#line 109 "../common/exportable.vala"
		_g_object_unref0 (chosen);
#line 109 "../common/exportable.vala"
		(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 109 "../common/exportable.vala"
		if (output) {
#line 109 "../common/exportable.vala"
			*output = _vala_output;
#line 750 "exportable.c"
		} else {
#line 109 "../common/exportable.vala"
			_vala_output = (g_free (_vala_output), NULL);
#line 754 "exportable.c"
		}
#line 109 "../common/exportable.vala"
		if (output_length1) {
#line 109 "../common/exportable.vala"
			*output_length1 = _vala_output_length1;
#line 760 "exportable.c"
		}
#line 109 "../common/exportable.vala"
		return result;
#line 764 "exportable.c"
	}
#line 112 "../common/exportable.vala"
	_tmp26_ = g_new0 (guint8, 0);
#line 112 "../common/exportable.vala"
	_vala_output = (g_free (_vala_output), NULL);
#line 112 "../common/exportable.vala"
	_vala_output = _tmp26_;
#line 112 "../common/exportable.vala"
	_vala_output_length1 = 0;
#line 113 "../common/exportable.vala"
	result = (guint) 0;
#line 113 "../common/exportable.vala"
	_g_object_unref0 (chosen);
#line 113 "../common/exportable.vala"
	(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 113 "../common/exportable.vala"
	if (output) {
#line 113 "../common/exportable.vala"
		*output = _vala_output;
#line 784 "exportable.c"
	} else {
#line 113 "../common/exportable.vala"
		_vala_output = (g_free (_vala_output), NULL);
#line 788 "exportable.c"
	}
#line 113 "../common/exportable.vala"
	if (output_length1) {
#line 113 "../common/exportable.vala"
		*output_length1 = _vala_output_length1;
#line 794 "exportable.c"
	}
#line 113 "../common/exportable.vala"
	return result;
#line 798 "exportable.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 124 "../common/exportable.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 124 "../common/exportable.vala"
	return _data4_;
#line 808 "exportable.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 124 "../common/exportable.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 124 "../common/exportable.vala"
		_g_object_unref0 (_data4_->_result_);
#line 124 "../common/exportable.vala"
		_g_main_loop_unref0 (_data4_->loop);
#line 124 "../common/exportable.vala"
		g_slice_free (Block4Data, _data4_);
#line 824 "exportable.c"
	}
}

static void
____lambda7_ (Block4Data* _data4_,
              GObject* obj,
              GAsyncResult* res)
{
	GAsyncResult* _tmp0_;
	GMainLoop* _tmp1_;
#line 159 "../common/exportable.vala"
	g_return_if_fail (res != NULL);
#line 160 "../common/exportable.vala"
	_tmp0_ = _g_object_ref0 (res);
#line 160 "../common/exportable.vala"
	_g_object_unref0 (_data4_->_result_);
#line 160 "../common/exportable.vala"
	_data4_->_result_ = _tmp0_;
#line 161 "../common/exportable.vala"
	_tmp1_ = _data4_->loop;
#line 161 "../common/exportable.vala"
	g_main_loop_quit (_tmp1_);
#line 847 "exportable.c"
}

static void
_____lambda7__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 159 "../common/exportable.vala"
	____lambda7_ (self, source_object, res);
#line 159 "../common/exportable.vala"
	block4_data_unref (self);
#line 859 "exportable.c"
}

gint
seahorse_exportable_export_to_prompt_wait (GList* objects,
                                           GtkWindow* parent,
                                           GError** error)
{
	gint count = 0;
	GHashTable* pending = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 118 "../common/exportable.vala"
	count = 0;
#line 120 "../common/exportable.vala"
	_tmp0_ = g_direct_hash;
#line 120 "../common/exportable.vala"
	_tmp1_ = g_direct_equal;
#line 120 "../common/exportable.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, NULL);
#line 120 "../common/exportable.vala"
	pending = _tmp2_;
#line 884 "exportable.c"
	{
		GList* object_collection = NULL;
		GList* object_it = NULL;
#line 121 "../common/exportable.vala"
		object_collection = objects;
#line 121 "../common/exportable.vala"
		for (object_it = object_collection; object_it != NULL; object_it = object_it->next) {
#line 892 "exportable.c"
			GObject* _tmp3_;
			GObject* object = NULL;
#line 121 "../common/exportable.vala"
			_tmp3_ = _g_object_ref0 ((GObject*) object_it->data);
#line 121 "../common/exportable.vala"
			object = _tmp3_;
#line 899 "exportable.c"
			{
				GHashTable* _tmp4_;
				GObject* _tmp5_;
#line 122 "../common/exportable.vala"
				_tmp4_ = pending;
#line 122 "../common/exportable.vala"
				_tmp5_ = object;
#line 122 "../common/exportable.vala"
				g_hash_table_add (_tmp4_, _tmp5_);
#line 121 "../common/exportable.vala"
				_g_object_unref0 (object);
#line 911 "exportable.c"
			}
		}
	}
	{
		GList* object_collection = NULL;
		GList* object_it = NULL;
#line 124 "../common/exportable.vala"
		object_collection = objects;
#line 124 "../common/exportable.vala"
		for (object_it = object_collection; object_it != NULL; object_it = object_it->next) {
#line 922 "exportable.c"
			GObject* _tmp6_;
			GObject* object = NULL;
#line 124 "../common/exportable.vala"
			_tmp6_ = _g_object_ref0 ((GObject*) object_it->data);
#line 124 "../common/exportable.vala"
			object = _tmp6_;
#line 929 "exportable.c"
			{
				Block4Data* _data4_;
				GHashTable* _tmp7_;
				GObject* _tmp8_;
				GObject* _tmp9_;
				GList* exporters = NULL;
				GObject* _tmp12_;
				GList* _tmp13_;
				GList* _tmp14_;
				gchar* directory = NULL;
				GFile* file = NULL;
				SeahorseExporter* exporter = NULL;
				gboolean ret = FALSE;
				GList* _tmp24_;
				GFile* _tmp25_ = NULL;
				SeahorseExporter* _tmp26_ = NULL;
				gboolean _tmp27_;
				GMainLoop* _tmp28_;
				SeahorseExporter* _tmp29_;
				GFile* _tmp30_;
				GMainLoop* _tmp31_;
				SeahorseExporter* _tmp32_;
				GAsyncResult* _tmp33_;
				SeahorseExporter* _tmp35_;
				GList* _tmp36_;
#line 124 "../common/exportable.vala"
				_data4_ = g_slice_new0 (Block4Data);
#line 124 "../common/exportable.vala"
				_data4_->_ref_count_ = 1;
#line 125 "../common/exportable.vala"
				_tmp7_ = pending;
#line 125 "../common/exportable.vala"
				_tmp8_ = object;
#line 125 "../common/exportable.vala"
				if (!g_hash_table_contains (_tmp7_, _tmp8_)) {
#line 126 "../common/exportable.vala"
					_g_object_unref0 (object);
#line 126 "../common/exportable.vala"
					block4_data_unref (_data4_);
#line 126 "../common/exportable.vala"
					_data4_ = NULL;
#line 126 "../common/exportable.vala"
					continue;
#line 973 "exportable.c"
				}
#line 128 "../common/exportable.vala"
				_tmp9_ = object;
#line 128 "../common/exportable.vala"
				if (!seahorse_exportable_can_export (_tmp9_)) {
#line 979 "exportable.c"
					GHashTable* _tmp10_;
					GObject* _tmp11_;
#line 129 "../common/exportable.vala"
					_tmp10_ = pending;
#line 129 "../common/exportable.vala"
					_tmp11_ = object;
#line 129 "../common/exportable.vala"
					g_hash_table_remove (_tmp10_, _tmp11_);
#line 130 "../common/exportable.vala"
					_g_object_unref0 (object);
#line 130 "../common/exportable.vala"
					block4_data_unref (_data4_);
#line 130 "../common/exportable.vala"
					_data4_ = NULL;
#line 130 "../common/exportable.vala"
					continue;
#line 996 "exportable.c"
				}
#line 133 "../common/exportable.vala"
				_tmp12_ = object;
#line 133 "../common/exportable.vala"
				_tmp13_ = seahorse_exportable_create_exporters (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, SEAHORSE_TYPE_EXPORTABLE, SeahorseExportable), SEAHORSE_EXPORTER_TYPE_ANY);
#line 133 "../common/exportable.vala"
				exporters = _tmp13_;
#line 134 "../common/exportable.vala"
				_tmp14_ = exporters;
#line 134 "../common/exportable.vala"
				if (_tmp14_ == NULL) {
#line 135 "../common/exportable.vala"
					(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 135 "../common/exportable.vala"
					_g_object_unref0 (object);
#line 135 "../common/exportable.vala"
					block4_data_unref (_data4_);
#line 135 "../common/exportable.vala"
					_data4_ = NULL;
#line 135 "../common/exportable.vala"
					continue;
#line 1018 "exportable.c"
				}
				{
					GList* x_collection = NULL;
					GList* x_it = NULL;
#line 137 "../common/exportable.vala"
					x_collection = objects;
#line 137 "../common/exportable.vala"
					for (x_it = x_collection; x_it != NULL; x_it = x_it->next) {
#line 1027 "exportable.c"
						GObject* _tmp15_;
						GObject* x = NULL;
#line 137 "../common/exportable.vala"
						_tmp15_ = _g_object_ref0 ((GObject*) x_it->data);
#line 137 "../common/exportable.vala"
						x = _tmp15_;
#line 1034 "exportable.c"
						{
							GObject* _tmp16_;
							GObject* _tmp17_;
							GHashTable* _tmp18_;
							GObject* _tmp19_;
#line 138 "../common/exportable.vala"
							_tmp16_ = x;
#line 138 "../common/exportable.vala"
							_tmp17_ = object;
#line 138 "../common/exportable.vala"
							if (_tmp16_ == _tmp17_) {
#line 139 "../common/exportable.vala"
								_g_object_unref0 (x);
#line 139 "../common/exportable.vala"
								continue;
#line 1050 "exportable.c"
							}
#line 140 "../common/exportable.vala"
							_tmp18_ = pending;
#line 140 "../common/exportable.vala"
							_tmp19_ = x;
#line 140 "../common/exportable.vala"
							if (g_hash_table_contains (_tmp18_, _tmp19_)) {
#line 1058 "exportable.c"
								GList* _tmp20_;
#line 141 "../common/exportable.vala"
								_tmp20_ = exporters;
#line 1062 "exportable.c"
								{
									GList* exporter_collection = NULL;
									GList* exporter_it = NULL;
#line 141 "../common/exportable.vala"
									exporter_collection = _tmp20_;
#line 141 "../common/exportable.vala"
									for (exporter_it = exporter_collection; exporter_it != NULL; exporter_it = exporter_it->next) {
#line 1070 "exportable.c"
										SeahorseExporter* _tmp21_;
										SeahorseExporter* exporter = NULL;
#line 141 "../common/exportable.vala"
										_tmp21_ = _g_object_ref0 ((SeahorseExporter*) exporter_it->data);
#line 141 "../common/exportable.vala"
										exporter = _tmp21_;
#line 1077 "exportable.c"
										{
											SeahorseExporter* _tmp22_;
											GObject* _tmp23_;
#line 142 "../common/exportable.vala"
											_tmp22_ = exporter;
#line 142 "../common/exportable.vala"
											_tmp23_ = x;
#line 142 "../common/exportable.vala"
											seahorse_exporter_add_object (_tmp22_, _tmp23_);
#line 141 "../common/exportable.vala"
											_g_object_unref0 (exporter);
#line 1089 "exportable.c"
										}
									}
								}
							}
#line 137 "../common/exportable.vala"
							_g_object_unref0 (x);
#line 1096 "exportable.c"
						}
					}
				}
#line 146 "../common/exportable.vala"
				directory = NULL;
#line 151 "../common/exportable.vala"
				_tmp24_ = exporters;
#line 151 "../common/exportable.vala"
				_tmp27_ = seahorse_exportable_prompt (_tmp24_, parent, &directory, &_tmp25_, &_tmp26_);
#line 151 "../common/exportable.vala"
				_g_object_unref0 (file);
#line 151 "../common/exportable.vala"
				file = _tmp25_;
#line 151 "../common/exportable.vala"
				_g_object_unref0 (exporter);
#line 151 "../common/exportable.vala"
				exporter = _tmp26_;
#line 151 "../common/exportable.vala"
				ret = _tmp27_;
#line 153 "../common/exportable.vala"
				if (!ret) {
#line 154 "../common/exportable.vala"
					_g_object_unref0 (exporter);
#line 154 "../common/exportable.vala"
					_g_object_unref0 (file);
#line 154 "../common/exportable.vala"
					_g_free0 (directory);
#line 154 "../common/exportable.vala"
					(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 154 "../common/exportable.vala"
					_g_object_unref0 (object);
#line 154 "../common/exportable.vala"
					block4_data_unref (_data4_);
#line 154 "../common/exportable.vala"
					_data4_ = NULL;
#line 154 "../common/exportable.vala"
					break;
#line 1134 "exportable.c"
				}
#line 156 "../common/exportable.vala"
				_tmp28_ = g_main_loop_new (NULL, FALSE);
#line 156 "../common/exportable.vala"
				_data4_->loop = _tmp28_;
#line 157 "../common/exportable.vala"
				_data4_->_result_ = NULL;
#line 159 "../common/exportable.vala"
				_tmp29_ = exporter;
#line 159 "../common/exportable.vala"
				_tmp30_ = file;
#line 159 "../common/exportable.vala"
				seahorse_exporter_export_to_file (_tmp29_, _tmp30_, TRUE, NULL, _____lambda7__gasync_ready_callback, block4_data_ref (_data4_));
#line 164 "../common/exportable.vala"
				_tmp31_ = _data4_->loop;
#line 164 "../common/exportable.vala"
				g_main_loop_run (_tmp31_);
#line 166 "../common/exportable.vala"
				_tmp32_ = exporter;
#line 166 "../common/exportable.vala"
				_tmp33_ = _data4_->_result_;
#line 166 "../common/exportable.vala"
				seahorse_exporter_export_to_file_finish (_tmp32_, _tmp33_, &_inner_error0_);
#line 166 "../common/exportable.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1160 "exportable.c"
					gint _tmp34_ = -1;
#line 166 "../common/exportable.vala"
					g_propagate_error (error, _inner_error0_);
#line 166 "../common/exportable.vala"
					_g_object_unref0 (exporter);
#line 166 "../common/exportable.vala"
					_g_object_unref0 (file);
#line 166 "../common/exportable.vala"
					_g_free0 (directory);
#line 166 "../common/exportable.vala"
					(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 166 "../common/exportable.vala"
					_g_object_unref0 (object);
#line 166 "../common/exportable.vala"
					block4_data_unref (_data4_);
#line 166 "../common/exportable.vala"
					_data4_ = NULL;
#line 166 "../common/exportable.vala"
					_g_hash_table_unref0 (pending);
#line 166 "../common/exportable.vala"
					return _tmp34_;
#line 1182 "exportable.c"
				}
#line 167 "../common/exportable.vala"
				_tmp35_ = exporter;
#line 167 "../common/exportable.vala"
				_tmp36_ = seahorse_exporter_get_objects (_tmp35_);
#line 1188 "exportable.c"
				{
					GList* e_collection = NULL;
					GList* e_it = NULL;
#line 167 "../common/exportable.vala"
					e_collection = _tmp36_;
#line 167 "../common/exportable.vala"
					for (e_it = e_collection; e_it != NULL; e_it = e_it->next) {
#line 1196 "exportable.c"
						GObject* _tmp37_;
						GObject* e = NULL;
#line 167 "../common/exportable.vala"
						_tmp37_ = _g_object_ref0 ((GObject*) e_it->data);
#line 167 "../common/exportable.vala"
						e = _tmp37_;
#line 1203 "exportable.c"
						{
							GHashTable* _tmp38_;
							GObject* _tmp39_;
							gint _tmp40_;
#line 168 "../common/exportable.vala"
							_tmp38_ = pending;
#line 168 "../common/exportable.vala"
							_tmp39_ = e;
#line 168 "../common/exportable.vala"
							g_hash_table_remove (_tmp38_, _tmp39_);
#line 169 "../common/exportable.vala"
							_tmp40_ = count;
#line 169 "../common/exportable.vala"
							count = _tmp40_ + 1;
#line 167 "../common/exportable.vala"
							_g_object_unref0 (e);
#line 1220 "exportable.c"
						}
					}
				}
#line 124 "../common/exportable.vala"
				_g_object_unref0 (exporter);
#line 124 "../common/exportable.vala"
				_g_object_unref0 (file);
#line 124 "../common/exportable.vala"
				_g_free0 (directory);
#line 124 "../common/exportable.vala"
				(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 124 "../common/exportable.vala"
				_g_object_unref0 (object);
#line 124 "../common/exportable.vala"
				block4_data_unref (_data4_);
#line 124 "../common/exportable.vala"
				_data4_ = NULL;
#line 1238 "exportable.c"
			}
		}
	}
#line 173 "../common/exportable.vala"
	result = count;
#line 173 "../common/exportable.vala"
	_g_hash_table_unref0 (pending);
#line 173 "../common/exportable.vala"
	return result;
#line 1248 "exportable.c"
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1171 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1172 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1172 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1174 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1174 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1270 "exportable.c"
		gchar* _tmp2_;
#line 1175 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1175 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1175 "glib-2.0.vapi"
		return result;
#line 1278 "exportable.c"
	} else {
#line 1177 "glib-2.0.vapi"
		result = -1;
#line 1177 "glib-2.0.vapi"
		return result;
#line 1284 "exportable.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 1308 "exportable.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 1317 "exportable.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1336 "exportable.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1340 "exportable.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1346 "exportable.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1356 "exportable.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1364 "exportable.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1368 "exportable.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 1374 "exportable.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 1384 "exportable.c"
}

static gchar*
seahorse_exportable_calculate_basename (GFile* file,
                                        const gchar* extension)
{
	gchar* basename = NULL;
	gchar* _tmp0_;
	gint dot = 0;
	const gchar* _tmp1_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 176 "../common/exportable.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 176 "../common/exportable.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 178 "../common/exportable.vala"
	_tmp0_ = g_file_get_basename (file);
#line 178 "../common/exportable.vala"
	basename = _tmp0_;
#line 179 "../common/exportable.vala"
	_tmp1_ = basename;
#line 179 "../common/exportable.vala"
	dot = string_last_index_of_char (_tmp1_, (gunichar) '.', 0);
#line 180 "../common/exportable.vala"
	if (dot != -1) {
#line 1412 "exportable.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 181 "../common/exportable.vala"
		_tmp2_ = basename;
#line 181 "../common/exportable.vala"
		_tmp3_ = string_substring (_tmp2_, (glong) 0, (glong) dot);
#line 181 "../common/exportable.vala"
		_g_free0 (basename);
#line 181 "../common/exportable.vala"
		basename = _tmp3_;
#line 1423 "exportable.c"
	}
#line 182 "../common/exportable.vala"
	_tmp4_ = basename;
#line 182 "../common/exportable.vala"
	_tmp5_ = g_strdup_printf ("%s%s", _tmp4_, extension);
#line 182 "../common/exportable.vala"
	result = _tmp5_;
#line 182 "../common/exportable.vala"
	_g_free0 (basename);
#line 182 "../common/exportable.vala"
	return result;
#line 1435 "exportable.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 185 "../common/exportable.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 185 "../common/exportable.vala"
	return _data5_;
#line 1445 "exportable.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 185 "../common/exportable.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 185 "../common/exportable.vala"
		_g_hash_table_unref0 (_data5_->filters);
#line 185 "../common/exportable.vala"
		_g_object_unref0 (_data5_->chooser);
#line 185 "../common/exportable.vala"
		g_slice_free (Block5Data, _data5_);
#line 1461 "exportable.c"
	}
}

static void
__lambda6_ (Block5Data* _data5_,
            GObject* obj,
            GParamSpec* prop)
{
	SeahorseExporter* exporter = NULL;
	GHashTable* _tmp0_;
	GtkFileChooserNative* _tmp1_;
	GtkFileFilter* _tmp2_;
	gconstpointer _tmp3_;
	SeahorseExporter* _tmp4_;
	gchar* name = NULL;
	SeahorseExporter* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gint dot = 0;
	const gchar* _tmp8_;
#line 209 "../common/exportable.vala"
	g_return_if_fail (obj != NULL);
#line 209 "../common/exportable.vala"
	g_return_if_fail (prop != NULL);
#line 210 "../common/exportable.vala"
	_tmp0_ = _data5_->filters;
#line 210 "../common/exportable.vala"
	_tmp1_ = _data5_->chooser;
#line 210 "../common/exportable.vala"
	_tmp2_ = gtk_file_chooser_get_filter ((GtkFileChooser*) _tmp1_);
#line 210 "../common/exportable.vala"
	_tmp3_ = g_hash_table_lookup (_tmp0_, _tmp2_);
#line 210 "../common/exportable.vala"
	_tmp4_ = _g_object_ref0 ((SeahorseExporter*) _tmp3_);
#line 210 "../common/exportable.vala"
	exporter = _tmp4_;
#line 211 "../common/exportable.vala"
	_tmp5_ = exporter;
#line 211 "../common/exportable.vala"
	_tmp6_ = seahorse_exporter_get_filename (_tmp5_);
#line 211 "../common/exportable.vala"
	_tmp7_ = _tmp6_;
#line 211 "../common/exportable.vala"
	name = _tmp7_;
#line 212 "../common/exportable.vala"
	_tmp8_ = name;
#line 212 "../common/exportable.vala"
	dot = string_last_index_of_char (_tmp8_, (gunichar) '.', 0);
#line 213 "../common/exportable.vala"
	if (dot != -1) {
#line 1512 "exportable.c"
		GFile* file = NULL;
		GtkFileChooserNative* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
#line 214 "../common/exportable.vala"
		_tmp9_ = _data5_->chooser;
#line 214 "../common/exportable.vala"
		_tmp10_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp9_);
#line 214 "../common/exportable.vala"
		file = _tmp10_;
#line 215 "../common/exportable.vala"
		_tmp11_ = file;
#line 215 "../common/exportable.vala"
		if (_tmp11_ != NULL) {
#line 1527 "exportable.c"
			gchar* basename = NULL;
			GFile* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			GtkFileChooserNative* _tmp18_;
			const gchar* _tmp19_;
#line 216 "../common/exportable.vala"
			_tmp12_ = file;
#line 216 "../common/exportable.vala"
			_tmp13_ = name;
#line 216 "../common/exportable.vala"
			_tmp14_ = string_substring (_tmp13_, (glong) dot, (glong) -1);
#line 216 "../common/exportable.vala"
			_tmp15_ = _tmp14_;
#line 216 "../common/exportable.vala"
			_tmp16_ = seahorse_exportable_calculate_basename (_tmp12_, _tmp15_);
#line 216 "../common/exportable.vala"
			_tmp17_ = _tmp16_;
#line 216 "../common/exportable.vala"
			_g_free0 (_tmp15_);
#line 216 "../common/exportable.vala"
			basename = _tmp17_;
#line 217 "../common/exportable.vala"
			_tmp18_ = _data5_->chooser;
#line 217 "../common/exportable.vala"
			_tmp19_ = basename;
#line 217 "../common/exportable.vala"
			gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp18_, _tmp19_);
#line 215 "../common/exportable.vala"
			_g_free0 (basename);
#line 1561 "exportable.c"
		} else {
			GtkFileChooserNative* _tmp20_;
			const gchar* _tmp21_;
#line 219 "../common/exportable.vala"
			_tmp20_ = _data5_->chooser;
#line 219 "../common/exportable.vala"
			_tmp21_ = name;
#line 219 "../common/exportable.vala"
			gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp20_, _tmp21_);
#line 1571 "exportable.c"
		}
#line 213 "../common/exportable.vala"
		_g_object_unref0 (file);
#line 1575 "exportable.c"
	}
#line 209 "../common/exportable.vala"
	_g_free0 (name);
#line 209 "../common/exportable.vala"
	_g_object_unref0 (exporter);
#line 1581 "exportable.c"
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 209 "../common/exportable.vala"
	__lambda6_ (self, _sender, pspec);
#line 1591 "exportable.c"
}

gboolean
seahorse_exportable_prompt (GList* exporters,
                            GtkWindow* parent,
                            gchar** directory,
                            GFile** chosen_file,
                            SeahorseExporter** chosen_exporter)
{
	GFile* _vala_chosen_file = NULL;
	SeahorseExporter* _vala_chosen_exporter = NULL;
	Block5Data* _data5_;
	GtkFileChooserNative* _tmp0_;
	GtkFileChooserNative* _tmp1_;
	GtkFileChooserNative* _tmp2_;
	GtkFileFilter* first = NULL;
	GHashFunc _tmp4_;
	GEqualFunc _tmp5_;
	GHashTable* _tmp6_;
	GtkFileChooserNative* _tmp22_;
	GtkFileChooserNative* _tmp23_;
	GtkFileFilter* _tmp24_;
	GtkFileChooserNative* _tmp25_;
	GtkFileChooserNative* _tmp36_;
	gboolean result;
#line 185 "../common/exportable.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 185 "../common/exportable.vala"
	_data5_->_ref_count_ = 1;
#line 190 "../common/exportable.vala"
	_tmp0_ = gtk_file_chooser_native_new (NULL, parent, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("Export"), _ ("_Cancel"));
#line 190 "../common/exportable.vala"
	_data5_->chooser = _tmp0_;
#line 193 "../common/exportable.vala"
	_tmp1_ = _data5_->chooser;
#line 193 "../common/exportable.vala"
	gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp1_, FALSE);
#line 194 "../common/exportable.vala"
	_tmp2_ = _data5_->chooser;
#line 194 "../common/exportable.vala"
	gtk_file_chooser_set_do_overwrite_confirmation ((GtkFileChooser*) _tmp2_, TRUE);
#line 196 "../common/exportable.vala"
	if ((*directory) != NULL) {
#line 1635 "exportable.c"
		GtkFileChooserNative* _tmp3_;
#line 197 "../common/exportable.vala"
		_tmp3_ = _data5_->chooser;
#line 197 "../common/exportable.vala"
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp3_, *directory);
#line 1641 "exportable.c"
	}
#line 199 "../common/exportable.vala"
	first = NULL;
#line 200 "../common/exportable.vala"
	_tmp4_ = g_direct_hash;
#line 200 "../common/exportable.vala"
	_tmp5_ = g_direct_equal;
#line 200 "../common/exportable.vala"
	_tmp6_ = g_hash_table_new_full (_tmp4_, _tmp5_, _g_object_unref0_, _g_object_unref0_);
#line 200 "../common/exportable.vala"
	_data5_->filters = _tmp6_;
#line 1653 "exportable.c"
	{
		GList* exporter_collection = NULL;
		GList* exporter_it = NULL;
#line 201 "../common/exportable.vala"
		exporter_collection = exporters;
#line 201 "../common/exportable.vala"
		for (exporter_it = exporter_collection; exporter_it != NULL; exporter_it = exporter_it->next) {
#line 1661 "exportable.c"
			SeahorseExporter* _tmp7_;
			SeahorseExporter* exporter = NULL;
#line 201 "../common/exportable.vala"
			_tmp7_ = _g_object_ref0 ((SeahorseExporter*) exporter_it->data);
#line 201 "../common/exportable.vala"
			exporter = _tmp7_;
#line 1668 "exportable.c"
			{
				GtkFileFilter* filter = NULL;
				SeahorseExporter* _tmp8_;
				GtkFileFilter* _tmp9_;
				GtkFileFilter* _tmp10_;
				GHashTable* _tmp11_;
				GtkFileFilter* _tmp12_;
				GtkFileFilter* _tmp13_;
				SeahorseExporter* _tmp14_;
				SeahorseExporter* _tmp15_;
				GtkFileChooserNative* _tmp16_;
				GtkFileFilter* _tmp17_;
				GtkFileFilter* _tmp18_;
				GtkFileFilter* _tmp19_;
#line 202 "../common/exportable.vala"
				_tmp8_ = exporter;
#line 202 "../common/exportable.vala"
				_tmp9_ = seahorse_exporter_get_file_filter (_tmp8_);
#line 202 "../common/exportable.vala"
				_tmp10_ = _tmp9_;
#line 202 "../common/exportable.vala"
				filter = _tmp10_;
#line 203 "../common/exportable.vala"
				_tmp11_ = _data5_->filters;
#line 203 "../common/exportable.vala"
				_tmp12_ = filter;
#line 203 "../common/exportable.vala"
				_tmp13_ = _g_object_ref0 (_tmp12_);
#line 203 "../common/exportable.vala"
				_tmp14_ = exporter;
#line 203 "../common/exportable.vala"
				_tmp15_ = _g_object_ref0 (_tmp14_);
#line 203 "../common/exportable.vala"
				g_hash_table_replace (_tmp11_, _tmp13_, _tmp15_);
#line 204 "../common/exportable.vala"
				_tmp16_ = _data5_->chooser;
#line 204 "../common/exportable.vala"
				_tmp17_ = filter;
#line 204 "../common/exportable.vala"
				_tmp18_ = _g_object_ref0 (_tmp17_);
#line 204 "../common/exportable.vala"
				gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp16_, _tmp18_);
#line 205 "../common/exportable.vala"
				_tmp19_ = first;
#line 205 "../common/exportable.vala"
				if (_tmp19_ == NULL) {
#line 1715 "exportable.c"
					GtkFileFilter* _tmp20_;
					GtkFileFilter* _tmp21_;
#line 206 "../common/exportable.vala"
					_tmp20_ = filter;
#line 206 "../common/exportable.vala"
					_tmp21_ = _g_object_ref0 (_tmp20_);
#line 206 "../common/exportable.vala"
					_g_object_unref0 (first);
#line 206 "../common/exportable.vala"
					first = _tmp21_;
#line 1726 "exportable.c"
				}
#line 201 "../common/exportable.vala"
				_g_object_unref0 (filter);
#line 201 "../common/exportable.vala"
				_g_object_unref0 (exporter);
#line 1732 "exportable.c"
			}
		}
	}
#line 209 "../common/exportable.vala"
	_tmp22_ = _data5_->chooser;
#line 209 "../common/exportable.vala"
	g_signal_connect_data ((GObject*) _tmp22_, "notify", (GCallback) ___lambda6__g_object_notify, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 224 "../common/exportable.vala"
	_tmp23_ = _data5_->chooser;
#line 224 "../common/exportable.vala"
	_tmp24_ = first;
#line 224 "../common/exportable.vala"
	gtk_file_chooser_set_filter ((GtkFileChooser*) _tmp23_, _tmp24_);
#line 226 "../common/exportable.vala"
	_tmp25_ = _data5_->chooser;
#line 226 "../common/exportable.vala"
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp25_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1750 "exportable.c"
		GtkFileChooserNative* _tmp26_;
		GFile* _tmp27_;
		GHashTable* _tmp28_;
		GtkFileChooserNative* _tmp29_;
		GtkFileFilter* _tmp30_;
		gconstpointer _tmp31_;
		SeahorseExporter* _tmp32_;
		GtkFileChooserNative* _tmp33_;
		gchar* _tmp34_;
		GtkFileChooserNative* _tmp35_;
#line 227 "../common/exportable.vala"
		_tmp26_ = _data5_->chooser;
#line 227 "../common/exportable.vala"
		_tmp27_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp26_);
#line 227 "../common/exportable.vala"
		_g_object_unref0 (_vala_chosen_file);
#line 227 "../common/exportable.vala"
		_vala_chosen_file = _tmp27_;
#line 228 "../common/exportable.vala"
		_tmp28_ = _data5_->filters;
#line 228 "../common/exportable.vala"
		_tmp29_ = _data5_->chooser;
#line 228 "../common/exportable.vala"
		_tmp30_ = gtk_file_chooser_get_filter ((GtkFileChooser*) _tmp29_);
#line 228 "../common/exportable.vala"
		_tmp31_ = g_hash_table_lookup (_tmp28_, _tmp30_);
#line 228 "../common/exportable.vala"
		_tmp32_ = _g_object_ref0 ((SeahorseExporter*) _tmp31_);
#line 228 "../common/exportable.vala"
		_g_object_unref0 (_vala_chosen_exporter);
#line 228 "../common/exportable.vala"
		_vala_chosen_exporter = _tmp32_;
#line 229 "../common/exportable.vala"
		_tmp33_ = _data5_->chooser;
#line 229 "../common/exportable.vala"
		_tmp34_ = gtk_file_chooser_get_current_folder ((GtkFileChooser*) _tmp33_);
#line 229 "../common/exportable.vala"
		_g_free0 (*directory);
#line 229 "../common/exportable.vala"
		*directory = _tmp34_;
#line 230 "../common/exportable.vala"
		_tmp35_ = _data5_->chooser;
#line 230 "../common/exportable.vala"
		gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp35_);
#line 231 "../common/exportable.vala"
		result = TRUE;
#line 231 "../common/exportable.vala"
		_g_object_unref0 (first);
#line 231 "../common/exportable.vala"
		block5_data_unref (_data5_);
#line 231 "../common/exportable.vala"
		_data5_ = NULL;
#line 231 "../common/exportable.vala"
		if (chosen_file) {
#line 231 "../common/exportable.vala"
			*chosen_file = _vala_chosen_file;
#line 1807 "exportable.c"
		} else {
#line 231 "../common/exportable.vala"
			_g_object_unref0 (_vala_chosen_file);
#line 1811 "exportable.c"
		}
#line 231 "../common/exportable.vala"
		if (chosen_exporter) {
#line 231 "../common/exportable.vala"
			*chosen_exporter = _vala_chosen_exporter;
#line 1817 "exportable.c"
		} else {
#line 231 "../common/exportable.vala"
			_g_object_unref0 (_vala_chosen_exporter);
#line 1821 "exportable.c"
		}
#line 231 "../common/exportable.vala"
		return result;
#line 1825 "exportable.c"
	}
#line 234 "../common/exportable.vala"
	_g_object_unref0 (_vala_chosen_file);
#line 234 "../common/exportable.vala"
	_vala_chosen_file = NULL;
#line 235 "../common/exportable.vala"
	_g_object_unref0 (_vala_chosen_exporter);
#line 235 "../common/exportable.vala"
	_vala_chosen_exporter = NULL;
#line 236 "../common/exportable.vala"
	_tmp36_ = _data5_->chooser;
#line 236 "../common/exportable.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp36_);
#line 237 "../common/exportable.vala"
	result = FALSE;
#line 237 "../common/exportable.vala"
	_g_object_unref0 (first);
#line 237 "../common/exportable.vala"
	block5_data_unref (_data5_);
#line 237 "../common/exportable.vala"
	_data5_ = NULL;
#line 237 "../common/exportable.vala"
	if (chosen_file) {
#line 237 "../common/exportable.vala"
		*chosen_file = _vala_chosen_file;
#line 1851 "exportable.c"
	} else {
#line 237 "../common/exportable.vala"
		_g_object_unref0 (_vala_chosen_file);
#line 1855 "exportable.c"
	}
#line 237 "../common/exportable.vala"
	if (chosen_exporter) {
#line 237 "../common/exportable.vala"
		*chosen_exporter = _vala_chosen_exporter;
#line 1861 "exportable.c"
	} else {
#line 237 "../common/exportable.vala"
		_g_object_unref0 (_vala_chosen_exporter);
#line 1865 "exportable.c"
	}
#line 237 "../common/exportable.vala"
	return result;
#line 1869 "exportable.c"
}

gboolean
seahorse_exportable_get_exportable (SeahorseExportable* self)
{
	SeahorseExportableIface* _iface_;
#line 24 "../common/exportable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 24 "../common/exportable.vala"
	_iface_ = SEAHORSE_EXPORTABLE_GET_INTERFACE (self);
#line 24 "../common/exportable.vala"
	if (_iface_->get_exportable) {
#line 24 "../common/exportable.vala"
		return _iface_->get_exportable (self);
#line 1884 "exportable.c"
	}
#line 24 "../common/exportable.vala"
	return FALSE;
#line 1888 "exportable.c"
}

static void
seahorse_exportable_default_init (SeahorseExportableIface * iface,
                                  gpointer iface_data)
{
#line 23 "../common/exportable.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("exportable", "exportable", "exportable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1897 "exportable.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_exportable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseExportableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_exportable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType seahorse_exportable_type_id;
	seahorse_exportable_type_id = g_type_register_static (G_TYPE_INTERFACE, "SeahorseExportable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (seahorse_exportable_type_id, G_TYPE_OBJECT);
	return seahorse_exportable_type_id;
}

GType
seahorse_exportable_get_type (void)
{
	static volatile gsize seahorse_exportable_type_id__once = 0;
	if (g_once_init_enter (&seahorse_exportable_type_id__once)) {
		GType seahorse_exportable_type_id;
		seahorse_exportable_type_id = seahorse_exportable_get_type_once ();
		g_once_init_leave (&seahorse_exportable_type_id__once, seahorse_exportable_type_id);
	}
	return seahorse_exportable_type_id__once;
}

