/* interaction.c generated by valac 0.56.11, the Vala compiler
 * generated from interaction.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */
/* FIXME: there are no bindings generated for these functions*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "seahorse-common.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

enum  {
	SEAHORSE_INTERACTION_0_PROPERTY,
	SEAHORSE_INTERACTION_PARENT_PROPERTY,
	SEAHORSE_INTERACTION_NUM_PROPERTIES
};
static GParamSpec* seahorse_interaction_properties[SEAHORSE_INTERACTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SeahorseInteractionPrivate {
	GtkWindow* _parent;
};

static gint SeahorseInteraction_private_offset;
static gpointer seahorse_interaction_parent_class = NULL;

gchar* gcr_secure_memory_strdup (const gchar* str);
void gcr_secure_memory_free (void* str);
static GTlsInteractionResult seahorse_interaction_real_ask_password (GTlsInteraction* base,
                                                              GTlsPassword* password,
                                                              GCancellable* cancellable,
                                                              GError** error);
static gchar* seahorse_interaction_calc_description (SeahorseInteraction* self,
                                              GTlsPassword* password);
static void _gcr_secure_memory_free_gdestroy_notify (void* data);
static void seahorse_interaction_finalize (GObject * obj);
static GType seahorse_interaction_get_type_once (void);
static void _vala_seahorse_interaction_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_seahorse_interaction_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
seahorse_interaction_get_instance_private (SeahorseInteraction* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseInteraction_private_offset);
}

SeahorseInteraction*
seahorse_interaction_construct (GType object_type,
                                GtkWindow* parent)
{
	SeahorseInteraction * self = NULL;
#line 35 "../common/interaction.vala"
	self = (SeahorseInteraction*) g_object_new (object_type, NULL);
#line 36 "../common/interaction.vala"
	seahorse_interaction_set_parent (self, parent);
#line 35 "../common/interaction.vala"
	return self;
#line 90 "interaction.c"
}

SeahorseInteraction*
seahorse_interaction_new (GtkWindow* parent)
{
#line 35 "../common/interaction.vala"
	return seahorse_interaction_construct (SEAHORSE_TYPE_INTERACTION, parent);
#line 98 "interaction.c"
}

static void
_gcr_secure_memory_free_gdestroy_notify (void* data)
{
#line 51 "../common/interaction.vala"
	gcr_secure_memory_free (data);
#line 106 "interaction.c"
}

static GTlsInteractionResult
seahorse_interaction_real_ask_password (GTlsInteraction* base,
                                        GTlsPassword* password,
                                        GCancellable* cancellable,
                                        GError** error)
{
	SeahorseInteraction * self;
	gchar* description = NULL;
	gchar* _tmp0_;
	SeahorsePassphrasePrompt* dialog = NULL;
	const gchar* _tmp1_;
	SeahorsePassphrasePrompt* _tmp2_;
	GtkWindow* _tmp3_;
	gint response = 0;
	SeahorsePassphrasePrompt* _tmp6_;
	SeahorsePassphrasePrompt* _tmp11_;
	GError* _inner_error0_ = NULL;
	GTlsInteractionResult result;
#line 39 "../common/interaction.vala"
	self = (SeahorseInteraction*) base;
#line 39 "../common/interaction.vala"
	g_return_val_if_fail (password != NULL, 0);
#line 42 "../common/interaction.vala"
	_tmp0_ = seahorse_interaction_calc_description (self, password);
#line 42 "../common/interaction.vala"
	description = _tmp0_;
#line 43 "../common/interaction.vala"
	_tmp1_ = description;
#line 43 "../common/interaction.vala"
	_tmp2_ = seahorse_passphrase_prompt_show_dialog (NULL, _tmp1_, NULL, NULL, FALSE);
#line 43 "../common/interaction.vala"
	dialog = _tmp2_;
#line 45 "../common/interaction.vala"
	_tmp3_ = self->priv->_parent;
#line 45 "../common/interaction.vala"
	if (_tmp3_ != NULL) {
#line 145 "interaction.c"
		SeahorsePassphrasePrompt* _tmp4_;
		GtkWindow* _tmp5_;
#line 46 "../common/interaction.vala"
		_tmp4_ = dialog;
#line 46 "../common/interaction.vala"
		_tmp5_ = self->priv->_parent;
#line 46 "../common/interaction.vala"
		gtk_window_set_transient_for ((GtkWindow*) _tmp4_, _tmp5_);
#line 154 "interaction.c"
	}
#line 48 "../common/interaction.vala"
	_tmp6_ = dialog;
#line 48 "../common/interaction.vala"
	response = gtk_dialog_run ((GtkDialog*) _tmp6_);
#line 50 "../common/interaction.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 162 "interaction.c"
		SeahorsePassphrasePrompt* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 51 "../common/interaction.vala"
		_tmp7_ = dialog;
#line 51 "../common/interaction.vala"
		_tmp8_ = seahorse_passphrase_prompt_get_text (_tmp7_);
#line 51 "../common/interaction.vala"
		_tmp9_ = _tmp8_;
#line 51 "../common/interaction.vala"
		_tmp10_ = gcr_secure_memory_strdup (_tmp9_);
#line 51 "../common/interaction.vala"
		g_tls_password_set_value_full (password, (guint8*) _tmp10_, (gssize) -1, _gcr_secure_memory_free_gdestroy_notify);
#line 51 "../common/interaction.vala"
		_g_free0 (_tmp9_);
#line 179 "interaction.c"
	}
#line 54 "../common/interaction.vala"
	_tmp11_ = dialog;
#line 54 "../common/interaction.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp11_);
#line 56 "../common/interaction.vala"
	if (response != ((gint) GTK_RESPONSE_ACCEPT)) {
#line 187 "interaction.c"
		GError* _tmp12_;
#line 57 "../common/interaction.vala"
		_tmp12_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_CANCELLED, "The password request was cancelled by the user");
#line 57 "../common/interaction.vala"
		_inner_error0_ = _tmp12_;
#line 57 "../common/interaction.vala"
		g_propagate_error (error, _inner_error0_);
#line 57 "../common/interaction.vala"
		_g_object_unref0 (dialog);
#line 57 "../common/interaction.vala"
		_g_free0 (description);
#line 57 "../common/interaction.vala"
		return 0;
#line 201 "interaction.c"
	}
#line 59 "../common/interaction.vala"
	result = G_TLS_INTERACTION_HANDLED;
#line 59 "../common/interaction.vala"
	_g_object_unref0 (dialog);
#line 59 "../common/interaction.vala"
	_g_free0 (description);
#line 59 "../common/interaction.vala"
	return result;
#line 211 "interaction.c"
}

static gchar*
seahorse_interaction_calc_description (SeahorseInteraction* self,
                                       GTlsPassword* password)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 62 "../common/interaction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../common/interaction.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 63 "../common/interaction.vala"
	_tmp0_ = g_tls_password_get_description (password);
#line 63 "../common/interaction.vala"
	_tmp1_ = _tmp0_;
#line 63 "../common/interaction.vala"
	_tmp2_ = g_strdup_printf (_ ("Enter PIN or password for: %s"), _tmp1_);
#line 63 "../common/interaction.vala"
	result = _tmp2_;
#line 63 "../common/interaction.vala"
	return result;
#line 236 "interaction.c"
}

GtkWindow*
seahorse_interaction_get_parent (SeahorseInteraction* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
#line 33 "../common/interaction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../common/interaction.vala"
	_tmp0_ = self->priv->_parent;
#line 33 "../common/interaction.vala"
	result = _tmp0_;
#line 33 "../common/interaction.vala"
	return result;
#line 252 "interaction.c"
}

void
seahorse_interaction_set_parent (SeahorseInteraction* self,
                                 GtkWindow* value)
{
	GtkWindow* old_value;
#line 33 "../common/interaction.vala"
	g_return_if_fail (self != NULL);
#line 33 "../common/interaction.vala"
	old_value = seahorse_interaction_get_parent (self);
#line 33 "../common/interaction.vala"
	if (old_value != value) {
#line 33 "../common/interaction.vala"
		self->priv->_parent = value;
#line 33 "../common/interaction.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_interaction_properties[SEAHORSE_INTERACTION_PARENT_PROPERTY]);
#line 270 "interaction.c"
	}
}

static void
seahorse_interaction_class_init (SeahorseInteractionClass * klass,
                                 gpointer klass_data)
{
#line 28 "../common/interaction.vala"
	seahorse_interaction_parent_class = g_type_class_peek_parent (klass);
#line 28 "../common/interaction.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseInteraction_private_offset);
#line 28 "../common/interaction.vala"
	((GTlsInteractionClass *) klass)->ask_password = (GTlsInteractionResult (*) (GTlsInteraction*, GTlsPassword*, GCancellable*, GError**)) seahorse_interaction_real_ask_password;
#line 28 "../common/interaction.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_interaction_get_property;
#line 28 "../common/interaction.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_interaction_set_property;
#line 28 "../common/interaction.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_interaction_finalize;
#line 290 "interaction.c"
	/**
	     * The parent window
	     */
#line 28 "../common/interaction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_INTERACTION_PARENT_PROPERTY, seahorse_interaction_properties[SEAHORSE_INTERACTION_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 296 "interaction.c"
}

static void
seahorse_interaction_instance_init (SeahorseInteraction * self,
                                    gpointer klass)
{
#line 28 "../common/interaction.vala"
	self->priv = seahorse_interaction_get_instance_private (self);
#line 305 "interaction.c"
}

static void
seahorse_interaction_finalize (GObject * obj)
{
	SeahorseInteraction * self;
#line 28 "../common/interaction.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_INTERACTION, SeahorseInteraction);
#line 28 "../common/interaction.vala"
	G_OBJECT_CLASS (seahorse_interaction_parent_class)->finalize (obj);
#line 316 "interaction.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_interaction_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseInteractionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_interaction_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseInteraction), 0, (GInstanceInitFunc) seahorse_interaction_instance_init, NULL };
	GType seahorse_interaction_type_id;
	seahorse_interaction_type_id = g_type_register_static (g_tls_interaction_get_type (), "SeahorseInteraction", &g_define_type_info, 0);
	SeahorseInteraction_private_offset = g_type_add_instance_private (seahorse_interaction_type_id, sizeof (SeahorseInteractionPrivate));
	return seahorse_interaction_type_id;
}

GType
seahorse_interaction_get_type (void)
{
	static volatile gsize seahorse_interaction_type_id__once = 0;
	if (g_once_init_enter (&seahorse_interaction_type_id__once)) {
		GType seahorse_interaction_type_id;
		seahorse_interaction_type_id = seahorse_interaction_get_type_once ();
		g_once_init_leave (&seahorse_interaction_type_id__once, seahorse_interaction_type_id);
	}
	return seahorse_interaction_type_id__once;
}

static void
_vala_seahorse_interaction_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	SeahorseInteraction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_INTERACTION, SeahorseInteraction);
#line 28 "../common/interaction.vala"
	switch (property_id) {
#line 28 "../common/interaction.vala"
		case SEAHORSE_INTERACTION_PARENT_PROPERTY:
#line 28 "../common/interaction.vala"
		g_value_set_object (value, seahorse_interaction_get_parent (self));
#line 28 "../common/interaction.vala"
		break;
#line 357 "interaction.c"
		default:
#line 28 "../common/interaction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../common/interaction.vala"
		break;
#line 363 "interaction.c"
	}
}

static void
_vala_seahorse_interaction_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	SeahorseInteraction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_INTERACTION, SeahorseInteraction);
#line 28 "../common/interaction.vala"
	switch (property_id) {
#line 28 "../common/interaction.vala"
		case SEAHORSE_INTERACTION_PARENT_PROPERTY:
#line 28 "../common/interaction.vala"
		seahorse_interaction_set_parent (self, g_value_get_object (value));
#line 28 "../common/interaction.vala"
		break;
#line 383 "interaction.c"
		default:
#line 28 "../common/interaction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../common/interaction.vala"
		break;
#line 389 "interaction.c"
	}
}

