/* item-list.c generated by valac 0.56.11, the Vala compiler
 * generated from item-list.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2019 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <gcr/gcr-base.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	SEAHORSE_ITEM_LIST_0_PROPERTY,
	SEAHORSE_ITEM_LIST_BASE_COLLECTION_PROPERTY,
	SEAHORSE_ITEM_LIST_SHOWFILTER_PROPERTY,
	SEAHORSE_ITEM_LIST_FILTER_TEXT_PROPERTY,
	SEAHORSE_ITEM_LIST_NUM_PROPERTIES
};
static GParamSpec* seahorse_item_list_properties[SEAHORSE_ITEM_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block6Data Block6Data;

struct _SeahorseItemListPrivate {
	GcrCollection* _base_collection;
	GPtrArray* items;
	SeahorseItemListShowFilter _showfilter;
	gchar* _filter_text;
};

struct _Block6Data {
	int _ref_count_;
	GPtrArray* self;
	GCompareFunc compare_func;
};

static gint SeahorseItemList_private_offset;
static gpointer seahorse_item_list_parent_class = NULL;
static GListModelInterface * seahorse_item_list_g_list_model_parent_iface = NULL;

static void _g_object_unref0_ (gpointer var);
static void seahorse_item_list_set_base_collection (SeahorseItemList* self,
                                             GcrCollection* value);
static void seahorse_item_list_on_collection_item_added (SeahorseItemList* self,
                                                  GObject* object);
static void _seahorse_item_list_on_collection_item_added_gcr_collection_added (GcrCollection* _sender,
                                                                        GObject* object,
                                                                        gpointer self);
static void seahorse_item_list_on_collection_item_removed (SeahorseItemList* self,
                                                    GObject* object);
static void _seahorse_item_list_on_collection_item_removed_gcr_collection_removed (GcrCollection* _sender,
                                                                            GObject* object,
                                                                            gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gint ___lambda0__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static gint seahorse_item_list_compare_items (GObject* gobj_a,
                                       GObject* gobj_b);
static gint _seahorse_item_list_compare_items_gcompare_func (gconstpointer a,
                                                      gconstpointer b);
static gboolean seahorse_item_list_item_matches_filters (SeahorseItemList* self,
                                                  GObject* object);
static gboolean seahorse_item_list_matches_showfilter (SeahorseItemList* self,
                                                GObject* obj);
static gboolean seahorse_item_list_object_contains_filtered_text (SeahorseItemList* self,
                                                           GObject* object,
                                                           const gchar* text);
static gint seahorse_item_list_compare_labels (const gchar* a_label,
                                        const gchar* b_label);
static GObject* seahorse_item_list_real_get_item (GListModel* base,
                                           guint position);
static GType seahorse_item_list_real_get_item_type (GListModel* base);
static guint seahorse_item_list_real_get_n_items (GListModel* base);
static void seahorse_item_list_finalize (GObject * obj);
static GType seahorse_item_list_get_type_once (void);
static void _vala_seahorse_item_list_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_seahorse_item_list_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
seahorse_item_list_get_instance_private (SeahorseItemList* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseItemList_private_offset);
}

const gchar*
seahorse_item_list_show_filter_to_string (SeahorseItemListShowFilter self)
{
	const gchar* result;
#line 45 "../common/item-list.vala"
	switch (self) {
#line 45 "../common/item-list.vala"
		case SEAHORSE_ITEM_LIST_SHOW_FILTER_ANY:
#line 123 "item-list.c"
		{
#line 47 "../common/item-list.vala"
			result = "";
#line 47 "../common/item-list.vala"
			return result;
#line 129 "item-list.c"
		}
#line 45 "../common/item-list.vala"
		case SEAHORSE_ITEM_LIST_SHOW_FILTER_PERSONAL:
#line 133 "item-list.c"
		{
#line 49 "../common/item-list.vala"
			result = "personal";
#line 49 "../common/item-list.vala"
			return result;
#line 139 "item-list.c"
		}
#line 45 "../common/item-list.vala"
		case SEAHORSE_ITEM_LIST_SHOW_FILTER_TRUSTED:
#line 143 "item-list.c"
		{
#line 51 "../common/item-list.vala"
			result = "trusted";
#line 51 "../common/item-list.vala"
			return result;
#line 149 "item-list.c"
		}
		default:
		{
#line 53 "../common/item-list.vala"
			g_assert_not_reached ();
#line 155 "item-list.c"
		}
	}
}

SeahorseItemListShowFilter
seahorse_item_list_show_filter_from_string (const gchar* str)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 58 "../common/item-list.vala"
	static GQuark _tmp1_label0 = 0;
#line 58 "../common/item-list.vala"
	static GQuark _tmp1_label1 = 0;
#line 58 "../common/item-list.vala"
	static GQuark _tmp1_label2 = 0;
#line 58 "../common/item-list.vala"
	static GQuark _tmp1_label3 = 0;
#line 58 "../common/item-list.vala"
	static GQuark _tmp1_label4 = 0;
#line 175 "item-list.c"
	SeahorseItemListShowFilter result;
#line 58 "../common/item-list.vala"
	_tmp0_ = str;
#line 58 "../common/item-list.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 58 "../common/item-list.vala"
	if (((_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string (NULL)))) || (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string (""))))) || (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("any"))))) {
#line 58 "../common/item-list.vala"
		switch (0) {
#line 185 "item-list.c"
			default:
			{
#line 62 "../common/item-list.vala"
				result = SEAHORSE_ITEM_LIST_SHOW_FILTER_ANY;
#line 62 "../common/item-list.vala"
				return result;
#line 192 "item-list.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("personal")))) {
#line 58 "../common/item-list.vala"
		switch (0) {
#line 198 "item-list.c"
			default:
			{
#line 64 "../common/item-list.vala"
				result = SEAHORSE_ITEM_LIST_SHOW_FILTER_PERSONAL;
#line 64 "../common/item-list.vala"
				return result;
#line 205 "item-list.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("trusted")))) {
#line 58 "../common/item-list.vala"
		switch (0) {
#line 211 "item-list.c"
			default:
			{
#line 66 "../common/item-list.vala"
				result = SEAHORSE_ITEM_LIST_SHOW_FILTER_TRUSTED;
#line 66 "../common/item-list.vala"
				return result;
#line 218 "item-list.c"
			}
		}
	} else {
#line 58 "../common/item-list.vala"
		switch (0) {
#line 224 "item-list.c"
			default:
			{
#line 68 "../common/item-list.vala"
				g_critical ("item-list.vala:68: Got unknown ShowFilter string: %s", str);
#line 69 "../common/item-list.vala"
				g_assert_not_reached ();
#line 231 "item-list.c"
			}
		}
	}
}

 G_GNUC_NO_INLINE static GType
seahorse_item_list_show_filter_get_type_once (void)
{
	static const GEnumValue values[] = {{SEAHORSE_ITEM_LIST_SHOW_FILTER_ANY, "SEAHORSE_ITEM_LIST_SHOW_FILTER_ANY", "any"}, {SEAHORSE_ITEM_LIST_SHOW_FILTER_PERSONAL, "SEAHORSE_ITEM_LIST_SHOW_FILTER_PERSONAL", "personal"}, {SEAHORSE_ITEM_LIST_SHOW_FILTER_TRUSTED, "SEAHORSE_ITEM_LIST_SHOW_FILTER_TRUSTED", "trusted"}, {0, NULL, NULL}};
	GType seahorse_item_list_show_filter_type_id;
	seahorse_item_list_show_filter_type_id = g_enum_register_static ("SeahorseItemListShowFilter", values);
	return seahorse_item_list_show_filter_type_id;
}

GType
seahorse_item_list_show_filter_get_type (void)
{
	static volatile gsize seahorse_item_list_show_filter_type_id__once = 0;
	if (g_once_init_enter (&seahorse_item_list_show_filter_type_id__once)) {
		GType seahorse_item_list_show_filter_type_id;
		seahorse_item_list_show_filter_type_id = seahorse_item_list_show_filter_get_type_once ();
		g_once_init_leave (&seahorse_item_list_show_filter_type_id__once, seahorse_item_list_show_filter_type_id);
	}
	return seahorse_item_list_show_filter_type_id__once;
}

static void
_g_object_unref0_ (gpointer var)
{
#line 37 "../common/item-list.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 263 "item-list.c"
}

static void
_seahorse_item_list_on_collection_item_added_gcr_collection_added (GcrCollection* _sender,
                                                                   GObject* object,
                                                                   gpointer self)
{
#line 90 "../common/item-list.vala"
	seahorse_item_list_on_collection_item_added ((SeahorseItemList*) self, object);
#line 273 "item-list.c"
}

static void
_seahorse_item_list_on_collection_item_removed_gcr_collection_removed (GcrCollection* _sender,
                                                                       GObject* object,
                                                                       gpointer self)
{
#line 91 "../common/item-list.vala"
	seahorse_item_list_on_collection_item_removed ((SeahorseItemList*) self, object);
#line 283 "item-list.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 95 "../common/item-list.vala"
	return self ? g_object_ref (self) : NULL;
#line 291 "item-list.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 5865 "glib-2.0.vapi"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 5865 "glib-2.0.vapi"
	return _data6_;
#line 301 "item-list.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 5865 "glib-2.0.vapi"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 311 "item-list.c"
		GPtrArray* self;
#line 5865 "glib-2.0.vapi"
		self = _data6_->self;
#line 5865 "glib-2.0.vapi"
		_g_ptr_array_unref0 (self);
#line 5865 "glib-2.0.vapi"
		g_slice_free (Block6Data, _data6_);
#line 319 "item-list.c"
	}
}

static gint
__lambda0_ (Block6Data* _data6_,
            gconstpointer** a,
            gconstpointer** b)
{
	GPtrArray* self;
	gint result;
#line 5866 "glib-2.0.vapi"
	self = _data6_->self;
#line 5867 "glib-2.0.vapi"
	result = _data6_->compare_func ((gconstpointer**) (*a), (gconstpointer**) (*b));
#line 5867 "glib-2.0.vapi"
	return result;
#line 336 "item-list.c"
}

static gint
___lambda0__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda0_ (self, a, b);
#line 5866 "glib-2.0.vapi"
	return result;
#line 348 "item-list.c"
}

static void
vala_g_ptr_array_sort (GPtrArray* self,
                       GCompareFunc compare_func)
{
	Block6Data* _data6_;
#line 5865 "glib-2.0.vapi"
	g_return_if_fail (self != NULL);
#line 5865 "glib-2.0.vapi"
	_data6_ = g_slice_new0 (Block6Data);
#line 5865 "glib-2.0.vapi"
	_data6_->_ref_count_ = 1;
#line 5865 "glib-2.0.vapi"
	_data6_->self = g_ptr_array_ref (self);
#line 5865 "glib-2.0.vapi"
	_data6_->compare_func = compare_func;
#line 5866 "glib-2.0.vapi"
	g_ptr_array_sort_with_data (self, ___lambda0__gcompare_data_func, _data6_);
#line 5865 "glib-2.0.vapi"
	block6_data_unref (_data6_);
#line 5865 "glib-2.0.vapi"
	_data6_ = NULL;
#line 372 "item-list.c"
}

static gint
_seahorse_item_list_compare_items_gcompare_func (gconstpointer a,
                                                 gconstpointer b)
{
	gint result;
	result = seahorse_item_list_compare_items ((GObject*) a, (GObject*) b);
#line 98 "../common/item-list.vala"
	return result;
#line 383 "item-list.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5893 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5894 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5894 "glib-2.0.vapi"
	return result;
#line 396 "item-list.c"
}

SeahorseItemList*
seahorse_item_list_construct (GType object_type,
                              GcrCollection* collection)
{
	SeahorseItemList * self = NULL;
	GList* _tmp0_;
	GPtrArray* _tmp4_;
	GPtrArray* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 86 "../common/item-list.vala"
	g_return_val_if_fail (collection != NULL, NULL);
#line 86 "../common/item-list.vala"
	self = (SeahorseItemList*) g_object_new (object_type, NULL);
#line 87 "../common/item-list.vala"
	seahorse_item_list_set_base_collection (self, collection);
#line 90 "../common/item-list.vala"
	g_signal_connect_object (collection, "added", (GCallback) _seahorse_item_list_on_collection_item_added_gcr_collection_added, self, 0);
#line 91 "../common/item-list.vala"
	g_signal_connect_object (collection, "removed", (GCallback) _seahorse_item_list_on_collection_item_removed_gcr_collection_removed, self, 0);
#line 94 "../common/item-list.vala"
	_tmp0_ = gcr_collection_get_objects (collection);
#line 421 "item-list.c"
	{
		GList* obj_collection = NULL;
		GList* obj_it = NULL;
#line 94 "../common/item-list.vala"
		obj_collection = _tmp0_;
#line 94 "../common/item-list.vala"
		for (obj_it = obj_collection; obj_it != NULL; obj_it = obj_it->next) {
#line 429 "item-list.c"
			GObject* obj = NULL;
#line 94 "../common/item-list.vala"
			obj = (GObject*) obj_it->data;
#line 433 "item-list.c"
			{
				GPtrArray* _tmp1_;
				GObject* _tmp2_;
				GObject* _tmp3_;
#line 95 "../common/item-list.vala"
				_tmp1_ = self->priv->items;
#line 95 "../common/item-list.vala"
				_tmp2_ = obj;
#line 95 "../common/item-list.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 95 "../common/item-list.vala"
				g_ptr_array_add (_tmp1_, _tmp3_);
#line 446 "item-list.c"
			}
		}
#line 94 "../common/item-list.vala"
		(obj_collection == NULL) ? NULL : (obj_collection = (g_list_free (obj_collection), NULL));
#line 451 "item-list.c"
	}
#line 98 "../common/item-list.vala"
	_tmp4_ = self->priv->items;
#line 98 "../common/item-list.vala"
	vala_g_ptr_array_sort (_tmp4_, _seahorse_item_list_compare_items_gcompare_func);
#line 101 "../common/item-list.vala"
	_tmp5_ = self->priv->items;
#line 101 "../common/item-list.vala"
	_tmp6_ = vala_g_ptr_array_get_length (_tmp5_);
#line 101 "../common/item-list.vala"
	_tmp7_ = _tmp6_;
#line 101 "../common/item-list.vala"
	g_list_model_items_changed ((GListModel*) self, (guint) 0, (guint) 0, (guint) _tmp7_);
#line 86 "../common/item-list.vala"
	return self;
#line 467 "item-list.c"
}

SeahorseItemList*
seahorse_item_list_new (GcrCollection* collection)
{
#line 86 "../common/item-list.vala"
	return seahorse_item_list_construct (SEAHORSE_TYPE_ITEM_LIST, collection);
#line 475 "item-list.c"
}

static void
seahorse_item_list_on_collection_item_added (SeahorseItemList* self,
                                             GObject* object)
{
	gint index = 0;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GPtrArray* _tmp10_;
	GObject* _tmp11_;
#line 104 "../common/item-list.vala"
	g_return_if_fail (self != NULL);
#line 104 "../common/item-list.vala"
	g_return_if_fail (object != NULL);
#line 106 "../common/item-list.vala"
	if (!seahorse_item_list_item_matches_filters (self, object)) {
#line 107 "../common/item-list.vala"
		return;
#line 496 "item-list.c"
	}
#line 109 "../common/item-list.vala"
	_tmp0_ = self->priv->items;
#line 109 "../common/item-list.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 109 "../common/item-list.vala"
	_tmp2_ = _tmp1_;
#line 109 "../common/item-list.vala"
	index = _tmp2_;
#line 506 "item-list.c"
	{
		gint i = 0;
#line 110 "../common/item-list.vala"
		i = 0;
#line 511 "item-list.c"
		{
			gboolean _tmp3_ = FALSE;
#line 110 "../common/item-list.vala"
			_tmp3_ = TRUE;
#line 110 "../common/item-list.vala"
			while (TRUE) {
#line 518 "item-list.c"
				GPtrArray* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				GPtrArray* _tmp8_;
				gconstpointer _tmp9_;
#line 110 "../common/item-list.vala"
				if (!_tmp3_) {
#line 526 "item-list.c"
					gint _tmp4_;
#line 110 "../common/item-list.vala"
					_tmp4_ = i;
#line 110 "../common/item-list.vala"
					i = _tmp4_ + 1;
#line 532 "item-list.c"
				}
#line 110 "../common/item-list.vala"
				_tmp3_ = FALSE;
#line 110 "../common/item-list.vala"
				_tmp5_ = self->priv->items;
#line 110 "../common/item-list.vala"
				_tmp6_ = vala_g_ptr_array_get_length (_tmp5_);
#line 110 "../common/item-list.vala"
				_tmp7_ = _tmp6_;
#line 110 "../common/item-list.vala"
				if (!(i < _tmp7_)) {
#line 110 "../common/item-list.vala"
					break;
#line 546 "item-list.c"
				}
#line 111 "../common/item-list.vala"
				_tmp8_ = self->priv->items;
#line 111 "../common/item-list.vala"
				_tmp9_ = g_ptr_array_index (_tmp8_, (guint) i);
#line 111 "../common/item-list.vala"
				if (seahorse_item_list_compare_items (object, (GObject*) _tmp9_) < 0) {
#line 112 "../common/item-list.vala"
					index = i;
#line 113 "../common/item-list.vala"
					break;
#line 558 "item-list.c"
				}
			}
		}
	}
#line 116 "../common/item-list.vala"
	_tmp10_ = self->priv->items;
#line 116 "../common/item-list.vala"
	_tmp11_ = _g_object_ref0 (object);
#line 116 "../common/item-list.vala"
	g_ptr_array_insert (_tmp10_, index, _tmp11_);
#line 117 "../common/item-list.vala"
	g_list_model_items_changed ((GListModel*) self, (guint) index, (guint) 0, (guint) 1);
#line 571 "item-list.c"
}

static void
seahorse_item_list_on_collection_item_removed (SeahorseItemList* self,
                                               GObject* object)
{
	guint index = 0U;
	GPtrArray* _tmp0_;
	guint _tmp1_ = 0U;
	gboolean _tmp2_;
#line 120 "../common/item-list.vala"
	g_return_if_fail (self != NULL);
#line 120 "../common/item-list.vala"
	g_return_if_fail (object != NULL);
#line 122 "../common/item-list.vala"
	_tmp0_ = self->priv->items;
#line 122 "../common/item-list.vala"
	_tmp2_ = g_ptr_array_find (_tmp0_, object, &_tmp1_);
#line 122 "../common/item-list.vala"
	index = _tmp1_;
#line 122 "../common/item-list.vala"
	if (_tmp2_) {
#line 594 "item-list.c"
		GPtrArray* _tmp3_;
#line 123 "../common/item-list.vala"
		_tmp3_ = self->priv->items;
#line 123 "../common/item-list.vala"
		g_ptr_array_remove_index (_tmp3_, index);
#line 124 "../common/item-list.vala"
		g_list_model_items_changed ((GListModel*) self, index, (guint) 1, (guint) 0);
#line 602 "item-list.c"
	}
}

static gboolean
seahorse_item_list_item_matches_filters (SeahorseItemList* self,
                                         GObject* object)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 128 "../common/item-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 128 "../common/item-list.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 129 "../common/item-list.vala"
	if (seahorse_item_list_matches_showfilter (self, object)) {
#line 618 "item-list.c"
		const gchar* _tmp1_;
#line 130 "../common/item-list.vala"
		_tmp1_ = self->priv->_filter_text;
#line 130 "../common/item-list.vala"
		_tmp0_ = seahorse_item_list_object_contains_filtered_text (self, object, _tmp1_);
#line 624 "item-list.c"
	} else {
#line 129 "../common/item-list.vala"
		_tmp0_ = FALSE;
#line 628 "item-list.c"
	}
#line 129 "../common/item-list.vala"
	result = _tmp0_;
#line 129 "../common/item-list.vala"
	return result;
#line 634 "item-list.c"
}

static gboolean
seahorse_item_list_matches_showfilter (SeahorseItemList* self,
                                       GObject* obj)
{
	SeahorseFlags obj_flags = 0U;
	SeahorseFlags _tmp0_ = 0U;
	SeahorseItemListShowFilter _tmp1_;
	gboolean result;
#line 133 "../common/item-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 134 "../common/item-list.vala"
	obj_flags = SEAHORSE_FLAG_NONE;
#line 135 "../common/item-list.vala"
	g_object_get (obj, "object-flags", &_tmp0_, NULL, NULL);
#line 135 "../common/item-list.vala"
	obj_flags = _tmp0_;
#line 137 "../common/item-list.vala"
	_tmp1_ = self->priv->_showfilter;
#line 137 "../common/item-list.vala"
	switch (_tmp1_) {
#line 137 "../common/item-list.vala"
		case SEAHORSE_ITEM_LIST_SHOW_FILTER_PERSONAL:
#line 659 "item-list.c"
		{
#line 139 "../common/item-list.vala"
			result = (obj_flags & SEAHORSE_FLAG_PERSONAL) == SEAHORSE_FLAG_PERSONAL;
#line 139 "../common/item-list.vala"
			return result;
#line 665 "item-list.c"
		}
#line 137 "../common/item-list.vala"
		case SEAHORSE_ITEM_LIST_SHOW_FILTER_TRUSTED:
#line 669 "item-list.c"
		{
#line 141 "../common/item-list.vala"
			result = (obj_flags & SEAHORSE_FLAG_TRUSTED) == SEAHORSE_FLAG_TRUSTED;
#line 141 "../common/item-list.vala"
			return result;
#line 675 "item-list.c"
		}
#line 137 "../common/item-list.vala"
		case SEAHORSE_ITEM_LIST_SHOW_FILTER_ANY:
#line 679 "item-list.c"
		{
#line 143 "../common/item-list.vala"
			result = TRUE;
#line 143 "../common/item-list.vala"
			return result;
#line 685 "item-list.c"
		}
		default:
#line 137 "../common/item-list.vala"
		break;
#line 690 "item-list.c"
	}
#line 146 "../common/item-list.vala"
	result = FALSE;
#line 146 "../common/item-list.vala"
	return result;
#line 696 "item-list.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 715 "item-list.c"
}

static gboolean
seahorse_item_list_object_contains_filtered_text (SeahorseItemList* self,
                                                  GObject* object,
                                                  const gchar* text)
{
	gboolean _tmp0_ = FALSE;
	gchar* name = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GObjectClass* _tmp7_;
	GParamSpec* _tmp8_;
	gboolean result;
#line 150 "../common/item-list.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 152 "../common/item-list.vala"
	if (text == NULL) {
#line 152 "../common/item-list.vala"
		_tmp0_ = TRUE;
#line 737 "item-list.c"
	} else {
#line 152 "../common/item-list.vala"
		_tmp0_ = g_strcmp0 (text, "") == 0;
#line 741 "item-list.c"
	}
#line 152 "../common/item-list.vala"
	if (_tmp0_) {
#line 153 "../common/item-list.vala"
		result = TRUE;
#line 153 "../common/item-list.vala"
		return result;
#line 749 "item-list.c"
	}
#line 155 "../common/item-list.vala"
	name = NULL;
#line 156 "../common/item-list.vala"
	g_object_get (object, "label", &_tmp1_, NULL, NULL);
#line 156 "../common/item-list.vala"
	_g_free0 (name);
#line 156 "../common/item-list.vala"
	name = _tmp1_;
#line 157 "../common/item-list.vala"
	_tmp3_ = name;
#line 157 "../common/item-list.vala"
	if (_tmp3_ != NULL) {
#line 763 "item-list.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 157 "../common/item-list.vala"
		_tmp4_ = name;
#line 157 "../common/item-list.vala"
		_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
#line 157 "../common/item-list.vala"
		_tmp6_ = _tmp5_;
#line 157 "../common/item-list.vala"
		_tmp2_ = string_contains (_tmp6_, text);
#line 157 "../common/item-list.vala"
		_g_free0 (_tmp6_);
#line 777 "item-list.c"
	} else {
#line 157 "../common/item-list.vala"
		_tmp2_ = FALSE;
#line 781 "item-list.c"
	}
#line 157 "../common/item-list.vala"
	if (_tmp2_) {
#line 158 "../common/item-list.vala"
		result = TRUE;
#line 158 "../common/item-list.vala"
		_g_free0 (name);
#line 158 "../common/item-list.vala"
		return result;
#line 791 "item-list.c"
	}
#line 160 "../common/item-list.vala"
	_tmp7_ = G_OBJECT_GET_CLASS (object);
#line 160 "../common/item-list.vala"
	_tmp8_ = g_object_class_find_property (_tmp7_, "description");
#line 160 "../common/item-list.vala"
	if (_tmp8_ != NULL) {
#line 799 "item-list.c"
		gchar* description = NULL;
		gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
#line 161 "../common/item-list.vala"
		description = NULL;
#line 162 "../common/item-list.vala"
		g_object_get (object, "description", &_tmp9_, NULL, NULL);
#line 162 "../common/item-list.vala"
		_g_free0 (description);
#line 162 "../common/item-list.vala"
		description = _tmp9_;
#line 163 "../common/item-list.vala"
		_tmp11_ = description;
#line 163 "../common/item-list.vala"
		if (_tmp11_ != NULL) {
#line 816 "item-list.c"
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 163 "../common/item-list.vala"
			_tmp12_ = description;
#line 163 "../common/item-list.vala"
			_tmp13_ = g_utf8_strdown (_tmp12_, (gssize) -1);
#line 163 "../common/item-list.vala"
			_tmp14_ = _tmp13_;
#line 163 "../common/item-list.vala"
			_tmp10_ = string_contains (_tmp14_, text);
#line 163 "../common/item-list.vala"
			_g_free0 (_tmp14_);
#line 830 "item-list.c"
		} else {
#line 163 "../common/item-list.vala"
			_tmp10_ = FALSE;
#line 834 "item-list.c"
		}
#line 163 "../common/item-list.vala"
		if (_tmp10_) {
#line 164 "../common/item-list.vala"
			result = TRUE;
#line 164 "../common/item-list.vala"
			_g_free0 (description);
#line 164 "../common/item-list.vala"
			_g_free0 (name);
#line 164 "../common/item-list.vala"
			return result;
#line 846 "item-list.c"
		}
#line 160 "../common/item-list.vala"
		_g_free0 (description);
#line 850 "item-list.c"
	}
#line 167 "../common/item-list.vala"
	result = FALSE;
#line 167 "../common/item-list.vala"
	_g_free0 (name);
#line 167 "../common/item-list.vala"
	return result;
#line 858 "item-list.c"
}

static gint
seahorse_item_list_compare_items (GObject* gobj_a,
                                  GObject* gobj_b)
{
	gchar* a_label = NULL;
	gchar* b_label = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gint result;
#line 170 "../common/item-list.vala"
	g_return_val_if_fail (gobj_a != NULL, 0);
#line 170 "../common/item-list.vala"
	g_return_val_if_fail (gobj_b != NULL, 0);
#line 171 "../common/item-list.vala"
	a_label = NULL;
#line 171 "../common/item-list.vala"
	b_label = NULL;
#line 173 "../common/item-list.vala"
	g_object_get (gobj_a, "label", &_tmp0_, NULL, NULL);
#line 173 "../common/item-list.vala"
	_g_free0 (a_label);
#line 173 "../common/item-list.vala"
	a_label = _tmp0_;
#line 174 "../common/item-list.vala"
	g_object_get (gobj_b, "label", &_tmp1_, NULL, NULL);
#line 174 "../common/item-list.vala"
	_g_free0 (b_label);
#line 174 "../common/item-list.vala"
	b_label = _tmp1_;
#line 177 "../common/item-list.vala"
	_tmp3_ = a_label;
#line 177 "../common/item-list.vala"
	if (_tmp3_ == NULL) {
#line 177 "../common/item-list.vala"
		_tmp2_ = TRUE;
#line 900 "item-list.c"
	} else {
		const gchar* _tmp4_;
#line 177 "../common/item-list.vala"
		_tmp4_ = b_label;
#line 177 "../common/item-list.vala"
		_tmp2_ = _tmp4_ == NULL;
#line 907 "item-list.c"
	}
#line 177 "../common/item-list.vala"
	if (_tmp2_) {
#line 911 "item-list.c"
		gint _tmp5_ = 0;
		const gchar* _tmp6_;
#line 178 "../common/item-list.vala"
		_tmp6_ = a_label;
#line 178 "../common/item-list.vala"
		if (_tmp6_ == NULL) {
#line 178 "../common/item-list.vala"
			_tmp5_ = 1;
#line 920 "item-list.c"
		} else {
#line 178 "../common/item-list.vala"
			_tmp5_ = -1;
#line 924 "item-list.c"
		}
#line 178 "../common/item-list.vala"
		result = _tmp5_;
#line 178 "../common/item-list.vala"
		_g_free0 (b_label);
#line 178 "../common/item-list.vala"
		_g_free0 (a_label);
#line 178 "../common/item-list.vala"
		return result;
#line 934 "item-list.c"
	}
#line 180 "../common/item-list.vala"
	_tmp7_ = a_label;
#line 180 "../common/item-list.vala"
	_tmp8_ = b_label;
#line 180 "../common/item-list.vala"
	result = seahorse_item_list_compare_labels (_tmp7_, _tmp8_);
#line 180 "../common/item-list.vala"
	_g_free0 (b_label);
#line 180 "../common/item-list.vala"
	_g_free0 (a_label);
#line 180 "../common/item-list.vala"
	return result;
#line 948 "item-list.c"
}

static GObject*
seahorse_item_list_real_get_item (GListModel* base,
                                  guint position)
{
	SeahorseItemList * self;
	GPtrArray* _tmp0_;
	gconstpointer _tmp1_;
	GObject* _tmp2_;
	GObject* result;
#line 183 "../common/item-list.vala"
	self = (SeahorseItemList*) base;
#line 184 "../common/item-list.vala"
	_tmp0_ = self->priv->items;
#line 184 "../common/item-list.vala"
	_tmp1_ = g_ptr_array_index (_tmp0_, position);
#line 184 "../common/item-list.vala"
	_tmp2_ = _g_object_ref0 ((GObject*) _tmp1_);
#line 184 "../common/item-list.vala"
	result = _tmp2_;
#line 184 "../common/item-list.vala"
	return result;
#line 972 "item-list.c"
}

static GType
seahorse_item_list_real_get_item_type (GListModel* base)
{
	SeahorseItemList * self;
	GType result;
#line 187 "../common/item-list.vala"
	self = (SeahorseItemList*) base;
#line 188 "../common/item-list.vala"
	result = G_TYPE_OBJECT;
#line 188 "../common/item-list.vala"
	return result;
#line 986 "item-list.c"
}

static guint
seahorse_item_list_real_get_n_items (GListModel* base)
{
	SeahorseItemList * self;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint result;
#line 191 "../common/item-list.vala"
	self = (SeahorseItemList*) base;
#line 192 "../common/item-list.vala"
	_tmp0_ = self->priv->items;
#line 192 "../common/item-list.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 192 "../common/item-list.vala"
	_tmp2_ = _tmp1_;
#line 192 "../common/item-list.vala"
	result = (guint) _tmp2_;
#line 192 "../common/item-list.vala"
	return result;
#line 1009 "item-list.c"
}

/**
     * Updates the collection.
     * Automatically called when you change filter_text to another value
     */
void
seahorse_item_list_refilter (SeahorseItemList* self)
{
	gint len = 0;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GPtrArray* _tmp3_;
	GcrCollection* _tmp4_;
	GList* _tmp5_;
	GPtrArray* _tmp10_;
	GPtrArray* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GPtrArray* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GcrCollection* _tmp17_;
	const gchar* _tmp18_;
#line 199 "../common/item-list.vala"
	g_return_if_fail (self != NULL);
#line 201 "../common/item-list.vala"
	_tmp0_ = self->priv->items;
#line 201 "../common/item-list.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 201 "../common/item-list.vala"
	_tmp2_ = _tmp1_;
#line 201 "../common/item-list.vala"
	len = _tmp2_;
#line 202 "../common/item-list.vala"
	_tmp3_ = self->priv->items;
#line 202 "../common/item-list.vala"
	g_ptr_array_remove_range (_tmp3_, (guint) 0, (guint) len);
#line 205 "../common/item-list.vala"
	_tmp4_ = self->priv->_base_collection;
#line 205 "../common/item-list.vala"
	_tmp5_ = gcr_collection_get_objects (_tmp4_);
#line 1053 "item-list.c"
	{
		GList* obj_collection = NULL;
		GList* obj_it = NULL;
#line 205 "../common/item-list.vala"
		obj_collection = _tmp5_;
#line 205 "../common/item-list.vala"
		for (obj_it = obj_collection; obj_it != NULL; obj_it = obj_it->next) {
#line 1061 "item-list.c"
			GObject* obj = NULL;
#line 205 "../common/item-list.vala"
			obj = (GObject*) obj_it->data;
#line 1065 "item-list.c"
			{
				GObject* _tmp6_;
#line 206 "../common/item-list.vala"
				_tmp6_ = obj;
#line 206 "../common/item-list.vala"
				if (seahorse_item_list_item_matches_filters (self, _tmp6_)) {
#line 1072 "item-list.c"
					GPtrArray* _tmp7_;
					GObject* _tmp8_;
					GObject* _tmp9_;
#line 207 "../common/item-list.vala"
					_tmp7_ = self->priv->items;
#line 207 "../common/item-list.vala"
					_tmp8_ = obj;
#line 207 "../common/item-list.vala"
					_tmp9_ = _g_object_ref0 (_tmp8_);
#line 207 "../common/item-list.vala"
					g_ptr_array_add (_tmp7_, _tmp9_);
#line 1084 "item-list.c"
				}
			}
		}
#line 205 "../common/item-list.vala"
		(obj_collection == NULL) ? NULL : (obj_collection = (g_list_free (obj_collection), NULL));
#line 1090 "item-list.c"
	}
#line 211 "../common/item-list.vala"
	_tmp10_ = self->priv->items;
#line 211 "../common/item-list.vala"
	vala_g_ptr_array_sort (_tmp10_, _seahorse_item_list_compare_items_gcompare_func);
#line 214 "../common/item-list.vala"
	_tmp11_ = self->priv->items;
#line 214 "../common/item-list.vala"
	_tmp12_ = vala_g_ptr_array_get_length (_tmp11_);
#line 214 "../common/item-list.vala"
	_tmp13_ = _tmp12_;
#line 214 "../common/item-list.vala"
	g_list_model_items_changed ((GListModel*) self, (guint) 0, (guint) len, (guint) _tmp13_);
#line 216 "../common/item-list.vala"
	_tmp14_ = self->priv->items;
#line 216 "../common/item-list.vala"
	_tmp15_ = vala_g_ptr_array_get_length (_tmp14_);
#line 216 "../common/item-list.vala"
	_tmp16_ = _tmp15_;
#line 216 "../common/item-list.vala"
	_tmp17_ = self->priv->_base_collection;
#line 216 "../common/item-list.vala"
	_tmp18_ = self->priv->_filter_text;
#line 216 "../common/item-list.vala"
	g_debug ("item-list.vala:216: %u/%u elements visible after refilter on '%s'", (guint) _tmp16_, gcr_collection_get_length (_tmp17_), _tmp18_);
#line 1116 "item-list.c"
}

static gint
seahorse_item_list_compare_labels (const gchar* a_label,
                                   const gchar* b_label)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result;
#line 223 "../common/item-list.vala"
	g_return_val_if_fail (a_label != NULL, 0);
#line 223 "../common/item-list.vala"
	g_return_val_if_fail (b_label != NULL, 0);
#line 224 "../common/item-list.vala"
	_tmp0_ = g_utf8_casefold (a_label, (gssize) -1);
#line 224 "../common/item-list.vala"
	_tmp1_ = _tmp0_;
#line 224 "../common/item-list.vala"
	_tmp2_ = g_utf8_casefold (b_label, (gssize) -1);
#line 224 "../common/item-list.vala"
	_tmp3_ = _tmp2_;
#line 224 "../common/item-list.vala"
	_tmp4_ = g_utf8_collate (_tmp1_, _tmp3_);
#line 224 "../common/item-list.vala"
	_g_free0 (_tmp3_);
#line 224 "../common/item-list.vala"
	_g_free0 (_tmp1_);
#line 224 "../common/item-list.vala"
	result = _tmp4_;
#line 224 "../common/item-list.vala"
	return result;
#line 1151 "item-list.c"
}

GcrCollection*
seahorse_item_list_get_base_collection (SeahorseItemList* self)
{
	GcrCollection* result;
	GcrCollection* _tmp0_;
#line 33 "../common/item-list.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../common/item-list.vala"
	_tmp0_ = self->priv->_base_collection;
#line 33 "../common/item-list.vala"
	result = _tmp0_;
#line 33 "../common/item-list.vala"
	return result;
#line 1167 "item-list.c"
}

static void
seahorse_item_list_set_base_collection (SeahorseItemList* self,
                                        GcrCollection* value)
{
	GcrCollection* old_value;
#line 33 "../common/item-list.vala"
	g_return_if_fail (self != NULL);
#line 33 "../common/item-list.vala"
	old_value = seahorse_item_list_get_base_collection (self);
#line 33 "../common/item-list.vala"
	if (old_value != value) {
#line 1181 "item-list.c"
		GcrCollection* _tmp0_;
#line 33 "../common/item-list.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 33 "../common/item-list.vala"
		_g_object_unref0 (self->priv->_base_collection);
#line 33 "../common/item-list.vala"
		self->priv->_base_collection = _tmp0_;
#line 33 "../common/item-list.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_item_list_properties[SEAHORSE_ITEM_LIST_BASE_COLLECTION_PROPERTY]);
#line 1191 "item-list.c"
	}
}

SeahorseItemListShowFilter
seahorse_item_list_get_showfilter (SeahorseItemList* self)
{
	SeahorseItemListShowFilter result;
#line 74 "../common/item-list.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 74 "../common/item-list.vala"
	result = self->priv->_showfilter;
#line 74 "../common/item-list.vala"
	return result;
#line 1205 "item-list.c"
}

void
seahorse_item_list_set_showfilter (SeahorseItemList* self,
                                   SeahorseItemListShowFilter value)
{
	SeahorseItemListShowFilter old_value;
#line 74 "../common/item-list.vala"
	g_return_if_fail (self != NULL);
#line 74 "../common/item-list.vala"
	old_value = seahorse_item_list_get_showfilter (self);
#line 74 "../common/item-list.vala"
	if (old_value != value) {
#line 74 "../common/item-list.vala"
		self->priv->_showfilter = value;
#line 74 "../common/item-list.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_item_list_properties[SEAHORSE_ITEM_LIST_SHOWFILTER_PROPERTY]);
#line 1223 "item-list.c"
	}
}

void
seahorse_item_list_set_filter_text (SeahorseItemList* self,
                                    const gchar* value)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 78 "../common/item-list.vala"
	g_return_if_fail (self != NULL);
#line 79 "../common/item-list.vala"
	_tmp0_ = self->priv->_filter_text;
#line 79 "../common/item-list.vala"
	if (g_strcmp0 (_tmp0_, value) == 0) {
#line 80 "../common/item-list.vala"
		return;
#line 1241 "item-list.c"
	}
#line 81 "../common/item-list.vala"
	_tmp1_ = g_utf8_casefold (value, (gssize) -1);
#line 81 "../common/item-list.vala"
	_g_free0 (self->priv->_filter_text);
#line 81 "../common/item-list.vala"
	self->priv->_filter_text = _tmp1_;
#line 82 "../common/item-list.vala"
	seahorse_item_list_refilter (self);
#line 78 "../common/item-list.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_item_list_properties[SEAHORSE_ITEM_LIST_FILTER_TEXT_PROPERTY]);
#line 1253 "item-list.c"
}

static void
seahorse_item_list_class_init (SeahorseItemListClass * klass,
                               gpointer klass_data)
{
#line 30 "../common/item-list.vala"
	seahorse_item_list_parent_class = g_type_class_peek_parent (klass);
#line 30 "../common/item-list.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseItemList_private_offset);
#line 30 "../common/item-list.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_item_list_get_property;
#line 30 "../common/item-list.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_item_list_set_property;
#line 30 "../common/item-list.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_item_list_finalize;
#line 1270 "item-list.c"
	/** The basic collection */
#line 30 "../common/item-list.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_ITEM_LIST_BASE_COLLECTION_PROPERTY, seahorse_item_list_properties[SEAHORSE_ITEM_LIST_BASE_COLLECTION_PROPERTY] = g_param_spec_object ("base-collection", "base-collection", "base-collection", gcr_collection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../common/item-list.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_ITEM_LIST_SHOWFILTER_PROPERTY, seahorse_item_list_properties[SEAHORSE_ITEM_LIST_SHOWFILTER_PROPERTY] = g_param_spec_enum ("showfilter", "showfilter", "showfilter", SEAHORSE_ITEM_LIST_TYPE_SHOW_FILTER, SEAHORSE_ITEM_LIST_SHOW_FILTER_ANY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../common/item-list.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_ITEM_LIST_FILTER_TEXT_PROPERTY, seahorse_item_list_properties[SEAHORSE_ITEM_LIST_FILTER_TEXT_PROPERTY] = g_param_spec_string ("filter-text", "filter-text", "filter-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 1278 "item-list.c"
}

static void
seahorse_item_list_g_list_model_interface_init (GListModelInterface * iface,
                                                gpointer iface_data)
{
#line 30 "../common/item-list.vala"
	seahorse_item_list_g_list_model_parent_iface = g_type_interface_peek_parent (iface);
#line 30 "../common/item-list.vala"
	iface->get_item = (GObject* (*) (GListModel*, guint)) seahorse_item_list_real_get_item;
#line 30 "../common/item-list.vala"
	iface->get_item_type = (GType (*) (GListModel*)) seahorse_item_list_real_get_item_type;
#line 30 "../common/item-list.vala"
	iface->get_n_items = (guint (*) (GListModel*)) seahorse_item_list_real_get_n_items;
#line 1293 "item-list.c"
}

static void
seahorse_item_list_instance_init (SeahorseItemList * self,
                                  gpointer klass)
{
	GPtrArray* _tmp0_;
	gchar* _tmp1_;
#line 30 "../common/item-list.vala"
	self->priv = seahorse_item_list_get_instance_private (self);
#line 37 "../common/item-list.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 37 "../common/item-list.vala"
	self->priv->items = _tmp0_;
#line 74 "../common/item-list.vala"
	self->priv->_showfilter = SEAHORSE_ITEM_LIST_SHOW_FILTER_ANY;
#line 76 "../common/item-list.vala"
	_tmp1_ = g_strdup ("");
#line 76 "../common/item-list.vala"
	self->priv->_filter_text = _tmp1_;
#line 1314 "item-list.c"
}

static void
seahorse_item_list_finalize (GObject * obj)
{
	SeahorseItemList * self;
#line 30 "../common/item-list.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_ITEM_LIST, SeahorseItemList);
#line 33 "../common/item-list.vala"
	_g_object_unref0 (self->priv->_base_collection);
#line 37 "../common/item-list.vala"
	_g_ptr_array_unref0 (self->priv->items);
#line 76 "../common/item-list.vala"
	_g_free0 (self->priv->_filter_text);
#line 30 "../common/item-list.vala"
	G_OBJECT_CLASS (seahorse_item_list_parent_class)->finalize (obj);
#line 1331 "item-list.c"
}

/**
 * A ItemList is a {@GLib.ListModel} which knows how to handle
 * {@link Gcr.Collection}s. These basically provide a compatibility wrapper
 * {@link GLib.ListModel}, lists that propagate changes to their listener (such
 * as a {@link Gtk.ListBox}).
 *
 * This list makes an assumption that each iten is a Seahorse.Object, or provides
 * the necessary properties like "label" and possibly "description".
 */
 G_GNUC_NO_INLINE static GType
seahorse_item_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseItemListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_item_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseItemList), 0, (GInstanceInitFunc) seahorse_item_list_instance_init, NULL };
	static const GInterfaceInfo g_list_model_info = { (GInterfaceInitFunc) seahorse_item_list_g_list_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType seahorse_item_list_type_id;
	seahorse_item_list_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorseItemList", &g_define_type_info, 0);
	g_type_add_interface_static (seahorse_item_list_type_id, g_list_model_get_type (), &g_list_model_info);
	SeahorseItemList_private_offset = g_type_add_instance_private (seahorse_item_list_type_id, sizeof (SeahorseItemListPrivate));
	return seahorse_item_list_type_id;
}

GType
seahorse_item_list_get_type (void)
{
	static volatile gsize seahorse_item_list_type_id__once = 0;
	if (g_once_init_enter (&seahorse_item_list_type_id__once)) {
		GType seahorse_item_list_type_id;
		seahorse_item_list_type_id = seahorse_item_list_get_type_once ();
		g_once_init_leave (&seahorse_item_list_type_id__once, seahorse_item_list_type_id);
	}
	return seahorse_item_list_type_id__once;
}

static void
_vala_seahorse_item_list_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	SeahorseItemList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_ITEM_LIST, SeahorseItemList);
#line 30 "../common/item-list.vala"
	switch (property_id) {
#line 30 "../common/item-list.vala"
		case SEAHORSE_ITEM_LIST_BASE_COLLECTION_PROPERTY:
#line 30 "../common/item-list.vala"
		g_value_set_object (value, seahorse_item_list_get_base_collection (self));
#line 30 "../common/item-list.vala"
		break;
#line 30 "../common/item-list.vala"
		case SEAHORSE_ITEM_LIST_SHOWFILTER_PROPERTY:
#line 30 "../common/item-list.vala"
		g_value_set_enum (value, seahorse_item_list_get_showfilter (self));
#line 30 "../common/item-list.vala"
		break;
#line 1389 "item-list.c"
		default:
#line 30 "../common/item-list.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../common/item-list.vala"
		break;
#line 1395 "item-list.c"
	}
}

static void
_vala_seahorse_item_list_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	SeahorseItemList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_ITEM_LIST, SeahorseItemList);
#line 30 "../common/item-list.vala"
	switch (property_id) {
#line 30 "../common/item-list.vala"
		case SEAHORSE_ITEM_LIST_BASE_COLLECTION_PROPERTY:
#line 30 "../common/item-list.vala"
		seahorse_item_list_set_base_collection (self, g_value_get_object (value));
#line 30 "../common/item-list.vala"
		break;
#line 30 "../common/item-list.vala"
		case SEAHORSE_ITEM_LIST_SHOWFILTER_PROPERTY:
#line 30 "../common/item-list.vala"
		seahorse_item_list_set_showfilter (self, g_value_get_enum (value));
#line 30 "../common/item-list.vala"
		break;
#line 30 "../common/item-list.vala"
		case SEAHORSE_ITEM_LIST_FILTER_TEXT_PROPERTY:
#line 30 "../common/item-list.vala"
		seahorse_item_list_set_filter_text (self, g_value_get_string (value));
#line 30 "../common/item-list.vala"
		break;
#line 1427 "item-list.c"
		default:
#line 30 "../common/item-list.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../common/item-list.vala"
		break;
#line 1433 "item-list.c"
	}
}

