/* server-category.c generated by valac 0.56.11, the Vala compiler
 * generated from server-category.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "pgp/seahorse-server-source.h"
#include "pgp/seahorse-ldap-source.h"
#include <glib/gi18n-lib.h>
#include "pgp/seahorse-hkp-source.h"

enum  {
	SEAHORSE_SERVER_CATEGORY_0_PROPERTY,
	SEAHORSE_SERVER_CATEGORY_GTYPE_PROPERTY,
	SEAHORSE_SERVER_CATEGORY_SCHEME_PROPERTY,
	SEAHORSE_SERVER_CATEGORY_DESCRIPTION_PROPERTY,
	SEAHORSE_SERVER_CATEGORY_NUM_PROPERTIES
};
static GParamSpec* seahorse_server_category_properties[SEAHORSE_SERVER_CATEGORY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))

struct _SeahorseServerCategoryPrivate {
	GType _gtype;
	gchar* _scheme;
	gchar* _description;
};

static gint SeahorseServerCategory_private_offset;
static gpointer seahorse_server_category_parent_class = NULL;
static GPtrArray* seahorse_server_category_categories;
static GPtrArray* seahorse_server_category_categories = NULL;

static void _g_object_unref0_ (gpointer var);
static gboolean _seahorse_ldap_is_valid_uri_seahorse_valid_uri_func (const gchar* uri);
static gboolean _seahorse_hkp_is_valid_uri_seahorse_valid_uri_func (const gchar* uri);
static void _vala_array_add9 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void seahorse_server_category_finalize (GObject * obj);
static GType seahorse_server_category_get_type_once (void);
static void _vala_seahorse_server_category_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_seahorse_server_category_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
seahorse_server_category_get_instance_private (SeahorseServerCategory* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseServerCategory_private_offset);
}

SeahorseServerCategory*
seahorse_server_category_construct (GType object_type,
                                    GType gtype,
                                    const gchar* scheme,
                                    const gchar* description,
                                    SeahorseValidUriFunc validator)
{
	SeahorseServerCategory * self = NULL;
#line 42 "../common/server-category.vala"
	g_return_val_if_fail (scheme != NULL, NULL);
#line 42 "../common/server-category.vala"
	g_return_val_if_fail (description != NULL, NULL);
#line 43 "../common/server-category.vala"
	self = (SeahorseServerCategory*) g_object_new (object_type, "gtype", gtype, "scheme", scheme, "description", description, NULL);
#line 46 "../common/server-category.vala"
	self->validator = validator;
#line 42 "../common/server-category.vala"
	return self;
#line 106 "server-category.c"
}

SeahorseServerCategory*
seahorse_server_category_new (GType gtype,
                              const gchar* scheme,
                              const gchar* description,
                              SeahorseValidUriFunc validator)
{
#line 42 "../common/server-category.vala"
	return seahorse_server_category_construct (SEAHORSE_TYPE_SERVER_CATEGORY, gtype, scheme, description, validator);
#line 117 "server-category.c"
}

SeahorseServerSource*
seahorse_server_category_create_server (const gchar* uri)
{
	SeahorseServerCategory* cat = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	SeahorseServerCategory* _tmp2_;
	SeahorseServerCategory* _tmp3_;
	SeahorseServerCategory* _tmp4_;
	SeahorseServerCategory* _tmp7_;
	GType _tmp8_;
	GObject* _tmp9_;
	GObject* _tmp10_;
	SeahorseServerSource* result;
#line 49 "../common/server-category.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 50 "../common/server-category.vala"
	_tmp0_ = g_uri_parse_scheme (uri);
#line 50 "../common/server-category.vala"
	_tmp1_ = _tmp0_;
#line 50 "../common/server-category.vala"
	_tmp2_ = seahorse_server_category_find_category (_tmp1_);
#line 50 "../common/server-category.vala"
	_tmp3_ = _tmp2_;
#line 50 "../common/server-category.vala"
	_g_free0 (_tmp1_);
#line 50 "../common/server-category.vala"
	cat = _tmp3_;
#line 51 "../common/server-category.vala"
	_tmp4_ = cat;
#line 51 "../common/server-category.vala"
	if (_tmp4_ == NULL) {
#line 152 "server-category.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 52 "../common/server-category.vala"
		_tmp5_ = g_uri_parse_scheme (uri);
#line 52 "../common/server-category.vala"
		_tmp6_ = _tmp5_;
#line 52 "../common/server-category.vala"
		g_warning ("server-category.vala:52: Unsupported scheme '%s'", _tmp6_);
#line 52 "../common/server-category.vala"
		_g_free0 (_tmp6_);
#line 53 "../common/server-category.vala"
		result = NULL;
#line 53 "../common/server-category.vala"
		return result;
#line 167 "server-category.c"
	}
#line 56 "../common/server-category.vala"
	_tmp7_ = cat;
#line 56 "../common/server-category.vala"
	_tmp8_ = _tmp7_->priv->_gtype;
#line 56 "../common/server-category.vala"
	_tmp9_ = g_object_new (_tmp8_, "uri", uri, NULL);
#line 56 "../common/server-category.vala"
	_tmp10_ = G_IS_INITIALLY_UNOWNED (_tmp9_) ? g_object_ref_sink (_tmp9_) : _tmp9_;
#line 56 "../common/server-category.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, SEAHORSE_TYPE_SERVER_SOURCE, SeahorseServerSource);
#line 56 "../common/server-category.vala"
	return result;
#line 181 "server-category.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 60 "../common/server-category.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 189 "server-category.c"
}

static gboolean
_seahorse_ldap_is_valid_uri_seahorse_valid_uri_func (const gchar* uri)
{
	gboolean result;
	result = seahorse_ldap_is_valid_uri (uri);
#line 63 "../common/server-category.vala"
	return result;
#line 199 "server-category.c"
}

static gboolean
_seahorse_hkp_is_valid_uri_seahorse_valid_uri_func (const gchar* uri)
{
	gboolean result;
	result = seahorse_hkp_is_valid_uri (uri);
#line 66 "../common/server-category.vala"
	return result;
#line 209 "server-category.c"
}

void
seahorse_server_category_init (void)
{
	GPtrArray* _tmp0_;
	GPtrArray* _tmp1_;
	SeahorseServerCategory* _tmp2_;
	GPtrArray* _tmp3_;
	SeahorseServerCategory* _tmp4_;
	GPtrArray* _tmp5_;
	SeahorseServerCategory* _tmp6_;
#line 60 "../common/server-category.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 60 "../common/server-category.vala"
	_g_ptr_array_unref0 (seahorse_server_category_categories);
#line 60 "../common/server-category.vala"
	seahorse_server_category_categories = _tmp0_;
#line 63 "../common/server-category.vala"
	_tmp1_ = seahorse_server_category_categories;
#line 63 "../common/server-category.vala"
	_tmp2_ = seahorse_server_category_new (SEAHORSE_TYPE_LDAP_SOURCE, "ldap", _ ("LDAP Key Server"), _seahorse_ldap_is_valid_uri_seahorse_valid_uri_func);
#line 63 "../common/server-category.vala"
	g_ptr_array_add (_tmp1_, _tmp2_);
#line 66 "../common/server-category.vala"
	_tmp3_ = seahorse_server_category_categories;
#line 66 "../common/server-category.vala"
	_tmp4_ = seahorse_server_category_new (SEAHORSE_TYPE_HKP_SOURCE, "hkp", _ ("HTTP Key Server"), _seahorse_hkp_is_valid_uri_seahorse_valid_uri_func);
#line 66 "../common/server-category.vala"
	g_ptr_array_add (_tmp3_, _tmp4_);
#line 67 "../common/server-category.vala"
	_tmp5_ = seahorse_server_category_categories;
#line 67 "../common/server-category.vala"
	_tmp6_ = seahorse_server_category_new (SEAHORSE_TYPE_HKP_SOURCE, "hkps", _ ("HTTPS Key Server"), _seahorse_hkp_is_valid_uri_seahorse_valid_uri_func);
#line 67 "../common/server-category.vala"
	g_ptr_array_add (_tmp5_, _tmp6_);
#line 246 "server-category.c"
}

/**
     * Returns a null-terminated string array of supported schemes
     */
static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5893 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5894 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5894 "glib-2.0.vapi"
	return result;
#line 262 "server-category.c"
}

static void
_vala_array_add9 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 79 "../common/server-category.vala"
	if ((*length) == (*size)) {
#line 79 "../common/server-category.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 79 "../common/server-category.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 277 "server-category.c"
	}
#line 79 "../common/server-category.vala"
	(*array)[(*length)++] = value;
#line 79 "../common/server-category.vala"
	(*array)[*length] = NULL;
#line 283 "server-category.c"
}

gchar**
seahorse_server_category_get_types (void)
{
	gchar** types = NULL;
	gchar** _tmp0_;
	gint types_length1;
	gint _types_size_;
	gchar** result;
#line 76 "../common/server-category.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 76 "../common/server-category.vala"
	types = _tmp0_;
#line 76 "../common/server-category.vala"
	types_length1 = 0;
#line 76 "../common/server-category.vala"
	_types_size_ = types_length1;
#line 302 "server-category.c"
	{
		guint i = 0U;
#line 78 "../common/server-category.vala"
		i = (guint) 0;
#line 307 "server-category.c"
		{
			gboolean _tmp1_ = FALSE;
#line 78 "../common/server-category.vala"
			_tmp1_ = TRUE;
#line 78 "../common/server-category.vala"
			while (TRUE) {
#line 314 "server-category.c"
				GPtrArray* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				GPtrArray* _tmp6_;
				gconstpointer _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
#line 78 "../common/server-category.vala"
				if (!_tmp1_) {
#line 324 "server-category.c"
					guint _tmp2_;
#line 78 "../common/server-category.vala"
					_tmp2_ = i;
#line 78 "../common/server-category.vala"
					i = _tmp2_ + 1;
#line 330 "server-category.c"
				}
#line 78 "../common/server-category.vala"
				_tmp1_ = FALSE;
#line 78 "../common/server-category.vala"
				_tmp3_ = seahorse_server_category_categories;
#line 78 "../common/server-category.vala"
				_tmp4_ = vala_g_ptr_array_get_length (_tmp3_);
#line 78 "../common/server-category.vala"
				_tmp5_ = _tmp4_;
#line 78 "../common/server-category.vala"
				if (!(i < ((guint) _tmp5_))) {
#line 78 "../common/server-category.vala"
					break;
#line 344 "server-category.c"
				}
#line 79 "../common/server-category.vala"
				_tmp6_ = seahorse_server_category_categories;
#line 79 "../common/server-category.vala"
				_tmp7_ = g_ptr_array_index (_tmp6_, i);
#line 79 "../common/server-category.vala"
				_tmp8_ = ((SeahorseServerCategory*) _tmp7_)->priv->_scheme;
#line 79 "../common/server-category.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 79 "../common/server-category.vala"
				_vala_array_add9 (&types, &types_length1, &_types_size_, _tmp9_);
#line 356 "server-category.c"
			}
		}
	}
#line 81 "../common/server-category.vala"
	result = types;
#line 81 "../common/server-category.vala"
	return result;
#line 364 "server-category.c"
}

SeahorseServerCategory*
seahorse_server_category_find_category (const gchar* scheme)
{
	SeahorseServerCategory* result;
	{
		guint i = 0U;
#line 85 "../common/server-category.vala"
		i = (guint) 0;
#line 375 "server-category.c"
		{
			gboolean _tmp0_ = FALSE;
#line 85 "../common/server-category.vala"
			_tmp0_ = TRUE;
#line 85 "../common/server-category.vala"
			while (TRUE) {
#line 382 "server-category.c"
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
				const gchar* _tmp7_;
#line 85 "../common/server-category.vala"
				if (!_tmp0_) {
#line 391 "server-category.c"
					guint _tmp1_;
#line 85 "../common/server-category.vala"
					_tmp1_ = i;
#line 85 "../common/server-category.vala"
					i = _tmp1_ + 1;
#line 397 "server-category.c"
				}
#line 85 "../common/server-category.vala"
				_tmp0_ = FALSE;
#line 85 "../common/server-category.vala"
				_tmp2_ = seahorse_server_category_categories;
#line 85 "../common/server-category.vala"
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
#line 85 "../common/server-category.vala"
				_tmp4_ = _tmp3_;
#line 85 "../common/server-category.vala"
				if (!(i < ((guint) _tmp4_))) {
#line 85 "../common/server-category.vala"
					break;
#line 411 "server-category.c"
				}
#line 86 "../common/server-category.vala"
				_tmp5_ = seahorse_server_category_categories;
#line 86 "../common/server-category.vala"
				_tmp6_ = g_ptr_array_index (_tmp5_, i);
#line 86 "../common/server-category.vala"
				_tmp7_ = ((SeahorseServerCategory*) _tmp6_)->priv->_scheme;
#line 86 "../common/server-category.vala"
				if (g_strcmp0 (scheme, _tmp7_) == 0) {
#line 421 "server-category.c"
					GPtrArray* _tmp8_;
					gconstpointer _tmp9_;
#line 87 "../common/server-category.vala"
					_tmp8_ = seahorse_server_category_categories;
#line 87 "../common/server-category.vala"
					_tmp9_ = g_ptr_array_index (_tmp8_, i);
#line 87 "../common/server-category.vala"
					result = (SeahorseServerCategory*) _tmp9_;
#line 87 "../common/server-category.vala"
					return result;
#line 432 "server-category.c"
				}
			}
		}
	}
#line 90 "../common/server-category.vala"
	result = NULL;
#line 90 "../common/server-category.vala"
	return result;
#line 441 "server-category.c"
}

/**
     * Checks to see if the passed uri is valid against registered validators
     */
gboolean
seahorse_server_category_is_valid_uri (const gchar* uri)
{
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result;
#line 96 "../common/server-category.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 97 "../common/server-category.vala"
	_tmp1_ = _tmp0_ = g_strsplit (uri, ":", 2);
#line 97 "../common/server-category.vala"
	parts = _tmp1_;
#line 97 "../common/server-category.vala"
	parts_length1 = _vala_array_length (_tmp0_);
#line 97 "../common/server-category.vala"
	_parts_size_ = parts_length1;
#line 98 "../common/server-category.vala"
	_tmp2_ = parts;
#line 98 "../common/server-category.vala"
	_tmp2__length1 = parts_length1;
#line 98 "../common/server-category.vala"
	if (_tmp2__length1 <= 0) {
#line 99 "../common/server-category.vala"
		result = FALSE;
#line 99 "../common/server-category.vala"
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 99 "../common/server-category.vala"
		return result;
#line 480 "server-category.c"
	}
	{
		guint i = 0U;
#line 101 "../common/server-category.vala"
		i = (guint) 0;
#line 486 "server-category.c"
		{
			gboolean _tmp3_ = FALSE;
#line 101 "../common/server-category.vala"
			_tmp3_ = TRUE;
#line 101 "../common/server-category.vala"
			while (TRUE) {
#line 493 "server-category.c"
				GPtrArray* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gboolean _tmp8_ = FALSE;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
				GPtrArray* _tmp11_;
				gconstpointer _tmp12_;
				const gchar* _tmp13_;
#line 101 "../common/server-category.vala"
				if (!_tmp3_) {
#line 506 "server-category.c"
					guint _tmp4_;
#line 101 "../common/server-category.vala"
					_tmp4_ = i;
#line 101 "../common/server-category.vala"
					i = _tmp4_ + 1;
#line 512 "server-category.c"
				}
#line 101 "../common/server-category.vala"
				_tmp3_ = FALSE;
#line 101 "../common/server-category.vala"
				_tmp5_ = seahorse_server_category_categories;
#line 101 "../common/server-category.vala"
				_tmp6_ = vala_g_ptr_array_get_length (_tmp5_);
#line 101 "../common/server-category.vala"
				_tmp7_ = _tmp6_;
#line 101 "../common/server-category.vala"
				if (!(i < ((guint) _tmp7_))) {
#line 101 "../common/server-category.vala"
					break;
#line 526 "server-category.c"
				}
#line 102 "../common/server-category.vala"
				_tmp9_ = parts;
#line 102 "../common/server-category.vala"
				_tmp9__length1 = parts_length1;
#line 102 "../common/server-category.vala"
				_tmp10_ = _tmp9_[0];
#line 102 "../common/server-category.vala"
				_tmp11_ = seahorse_server_category_categories;
#line 102 "../common/server-category.vala"
				_tmp12_ = g_ptr_array_index (_tmp11_, i);
#line 102 "../common/server-category.vala"
				_tmp13_ = ((SeahorseServerCategory*) _tmp12_)->priv->_scheme;
#line 102 "../common/server-category.vala"
				if (g_strcmp0 (_tmp10_, _tmp13_) == 0) {
#line 542 "server-category.c"
					GPtrArray* _tmp14_;
					gconstpointer _tmp15_;
					SeahorseValidUriFunc _tmp16_;
#line 102 "../common/server-category.vala"
					_tmp14_ = seahorse_server_category_categories;
#line 102 "../common/server-category.vala"
					_tmp15_ = g_ptr_array_index (_tmp14_, i);
#line 102 "../common/server-category.vala"
					_tmp16_ = ((SeahorseServerCategory*) _tmp15_)->validator;
#line 102 "../common/server-category.vala"
					_tmp8_ = _tmp16_ (uri);
#line 554 "server-category.c"
				} else {
#line 102 "../common/server-category.vala"
					_tmp8_ = FALSE;
#line 558 "server-category.c"
				}
#line 102 "../common/server-category.vala"
				if (_tmp8_) {
#line 103 "../common/server-category.vala"
					result = TRUE;
#line 103 "../common/server-category.vala"
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 103 "../common/server-category.vala"
					return result;
#line 568 "server-category.c"
				}
			}
		}
	}
#line 106 "../common/server-category.vala"
	result = FALSE;
#line 106 "../common/server-category.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 106 "../common/server-category.vala"
	return result;
#line 579 "server-category.c"
}

GType
seahorse_server_category_get_gtype (SeahorseServerCategory* self)
{
	GType result;
#line 29 "../common/server-category.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 29 "../common/server-category.vala"
	result = self->priv->_gtype;
#line 29 "../common/server-category.vala"
	return result;
#line 592 "server-category.c"
}

static void
seahorse_server_category_set_gtype (SeahorseServerCategory* self,
                                    GType value)
{
	GType old_value;
#line 29 "../common/server-category.vala"
	g_return_if_fail (self != NULL);
#line 29 "../common/server-category.vala"
	old_value = seahorse_server_category_get_gtype (self);
#line 29 "../common/server-category.vala"
	if (old_value != value) {
#line 29 "../common/server-category.vala"
		self->priv->_gtype = value;
#line 29 "../common/server-category.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_server_category_properties[SEAHORSE_SERVER_CATEGORY_GTYPE_PROPERTY]);
#line 610 "server-category.c"
	}
}

const gchar*
seahorse_server_category_get_scheme (SeahorseServerCategory* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../common/server-category.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../common/server-category.vala"
	_tmp0_ = self->priv->_scheme;
#line 32 "../common/server-category.vala"
	result = _tmp0_;
#line 32 "../common/server-category.vala"
	return result;
#line 627 "server-category.c"
}

static void
seahorse_server_category_set_scheme (SeahorseServerCategory* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 32 "../common/server-category.vala"
	g_return_if_fail (self != NULL);
#line 32 "../common/server-category.vala"
	old_value = seahorse_server_category_get_scheme (self);
#line 32 "../common/server-category.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 641 "server-category.c"
		gchar* _tmp0_;
#line 32 "../common/server-category.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../common/server-category.vala"
		_g_free0 (self->priv->_scheme);
#line 32 "../common/server-category.vala"
		self->priv->_scheme = _tmp0_;
#line 32 "../common/server-category.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_server_category_properties[SEAHORSE_SERVER_CATEGORY_SCHEME_PROPERTY]);
#line 651 "server-category.c"
	}
}

const gchar*
seahorse_server_category_get_description (SeahorseServerCategory* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../common/server-category.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../common/server-category.vala"
	_tmp0_ = self->priv->_description;
#line 35 "../common/server-category.vala"
	result = _tmp0_;
#line 35 "../common/server-category.vala"
	return result;
#line 668 "server-category.c"
}

static void
seahorse_server_category_set_description (SeahorseServerCategory* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 35 "../common/server-category.vala"
	g_return_if_fail (self != NULL);
#line 35 "../common/server-category.vala"
	old_value = seahorse_server_category_get_description (self);
#line 35 "../common/server-category.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 682 "server-category.c"
		gchar* _tmp0_;
#line 35 "../common/server-category.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../common/server-category.vala"
		_g_free0 (self->priv->_description);
#line 35 "../common/server-category.vala"
		self->priv->_description = _tmp0_;
#line 35 "../common/server-category.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_server_category_properties[SEAHORSE_SERVER_CATEGORY_DESCRIPTION_PROPERTY]);
#line 692 "server-category.c"
	}
}

static void
seahorse_server_category_class_init (SeahorseServerCategoryClass * klass,
                                     gpointer klass_data)
{
#line 24 "../common/server-category.vala"
	seahorse_server_category_parent_class = g_type_class_peek_parent (klass);
#line 24 "../common/server-category.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseServerCategory_private_offset);
#line 24 "../common/server-category.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_server_category_get_property;
#line 24 "../common/server-category.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_server_category_set_property;
#line 24 "../common/server-category.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_server_category_finalize;
#line 710 "server-category.c"
	/** The scheme of servers (ie the scheme) */
#line 24 "../common/server-category.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SERVER_CATEGORY_GTYPE_PROPERTY, seahorse_server_category_properties[SEAHORSE_SERVER_CATEGORY_GTYPE_PROPERTY] = g_param_spec_gtype ("gtype", "gtype", "gtype", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 714 "server-category.c"
	/** The scheme of servers (ie the scheme) */
#line 24 "../common/server-category.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SERVER_CATEGORY_SCHEME_PROPERTY, seahorse_server_category_properties[SEAHORSE_SERVER_CATEGORY_SCHEME_PROPERTY] = g_param_spec_string ("scheme", "scheme", "scheme", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 718 "server-category.c"
	/** User-facing string to describe it */
#line 24 "../common/server-category.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SERVER_CATEGORY_DESCRIPTION_PROPERTY, seahorse_server_category_properties[SEAHORSE_SERVER_CATEGORY_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 722 "server-category.c"
}

static void
seahorse_server_category_instance_init (SeahorseServerCategory * self,
                                        gpointer klass)
{
#line 24 "../common/server-category.vala"
	self->priv = seahorse_server_category_get_instance_private (self);
#line 731 "server-category.c"
}

static void
seahorse_server_category_finalize (GObject * obj)
{
	SeahorseServerCategory * self;
#line 24 "../common/server-category.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_SERVER_CATEGORY, SeahorseServerCategory);
#line 32 "../common/server-category.vala"
	_g_free0 (self->priv->_scheme);
#line 35 "../common/server-category.vala"
	_g_free0 (self->priv->_description);
#line 49 "../common/server-category.vala"
	G_OBJECT_CLASS (seahorse_server_category_parent_class)->finalize (obj);
#line 746 "server-category.c"
}

/**
 * Describes a category of servers
 */
 G_GNUC_NO_INLINE static GType
seahorse_server_category_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseServerCategoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_server_category_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseServerCategory), 0, (GInstanceInitFunc) seahorse_server_category_instance_init, NULL };
	GType seahorse_server_category_type_id;
	seahorse_server_category_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorseServerCategory", &g_define_type_info, 0);
	SeahorseServerCategory_private_offset = g_type_add_instance_private (seahorse_server_category_type_id, sizeof (SeahorseServerCategoryPrivate));
	return seahorse_server_category_type_id;
}

GType
seahorse_server_category_get_type (void)
{
	static volatile gsize seahorse_server_category_type_id__once = 0;
	if (g_once_init_enter (&seahorse_server_category_type_id__once)) {
		GType seahorse_server_category_type_id;
		seahorse_server_category_type_id = seahorse_server_category_get_type_once ();
		g_once_init_leave (&seahorse_server_category_type_id__once, seahorse_server_category_type_id);
	}
	return seahorse_server_category_type_id__once;
}

static void
_vala_seahorse_server_category_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	SeahorseServerCategory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_SERVER_CATEGORY, SeahorseServerCategory);
#line 24 "../common/server-category.vala"
	switch (property_id) {
#line 24 "../common/server-category.vala"
		case SEAHORSE_SERVER_CATEGORY_GTYPE_PROPERTY:
#line 24 "../common/server-category.vala"
		g_value_set_gtype (value, seahorse_server_category_get_gtype (self));
#line 24 "../common/server-category.vala"
		break;
#line 24 "../common/server-category.vala"
		case SEAHORSE_SERVER_CATEGORY_SCHEME_PROPERTY:
#line 24 "../common/server-category.vala"
		g_value_set_string (value, seahorse_server_category_get_scheme (self));
#line 24 "../common/server-category.vala"
		break;
#line 24 "../common/server-category.vala"
		case SEAHORSE_SERVER_CATEGORY_DESCRIPTION_PROPERTY:
#line 24 "../common/server-category.vala"
		g_value_set_string (value, seahorse_server_category_get_description (self));
#line 24 "../common/server-category.vala"
		break;
#line 802 "server-category.c"
		default:
#line 24 "../common/server-category.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../common/server-category.vala"
		break;
#line 808 "server-category.c"
	}
}

static void
_vala_seahorse_server_category_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	SeahorseServerCategory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_SERVER_CATEGORY, SeahorseServerCategory);
#line 24 "../common/server-category.vala"
	switch (property_id) {
#line 24 "../common/server-category.vala"
		case SEAHORSE_SERVER_CATEGORY_GTYPE_PROPERTY:
#line 24 "../common/server-category.vala"
		seahorse_server_category_set_gtype (self, g_value_get_gtype (value));
#line 24 "../common/server-category.vala"
		break;
#line 24 "../common/server-category.vala"
		case SEAHORSE_SERVER_CATEGORY_SCHEME_PROPERTY:
#line 24 "../common/server-category.vala"
		seahorse_server_category_set_scheme (self, g_value_get_string (value));
#line 24 "../common/server-category.vala"
		break;
#line 24 "../common/server-category.vala"
		case SEAHORSE_SERVER_CATEGORY_DESCRIPTION_PROPERTY:
#line 24 "../common/server-category.vala"
		seahorse_server_category_set_description (self, g_value_get_string (value));
#line 24 "../common/server-category.vala"
		break;
#line 840 "server-category.c"
		default:
#line 24 "../common/server-category.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../common/server-category.vala"
		break;
#line 846 "server-category.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 24 "../common/server-category.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 857 "server-category.c"
		gssize i;
#line 24 "../common/server-category.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 24 "../common/server-category.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 24 "../common/server-category.vala"
				destroy_func (((gpointer*) array)[i]);
#line 865 "server-category.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 24 "../common/server-category.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 24 "../common/server-category.vala"
	g_free (array);
#line 880 "server-category.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 24 "../common/server-category.vala"
	if (array) {
#line 24 "../common/server-category.vala"
		while (((gpointer*) array)[length]) {
#line 24 "../common/server-category.vala"
			length++;
#line 894 "server-category.c"
		}
	}
#line 24 "../common/server-category.vala"
	return length;
#line 899 "server-category.c"
}

