/* viewable.c generated by valac 0.56.11, the Vala compiler
 * generated from viewable.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2012 Stefan Walter
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Stef Walter <stefw@collabora.co.uk>
 */

#include "seahorse-common.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;

struct _Block7Data {
	int _ref_count_;
	GObject* object;
};

static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void ___lambda9_ (Block7Data* _data7_);
static void ____lambda9__gtk_widget_destroy (GtkWidget* _sender,
                                      gpointer self);
static GType seahorse_viewable_get_type_once (void);

GtkWindow*
seahorse_viewable_create_viewer (SeahorseViewable* self,
                                 GtkWindow* parent)
{
	SeahorseViewableIface* _iface_;
#line 26 "../common/viewable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../common/viewable.vala"
	_iface_ = SEAHORSE_VIEWABLE_GET_INTERFACE (self);
#line 26 "../common/viewable.vala"
	if (_iface_->create_viewer) {
#line 26 "../common/viewable.vala"
		return _iface_->create_viewer (self, parent);
#line 59 "viewable.c"
	}
#line 26 "../common/viewable.vala"
	return NULL;
#line 63 "viewable.c"
}

gboolean
seahorse_viewable_can_view (GObject* object)
{
	gboolean result;
#line 28 "../common/viewable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 29 "../common/viewable.vala"
	result = SEAHORSE_IS_VIEWABLE (object);
#line 29 "../common/viewable.vala"
	return result;
#line 76 "viewable.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 32 "../common/viewable.vala"
	return self ? g_object_ref (self) : NULL;
#line 84 "viewable.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 32 "../common/viewable.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 32 "../common/viewable.vala"
	return _data7_;
#line 94 "viewable.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 32 "../common/viewable.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 32 "../common/viewable.vala"
		_g_object_unref0 (_data7_->object);
#line 32 "../common/viewable.vala"
		g_slice_free (Block7Data, _data7_);
#line 108 "viewable.c"
	}
}

static void
___lambda9_ (Block7Data* _data7_)
{
#line 48 "../common/viewable.vala"
	g_object_set_data_full (_data7_->object, "viewable-window", NULL, NULL);
#line 117 "viewable.c"
}

static void
____lambda9__gtk_widget_destroy (GtkWidget* _sender,
                                 gpointer self)
{
#line 47 "../common/viewable.vala"
	___lambda9_ (self);
#line 126 "viewable.c"
}

gboolean
seahorse_viewable_view (GObject* object,
                        GtkWindow* parent)
{
	Block7Data* _data7_;
	GObject* _tmp0_;
	GtkWindow* window = NULL;
	gconstpointer _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp3_;
	GtkWindow* _tmp11_;
	GtkWindow* _tmp12_;
	gboolean result;
#line 32 "../common/viewable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 32 "../common/viewable.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 32 "../common/viewable.vala"
	_data7_->_ref_count_ = 1;
#line 32 "../common/viewable.vala"
	_tmp0_ = _g_object_ref0 (object);
#line 32 "../common/viewable.vala"
	_g_object_unref0 (_data7_->object);
#line 32 "../common/viewable.vala"
	_data7_->object = _tmp0_;
#line 34 "../common/viewable.vala"
	if (!seahorse_viewable_can_view (_data7_->object)) {
#line 35 "../common/viewable.vala"
		result = FALSE;
#line 35 "../common/viewable.vala"
		block7_data_unref (_data7_);
#line 35 "../common/viewable.vala"
		_data7_ = NULL;
#line 35 "../common/viewable.vala"
		return result;
#line 164 "viewable.c"
	}
#line 37 "../common/viewable.vala"
	window = NULL;
#line 39 "../common/viewable.vala"
	_tmp1_ = g_object_get_data (_data7_->object, "viewable-window");
#line 39 "../common/viewable.vala"
	_tmp2_ = _g_object_ref0 ((GtkWindow*) _tmp1_);
#line 39 "../common/viewable.vala"
	_g_object_unref0 (window);
#line 39 "../common/viewable.vala"
	window = _tmp2_;
#line 40 "../common/viewable.vala"
	_tmp3_ = window;
#line 40 "../common/viewable.vala"
	if (_tmp3_ == NULL) {
#line 180 "viewable.c"
		SeahorseViewable* viewable = NULL;
		SeahorseViewable* _tmp4_;
		SeahorseViewable* _tmp5_;
		GtkWindow* _tmp6_;
		GtkWindow* _tmp7_;
		GtkWindow* _tmp8_;
		GtkWindow* _tmp9_;
		GtkWindow* _tmp10_;
#line 41 "../common/viewable.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data7_->object, SEAHORSE_TYPE_VIEWABLE, SeahorseViewable));
#line 41 "../common/viewable.vala"
		viewable = _tmp4_;
#line 42 "../common/viewable.vala"
		_tmp5_ = viewable;
#line 42 "../common/viewable.vala"
		_tmp6_ = seahorse_viewable_create_viewer (_tmp5_, parent);
#line 42 "../common/viewable.vala"
		_g_object_unref0 (window);
#line 42 "../common/viewable.vala"
		window = _tmp6_;
#line 43 "../common/viewable.vala"
		_tmp7_ = window;
#line 43 "../common/viewable.vala"
		if (_tmp7_ == NULL) {
#line 44 "../common/viewable.vala"
			result = FALSE;
#line 44 "../common/viewable.vala"
			_g_object_unref0 (viewable);
#line 44 "../common/viewable.vala"
			_g_object_unref0 (window);
#line 44 "../common/viewable.vala"
			block7_data_unref (_data7_);
#line 44 "../common/viewable.vala"
			_data7_ = NULL;
#line 44 "../common/viewable.vala"
			return result;
#line 217 "viewable.c"
		}
#line 46 "../common/viewable.vala"
		_tmp8_ = window;
#line 46 "../common/viewable.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 46 "../common/viewable.vala"
		g_object_set_data_full (_data7_->object, "viewable-window", _tmp9_, g_object_unref);
#line 47 "../common/viewable.vala"
		_tmp10_ = window;
#line 47 "../common/viewable.vala"
		g_signal_connect_data ((GtkWidget*) _tmp10_, "destroy", (GCallback) ____lambda9__gtk_widget_destroy, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 40 "../common/viewable.vala"
		_g_object_unref0 (viewable);
#line 231 "viewable.c"
	}
#line 52 "../common/viewable.vala"
	_tmp11_ = window;
#line 52 "../common/viewable.vala"
	gtk_window_present (_tmp11_);
#line 53 "../common/viewable.vala"
	_tmp12_ = window;
#line 53 "../common/viewable.vala"
	gtk_widget_show ((GtkWidget*) _tmp12_);
#line 54 "../common/viewable.vala"
	result = TRUE;
#line 54 "../common/viewable.vala"
	_g_object_unref0 (window);
#line 54 "../common/viewable.vala"
	block7_data_unref (_data7_);
#line 54 "../common/viewable.vala"
	_data7_ = NULL;
#line 54 "../common/viewable.vala"
	return result;
#line 251 "viewable.c"
}

static void
seahorse_viewable_default_init (SeahorseViewableIface * iface,
                                gpointer iface_data)
{
}

 G_GNUC_NO_INLINE static GType
seahorse_viewable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseViewableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_viewable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType seahorse_viewable_type_id;
	seahorse_viewable_type_id = g_type_register_static (G_TYPE_INTERFACE, "SeahorseViewable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (seahorse_viewable_type_id, G_TYPE_OBJECT);
	return seahorse_viewable_type_id;
}

GType
seahorse_viewable_get_type (void)
{
	static volatile gsize seahorse_viewable_type_id__once = 0;
	if (g_once_init_enter (&seahorse_viewable_type_id__once)) {
		GType seahorse_viewable_type_id;
		seahorse_viewable_type_id = seahorse_viewable_get_type_once ();
		g_once_init_leave (&seahorse_viewable_type_id__once, seahorse_viewable_type_id);
	}
	return seahorse_viewable_type_id__once;
}

