/* gkr-item-add.c generated by valac 0.56.11, the Vala compiler
 * generated from gkr-item-add.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2018 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "seahorse-gkr.h"
#include <gtk/gtk.h>
#include <pwquality.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <libsecret/secret.h>
#include <gio/gio.h>
#include "seahorse-common.h"

enum  {
	SEAHORSE_GKR_ITEM_ADD_0_PROPERTY,
	SEAHORSE_GKR_ITEM_ADD_NUM_PROPERTIES
};
static GParamSpec* seahorse_gkr_item_add_properties[SEAHORSE_GKR_ITEM_ADD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _pwquality_free_settings0(var) ((var == NULL) ? NULL : (var = (pwquality_free_settings (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _secret_value_unref0(var) ((var == NULL) ? NULL : (var = (secret_value_unref (var), NULL)))

struct _SeahorseGkrItemAddPrivate {
	GtkComboBox* item_keyring_combo;
	GtkContainer* password_area;
	GtkEntry* password_entry;
	GtkEntry* item_entry;
	GtkLevelBar* password_strength_bar;
	GtkImage* password_strength_icon;
	pwquality_settings_t* pwquality;
};

struct _Block2Data {
	int _ref_count_;
	SeahorseGkrItemAdd* self;
	SecretCollection* collection;
	SeahorseGkrKeyring* keyring;
	GtkEntryBuffer* item_buffer;
	GtkEntryBuffer* secret_buffer;
};

static gint SeahorseGkrItemAdd_private_offset;
static gpointer seahorse_gkr_item_add_parent_class = NULL;

static void seahorse_gkr_item_add_on_add_item_entry_changed (SeahorseGkrItemAdd* self,
                                                      GtkEditable* entry);
static void _seahorse_gkr_item_add_on_add_item_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                            gpointer self);
static void seahorse_gkr_item_add_on_password_entry_changed (SeahorseGkrItemAdd* self,
                                                      GtkEditable* entry);
static void seahorse_gkr_item_add_real_response (GtkDialog* base,
                                          gint resp);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda16_ (Block2Data* _data2_,
                  GObject* obj,
                  GAsyncResult* res);
static void seahorse_gkr_item_add_create_secret (SeahorseGkrItemAdd* self,
                                          GtkEntryBuffer* item_buffer,
                                          GtkEntryBuffer* secret_buffer,
                                          SecretCollection* collection);
static void ___lambda16__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void _g_free0_ (gpointer var);
static void __lambda17_ (SeahorseGkrItemAdd* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda17__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static GObject * seahorse_gkr_item_add_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _seahorse_gkr_item_add_on_password_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                            gpointer self);
static void seahorse_gkr_item_add_finalize (GObject * obj);
static GType seahorse_gkr_item_add_get_type_once (void);

static inline gpointer
seahorse_gkr_item_add_get_instance_private (SeahorseGkrItemAdd* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseGkrItemAdd_private_offset);
}

SeahorseGkrItemAdd*
seahorse_gkr_item_add_construct (GType object_type,
                                 GtkWindow* parent)
{
	SeahorseGkrItemAdd * self = NULL;
#line 64 "../gkr/gkr-item-add.vala"
	self = (SeahorseGkrItemAdd*) g_object_new (object_type, "transient-for", parent, "use-header-bar", 1, NULL);
#line 63 "../gkr/gkr-item-add.vala"
	return self;
#line 124 "gkr-item-add.c"
}

SeahorseGkrItemAdd*
seahorse_gkr_item_add_new (GtkWindow* parent)
{
#line 63 "../gkr/gkr-item-add.vala"
	return seahorse_gkr_item_add_construct (SEAHORSE_GKR_TYPE_ITEM_ADD, parent);
#line 132 "gkr-item-add.c"
}

static void
seahorse_gkr_item_add_on_add_item_entry_changed (SeahorseGkrItemAdd* self,
                                                 GtkEditable* entry)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 71 "../gkr/gkr-item-add.vala"
	g_return_if_fail (self != NULL);
#line 71 "../gkr/gkr-item-add.vala"
	g_return_if_fail (entry != NULL);
#line 72 "../gkr/gkr-item-add.vala"
	_tmp0_ = self->priv->item_entry;
#line 72 "../gkr/gkr-item-add.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 72 "../gkr/gkr-item-add.vala"
	_tmp2_ = _tmp1_;
#line 72 "../gkr/gkr-item-add.vala"
	gtk_dialog_set_response_sensitive ((GtkDialog*) self, (gint) GTK_RESPONSE_ACCEPT, g_strcmp0 (_tmp2_, "") != 0);
#line 154 "gkr-item-add.c"
}

static void
_seahorse_gkr_item_add_on_add_item_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                       gpointer self)
{
#line 21 "../gkr/gkr-item-add.vala"
	seahorse_gkr_item_add_on_add_item_entry_changed ((SeahorseGkrItemAdd*) self, _sender);
#line 163 "gkr-item-add.c"
}

static gchar*
pwquality_error_to_string (int self,
                           void* auxerror)
{
	gchar* ret = NULL;
	const gchar** retp = NULL;
	const gchar** _tmp0_;
	void* _tmp1_;
	void* res = NULL;
	const gchar** _tmp2_;
	void* _tmp3_;
	void* _tmp4_;
	const gchar** _tmp5_;
	gchar* result;
#line 81 "pwquality.vapi"
	ret = NULL;
#line 82 "pwquality.vapi"
	retp = &ret;
#line 83 "pwquality.vapi"
	_tmp0_ = retp;
#line 83 "pwquality.vapi"
	_tmp1_ = g_malloc ((gsize) PWQ_MAX_ERROR_MESSAGE_LEN);
#line 83 "pwquality.vapi"
	*_tmp0_ = _tmp1_;
#line 84 "pwquality.vapi"
	_tmp2_ = retp;
#line 84 "pwquality.vapi"
	_tmp3_ = pwquality_strerror (*_tmp2_, (gsize) PWQ_MAX_ERROR_MESSAGE_LEN, self, auxerror);
#line 84 "pwquality.vapi"
	res = _tmp3_;
#line 86 "pwquality.vapi"
	_tmp4_ = res;
#line 86 "pwquality.vapi"
	_tmp5_ = retp;
#line 86 "pwquality.vapi"
	if (_tmp4_ != (*_tmp5_)) {
#line 202 "gkr-item-add.c"
		const gchar** _tmp6_;
		void* _tmp7_;
		void* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 87 "pwquality.vapi"
		_tmp6_ = retp;
#line 87 "pwquality.vapi"
		_tmp7_ = res;
#line 87 "pwquality.vapi"
		_tmp8_ = res;
#line 87 "pwquality.vapi"
		_tmp9_ = strlen ((const gchar*) _tmp8_);
#line 87 "pwquality.vapi"
		_tmp10_ = _tmp9_;
#line 87 "pwquality.vapi"
		memcpy (*_tmp6_, _tmp7_, (gsize) (_tmp10_ + 1));
#line 220 "gkr-item-add.c"
	}
#line 90 "pwquality.vapi"
	result = ret;
#line 90 "pwquality.vapi"
	return result;
#line 226 "gkr-item-add.c"
}

static void
seahorse_gkr_item_add_on_password_entry_changed (SeahorseGkrItemAdd* self,
                                                 GtkEditable* entry)
{
	void* auxerr = NULL;
	gint score = 0;
	pwquality_settings_t* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	void* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	GtkLevelBar* _tmp12_;
#line 75 "../gkr/gkr-item-add.vala"
	g_return_if_fail (self != NULL);
#line 75 "../gkr/gkr-item-add.vala"
	g_return_if_fail (entry != NULL);
#line 77 "../gkr/gkr-item-add.vala"
	_tmp0_ = self->priv->pwquality;
#line 77 "../gkr/gkr-item-add.vala"
	_tmp1_ = gtk_editable_get_chars (entry, 0, -1);
#line 77 "../gkr/gkr-item-add.vala"
	_tmp2_ = _tmp1_;
#line 77 "../gkr/gkr-item-add.vala"
	_tmp4_ = pwquality_check (_tmp0_, _tmp2_, NULL, NULL, &_tmp3_);
#line 77 "../gkr/gkr-item-add.vala"
	auxerr = _tmp3_;
#line 77 "../gkr/gkr-item-add.vala"
	_tmp5_ = _tmp4_;
#line 77 "../gkr/gkr-item-add.vala"
	_g_free0 (_tmp2_);
#line 77 "../gkr/gkr-item-add.vala"
	score = _tmp5_;
#line 79 "../gkr/gkr-item-add.vala"
	if (score < 0) {
#line 264 "gkr-item-add.c"
		int err = 0;
		GtkImage* _tmp6_;
		void* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GtkImage* _tmp10_;
#line 80 "../gkr/gkr-item-add.vala"
		err = (int) score;
#line 81 "../gkr/gkr-item-add.vala"
		_tmp6_ = self->priv->password_strength_icon;
#line 81 "../gkr/gkr-item-add.vala"
		_tmp7_ = auxerr;
#line 81 "../gkr/gkr-item-add.vala"
		_tmp8_ = pwquality_error_to_string (err, _tmp7_);
#line 81 "../gkr/gkr-item-add.vala"
		_tmp9_ = _tmp8_;
#line 81 "../gkr/gkr-item-add.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, g_dgettext ("libpwquality", _tmp9_));
#line 81 "../gkr/gkr-item-add.vala"
		_g_free0 (_tmp9_);
#line 82 "../gkr/gkr-item-add.vala"
		_tmp10_ = self->priv->password_strength_icon;
#line 82 "../gkr/gkr-item-add.vala"
		gtk_widget_show ((GtkWidget*) _tmp10_);
#line 289 "gkr-item-add.c"
	} else {
		GtkImage* _tmp11_;
#line 84 "../gkr/gkr-item-add.vala"
		_tmp11_ = self->priv->password_strength_icon;
#line 84 "../gkr/gkr-item-add.vala"
		gtk_widget_hide ((GtkWidget*) _tmp11_);
#line 296 "gkr-item-add.c"
	}
#line 87 "../gkr/gkr-item-add.vala"
	_tmp12_ = self->priv->password_strength_bar;
#line 87 "../gkr/gkr-item-add.vala"
	gtk_level_bar_set_value (_tmp12_, (gdouble) CLAMP ((score / 25) + 1, 1, 5));
#line 302 "gkr-item-add.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 90 "../gkr/gkr-item-add.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 90 "../gkr/gkr-item-add.vala"
	return _data2_;
#line 312 "gkr-item-add.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 90 "../gkr/gkr-item-add.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 322 "gkr-item-add.c"
		SeahorseGkrItemAdd* self;
#line 90 "../gkr/gkr-item-add.vala"
		self = _data2_->self;
#line 90 "../gkr/gkr-item-add.vala"
		_g_object_unref0 (_data2_->secret_buffer);
#line 90 "../gkr/gkr-item-add.vala"
		_g_object_unref0 (_data2_->item_buffer);
#line 90 "../gkr/gkr-item-add.vala"
		_g_object_unref0 (_data2_->keyring);
#line 90 "../gkr/gkr-item-add.vala"
		_g_object_unref0 (_data2_->collection);
#line 90 "../gkr/gkr-item-add.vala"
		_g_object_unref0 (self);
#line 90 "../gkr/gkr-item-add.vala"
		g_slice_free (Block2Data, _data2_);
#line 338 "gkr-item-add.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 101 "../gkr/gkr-item-add.vala"
	return self ? g_object_ref (self) : NULL;
#line 347 "gkr-item-add.c"
}

static void
__lambda16_ (Block2Data* _data2_,
             GObject* obj,
             GAsyncResult* res)
{
	SeahorseGkrItemAdd* self;
	GError* _inner_error0_ = NULL;
#line 107 "../gkr/gkr-item-add.vala"
	self = _data2_->self;
#line 107 "../gkr/gkr-item-add.vala"
	g_return_if_fail (res != NULL);
#line 361 "gkr-item-add.c"
	{
		gboolean _tmp0_ = FALSE;
		SeahorseGkrKeyring* _tmp1_;
#line 109 "../gkr/gkr-item-add.vala"
		_tmp1_ = _data2_->keyring;
#line 109 "../gkr/gkr-item-add.vala"
		_tmp0_ = seahorse_lockable_unlock_finish ((SeahorseLockable*) _tmp1_, res, &_inner_error0_);
#line 109 "../gkr/gkr-item-add.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 371 "gkr-item-add.c"
			goto __catch0_g_error;
		}
#line 109 "../gkr/gkr-item-add.vala"
		if (_tmp0_) {
#line 376 "gkr-item-add.c"
			GtkEntryBuffer* _tmp2_;
			GtkEntryBuffer* _tmp3_;
			SecretCollection* _tmp4_;
#line 110 "../gkr/gkr-item-add.vala"
			_tmp2_ = _data2_->item_buffer;
#line 110 "../gkr/gkr-item-add.vala"
			_tmp3_ = _data2_->secret_buffer;
#line 110 "../gkr/gkr-item-add.vala"
			_tmp4_ = _data2_->collection;
#line 110 "../gkr/gkr-item-add.vala"
			seahorse_gkr_item_add_create_secret (self, _tmp2_, _tmp3_, _tmp4_);
#line 388 "gkr-item-add.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 108 "../gkr/gkr-item-add.vala"
		e = _inner_error0_;
#line 108 "../gkr/gkr-item-add.vala"
		_inner_error0_ = NULL;
#line 113 "../gkr/gkr-item-add.vala"
		_tmp5_ = e;
#line 113 "../gkr/gkr-item-add.vala"
		_tmp6_ = _tmp5_->message;
#line 113 "../gkr/gkr-item-add.vala"
		seahorse_util_show_error ((GtkWidget*) self, _ ("Couldn’t unlock"), _tmp6_);
#line 108 "../gkr/gkr-item-add.vala"
		_g_error_free0 (e);
#line 409 "gkr-item-add.c"
	}
	__finally0:
#line 108 "../gkr/gkr-item-add.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../gkr/gkr-item-add.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 108 "../gkr/gkr-item-add.vala"
		g_clear_error (&_inner_error0_);
#line 108 "../gkr/gkr-item-add.vala"
		return;
#line 420 "gkr-item-add.c"
	}
}

static void
___lambda16__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 107 "../gkr/gkr-item-add.vala"
	__lambda16_ (self, source_object, res);
#line 107 "../gkr/gkr-item-add.vala"
	block2_data_unref (self);
#line 433 "gkr-item-add.c"
}

static void
seahorse_gkr_item_add_real_response (GtkDialog* base,
                                     gint resp)
{
	SeahorseGkrItemAdd * self;
	Block2Data* _data2_;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkComboBox* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeIter _tmp6_;
	SecretCollection* _tmp7_ = NULL;
	SecretCollection* _tmp8_;
	SeahorseGkrKeyring* _tmp9_;
	GCancellable* cancellable = NULL;
	GCancellable* _tmp10_;
	SeahorseInteraction* interaction = NULL;
	SeahorseInteraction* _tmp11_;
	GtkEntry* _tmp12_;
	GtkEntryBuffer* _tmp13_;
	GtkEntryBuffer* _tmp14_;
	GtkEntryBuffer* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntryBuffer* _tmp17_;
	GtkEntryBuffer* _tmp18_;
	GtkEntryBuffer* _tmp19_;
	SeahorseGkrKeyring* _tmp20_;
	SeahorseInteraction* _tmp21_;
	GCancellable* _tmp22_;
#line 90 "../gkr/gkr-item-add.vala"
	self = (SeahorseGkrItemAdd*) base;
#line 90 "../gkr/gkr-item-add.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 90 "../gkr/gkr-item-add.vala"
	_data2_->_ref_count_ = 1;
#line 90 "../gkr/gkr-item-add.vala"
	_data2_->self = g_object_ref (self);
#line 91 "../gkr/gkr-item-add.vala"
	if (resp != ((gint) GTK_RESPONSE_ACCEPT)) {
#line 92 "../gkr/gkr-item-add.vala"
		block2_data_unref (_data2_);
#line 92 "../gkr/gkr-item-add.vala"
		_data2_ = NULL;
#line 92 "../gkr/gkr-item-add.vala"
		return;
#line 484 "gkr-item-add.c"
	}
#line 95 "../gkr/gkr-item-add.vala"
	_tmp0_ = self->priv->item_keyring_combo;
#line 95 "../gkr/gkr-item-add.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 95 "../gkr/gkr-item-add.vala"
	iter = _tmp1_;
#line 95 "../gkr/gkr-item-add.vala"
	if (!_tmp2_) {
#line 96 "../gkr/gkr-item-add.vala"
		block2_data_unref (_data2_);
#line 96 "../gkr/gkr-item-add.vala"
		_data2_ = NULL;
#line 96 "../gkr/gkr-item-add.vala"
		return;
#line 500 "gkr-item-add.c"
	}
#line 99 "../gkr/gkr-item-add.vala"
	_tmp3_ = self->priv->item_keyring_combo;
#line 99 "../gkr/gkr-item-add.vala"
	_tmp4_ = gtk_combo_box_get_model (_tmp3_);
#line 99 "../gkr/gkr-item-add.vala"
	_tmp5_ = _tmp4_;
#line 99 "../gkr/gkr-item-add.vala"
	_tmp6_ = iter;
#line 99 "../gkr/gkr-item-add.vala"
	gtk_tree_model_get (_tmp5_, &_tmp6_, 1, &_tmp7_, -1, -1);
#line 99 "../gkr/gkr-item-add.vala"
	_g_object_unref0 (_data2_->collection);
#line 99 "../gkr/gkr-item-add.vala"
	_data2_->collection = _tmp7_;
#line 101 "../gkr/gkr-item-add.vala"
	_tmp8_ = _data2_->collection;
#line 101 "../gkr/gkr-item-add.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, SEAHORSE_GKR_TYPE_KEYRING, SeahorseGkrKeyring));
#line 101 "../gkr/gkr-item-add.vala"
	_data2_->keyring = _tmp9_;
#line 102 "../gkr/gkr-item-add.vala"
	_tmp10_ = g_cancellable_new ();
#line 102 "../gkr/gkr-item-add.vala"
	cancellable = _tmp10_;
#line 103 "../gkr/gkr-item-add.vala"
	_tmp11_ = seahorse_interaction_new ((GtkWindow*) self);
#line 103 "../gkr/gkr-item-add.vala"
	interaction = _tmp11_;
#line 104 "../gkr/gkr-item-add.vala"
	_tmp12_ = self->priv->item_entry;
#line 104 "../gkr/gkr-item-add.vala"
	_tmp13_ = gtk_entry_get_buffer (_tmp12_);
#line 104 "../gkr/gkr-item-add.vala"
	_tmp14_ = _tmp13_;
#line 104 "../gkr/gkr-item-add.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 104 "../gkr/gkr-item-add.vala"
	_data2_->item_buffer = _tmp15_;
#line 105 "../gkr/gkr-item-add.vala"
	_tmp16_ = self->priv->password_entry;
#line 105 "../gkr/gkr-item-add.vala"
	_tmp17_ = gtk_entry_get_buffer (_tmp16_);
#line 105 "../gkr/gkr-item-add.vala"
	_tmp18_ = _tmp17_;
#line 105 "../gkr/gkr-item-add.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 105 "../gkr/gkr-item-add.vala"
	_data2_->secret_buffer = _tmp19_;
#line 107 "../gkr/gkr-item-add.vala"
	_tmp20_ = _data2_->keyring;
#line 107 "../gkr/gkr-item-add.vala"
	_tmp21_ = interaction;
#line 107 "../gkr/gkr-item-add.vala"
	_tmp22_ = cancellable;
#line 107 "../gkr/gkr-item-add.vala"
	seahorse_lockable_unlock ((SeahorseLockable*) _tmp20_, (GTlsInteraction*) _tmp21_, _tmp22_, ___lambda16__gasync_ready_callback, block2_data_ref (_data2_));
#line 90 "../gkr/gkr-item-add.vala"
	_g_object_unref0 (interaction);
#line 90 "../gkr/gkr-item-add.vala"
	_g_object_unref0 (cancellable);
#line 90 "../gkr/gkr-item-add.vala"
	block2_data_unref (_data2_);
#line 90 "../gkr/gkr-item-add.vala"
	_data2_ = NULL;
#line 566 "gkr-item-add.c"
}

static void
_g_free0_ (gpointer var)
{
#line 123 "../gkr/gkr-item-add.vala"
	var = (g_free (var), NULL);
#line 574 "gkr-item-add.c"
}

static void
__lambda17_ (SeahorseGkrItemAdd* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 130 "../gkr/gkr-item-add.vala"
	g_return_if_fail (res != NULL);
#line 585 "gkr-item-add.c"
	{
		SecretItem* _tmp0_;
		SecretItem* _tmp1_;
#line 133 "../gkr/gkr-item-add.vala"
		seahorse_gkr_dialog_complete_request ((GtkWidget*) self, FALSE);
#line 135 "../gkr/gkr-item-add.vala"
		_tmp0_ = secret_item_create_finish (res, &_inner_error0_);
#line 135 "../gkr/gkr-item-add.vala"
		_tmp1_ = _tmp0_;
#line 135 "../gkr/gkr-item-add.vala"
		_g_object_unref0 (_tmp1_);
#line 135 "../gkr/gkr-item-add.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 599 "gkr-item-add.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 131 "../gkr/gkr-item-add.vala"
		err = _inner_error0_;
#line 131 "../gkr/gkr-item-add.vala"
		_inner_error0_ = NULL;
#line 137 "../gkr/gkr-item-add.vala"
		_tmp2_ = err;
#line 137 "../gkr/gkr-item-add.vala"
		_tmp3_ = _tmp2_->message;
#line 137 "../gkr/gkr-item-add.vala"
		seahorse_util_show_error ((GtkWidget*) self, _ ("Couldn’t add item"), _tmp3_);
#line 131 "../gkr/gkr-item-add.vala"
		_g_error_free0 (err);
#line 621 "gkr-item-add.c"
	}
	__finally0:
#line 131 "../gkr/gkr-item-add.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../gkr/gkr-item-add.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../gkr/gkr-item-add.vala"
		g_clear_error (&_inner_error0_);
#line 131 "../gkr/gkr-item-add.vala"
		return;
#line 632 "gkr-item-add.c"
	}
}

static void
___lambda17__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 128 "../gkr/gkr-item-add.vala"
	__lambda17_ ((SeahorseGkrItemAdd*) self, source_object, res);
#line 128 "../gkr/gkr-item-add.vala"
	g_object_unref (self);
#line 645 "gkr-item-add.c"
}

static void
seahorse_gkr_item_add_create_secret (SeahorseGkrItemAdd* self,
                                     GtkEntryBuffer* item_buffer,
                                     GtkEntryBuffer* secret_buffer,
                                     SecretCollection* collection)
{
	SecretValue* secret = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	SecretValue* _tmp2_;
	GCancellable* cancellable = NULL;
	GCancellable* _tmp3_;
	GHashTable* attributes = NULL;
	GHashFunc _tmp4_;
	GEqualFunc _tmp5_;
	GHashTable* _tmp6_;
	SecretSchema* schema = NULL;
	SecretSchema* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 118 "../gkr/gkr-item-add.vala"
	g_return_if_fail (self != NULL);
#line 118 "../gkr/gkr-item-add.vala"
	g_return_if_fail (item_buffer != NULL);
#line 118 "../gkr/gkr-item-add.vala"
	g_return_if_fail (secret_buffer != NULL);
#line 118 "../gkr/gkr-item-add.vala"
	g_return_if_fail (collection != NULL);
#line 121 "../gkr/gkr-item-add.vala"
	_tmp0_ = gtk_entry_buffer_get_text (secret_buffer);
#line 121 "../gkr/gkr-item-add.vala"
	_tmp1_ = _tmp0_;
#line 121 "../gkr/gkr-item-add.vala"
	_tmp2_ = secret_value_new (_tmp1_, (gssize) -1, "text/plain");
#line 121 "../gkr/gkr-item-add.vala"
	secret = _tmp2_;
#line 122 "../gkr/gkr-item-add.vala"
	_tmp3_ = seahorse_gkr_dialog_begin_request ((GtkWidget*) self);
#line 122 "../gkr/gkr-item-add.vala"
	cancellable = _tmp3_;
#line 123 "../gkr/gkr-item-add.vala"
	_tmp4_ = g_str_hash;
#line 123 "../gkr/gkr-item-add.vala"
	_tmp5_ = g_str_equal;
#line 123 "../gkr/gkr-item-add.vala"
	_tmp6_ = g_hash_table_new_full (_tmp4_, _tmp5_, _g_free0_, _g_free0_);
#line 123 "../gkr/gkr-item-add.vala"
	attributes = _tmp6_;
#line 126 "../gkr/gkr-item-add.vala"
	_tmp7_ = secret_schema_new ("org.gnome.keyring.Note", SECRET_SCHEMA_NONE, NULL);
#line 126 "../gkr/gkr-item-add.vala"
	schema = _tmp7_;
#line 128 "../gkr/gkr-item-add.vala"
	_tmp8_ = gtk_entry_buffer_get_text (item_buffer);
#line 128 "../gkr/gkr-item-add.vala"
	_tmp9_ = _tmp8_;
#line 128 "../gkr/gkr-item-add.vala"
	secret_item_create (collection, schema, attributes, _tmp9_, secret, SECRET_ITEM_CREATE_NONE, cancellable, ___lambda17__gasync_ready_callback, g_object_ref (self));
#line 118 "../gkr/gkr-item-add.vala"
	_secret_schema_unref0 (schema);
#line 118 "../gkr/gkr-item-add.vala"
	_g_hash_table_unref0 (attributes);
#line 118 "../gkr/gkr-item-add.vala"
	_g_object_unref0 (cancellable);
#line 118 "../gkr/gkr-item-add.vala"
	_secret_value_unref0 (secret);
#line 714 "gkr-item-add.c"
}

static void
_seahorse_gkr_item_add_on_password_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                       gpointer self)
{
#line 58 "../gkr/gkr-item-add.vala"
	seahorse_gkr_item_add_on_password_entry_changed ((SeahorseGkrItemAdd*) self, _sender);
#line 723 "gkr-item-add.c"
}

static GObject *
seahorse_gkr_item_add_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorseGkrItemAdd * self;
	GtkListStore* store = NULL;
	GtkListStore* _tmp0_;
	GtkComboBox* _tmp1_;
	GtkListStore* _tmp2_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp3_;
	GtkComboBox* _tmp4_;
	GtkCellRendererText* _tmp5_;
	GtkComboBox* _tmp6_;
	GtkCellRendererText* _tmp7_;
	SeahorseGkrBackend* _tmp8_;
	SeahorseGkrBackend* _tmp9_;
	GList* _tmp10_;
	GList* _tmp11_;
	SeahorseGkrPasswordEntry* _tmp26_;
	GtkEntry* _tmp27_;
	GtkEntry* _tmp28_;
	GtkContainer* _tmp29_;
	GtkEntry* _tmp30_;
	GtkEntry* _tmp31_;
#line 36 "../gkr/gkr-item-add.vala"
	parent_class = G_OBJECT_CLASS (seahorse_gkr_item_add_parent_class);
#line 36 "../gkr/gkr-item-add.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "../gkr/gkr-item-add.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_GKR_TYPE_ITEM_ADD, SeahorseGkrItemAdd);
#line 38 "../gkr/gkr-item-add.vala"
	_tmp0_ = gtk_list_store_new (2, G_TYPE_STRING, secret_collection_get_type (), -1);
#line 38 "../gkr/gkr-item-add.vala"
	store = _tmp0_;
#line 39 "../gkr/gkr-item-add.vala"
	_tmp1_ = self->priv->item_keyring_combo;
#line 39 "../gkr/gkr-item-add.vala"
	_tmp2_ = store;
#line 39 "../gkr/gkr-item-add.vala"
	gtk_combo_box_set_model (_tmp1_, (GtkTreeModel*) _tmp2_);
#line 41 "../gkr/gkr-item-add.vala"
	_tmp3_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 41 "../gkr/gkr-item-add.vala"
	g_object_ref_sink (_tmp3_);
#line 41 "../gkr/gkr-item-add.vala"
	cell = _tmp3_;
#line 42 "../gkr/gkr-item-add.vala"
	_tmp4_ = self->priv->item_keyring_combo;
#line 42 "../gkr/gkr-item-add.vala"
	_tmp5_ = cell;
#line 42 "../gkr/gkr-item-add.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp4_, (GtkCellRenderer*) _tmp5_, TRUE);
#line 43 "../gkr/gkr-item-add.vala"
	_tmp6_ = self->priv->item_keyring_combo;
#line 43 "../gkr/gkr-item-add.vala"
	_tmp7_ = cell;
#line 43 "../gkr/gkr-item-add.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp6_, (GtkCellRenderer*) _tmp7_, "text", 0);
#line 45 "../gkr/gkr-item-add.vala"
	_tmp8_ = seahorse_gkr_backend_instance ();
#line 45 "../gkr/gkr-item-add.vala"
	_tmp9_ = _tmp8_;
#line 45 "../gkr/gkr-item-add.vala"
	_tmp10_ = seahorse_gkr_backend_get_keyrings (_tmp9_);
#line 45 "../gkr/gkr-item-add.vala"
	_tmp11_ = _tmp10_;
#line 45 "../gkr/gkr-item-add.vala"
	_g_object_unref0 (_tmp9_);
#line 798 "gkr-item-add.c"
	{
		GList* keyring_collection = NULL;
		GList* keyring_it = NULL;
#line 45 "../gkr/gkr-item-add.vala"
		keyring_collection = _tmp11_;
#line 45 "../gkr/gkr-item-add.vala"
		for (keyring_it = keyring_collection; keyring_it != NULL; keyring_it = keyring_it->next) {
#line 806 "gkr-item-add.c"
			SeahorseGkrKeyring* keyring = NULL;
#line 45 "../gkr/gkr-item-add.vala"
			keyring = (SeahorseGkrKeyring*) keyring_it->data;
#line 810 "gkr-item-add.c"
			{
				GtkTreeIter iter = {0};
				GtkListStore* _tmp12_;
				GtkTreeIter _tmp13_ = {0};
				GtkListStore* _tmp14_;
				GtkTreeIter _tmp15_;
				SeahorseGkrKeyring* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				SeahorseGkrKeyring* _tmp20_;
				SeahorseGkrKeyring* _tmp21_;
				gboolean _tmp22_;
				gboolean _tmp23_;
#line 47 "../gkr/gkr-item-add.vala"
				_tmp12_ = store;
#line 47 "../gkr/gkr-item-add.vala"
				gtk_list_store_append (_tmp12_, &_tmp13_);
#line 47 "../gkr/gkr-item-add.vala"
				iter = _tmp13_;
#line 48 "../gkr/gkr-item-add.vala"
				_tmp14_ = store;
#line 48 "../gkr/gkr-item-add.vala"
				_tmp15_ = iter;
#line 48 "../gkr/gkr-item-add.vala"
				_tmp16_ = keyring;
#line 48 "../gkr/gkr-item-add.vala"
				_tmp17_ = seahorse_place_get_label ((SeahorsePlace*) _tmp16_);
#line 48 "../gkr/gkr-item-add.vala"
				_tmp18_ = _tmp17_;
#line 48 "../gkr/gkr-item-add.vala"
				_tmp19_ = _tmp18_;
#line 48 "../gkr/gkr-item-add.vala"
				_tmp20_ = keyring;
#line 48 "../gkr/gkr-item-add.vala"
				gtk_list_store_set (_tmp14_, &_tmp15_, 0, _tmp19_, 1, _tmp20_, -1);
#line 48 "../gkr/gkr-item-add.vala"
				_g_free0 (_tmp19_);
#line 50 "../gkr/gkr-item-add.vala"
				_tmp21_ = keyring;
#line 50 "../gkr/gkr-item-add.vala"
				_tmp22_ = seahorse_gkr_keyring_get_is_default (_tmp21_);
#line 50 "../gkr/gkr-item-add.vala"
				_tmp23_ = _tmp22_;
#line 50 "../gkr/gkr-item-add.vala"
				if (_tmp23_) {
#line 857 "gkr-item-add.c"
					GtkComboBox* _tmp24_;
					GtkTreeIter _tmp25_;
#line 51 "../gkr/gkr-item-add.vala"
					_tmp24_ = self->priv->item_keyring_combo;
#line 51 "../gkr/gkr-item-add.vala"
					_tmp25_ = iter;
#line 51 "../gkr/gkr-item-add.vala"
					gtk_combo_box_set_active_iter (_tmp24_, &_tmp25_);
#line 866 "gkr-item-add.c"
				}
			}
		}
#line 45 "../gkr/gkr-item-add.vala"
		(keyring_collection == NULL) ? NULL : (keyring_collection = (g_list_free (keyring_collection), NULL));
#line 872 "gkr-item-add.c"
	}
#line 54 "../gkr/gkr-item-add.vala"
	gtk_dialog_set_response_sensitive ((GtkDialog*) self, (gint) GTK_RESPONSE_ACCEPT, FALSE);
#line 56 "../gkr/gkr-item-add.vala"
	_tmp26_ = seahorse_gkr_password_entry_new ();
#line 56 "../gkr/gkr-item-add.vala"
	g_object_ref_sink (_tmp26_);
#line 56 "../gkr/gkr-item-add.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 56 "../gkr/gkr-item-add.vala"
	self->priv->password_entry = (GtkEntry*) _tmp26_;
#line 57 "../gkr/gkr-item-add.vala"
	_tmp27_ = self->priv->password_entry;
#line 57 "../gkr/gkr-item-add.vala"
	gtk_entry_set_visibility (_tmp27_, FALSE);
#line 58 "../gkr/gkr-item-add.vala"
	_tmp28_ = self->priv->password_entry;
#line 58 "../gkr/gkr-item-add.vala"
	g_signal_connect_object ((GtkEditable*) _tmp28_, "changed", (GCallback) _seahorse_gkr_item_add_on_password_entry_changed_gtk_editable_changed, self, 0);
#line 59 "../gkr/gkr-item-add.vala"
	_tmp29_ = self->priv->password_area;
#line 59 "../gkr/gkr-item-add.vala"
	_tmp30_ = self->priv->password_entry;
#line 59 "../gkr/gkr-item-add.vala"
	gtk_container_add (_tmp29_, (GtkWidget*) _tmp30_);
#line 60 "../gkr/gkr-item-add.vala"
	_tmp31_ = self->priv->password_entry;
#line 60 "../gkr/gkr-item-add.vala"
	gtk_widget_show ((GtkWidget*) _tmp31_);
#line 36 "../gkr/gkr-item-add.vala"
	_g_object_unref0 (cell);
#line 36 "../gkr/gkr-item-add.vala"
	_g_object_unref0 (store);
#line 36 "../gkr/gkr-item-add.vala"
	return obj;
#line 908 "gkr-item-add.c"
}

static void
seahorse_gkr_item_add_class_init (SeahorseGkrItemAddClass * klass,
                                  gpointer klass_data)
{
#line 21 "../gkr/gkr-item-add.vala"
	seahorse_gkr_item_add_parent_class = g_type_class_peek_parent (klass);
#line 21 "../gkr/gkr-item-add.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseGkrItemAdd_private_offset);
#line 21 "../gkr/gkr-item-add.vala"
	((GtkDialogClass *) klass)->response = (void (*) (GtkDialog*, gint)) seahorse_gkr_item_add_real_response;
#line 21 "../gkr/gkr-item-add.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_gkr_item_add_constructor;
#line 21 "../gkr/gkr-item-add.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_gkr_item_add_finalize;
#line 21 "../gkr/gkr-item-add.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Seahorse/seahorse-gkr-add-item.ui");
#line 21 "../gkr/gkr-item-add.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "item_keyring_combo", FALSE, SeahorseGkrItemAdd_private_offset + G_STRUCT_OFFSET (SeahorseGkrItemAddPrivate, item_keyring_combo));
#line 21 "../gkr/gkr-item-add.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "password_area", FALSE, SeahorseGkrItemAdd_private_offset + G_STRUCT_OFFSET (SeahorseGkrItemAddPrivate, password_area));
#line 21 "../gkr/gkr-item-add.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "item_entry", FALSE, SeahorseGkrItemAdd_private_offset + G_STRUCT_OFFSET (SeahorseGkrItemAddPrivate, item_entry));
#line 21 "../gkr/gkr-item-add.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "password_strength_bar", FALSE, SeahorseGkrItemAdd_private_offset + G_STRUCT_OFFSET (SeahorseGkrItemAddPrivate, password_strength_bar));
#line 21 "../gkr/gkr-item-add.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "password_strength_icon", FALSE, SeahorseGkrItemAdd_private_offset + G_STRUCT_OFFSET (SeahorseGkrItemAddPrivate, password_strength_icon));
#line 21 "../gkr/gkr-item-add.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_add_item_entry_changed", G_CALLBACK(_seahorse_gkr_item_add_on_add_item_entry_changed_gtk_editable_changed));
#line 939 "gkr-item-add.c"
}

static void
seahorse_gkr_item_add_instance_init (SeahorseGkrItemAdd * self,
                                     gpointer klass)
{
	pwquality_settings_t* _tmp0_;
#line 21 "../gkr/gkr-item-add.vala"
	self->priv = seahorse_gkr_item_add_get_instance_private (self);
#line 34 "../gkr/gkr-item-add.vala"
	_tmp0_ = pwquality_default_settings ();
#line 34 "../gkr/gkr-item-add.vala"
	self->priv->pwquality = _tmp0_;
#line 21 "../gkr/gkr-item-add.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 955 "gkr-item-add.c"
}

static void
seahorse_gkr_item_add_finalize (GObject * obj)
{
	SeahorseGkrItemAdd * self;
#line 21 "../gkr/gkr-item-add.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_GKR_TYPE_ITEM_ADD, SeahorseGkrItemAdd);
#line 26 "../gkr/gkr-item-add.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 34 "../gkr/gkr-item-add.vala"
	_pwquality_free_settings0 (self->priv->pwquality);
#line 21 "../gkr/gkr-item-add.vala"
	G_OBJECT_CLASS (seahorse_gkr_item_add_parent_class)->finalize (obj);
#line 970 "gkr-item-add.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_gkr_item_add_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseGkrItemAddClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_gkr_item_add_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseGkrItemAdd), 0, (GInstanceInitFunc) seahorse_gkr_item_add_instance_init, NULL };
	GType seahorse_gkr_item_add_type_id;
	seahorse_gkr_item_add_type_id = g_type_register_static (gtk_dialog_get_type (), "SeahorseGkrItemAdd", &g_define_type_info, 0);
	SeahorseGkrItemAdd_private_offset = g_type_add_instance_private (seahorse_gkr_item_add_type_id, sizeof (SeahorseGkrItemAddPrivate));
	return seahorse_gkr_item_add_type_id;
}

GType
seahorse_gkr_item_add_get_type (void)
{
	static volatile gsize seahorse_gkr_item_add_type_id__once = 0;
	if (g_once_init_enter (&seahorse_gkr_item_add_type_id__once)) {
		GType seahorse_gkr_item_add_type_id;
		seahorse_gkr_item_add_type_id = seahorse_gkr_item_add_get_type_once ();
		g_once_init_leave (&seahorse_gkr_item_add_type_id__once, seahorse_gkr_item_add_type_id);
	}
	return seahorse_gkr_item_add_type_id__once;
}

