/* pkcs11-properties.c generated by valac 0.56.11, the Vala compiler
 * generated from pkcs11-properties.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2013 Red Hat Inc.
 * Copyright (C) 2020 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * Author: Stef Walter <stefw@redhat.com>
 */

#include "seahorse-pkcs11.h"
#include <gck/gck.h>
#include <gtk/gtk.h>
#include <ui/gcr-ui.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include "seahorse-common.h"
#include <gcr/gcr-base.h>

enum  {
	SEAHORSE_PKCS11_PROPERTIES_0_PROPERTY,
	SEAHORSE_PKCS11_PROPERTIES_OBJECT_PROPERTY,
	SEAHORSE_PKCS11_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* seahorse_pkcs11_properties_properties[SEAHORSE_PKCS11_PROPERTIES_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gck_attributes_unref0(var) ((var == NULL) ? NULL : (var = (gck_attributes_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;

#define SEAHORSE_PKCS11_TYPE_KEY_DELETER (seahorse_pkcs11_key_deleter_get_type ())
#define SEAHORSE_PKCS11_KEY_DELETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_PKCS11_TYPE_KEY_DELETER, SeahorsePkcs11KeyDeleter))
#define SEAHORSE_PKCS11_KEY_DELETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_PKCS11_TYPE_KEY_DELETER, SeahorsePkcs11KeyDeleterClass))
#define SEAHORSE_PKCS11_IS_KEY_DELETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_PKCS11_TYPE_KEY_DELETER))
#define SEAHORSE_PKCS11_IS_KEY_DELETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_PKCS11_TYPE_KEY_DELETER))
#define SEAHORSE_PKCS11_KEY_DELETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_PKCS11_TYPE_KEY_DELETER, SeahorsePkcs11KeyDeleterClass))

typedef struct _SeahorsePkcs11KeyDeleter SeahorsePkcs11KeyDeleter;
typedef struct _SeahorsePkcs11KeyDeleterClass SeahorsePkcs11KeyDeleterClass;
typedef struct _Block2Data Block2Data;

struct _SeahorsePkcs11PropertiesPrivate {
	GckObject* _object;
	GtkButton* delete_button;
	GtkButton* export_button;
	GtkButton* request_certificate_button;
	GtkBox* content;
	GcrViewer* _viewer;
	GCancellable* _cancellable;
	GckObject* _request_key;
};

struct _Block1Data {
	int _ref_count_;
	SeahorsePkcs11Properties* self;
	SeahorsePkcs11Deleter* deleter;
};

struct _Block2Data {
	int _ref_count_;
	SeahorsePkcs11Properties* self;
	GObject* object;
};

static gint SeahorsePkcs11Properties_private_offset;
static gpointer seahorse_pkcs11_properties_parent_class = NULL;

static void seahorse_pkcs11_properties_real_dispose (GObject* base);
static void seahorse_pkcs11_properties_update_label (SeahorsePkcs11Properties* self);
static void seahorse_pkcs11_properties_add_renderer_for_object (SeahorsePkcs11Properties* self,
                                                         GObject* object);
static void seahorse_pkcs11_properties_on_export_button_clicked (SeahorsePkcs11Properties* self,
                                                          GtkButton* export_button);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _seahorse_pkcs11_properties_on_export_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                              gpointer self);
static void seahorse_pkcs11_properties_on_delete_button_clicked (SeahorsePkcs11Properties* self,
                                                          GtkButton* delete_button);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
VALA_EXTERN SeahorsePkcs11KeyDeleter* seahorse_pkcs11_key_deleter_new (GckObject* cert_or_key);
VALA_EXTERN SeahorsePkcs11KeyDeleter* seahorse_pkcs11_key_deleter_construct (GType object_type,
                                                                 GckObject* cert_or_key);
VALA_EXTERN GType seahorse_pkcs11_key_deleter_get_type (void) G_GNUC_CONST ;
static void ___lambda4_ (Block1Data* _data1_,
                  GObject* obj,
                  GAsyncResult* res);
static void ____lambda4__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void _seahorse_pkcs11_properties_on_delete_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                              gpointer self);
static void seahorse_pkcs11_properties_on_request_certificate_button_clicked (SeahorsePkcs11Properties* self,
                                                                       GtkButton* request_button);
static void _seahorse_pkcs11_properties_on_request_certificate_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                           gpointer self);
static void seahorse_pkcs11_properties_check_certificate_request_capable (SeahorsePkcs11Properties* self,
                                                                   GObject* object);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda8_ (Block2Data* _data2_,
                 GObject* obj,
                 GAsyncResult* res);
static void ___lambda8__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static GObject * seahorse_pkcs11_properties_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void _seahorse_pkcs11_properties___lambda9_ (SeahorsePkcs11Properties* self);
static void __seahorse_pkcs11_properties___lambda9__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void seahorse_pkcs11_properties_finalize (GObject * obj);
static GType seahorse_pkcs11_properties_get_type_once (void);
static void _vala_seahorse_pkcs11_properties_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_seahorse_pkcs11_properties_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
seahorse_pkcs11_properties_get_instance_private (SeahorsePkcs11Properties* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorsePkcs11Properties_private_offset);
}

SeahorsePkcs11Properties*
seahorse_pkcs11_properties_construct (GType object_type,
                                      GckObject* object,
                                      GtkWindow* window)
{
	SeahorsePkcs11Properties * self = NULL;
#line 47 "../pkcs11/pkcs11-properties.vala"
	g_return_val_if_fail (object != NULL, NULL);
#line 47 "../pkcs11/pkcs11-properties.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 48 "../pkcs11/pkcs11-properties.vala"
	self = (SeahorsePkcs11Properties*) g_object_new (object_type, "object", object, "transient-for", window, NULL);
#line 47 "../pkcs11/pkcs11-properties.vala"
	return self;
#line 172 "pkcs11-properties.c"
}

SeahorsePkcs11Properties*
seahorse_pkcs11_properties_new (GckObject* object,
                                GtkWindow* window)
{
#line 47 "../pkcs11/pkcs11-properties.vala"
	return seahorse_pkcs11_properties_construct (SEAHORSE_PKCS11_TYPE_PROPERTIES, object, window);
#line 181 "pkcs11-properties.c"
}

static void
seahorse_pkcs11_properties_real_dispose (GObject* base)
{
	SeahorsePkcs11Properties * self;
	GCancellable* _tmp0_;
#line 88 "../pkcs11/pkcs11-properties.vala"
	self = (SeahorsePkcs11Properties*) base;
#line 89 "../pkcs11/pkcs11-properties.vala"
	_tmp0_ = self->priv->_cancellable;
#line 89 "../pkcs11/pkcs11-properties.vala"
	g_cancellable_cancel (_tmp0_);
#line 90 "../pkcs11/pkcs11-properties.vala"
	G_OBJECT_CLASS (seahorse_pkcs11_properties_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_dialog_get_type (), GtkDialog));
#line 197 "pkcs11-properties.c"
}

static void
seahorse_pkcs11_properties_update_label (SeahorsePkcs11Properties* self)
{
	gchar* label = NULL;
	gchar* description = NULL;
	GckObject* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
#line 93 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (self != NULL);
#line 96 "../pkcs11/pkcs11-properties.vala"
	_tmp0_ = self->priv->_object;
#line 96 "../pkcs11/pkcs11-properties.vala"
	g_object_get ((GObject*) _tmp0_, "label", &_tmp1_, "description", &_tmp2_, NULL);
#line 96 "../pkcs11/pkcs11-properties.vala"
	_g_free0 (label);
#line 96 "../pkcs11/pkcs11-properties.vala"
	label = _tmp1_;
#line 96 "../pkcs11/pkcs11-properties.vala"
	_g_free0 (description);
#line 96 "../pkcs11/pkcs11-properties.vala"
	description = _tmp2_;
#line 97 "../pkcs11/pkcs11-properties.vala"
	_tmp4_ = label;
#line 97 "../pkcs11/pkcs11-properties.vala"
	if (_tmp4_ == NULL) {
#line 97 "../pkcs11/pkcs11-properties.vala"
		_tmp3_ = TRUE;
#line 234 "pkcs11-properties.c"
	} else {
		const gchar* _tmp5_;
#line 97 "../pkcs11/pkcs11-properties.vala"
		_tmp5_ = label;
#line 97 "../pkcs11/pkcs11-properties.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "") == 0;
#line 241 "pkcs11-properties.c"
	}
#line 97 "../pkcs11/pkcs11-properties.vala"
	if (_tmp3_) {
#line 245 "pkcs11-properties.c"
		gchar* _tmp6_;
#line 98 "../pkcs11/pkcs11-properties.vala"
		_tmp6_ = g_strdup (_ ("Unnamed"));
#line 98 "../pkcs11/pkcs11-properties.vala"
		_g_free0 (label);
#line 98 "../pkcs11/pkcs11-properties.vala"
		label = _tmp6_;
#line 253 "pkcs11-properties.c"
	}
#line 99 "../pkcs11/pkcs11-properties.vala"
	_tmp7_ = label;
#line 99 "../pkcs11/pkcs11-properties.vala"
	_tmp8_ = description;
#line 99 "../pkcs11/pkcs11-properties.vala"
	_tmp9_ = g_strdup_printf ("%s - %s", _tmp7_, _tmp8_);
#line 99 "../pkcs11/pkcs11-properties.vala"
	_tmp10_ = _tmp9_;
#line 99 "../pkcs11/pkcs11-properties.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp10_);
#line 99 "../pkcs11/pkcs11-properties.vala"
	_g_free0 (_tmp10_);
#line 93 "../pkcs11/pkcs11-properties.vala"
	_g_free0 (description);
#line 93 "../pkcs11/pkcs11-properties.vala"
	_g_free0 (label);
#line 271 "pkcs11-properties.c"
}

static void
seahorse_pkcs11_properties_add_renderer_for_object (SeahorsePkcs11Properties* self,
                                                    GObject* object)
{
	GckAttributes* attributes = NULL;
	gchar* label = NULL;
	GckAttributes* _tmp0_;
#line 102 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (self != NULL);
#line 102 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (object != NULL);
#line 103 "../pkcs11/pkcs11-properties.vala"
	attributes = NULL;
#line 104 "../pkcs11/pkcs11-properties.vala"
	label = NULL;
#line 106 "../pkcs11/pkcs11-properties.vala"
	g_object_get (object, "label", &label, "attributes", &attributes, NULL);
#line 107 "../pkcs11/pkcs11-properties.vala"
	_tmp0_ = attributes;
#line 107 "../pkcs11/pkcs11-properties.vala"
	if (_tmp0_ != NULL) {
#line 295 "pkcs11-properties.c"
		GcrRenderer* renderer = NULL;
		const gchar* _tmp1_;
		GckAttributes* _tmp2_;
		GcrRenderer* _tmp3_;
		GcrRenderer* _tmp4_;
#line 108 "../pkcs11/pkcs11-properties.vala"
		_tmp1_ = label;
#line 108 "../pkcs11/pkcs11-properties.vala"
		_tmp2_ = attributes;
#line 108 "../pkcs11/pkcs11-properties.vala"
		_tmp3_ = gcr_renderer_create (_tmp1_, _tmp2_);
#line 108 "../pkcs11/pkcs11-properties.vala"
		renderer = _tmp3_;
#line 109 "../pkcs11/pkcs11-properties.vala"
		_tmp4_ = renderer;
#line 109 "../pkcs11/pkcs11-properties.vala"
		if (_tmp4_ != NULL) {
#line 313 "pkcs11-properties.c"
			GcrRenderer* _tmp5_;
			GcrRenderer* _tmp6_;
			GcrRenderer* _tmp7_;
			GObjectClass* _tmp8_;
			GParamSpec* _tmp9_;
			GcrViewer* _tmp11_;
			GcrRenderer* _tmp12_;
#line 110 "../pkcs11/pkcs11-properties.vala"
			_tmp5_ = renderer;
#line 110 "../pkcs11/pkcs11-properties.vala"
			g_object_bind_property_with_closures (object, "label", (GObject*) _tmp5_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 112 "../pkcs11/pkcs11-properties.vala"
			_tmp6_ = renderer;
#line 112 "../pkcs11/pkcs11-properties.vala"
			g_object_bind_property_with_closures (object, "attributes", (GObject*) _tmp6_, "attributes", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 115 "../pkcs11/pkcs11-properties.vala"
			_tmp7_ = renderer;
#line 115 "../pkcs11/pkcs11-properties.vala"
			_tmp8_ = G_OBJECT_GET_CLASS ((GObject*) _tmp7_);
#line 115 "../pkcs11/pkcs11-properties.vala"
			_tmp9_ = g_object_class_find_property (_tmp8_, "object");
#line 115 "../pkcs11/pkcs11-properties.vala"
			if (_tmp9_ != NULL) {
#line 337 "pkcs11-properties.c"
				GcrRenderer* _tmp10_;
#line 116 "../pkcs11/pkcs11-properties.vala"
				_tmp10_ = renderer;
#line 116 "../pkcs11/pkcs11-properties.vala"
				g_object_set ((GObject*) _tmp10_, "object", object, NULL);
#line 343 "pkcs11-properties.c"
			}
#line 118 "../pkcs11/pkcs11-properties.vala"
			_tmp11_ = self->priv->_viewer;
#line 118 "../pkcs11/pkcs11-properties.vala"
			_tmp12_ = renderer;
#line 118 "../pkcs11/pkcs11-properties.vala"
			gcr_viewer_add_renderer (_tmp11_, _tmp12_);
#line 351 "pkcs11-properties.c"
		}
#line 107 "../pkcs11/pkcs11-properties.vala"
		_g_object_unref0 (renderer);
#line 355 "pkcs11-properties.c"
	}
#line 102 "../pkcs11/pkcs11-properties.vala"
	_g_free0 (label);
#line 102 "../pkcs11/pkcs11-properties.vala"
	_gck_attributes_unref0 (attributes);
#line 361 "pkcs11-properties.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 126 "../pkcs11/pkcs11-properties.vala"
	return self ? g_object_ref (self) : NULL;
#line 369 "pkcs11-properties.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 127 "../pkcs11/pkcs11-properties.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 377 "pkcs11-properties.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 127 "../pkcs11/pkcs11-properties.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 385 "pkcs11-properties.c"
}

static void
seahorse_pkcs11_properties_on_export_button_clicked (SeahorsePkcs11Properties* self,
                                                     GtkButton* export_button)
{
	GList* objects = NULL;
	GckObject* _tmp0_;
	GObject* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 124 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (self != NULL);
#line 124 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (export_button != NULL);
#line 125 "../pkcs11/pkcs11-properties.vala"
	objects = NULL;
#line 126 "../pkcs11/pkcs11-properties.vala"
	_tmp0_ = self->priv->_object;
#line 126 "../pkcs11/pkcs11-properties.vala"
	_tmp1_ = _g_object_ref0 ((GObject*) _tmp0_);
#line 126 "../pkcs11/pkcs11-properties.vala"
	objects = g_list_append (objects, _tmp1_);
#line 408 "pkcs11-properties.c"
	{
#line 128 "../pkcs11/pkcs11-properties.vala"
		seahorse_exportable_export_to_prompt_wait (objects, (GtkWindow*) self, &_inner_error0_);
#line 128 "../pkcs11/pkcs11-properties.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 414 "pkcs11-properties.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 127 "../pkcs11/pkcs11-properties.vala"
		err = _inner_error0_;
#line 127 "../pkcs11/pkcs11-properties.vala"
		_inner_error0_ = NULL;
#line 130 "../pkcs11/pkcs11-properties.vala"
		_tmp2_ = err;
#line 130 "../pkcs11/pkcs11-properties.vala"
		_tmp3_ = _tmp2_->message;
#line 130 "../pkcs11/pkcs11-properties.vala"
		seahorse_util_show_error ((GtkWidget*) self, _ ("Failed to export certificate"), _tmp3_);
#line 127 "../pkcs11/pkcs11-properties.vala"
		_g_error_free0 (err);
#line 436 "pkcs11-properties.c"
	}
	__finally0:
#line 127 "../pkcs11/pkcs11-properties.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 127 "../pkcs11/pkcs11-properties.vala"
		(objects == NULL) ? NULL : (objects = (_g_list_free__g_object_unref0_ (objects), NULL));
#line 127 "../pkcs11/pkcs11-properties.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 127 "../pkcs11/pkcs11-properties.vala"
		g_clear_error (&_inner_error0_);
#line 127 "../pkcs11/pkcs11-properties.vala"
		return;
#line 449 "pkcs11-properties.c"
	}
#line 124 "../pkcs11/pkcs11-properties.vala"
	(objects == NULL) ? NULL : (objects = (_g_list_free__g_object_unref0_ (objects), NULL));
#line 453 "pkcs11-properties.c"
}

static void
_seahorse_pkcs11_properties_on_export_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                         gpointer self)
{
#line 27 "../pkcs11/pkcs11-properties.vala"
	seahorse_pkcs11_properties_on_export_button_clicked ((SeahorsePkcs11Properties*) self, _sender);
#line 462 "pkcs11-properties.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 135 "../pkcs11/pkcs11-properties.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 135 "../pkcs11/pkcs11-properties.vala"
	return _data1_;
#line 472 "pkcs11-properties.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 135 "../pkcs11/pkcs11-properties.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 482 "pkcs11-properties.c"
		SeahorsePkcs11Properties* self;
#line 135 "../pkcs11/pkcs11-properties.vala"
		self = _data1_->self;
#line 135 "../pkcs11/pkcs11-properties.vala"
		_g_object_unref0 (_data1_->deleter);
#line 135 "../pkcs11/pkcs11-properties.vala"
		_g_object_unref0 (self);
#line 135 "../pkcs11/pkcs11-properties.vala"
		g_slice_free (Block1Data, _data1_);
#line 492 "pkcs11-properties.c"
	}
}

static void
___lambda4_ (Block1Data* _data1_,
             GObject* obj,
             GAsyncResult* res)
{
	SeahorsePkcs11Properties* self;
	GError* _inner_error0_ = NULL;
#line 149 "../pkcs11/pkcs11-properties.vala"
	self = _data1_->self;
#line 149 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (res != NULL);
#line 507 "pkcs11-properties.c"
	{
		gboolean _tmp0_ = FALSE;
		SeahorsePkcs11Deleter* _tmp1_;
#line 151 "../pkcs11/pkcs11-properties.vala"
		_tmp1_ = _data1_->deleter;
#line 151 "../pkcs11/pkcs11-properties.vala"
		_tmp0_ = seahorse_deleter_delete_finish ((SeahorseDeleter*) _tmp1_, res, &_inner_error0_);
#line 151 "../pkcs11/pkcs11-properties.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 517 "pkcs11-properties.c"
			goto __catch0_g_error;
		}
#line 151 "../pkcs11/pkcs11-properties.vala"
		if (_tmp0_) {
#line 152 "../pkcs11/pkcs11-properties.vala"
			gtk_widget_destroy ((GtkWidget*) self);
#line 524 "pkcs11-properties.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 150 "../pkcs11/pkcs11-properties.vala"
		err = _inner_error0_;
#line 150 "../pkcs11/pkcs11-properties.vala"
		_inner_error0_ = NULL;
#line 154 "../pkcs11/pkcs11-properties.vala"
		_tmp2_ = err;
#line 154 "../pkcs11/pkcs11-properties.vala"
		_tmp3_ = _tmp2_->message;
#line 154 "../pkcs11/pkcs11-properties.vala"
		seahorse_util_show_error ((GtkWidget*) self, _ ("Couldn’t delete"), _tmp3_);
#line 150 "../pkcs11/pkcs11-properties.vala"
		_g_error_free0 (err);
#line 545 "pkcs11-properties.c"
	}
	__finally0:
#line 150 "../pkcs11/pkcs11-properties.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "../pkcs11/pkcs11-properties.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../pkcs11/pkcs11-properties.vala"
		g_clear_error (&_inner_error0_);
#line 150 "../pkcs11/pkcs11-properties.vala"
		return;
#line 556 "pkcs11-properties.c"
	}
}

static void
____lambda4__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 149 "../pkcs11/pkcs11-properties.vala"
	___lambda4_ (self, source_object, res);
#line 149 "../pkcs11/pkcs11-properties.vala"
	block1_data_unref (self);
#line 569 "pkcs11-properties.c"
}

static void
seahorse_pkcs11_properties_on_delete_button_clicked (SeahorsePkcs11Properties* self,
                                                     GtkButton* delete_button)
{
	Block1Data* _data1_;
	GObject* partner = NULL;
	GckObject* _tmp0_;
	GObject* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GObject* _tmp3_;
	SeahorsePkcs11Deleter* _tmp11_;
#line 135 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (self != NULL);
#line 135 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (delete_button != NULL);
#line 135 "../pkcs11/pkcs11-properties.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 135 "../pkcs11/pkcs11-properties.vala"
	_data1_->_ref_count_ = 1;
#line 135 "../pkcs11/pkcs11-properties.vala"
	_data1_->self = g_object_ref (self);
#line 137 "../pkcs11/pkcs11-properties.vala"
	_tmp0_ = self->priv->_object;
#line 137 "../pkcs11/pkcs11-properties.vala"
	g_object_get ((GObject*) _tmp0_, "partner", &_tmp1_, NULL);
#line 137 "../pkcs11/pkcs11-properties.vala"
	_g_object_unref0 (partner);
#line 137 "../pkcs11/pkcs11-properties.vala"
	partner = _tmp1_;
#line 140 "../pkcs11/pkcs11-properties.vala"
	_tmp3_ = partner;
#line 140 "../pkcs11/pkcs11-properties.vala"
	if (_tmp3_ != NULL) {
#line 140 "../pkcs11/pkcs11-properties.vala"
		_tmp2_ = TRUE;
#line 607 "pkcs11-properties.c"
	} else {
		GckObject* _tmp4_;
#line 140 "../pkcs11/pkcs11-properties.vala"
		_tmp4_ = self->priv->_object;
#line 140 "../pkcs11/pkcs11-properties.vala"
		_tmp2_ = SEAHORSE_PKCS11_IS_PRIVATE_KEY (_tmp4_);
#line 614 "pkcs11-properties.c"
	}
#line 140 "../pkcs11/pkcs11-properties.vala"
	if (_tmp2_) {
#line 618 "pkcs11-properties.c"
		GckObject* _tmp5_;
		SeahorsePkcs11KeyDeleter* _tmp6_;
		SeahorsePkcs11Deleter* _tmp7_;
		GObject* _tmp8_;
#line 141 "../pkcs11/pkcs11-properties.vala"
		_tmp5_ = self->priv->_object;
#line 141 "../pkcs11/pkcs11-properties.vala"
		_tmp6_ = seahorse_pkcs11_key_deleter_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gck_object_get_type (), GckObject));
#line 141 "../pkcs11/pkcs11-properties.vala"
		_g_object_unref0 (_data1_->deleter);
#line 141 "../pkcs11/pkcs11-properties.vala"
		_data1_->deleter = (SeahorsePkcs11Deleter*) _tmp6_;
#line 142 "../pkcs11/pkcs11-properties.vala"
		_tmp7_ = _data1_->deleter;
#line 142 "../pkcs11/pkcs11-properties.vala"
		_tmp8_ = partner;
#line 142 "../pkcs11/pkcs11-properties.vala"
		if (!seahorse_deleter_add_object ((SeahorseDeleter*) _tmp7_, _tmp8_)) {
#line 143 "../pkcs11/pkcs11-properties.vala"
			g_assert_not_reached ();
#line 639 "pkcs11-properties.c"
		}
	} else {
		GckObject* _tmp9_;
		SeahorsePkcs11Deleter* _tmp10_;
#line 145 "../pkcs11/pkcs11-properties.vala"
		_tmp9_ = self->priv->_object;
#line 145 "../pkcs11/pkcs11-properties.vala"
		_tmp10_ = seahorse_pkcs11_deleter_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gck_object_get_type (), GckObject));
#line 145 "../pkcs11/pkcs11-properties.vala"
		_g_object_unref0 (_data1_->deleter);
#line 145 "../pkcs11/pkcs11-properties.vala"
		_data1_->deleter = _tmp10_;
#line 652 "pkcs11-properties.c"
	}
#line 148 "../pkcs11/pkcs11-properties.vala"
	_tmp11_ = _data1_->deleter;
#line 148 "../pkcs11/pkcs11-properties.vala"
	if (seahorse_deleter_prompt ((SeahorseDeleter*) _tmp11_, (GtkWindow*) self)) {
#line 658 "pkcs11-properties.c"
		SeahorsePkcs11Deleter* _tmp12_;
		GCancellable* _tmp13_;
#line 149 "../pkcs11/pkcs11-properties.vala"
		_tmp12_ = _data1_->deleter;
#line 149 "../pkcs11/pkcs11-properties.vala"
		_tmp13_ = self->priv->_cancellable;
#line 149 "../pkcs11/pkcs11-properties.vala"
		seahorse_deleter_delete ((SeahorseDeleter*) _tmp12_, _tmp13_, ____lambda4__gasync_ready_callback, block1_data_ref (_data1_));
#line 667 "pkcs11-properties.c"
	}
#line 135 "../pkcs11/pkcs11-properties.vala"
	_g_object_unref0 (partner);
#line 135 "../pkcs11/pkcs11-properties.vala"
	block1_data_unref (_data1_);
#line 135 "../pkcs11/pkcs11-properties.vala"
	_data1_ = NULL;
#line 675 "pkcs11-properties.c"
}

static void
_seahorse_pkcs11_properties_on_delete_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                         gpointer self)
{
#line 27 "../pkcs11/pkcs11-properties.vala"
	seahorse_pkcs11_properties_on_delete_button_clicked ((SeahorsePkcs11Properties*) self, _sender);
#line 684 "pkcs11-properties.c"
}

static void
seahorse_pkcs11_properties_on_request_certificate_button_clicked (SeahorsePkcs11Properties* self,
                                                                  GtkButton* request_button)
{
	GckObject* _tmp0_;
#line 161 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (self != NULL);
#line 161 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (request_button != NULL);
#line 162 "../pkcs11/pkcs11-properties.vala"
	_tmp0_ = self->priv->_request_key;
#line 162 "../pkcs11/pkcs11-properties.vala"
	seahorse_pkcs11_request_prompt ((GtkWindow*) self, _tmp0_);
#line 700 "pkcs11-properties.c"
}

static void
_seahorse_pkcs11_properties_on_request_certificate_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                      gpointer self)
{
#line 27 "../pkcs11/pkcs11-properties.vala"
	seahorse_pkcs11_properties_on_request_certificate_button_clicked ((SeahorsePkcs11Properties*) self, _sender);
#line 709 "pkcs11-properties.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 165 "../pkcs11/pkcs11-properties.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 165 "../pkcs11/pkcs11-properties.vala"
	return _data2_;
#line 719 "pkcs11-properties.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 165 "../pkcs11/pkcs11-properties.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 729 "pkcs11-properties.c"
		SeahorsePkcs11Properties* self;
#line 165 "../pkcs11/pkcs11-properties.vala"
		self = _data2_->self;
#line 165 "../pkcs11/pkcs11-properties.vala"
		_g_object_unref0 (_data2_->object);
#line 165 "../pkcs11/pkcs11-properties.vala"
		_g_object_unref0 (self);
#line 165 "../pkcs11/pkcs11-properties.vala"
		g_slice_free (Block2Data, _data2_);
#line 739 "pkcs11-properties.c"
	}
}

static void
__lambda8_ (Block2Data* _data2_,
            GObject* obj,
            GAsyncResult* res)
{
	SeahorsePkcs11Properties* self;
	GError* _inner_error0_ = NULL;
#line 169 "../pkcs11/pkcs11-properties.vala"
	self = _data2_->self;
#line 169 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (res != NULL);
#line 754 "pkcs11-properties.c"
	{
		gboolean _tmp0_ = FALSE;
#line 171 "../pkcs11/pkcs11-properties.vala"
		_tmp0_ = gcr_certificate_request_capable_finish (res, &_inner_error0_);
#line 171 "../pkcs11/pkcs11-properties.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 761 "pkcs11-properties.c"
			goto __catch0_g_error;
		}
#line 171 "../pkcs11/pkcs11-properties.vala"
		if (_tmp0_) {
#line 766 "pkcs11-properties.c"
			GtkButton* _tmp1_;
			GckObject* _tmp2_;
#line 172 "../pkcs11/pkcs11-properties.vala"
			_tmp1_ = self->priv->request_certificate_button;
#line 172 "../pkcs11/pkcs11-properties.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 173 "../pkcs11/pkcs11-properties.vala"
			_tmp2_ = _g_object_ref0 ((GckObject*) G_TYPE_CHECK_INSTANCE_CAST (_data2_->object, SEAHORSE_PKCS11_TYPE_PRIVATE_KEY, SeahorsePkcs11PrivateKey));
#line 173 "../pkcs11/pkcs11-properties.vala"
			_g_object_unref0 (self->priv->_request_key);
#line 173 "../pkcs11/pkcs11-properties.vala"
			self->priv->_request_key = _tmp2_;
#line 779 "pkcs11-properties.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 170 "../pkcs11/pkcs11-properties.vala"
		err = _inner_error0_;
#line 170 "../pkcs11/pkcs11-properties.vala"
		_inner_error0_ = NULL;
#line 176 "../pkcs11/pkcs11-properties.vala"
		_tmp3_ = err;
#line 176 "../pkcs11/pkcs11-properties.vala"
		_tmp4_ = _tmp3_->message;
#line 176 "../pkcs11/pkcs11-properties.vala"
		g_message ("pkcs11-properties.vala:176: couldn't check capabilities of private key" \
": %s", _tmp4_);
#line 170 "../pkcs11/pkcs11-properties.vala"
		_g_error_free0 (err);
#line 800 "pkcs11-properties.c"
	}
	__finally0:
#line 170 "../pkcs11/pkcs11-properties.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "../pkcs11/pkcs11-properties.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "../pkcs11/pkcs11-properties.vala"
		g_clear_error (&_inner_error0_);
#line 170 "../pkcs11/pkcs11-properties.vala"
		return;
#line 811 "pkcs11-properties.c"
	}
}

static void
___lambda8__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 169 "../pkcs11/pkcs11-properties.vala"
	__lambda8_ (self, source_object, res);
#line 169 "../pkcs11/pkcs11-properties.vala"
	block2_data_unref (self);
#line 824 "pkcs11-properties.c"
}

static void
seahorse_pkcs11_properties_check_certificate_request_capable (SeahorsePkcs11Properties* self,
                                                              GObject* object)
{
	Block2Data* _data2_;
	GObject* _tmp0_;
	GCancellable* _tmp1_;
#line 165 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (self != NULL);
#line 165 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (object != NULL);
#line 165 "../pkcs11/pkcs11-properties.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 165 "../pkcs11/pkcs11-properties.vala"
	_data2_->_ref_count_ = 1;
#line 165 "../pkcs11/pkcs11-properties.vala"
	_data2_->self = g_object_ref (self);
#line 165 "../pkcs11/pkcs11-properties.vala"
	_tmp0_ = _g_object_ref0 (object);
#line 165 "../pkcs11/pkcs11-properties.vala"
	_g_object_unref0 (_data2_->object);
#line 165 "../pkcs11/pkcs11-properties.vala"
	_data2_->object = _tmp0_;
#line 166 "../pkcs11/pkcs11-properties.vala"
	if (!SEAHORSE_PKCS11_IS_PRIVATE_KEY (_data2_->object)) {
#line 167 "../pkcs11/pkcs11-properties.vala"
		block2_data_unref (_data2_);
#line 167 "../pkcs11/pkcs11-properties.vala"
		_data2_ = NULL;
#line 167 "../pkcs11/pkcs11-properties.vala"
		return;
#line 858 "pkcs11-properties.c"
	}
#line 169 "../pkcs11/pkcs11-properties.vala"
	_tmp1_ = self->priv->_cancellable;
#line 169 "../pkcs11/pkcs11-properties.vala"
	gcr_certificate_request_capable_async ((GckObject*) G_TYPE_CHECK_INSTANCE_CAST (_data2_->object, SEAHORSE_PKCS11_TYPE_PRIVATE_KEY, SeahorsePkcs11PrivateKey), _tmp1_, ___lambda8__gasync_ready_callback, block2_data_ref (_data2_));
#line 165 "../pkcs11/pkcs11-properties.vala"
	block2_data_unref (_data2_);
#line 165 "../pkcs11/pkcs11-properties.vala"
	_data2_ = NULL;
#line 868 "pkcs11-properties.c"
}

GckObject*
seahorse_pkcs11_properties_get_object (SeahorsePkcs11Properties* self)
{
	GckObject* result;
	GckObject* _tmp0_;
#line 29 "../pkcs11/pkcs11-properties.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../pkcs11/pkcs11-properties.vala"
	_tmp0_ = self->priv->_object;
#line 29 "../pkcs11/pkcs11-properties.vala"
	result = _tmp0_;
#line 29 "../pkcs11/pkcs11-properties.vala"
	return result;
#line 884 "pkcs11-properties.c"
}

static void
seahorse_pkcs11_properties_set_object (SeahorsePkcs11Properties* self,
                                       GckObject* value)
{
	GckObject* old_value;
#line 29 "../pkcs11/pkcs11-properties.vala"
	g_return_if_fail (self != NULL);
#line 29 "../pkcs11/pkcs11-properties.vala"
	old_value = seahorse_pkcs11_properties_get_object (self);
#line 29 "../pkcs11/pkcs11-properties.vala"
	if (old_value != value) {
#line 898 "pkcs11-properties.c"
		GckObject* _tmp0_;
#line 29 "../pkcs11/pkcs11-properties.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../pkcs11/pkcs11-properties.vala"
		_g_object_unref0 (self->priv->_object);
#line 29 "../pkcs11/pkcs11-properties.vala"
		self->priv->_object = _tmp0_;
#line 29 "../pkcs11/pkcs11-properties.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_pkcs11_properties_properties[SEAHORSE_PKCS11_PROPERTIES_OBJECT_PROPERTY]);
#line 908 "pkcs11-properties.c"
	}
}

static void
_seahorse_pkcs11_properties___lambda9_ (SeahorsePkcs11Properties* self)
{
#line 67 "../pkcs11/pkcs11-properties.vala"
	seahorse_pkcs11_properties_update_label (self);
#line 917 "pkcs11-properties.c"
}

static void
__seahorse_pkcs11_properties___lambda9__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 67 "../pkcs11/pkcs11-properties.vala"
	_seahorse_pkcs11_properties___lambda9_ ((SeahorsePkcs11Properties*) self);
#line 927 "pkcs11-properties.c"
}

static GObject *
seahorse_pkcs11_properties_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorsePkcs11Properties * self;
	GCancellable* _tmp0_;
	GcrViewer* _tmp1_;
	GcrViewer* _tmp2_;
	GtkBox* _tmp3_;
	GcrViewer* _tmp4_;
	GcrViewer* _tmp5_;
	GcrViewer* _tmp6_;
	GcrViewer* _tmp7_;
	GckObject* _tmp8_;
	GtkButton* _tmp9_;
	GckObject* _tmp10_;
	GtkButton* _tmp11_;
	GckObject* _tmp12_;
	GckObject* _tmp13_;
	GckObject* _tmp14_;
	GObject* partner = NULL;
	GckObject* _tmp15_;
	GObject* _tmp16_ = NULL;
	GObject* _tmp17_;
	GList* exporters = NULL;
	GckObject* _tmp20_;
	GtkButton* _tmp23_;
	GList* _tmp24_;
	GcrViewer* _tmp25_;
#line 51 "../pkcs11/pkcs11-properties.vala"
	parent_class = G_OBJECT_CLASS (seahorse_pkcs11_properties_parent_class);
#line 51 "../pkcs11/pkcs11-properties.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../pkcs11/pkcs11-properties.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_PKCS11_TYPE_PROPERTIES, SeahorsePkcs11Properties);
#line 52 "../pkcs11/pkcs11-properties.vala"
	_tmp0_ = g_cancellable_new ();
#line 52 "../pkcs11/pkcs11-properties.vala"
	_g_object_unref0 (self->priv->_cancellable);
#line 52 "../pkcs11/pkcs11-properties.vala"
	self->priv->_cancellable = _tmp0_;
#line 54 "../pkcs11/pkcs11-properties.vala"
	_tmp1_ = gcr_viewer_new_scrolled ();
#line 54 "../pkcs11/pkcs11-properties.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 54 "../pkcs11/pkcs11-properties.vala"
	_g_object_unref0 (self->priv->_viewer);
#line 54 "../pkcs11/pkcs11-properties.vala"
	self->priv->_viewer = _tmp2_;
#line 55 "../pkcs11/pkcs11-properties.vala"
	_tmp3_ = self->priv->content;
#line 55 "../pkcs11/pkcs11-properties.vala"
	_tmp4_ = self->priv->_viewer;
#line 55 "../pkcs11/pkcs11-properties.vala"
	gtk_box_pack_start (_tmp3_, (GtkWidget*) _tmp4_, TRUE, TRUE, (guint) 0);
#line 56 "../pkcs11/pkcs11-properties.vala"
	_tmp5_ = self->priv->_viewer;
#line 56 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp5_, TRUE);
#line 57 "../pkcs11/pkcs11-properties.vala"
	_tmp6_ = self->priv->_viewer;
#line 57 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp6_, TRUE);
#line 58 "../pkcs11/pkcs11-properties.vala"
	_tmp7_ = self->priv->_viewer;
#line 58 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_show ((GtkWidget*) _tmp7_);
#line 62 "../pkcs11/pkcs11-properties.vala"
	_tmp8_ = self->priv->_object;
#line 62 "../pkcs11/pkcs11-properties.vala"
	_tmp9_ = self->priv->delete_button;
#line 62 "../pkcs11/pkcs11-properties.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp8_, "deletable", (GObject*) _tmp9_, "visible", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 64 "../pkcs11/pkcs11-properties.vala"
	_tmp10_ = self->priv->_object;
#line 64 "../pkcs11/pkcs11-properties.vala"
	_tmp11_ = self->priv->export_button;
#line 64 "../pkcs11/pkcs11-properties.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp10_, "exportable", (GObject*) _tmp11_, "visible", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 67 "../pkcs11/pkcs11-properties.vala"
	_tmp12_ = self->priv->_object;
#line 67 "../pkcs11/pkcs11-properties.vala"
	g_signal_connect_object ((GObject*) _tmp12_, "notify::label", (GCallback) __seahorse_pkcs11_properties___lambda9__g_object_notify, self, 0);
#line 68 "../pkcs11/pkcs11-properties.vala"
	seahorse_pkcs11_properties_update_label (self);
#line 69 "../pkcs11/pkcs11-properties.vala"
	_tmp13_ = self->priv->_object;
#line 69 "../pkcs11/pkcs11-properties.vala"
	seahorse_pkcs11_properties_add_renderer_for_object (self, (GObject*) _tmp13_);
#line 70 "../pkcs11/pkcs11-properties.vala"
	_tmp14_ = self->priv->_object;
#line 70 "../pkcs11/pkcs11-properties.vala"
	seahorse_pkcs11_properties_check_certificate_request_capable (self, (GObject*) _tmp14_);
#line 73 "../pkcs11/pkcs11-properties.vala"
	_tmp15_ = self->priv->_object;
#line 73 "../pkcs11/pkcs11-properties.vala"
	g_object_get ((GObject*) _tmp15_, "partner", &_tmp16_, NULL);
#line 73 "../pkcs11/pkcs11-properties.vala"
	_g_object_unref0 (partner);
#line 73 "../pkcs11/pkcs11-properties.vala"
	partner = _tmp16_;
#line 74 "../pkcs11/pkcs11-properties.vala"
	_tmp17_ = partner;
#line 74 "../pkcs11/pkcs11-properties.vala"
	if (_tmp17_ != NULL) {
#line 1038 "pkcs11-properties.c"
		GObject* _tmp18_;
		GObject* _tmp19_;
#line 75 "../pkcs11/pkcs11-properties.vala"
		_tmp18_ = partner;
#line 75 "../pkcs11/pkcs11-properties.vala"
		seahorse_pkcs11_properties_add_renderer_for_object (self, _tmp18_);
#line 76 "../pkcs11/pkcs11-properties.vala"
		_tmp19_ = partner;
#line 76 "../pkcs11/pkcs11-properties.vala"
		seahorse_pkcs11_properties_check_certificate_request_capable (self, _tmp19_);
#line 1049 "pkcs11-properties.c"
	}
#line 79 "../pkcs11/pkcs11-properties.vala"
	exporters = NULL;
#line 80 "../pkcs11/pkcs11-properties.vala"
	_tmp20_ = self->priv->_object;
#line 80 "../pkcs11/pkcs11-properties.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp20_, SEAHORSE_TYPE_EXPORTABLE)) {
#line 1057 "pkcs11-properties.c"
		GckObject* _tmp21_;
		GList* _tmp22_;
#line 81 "../pkcs11/pkcs11-properties.vala"
		_tmp21_ = self->priv->_object;
#line 81 "../pkcs11/pkcs11-properties.vala"
		_tmp22_ = seahorse_exportable_create_exporters (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, SEAHORSE_TYPE_EXPORTABLE, SeahorseExportable), SEAHORSE_EXPORTER_TYPE_ANY);
#line 81 "../pkcs11/pkcs11-properties.vala"
		(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 81 "../pkcs11/pkcs11-properties.vala"
		exporters = _tmp22_;
#line 1068 "pkcs11-properties.c"
	}
#line 83 "../pkcs11/pkcs11-properties.vala"
	_tmp23_ = self->priv->export_button;
#line 83 "../pkcs11/pkcs11-properties.vala"
	_tmp24_ = exporters;
#line 83 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp23_, _tmp24_ != NULL);
#line 85 "../pkcs11/pkcs11-properties.vala"
	_tmp25_ = self->priv->_viewer;
#line 85 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp25_);
#line 51 "../pkcs11/pkcs11-properties.vala"
	(exporters == NULL) ? NULL : (exporters = (_g_list_free__g_object_unref0_ (exporters), NULL));
#line 51 "../pkcs11/pkcs11-properties.vala"
	_g_object_unref0 (partner);
#line 51 "../pkcs11/pkcs11-properties.vala"
	return obj;
#line 1086 "pkcs11-properties.c"
}

static void
seahorse_pkcs11_properties_class_init (SeahorsePkcs11PropertiesClass * klass,
                                       gpointer klass_data)
{
#line 27 "../pkcs11/pkcs11-properties.vala"
	seahorse_pkcs11_properties_parent_class = g_type_class_peek_parent (klass);
#line 27 "../pkcs11/pkcs11-properties.vala"
	g_type_class_adjust_private_offset (klass, &SeahorsePkcs11Properties_private_offset);
#line 27 "../pkcs11/pkcs11-properties.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) seahorse_pkcs11_properties_real_dispose;
#line 27 "../pkcs11/pkcs11-properties.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_pkcs11_properties_get_property;
#line 27 "../pkcs11/pkcs11-properties.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_pkcs11_properties_set_property;
#line 27 "../pkcs11/pkcs11-properties.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_pkcs11_properties_constructor;
#line 27 "../pkcs11/pkcs11-properties.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_pkcs11_properties_finalize;
#line 27 "../pkcs11/pkcs11-properties.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_PROPERTIES_OBJECT_PROPERTY, seahorse_pkcs11_properties_properties[SEAHORSE_PKCS11_PROPERTIES_OBJECT_PROPERTY] = g_param_spec_object ("object", "object", "object", gck_object_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 27 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Seahorse/seahorse-pkcs11-properties.ui");
#line 27 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delete_button", FALSE, SeahorsePkcs11Properties_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11PropertiesPrivate, delete_button));
#line 27 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "export_button", FALSE, SeahorsePkcs11Properties_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11PropertiesPrivate, export_button));
#line 27 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "request_certificate_button", FALSE, SeahorsePkcs11Properties_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11PropertiesPrivate, request_certificate_button));
#line 27 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "content", FALSE, SeahorsePkcs11Properties_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11PropertiesPrivate, content));
#line 27 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_export_button_clicked", G_CALLBACK(_seahorse_pkcs11_properties_on_export_button_clicked_gtk_button_clicked));
#line 27 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_delete_button_clicked", G_CALLBACK(_seahorse_pkcs11_properties_on_delete_button_clicked_gtk_button_clicked));
#line 27 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_request_certificate_button_clicked", G_CALLBACK(_seahorse_pkcs11_properties_on_request_certificate_button_clicked_gtk_button_clicked));
#line 1125 "pkcs11-properties.c"
}

static void
seahorse_pkcs11_properties_instance_init (SeahorsePkcs11Properties * self,
                                          gpointer klass)
{
#line 27 "../pkcs11/pkcs11-properties.vala"
	self->priv = seahorse_pkcs11_properties_get_instance_private (self);
#line 27 "../pkcs11/pkcs11-properties.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1136 "pkcs11-properties.c"
}

static void
seahorse_pkcs11_properties_finalize (GObject * obj)
{
	SeahorsePkcs11Properties * self;
#line 27 "../pkcs11/pkcs11-properties.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_PKCS11_TYPE_PROPERTIES, SeahorsePkcs11Properties);
#line 29 "../pkcs11/pkcs11-properties.vala"
	_g_object_unref0 (self->priv->_object);
#line 43 "../pkcs11/pkcs11-properties.vala"
	_g_object_unref0 (self->priv->_viewer);
#line 44 "../pkcs11/pkcs11-properties.vala"
	_g_object_unref0 (self->priv->_cancellable);
#line 45 "../pkcs11/pkcs11-properties.vala"
	_g_object_unref0 (self->priv->_request_key);
#line 27 "../pkcs11/pkcs11-properties.vala"
	G_OBJECT_CLASS (seahorse_pkcs11_properties_parent_class)->finalize (obj);
#line 1155 "pkcs11-properties.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_pkcs11_properties_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorsePkcs11PropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_pkcs11_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorsePkcs11Properties), 0, (GInstanceInitFunc) seahorse_pkcs11_properties_instance_init, NULL };
	GType seahorse_pkcs11_properties_type_id;
	seahorse_pkcs11_properties_type_id = g_type_register_static (gtk_dialog_get_type (), "SeahorsePkcs11Properties", &g_define_type_info, 0);
	SeahorsePkcs11Properties_private_offset = g_type_add_instance_private (seahorse_pkcs11_properties_type_id, sizeof (SeahorsePkcs11PropertiesPrivate));
	return seahorse_pkcs11_properties_type_id;
}

GType
seahorse_pkcs11_properties_get_type (void)
{
	static volatile gsize seahorse_pkcs11_properties_type_id__once = 0;
	if (g_once_init_enter (&seahorse_pkcs11_properties_type_id__once)) {
		GType seahorse_pkcs11_properties_type_id;
		seahorse_pkcs11_properties_type_id = seahorse_pkcs11_properties_get_type_once ();
		g_once_init_leave (&seahorse_pkcs11_properties_type_id__once, seahorse_pkcs11_properties_type_id);
	}
	return seahorse_pkcs11_properties_type_id__once;
}

static void
_vala_seahorse_pkcs11_properties_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	SeahorsePkcs11Properties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_PKCS11_TYPE_PROPERTIES, SeahorsePkcs11Properties);
#line 27 "../pkcs11/pkcs11-properties.vala"
	switch (property_id) {
#line 27 "../pkcs11/pkcs11-properties.vala"
		case SEAHORSE_PKCS11_PROPERTIES_OBJECT_PROPERTY:
#line 27 "../pkcs11/pkcs11-properties.vala"
		g_value_set_object (value, seahorse_pkcs11_properties_get_object (self));
#line 27 "../pkcs11/pkcs11-properties.vala"
		break;
#line 1196 "pkcs11-properties.c"
		default:
#line 27 "../pkcs11/pkcs11-properties.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../pkcs11/pkcs11-properties.vala"
		break;
#line 1202 "pkcs11-properties.c"
	}
}

static void
_vala_seahorse_pkcs11_properties_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	SeahorsePkcs11Properties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_PKCS11_TYPE_PROPERTIES, SeahorsePkcs11Properties);
#line 27 "../pkcs11/pkcs11-properties.vala"
	switch (property_id) {
#line 27 "../pkcs11/pkcs11-properties.vala"
		case SEAHORSE_PKCS11_PROPERTIES_OBJECT_PROPERTY:
#line 27 "../pkcs11/pkcs11-properties.vala"
		seahorse_pkcs11_properties_set_object (self, g_value_get_object (value));
#line 27 "../pkcs11/pkcs11-properties.vala"
		break;
#line 1222 "pkcs11-properties.c"
		default:
#line 27 "../pkcs11/pkcs11-properties.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../pkcs11/pkcs11-properties.vala"
		break;
#line 1228 "pkcs11-properties.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

