/* algorithm.c generated by valac 0.56.11, the Vala compiler
 * generated from algorithm.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (c) 2016 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-ssh.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define _g_free0(var) (var = (g_free (var), NULL))

/**
 * Enumerates the possible algorithms in which an SSH key can be encrypted.
 * This is also known as the 'type' of a key.
 */
/**
     * Returns a (non-localized) string representation.
     *
     * @return A string representation, or null if UNKNOWN.
     */
gchar*
seahorse_ssh_algorithm_to_string (SeahorseSshAlgorithm self)
{
	gchar* result;
#line 37 "../ssh/algorithm.vala"
	switch (self) {
#line 37 "../ssh/algorithm.vala"
		case SEAHORSE_SSH_ALGORITHM_UNKNOWN:
#line 48 "algorithm.c"
		{
			gchar* _tmp0_;
#line 39 "../ssh/algorithm.vala"
			_tmp0_ = g_strdup ("");
#line 39 "../ssh/algorithm.vala"
			result = _tmp0_;
#line 39 "../ssh/algorithm.vala"
			return result;
#line 57 "algorithm.c"
		}
#line 37 "../ssh/algorithm.vala"
		case SEAHORSE_SSH_ALGORITHM_RSA:
#line 61 "algorithm.c"
		{
			gchar* _tmp1_;
#line 41 "../ssh/algorithm.vala"
			_tmp1_ = g_strdup ("RSA");
#line 41 "../ssh/algorithm.vala"
			result = _tmp1_;
#line 41 "../ssh/algorithm.vala"
			return result;
#line 70 "algorithm.c"
		}
#line 37 "../ssh/algorithm.vala"
		case SEAHORSE_SSH_ALGORITHM_DSA:
#line 74 "algorithm.c"
		{
			gchar* _tmp2_;
#line 43 "../ssh/algorithm.vala"
			_tmp2_ = g_strdup ("DSA");
#line 43 "../ssh/algorithm.vala"
			result = _tmp2_;
#line 43 "../ssh/algorithm.vala"
			return result;
#line 83 "algorithm.c"
		}
#line 37 "../ssh/algorithm.vala"
		case SEAHORSE_SSH_ALGORITHM_ECDSA:
#line 87 "algorithm.c"
		{
			gchar* _tmp3_;
#line 45 "../ssh/algorithm.vala"
			_tmp3_ = g_strdup ("ECDSA");
#line 45 "../ssh/algorithm.vala"
			result = _tmp3_;
#line 45 "../ssh/algorithm.vala"
			return result;
#line 96 "algorithm.c"
		}
#line 37 "../ssh/algorithm.vala"
		case SEAHORSE_SSH_ALGORITHM_ED25519:
#line 100 "algorithm.c"
		{
			gchar* _tmp4_;
#line 47 "../ssh/algorithm.vala"
			_tmp4_ = g_strdup ("ED25519");
#line 47 "../ssh/algorithm.vala"
			result = _tmp4_;
#line 47 "../ssh/algorithm.vala"
			return result;
#line 109 "algorithm.c"
		}
		default:
		{
#line 49 "../ssh/algorithm.vala"
			g_assert_not_reached ();
#line 115 "algorithm.c"
		}
	}
}

/**
     * Converts a string representation into a Algorithm.
     *
     * @return The algorithm (can be UNKNOWN).
     */
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 143 "algorithm.c"
}

SeahorseSshAlgorithm
seahorse_ssh_algorithm_from_string (const gchar* type)
{
	gboolean _tmp0_ = FALSE;
	gchar* _type = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GQuark _tmp8_ = 0U;
#line 63 "../ssh/algorithm.vala"
	static GQuark _tmp7_label0 = 0;
#line 63 "../ssh/algorithm.vala"
	static GQuark _tmp7_label1 = 0;
#line 63 "../ssh/algorithm.vala"
	static GQuark _tmp7_label2 = 0;
#line 63 "../ssh/algorithm.vala"
	static GQuark _tmp7_label3 = 0;
#line 63 "../ssh/algorithm.vala"
	static GQuark _tmp7_label4 = 0;
#line 168 "algorithm.c"
	SeahorseSshAlgorithm result;
#line 59 "../ssh/algorithm.vala"
	if (type == NULL) {
#line 59 "../ssh/algorithm.vala"
		_tmp0_ = TRUE;
#line 174 "algorithm.c"
	} else {
#line 59 "../ssh/algorithm.vala"
		_tmp0_ = g_strcmp0 (type, "") == 0;
#line 178 "algorithm.c"
	}
#line 59 "../ssh/algorithm.vala"
	if (_tmp0_) {
#line 60 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_UNKNOWN;
#line 60 "../ssh/algorithm.vala"
		return result;
#line 186 "algorithm.c"
	}
#line 62 "../ssh/algorithm.vala"
	_tmp1_ = string_strip (type);
#line 62 "../ssh/algorithm.vala"
	_tmp2_ = _tmp1_;
#line 62 "../ssh/algorithm.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 62 "../ssh/algorithm.vala"
	_tmp4_ = _tmp3_;
#line 62 "../ssh/algorithm.vala"
	_g_free0 (_tmp2_);
#line 62 "../ssh/algorithm.vala"
	_type = _tmp4_;
#line 63 "../ssh/algorithm.vala"
	_tmp5_ = _type;
#line 63 "../ssh/algorithm.vala"
	_tmp6_ = _tmp5_;
#line 63 "../ssh/algorithm.vala"
	_tmp8_ = (NULL == _tmp6_) ? 0 : g_quark_from_string (_tmp6_);
#line 63 "../ssh/algorithm.vala"
	if (_tmp8_ == ((0 != _tmp7_label0) ? _tmp7_label0 : (_tmp7_label0 = g_quark_from_static_string ("rsa")))) {
#line 63 "../ssh/algorithm.vala"
		switch (0) {
#line 210 "algorithm.c"
			default:
			{
#line 65 "../ssh/algorithm.vala"
				result = SEAHORSE_SSH_ALGORITHM_RSA;
#line 65 "../ssh/algorithm.vala"
				_g_free0 (_type);
#line 65 "../ssh/algorithm.vala"
				return result;
#line 219 "algorithm.c"
			}
		}
	} else if ((_tmp8_ == ((0 != _tmp7_label1) ? _tmp7_label1 : (_tmp7_label1 = g_quark_from_static_string ("dsa")))) || (_tmp8_ == ((0 != _tmp7_label2) ? _tmp7_label2 : (_tmp7_label2 = g_quark_from_static_string ("dss"))))) {
#line 63 "../ssh/algorithm.vala"
		switch (0) {
#line 225 "algorithm.c"
			default:
			{
#line 68 "../ssh/algorithm.vala"
				result = SEAHORSE_SSH_ALGORITHM_DSA;
#line 68 "../ssh/algorithm.vala"
				_g_free0 (_type);
#line 68 "../ssh/algorithm.vala"
				return result;
#line 234 "algorithm.c"
			}
		}
	} else if (_tmp8_ == ((0 != _tmp7_label3) ? _tmp7_label3 : (_tmp7_label3 = g_quark_from_static_string ("ecdsa")))) {
#line 63 "../ssh/algorithm.vala"
		switch (0) {
#line 240 "algorithm.c"
			default:
			{
#line 70 "../ssh/algorithm.vala"
				result = SEAHORSE_SSH_ALGORITHM_ECDSA;
#line 70 "../ssh/algorithm.vala"
				_g_free0 (_type);
#line 70 "../ssh/algorithm.vala"
				return result;
#line 249 "algorithm.c"
			}
		}
	} else if (_tmp8_ == ((0 != _tmp7_label4) ? _tmp7_label4 : (_tmp7_label4 = g_quark_from_static_string ("ed25519")))) {
#line 63 "../ssh/algorithm.vala"
		switch (0) {
#line 255 "algorithm.c"
			default:
			{
#line 72 "../ssh/algorithm.vala"
				result = SEAHORSE_SSH_ALGORITHM_ED25519;
#line 72 "../ssh/algorithm.vala"
				_g_free0 (_type);
#line 72 "../ssh/algorithm.vala"
				return result;
#line 264 "algorithm.c"
			}
		}
	} else {
#line 63 "../ssh/algorithm.vala"
		switch (0) {
#line 270 "algorithm.c"
			default:
			{
#line 74 "../ssh/algorithm.vala"
				result = SEAHORSE_SSH_ALGORITHM_UNKNOWN;
#line 74 "../ssh/algorithm.vala"
				_g_free0 (_type);
#line 74 "../ssh/algorithm.vala"
				return result;
#line 279 "algorithm.c"
			}
		}
	}
}

/**
     * Tries to make an educated guess for the algorithm type.
     * Basically it just checks if the given string contains the type.
     *
     * @return The guessed algorithm (can be UNKNOWN)
     */
static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 307 "algorithm.c"
}

SeahorseSshAlgorithm
seahorse_ssh_algorithm_guess_from_string (const gchar* str)
{
	gboolean _tmp0_ = FALSE;
	gchar* str_down = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	SeahorseSshAlgorithm result;
#line 85 "../ssh/algorithm.vala"
	if (str == NULL) {
#line 85 "../ssh/algorithm.vala"
		_tmp0_ = TRUE;
#line 326 "algorithm.c"
	} else {
#line 85 "../ssh/algorithm.vala"
		_tmp0_ = g_strcmp0 (str, "") == 0;
#line 330 "algorithm.c"
	}
#line 85 "../ssh/algorithm.vala"
	if (_tmp0_) {
#line 86 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_UNKNOWN;
#line 86 "../ssh/algorithm.vala"
		return result;
#line 338 "algorithm.c"
	}
#line 88 "../ssh/algorithm.vala"
	_tmp1_ = g_utf8_strdown (str, (gssize) -1);
#line 88 "../ssh/algorithm.vala"
	str_down = _tmp1_;
#line 89 "../ssh/algorithm.vala"
	_tmp2_ = str_down;
#line 89 "../ssh/algorithm.vala"
	if (string_contains (_tmp2_, "rsa")) {
#line 90 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_RSA;
#line 90 "../ssh/algorithm.vala"
		_g_free0 (str_down);
#line 90 "../ssh/algorithm.vala"
		return result;
#line 354 "algorithm.c"
	}
#line 92 "../ssh/algorithm.vala"
	_tmp4_ = str_down;
#line 92 "../ssh/algorithm.vala"
	if (string_contains (_tmp4_, "dsa")) {
#line 92 "../ssh/algorithm.vala"
		_tmp3_ = TRUE;
#line 362 "algorithm.c"
	} else {
		const gchar* _tmp5_;
#line 92 "../ssh/algorithm.vala"
		_tmp5_ = str_down;
#line 92 "../ssh/algorithm.vala"
		_tmp3_ = string_contains (_tmp5_, "dss");
#line 369 "algorithm.c"
	}
#line 92 "../ssh/algorithm.vala"
	if (_tmp3_) {
#line 93 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_DSA;
#line 93 "../ssh/algorithm.vala"
		_g_free0 (str_down);
#line 93 "../ssh/algorithm.vala"
		return result;
#line 379 "algorithm.c"
	}
#line 95 "../ssh/algorithm.vala"
	_tmp6_ = str_down;
#line 95 "../ssh/algorithm.vala"
	if (string_contains (_tmp6_, "ecdsa")) {
#line 96 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_ECDSA;
#line 96 "../ssh/algorithm.vala"
		_g_free0 (str_down);
#line 96 "../ssh/algorithm.vala"
		return result;
#line 391 "algorithm.c"
	}
#line 98 "../ssh/algorithm.vala"
	_tmp7_ = str_down;
#line 98 "../ssh/algorithm.vala"
	if (string_contains (_tmp7_, "ed25519")) {
#line 99 "../ssh/algorithm.vala"
		result = SEAHORSE_SSH_ALGORITHM_ED25519;
#line 99 "../ssh/algorithm.vala"
		_g_free0 (str_down);
#line 99 "../ssh/algorithm.vala"
		return result;
#line 403 "algorithm.c"
	}
#line 101 "../ssh/algorithm.vala"
	result = SEAHORSE_SSH_ALGORITHM_UNKNOWN;
#line 101 "../ssh/algorithm.vala"
	_g_free0 (str_down);
#line 101 "../ssh/algorithm.vala"
	return result;
#line 411 "algorithm.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_ssh_algorithm_get_type_once (void)
{
	static const GEnumValue values[] = {{SEAHORSE_SSH_ALGORITHM_UNKNOWN, "SEAHORSE_SSH_ALGORITHM_UNKNOWN", "unknown"}, {SEAHORSE_SSH_ALGORITHM_RSA, "SEAHORSE_SSH_ALGORITHM_RSA", "rsa"}, {SEAHORSE_SSH_ALGORITHM_DSA, "SEAHORSE_SSH_ALGORITHM_DSA", "dsa"}, {SEAHORSE_SSH_ALGORITHM_ECDSA, "SEAHORSE_SSH_ALGORITHM_ECDSA", "ecdsa"}, {SEAHORSE_SSH_ALGORITHM_ED25519, "SEAHORSE_SSH_ALGORITHM_ED25519", "ed25519"}, {0, NULL, NULL}};
	GType seahorse_ssh_algorithm_type_id;
	seahorse_ssh_algorithm_type_id = g_enum_register_static ("SeahorseSshAlgorithm", values);
	return seahorse_ssh_algorithm_type_id;
}

GType
seahorse_ssh_algorithm_get_type (void)
{
	static volatile gsize seahorse_ssh_algorithm_type_id__once = 0;
	if (g_once_init_enter (&seahorse_ssh_algorithm_type_id__once)) {
		GType seahorse_ssh_algorithm_type_id;
		seahorse_ssh_algorithm_type_id = seahorse_ssh_algorithm_get_type_once ();
		g_once_init_leave (&seahorse_ssh_algorithm_type_id__once, seahorse_ssh_algorithm_type_id);
	}
	return seahorse_ssh_algorithm_type_id__once;
}

