/* key-data.c generated by valac 0.56.11, the Vala compiler
 * generated from key-data.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2006 Stefan Walter
 * Copyright (C) 2016 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-ssh.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <glib-object.h>

enum  {
	SEAHORSE_SSH_KEY_DATA_0_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY,
	SEAHORSE_SSH_KEY_DATA_NUM_PROPERTIES
};
static GParamSpec* seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	SEAHORSE_SSH_SEC_DATA_0_PROPERTY,
	SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY,
	SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY,
	SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY,
	SEAHORSE_SSH_SEC_DATA_NUM_PROPERTIES
};
static GParamSpec* seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_NUM_PROPERTIES];

struct _SeahorseSshKeyDataPrivate {
	gchar* _privfile;
	gchar* _pubfile;
	gboolean _partial;
	gboolean _authorized;
	gchar* _rawdata;
	gchar* _comment;
	gchar* _fingerprint;
	guint _length;
	SeahorseSshAlgorithm _algo;
};

struct _SeahorseSshSecDataPrivate {
	gchar* _rawdata;
	gchar* _comment;
	SeahorseSshAlgorithm _algo;
};

static gint SeahorseSshKeyData_private_offset;
static gpointer seahorse_ssh_key_data_parent_class = NULL;
static gint SeahorseSshSecData_private_offset;
static gpointer seahorse_ssh_sec_data_parent_class = NULL;

VALA_EXTERN void seahorse_ssh_key_data_set_rawdata (SeahorseSshKeyData* self,
                                        const gchar* value);
VALA_EXTERN void seahorse_ssh_key_data_set_algo (SeahorseSshKeyData* self,
                                     SeahorseSshAlgorithm value);
VALA_EXTERN gchar* seahorse_ssh_key_data_parse_key_blob (guchar* bytes,
                                             gint bytes_length1,
                                             GError** error);
VALA_EXTERN void seahorse_ssh_key_data_set_fingerprint (SeahorseSshKeyData* self,
                                            const gchar* value);
VALA_EXTERN guint seahorse_ssh_key_data_calc_bits (SeahorseSshAlgorithm algo,
                                       guint len);
VALA_EXTERN void seahorse_ssh_key_data_set_length (SeahorseSshKeyData* self,
                                       guint value);
VALA_EXTERN void seahorse_ssh_key_data_set_comment (SeahorseSshKeyData* self,
                                        const gchar* value);
static void seahorse_ssh_key_data_finalize (GObject * obj);
static GType seahorse_ssh_key_data_get_type_once (void);
static void _vala_seahorse_ssh_key_data_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_seahorse_ssh_key_data_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
VALA_EXTERN void seahorse_ssh_sec_data_set_comment (SeahorseSshSecData* self,
                                        const gchar* value);
static gchar* seahorse_ssh_sec_data_parse_lines_block (GString* data,
                                                const gchar* start,
                                                const gchar* end);
VALA_EXTERN void seahorse_ssh_sec_data_set_rawdata (SeahorseSshSecData* self,
                                        const gchar* value);
VALA_EXTERN void seahorse_ssh_sec_data_set_algo (SeahorseSshSecData* self,
                                     SeahorseSshAlgorithm value);
static void seahorse_ssh_sec_data_finalize (GObject * obj);
static GType seahorse_ssh_sec_data_get_type_once (void);
static void _vala_seahorse_ssh_sec_data_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_seahorse_ssh_sec_data_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
seahorse_ssh_key_data_get_instance_private (SeahorseSshKeyData* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseSshKeyData_private_offset);
}

gboolean
seahorse_ssh_key_data_is_valid (SeahorseSshKeyData* self)
{
	const gchar* _tmp0_;
	gboolean result;
#line 36 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "../ssh/key-data.vala"
	_tmp0_ = self->priv->_fingerprint;
#line 37 "../ssh/key-data.vala"
	result = _tmp0_ != NULL;
#line 37 "../ssh/key-data.vala"
	return result;
#line 155 "key-data.c"
}

/**
     * Checks whether this key and another (in the form of a string) match.
     */
gboolean
seahorse_ssh_key_data_match (SeahorseSshKeyData* self,
                             const gchar* line)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 43 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../ssh/key-data.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 44 "../ssh/key-data.vala"
	if (!seahorse_ssh_key_data_is_valid (self)) {
#line 45 "../ssh/key-data.vala"
		result = FALSE;
#line 45 "../ssh/key-data.vala"
		return result;
#line 177 "key-data.c"
	}
	{
		SeahorseSshKeyData* other = NULL;
		SeahorseSshKeyData* _tmp0_;
		gboolean _tmp1_ = FALSE;
		SeahorseSshKeyData* _tmp2_;
		const gchar* _tmp3_;
#line 48 "../ssh/key-data.vala"
		_tmp0_ = seahorse_ssh_key_data_parse_line (line, &_inner_error0_);
#line 48 "../ssh/key-data.vala"
		other = _tmp0_;
#line 48 "../ssh/key-data.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "key-data.c"
			goto __catch0_g_error;
		}
#line 49 "../ssh/key-data.vala"
		_tmp2_ = other;
#line 49 "../ssh/key-data.vala"
		_tmp3_ = _tmp2_->priv->_fingerprint;
#line 49 "../ssh/key-data.vala"
		if (_tmp3_ != NULL) {
#line 200 "key-data.c"
			const gchar* _tmp4_;
			SeahorseSshKeyData* _tmp5_;
			const gchar* _tmp6_;
#line 49 "../ssh/key-data.vala"
			_tmp4_ = self->priv->_fingerprint;
#line 49 "../ssh/key-data.vala"
			_tmp5_ = other;
#line 49 "../ssh/key-data.vala"
			_tmp6_ = _tmp5_->priv->_fingerprint;
#line 49 "../ssh/key-data.vala"
			_tmp1_ = g_strcmp0 (_tmp4_, _tmp6_) == 0;
#line 212 "key-data.c"
		} else {
#line 49 "../ssh/key-data.vala"
			_tmp1_ = FALSE;
#line 216 "key-data.c"
		}
#line 49 "../ssh/key-data.vala"
		result = _tmp1_;
#line 49 "../ssh/key-data.vala"
		_g_object_unref0 (other);
#line 49 "../ssh/key-data.vala"
		return result;
#line 224 "key-data.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 47 "../ssh/key-data.vala"
		e = _inner_error0_;
#line 47 "../ssh/key-data.vala"
		_inner_error0_ = NULL;
#line 51 "../ssh/key-data.vala"
		_tmp7_ = e;
#line 51 "../ssh/key-data.vala"
		_tmp8_ = _tmp7_->message;
#line 51 "../ssh/key-data.vala"
		g_warning ("key-data.vala:51: %s", _tmp8_);
#line 47 "../ssh/key-data.vala"
		_g_error_free0 (e);
#line 244 "key-data.c"
	}
	__finally0:
#line 47 "../ssh/key-data.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 249 "key-data.c"
		gboolean _tmp9_ = FALSE;
#line 47 "../ssh/key-data.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 47 "../ssh/key-data.vala"
		g_clear_error (&_inner_error0_);
#line 47 "../ssh/key-data.vala"
		return _tmp9_;
#line 257 "key-data.c"
	}
#line 54 "../ssh/key-data.vala"
	result = FALSE;
#line 54 "../ssh/key-data.vala"
	return result;
#line 263 "key-data.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 284 "key-data.c"
}

static gchar*
string_chug (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strchug (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 305 "key-data.c"
}

SeahorseSshKeyData*
seahorse_ssh_key_data_parse_line (const gchar* line,
                                  GError** error)
{
	gboolean _tmp0_ = FALSE;
	gchar* no_leading = NULL;
	gchar* _tmp4_;
	SeahorseSshKeyData* _result_ = NULL;
	SeahorseSshKeyData* _tmp5_;
	SeahorseSshKeyData* _tmp6_;
	const gchar* _tmp7_;
	gchar** type_rest = NULL;
	const gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint type_rest_length1;
	gint _type_rest_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* type = NULL;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	SeahorseSshKeyData* _tmp18_;
	const gchar* _tmp19_;
	SeahorseSshKeyData* _tmp20_;
	SeahorseSshAlgorithm _tmp21_;
	gchar* rest = NULL;
	gchar** _tmp27_;
	gint _tmp27__length1;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar** data_comment = NULL;
	const gchar* _tmp32_;
	gchar** _tmp33_;
	gchar** _tmp34_;
	gint data_comment_length1;
	gint _data_comment_size_;
	guchar* bytes = NULL;
	gchar** _tmp35_;
	gint _tmp35__length1;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gsize _tmp39_ = 0;
	guchar* _tmp40_;
	guchar* _tmp41_;
	gint _tmp41__length1;
	gint bytes_length1;
	gint _bytes_size_;
	gchar* _tmp42_ = NULL;
	guchar* _tmp43_;
	gint _tmp43__length1;
	gchar* _tmp44_;
	SeahorseSshKeyData* _tmp45_;
	SeahorseSshKeyData* _tmp46_;
	SeahorseSshKeyData* _tmp47_;
	SeahorseSshAlgorithm _tmp48_;
	guchar* _tmp49_;
	gint _tmp49__length1;
	gchar** _tmp50_;
	gint _tmp50__length1;
	GError* _inner_error0_ = NULL;
	SeahorseSshKeyData* result;
#line 58 "../ssh/key-data.vala"
	if (line == NULL) {
#line 58 "../ssh/key-data.vala"
		_tmp0_ = TRUE;
#line 379 "key-data.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 58 "../ssh/key-data.vala"
		_tmp1_ = string_strip (line);
#line 58 "../ssh/key-data.vala"
		_tmp2_ = _tmp1_;
#line 58 "../ssh/key-data.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
#line 58 "../ssh/key-data.vala"
		_g_free0 (_tmp2_);
#line 391 "key-data.c"
	}
#line 58 "../ssh/key-data.vala"
	if (_tmp0_) {
#line 395 "key-data.c"
		GError* _tmp3_;
#line 59 "../ssh/key-data.vala"
		_tmp3_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Can't parse key from empty line.");
#line 59 "../ssh/key-data.vala"
		_inner_error0_ = _tmp3_;
#line 59 "../ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 59 "../ssh/key-data.vala"
		return NULL;
#line 405 "key-data.c"
	}
#line 61 "../ssh/key-data.vala"
	_tmp4_ = string_chug (line);
#line 61 "../ssh/key-data.vala"
	no_leading = _tmp4_;
#line 62 "../ssh/key-data.vala"
	_tmp5_ = seahorse_ssh_key_data_new ();
#line 62 "../ssh/key-data.vala"
	_result_ = _tmp5_;
#line 63 "../ssh/key-data.vala"
	_tmp6_ = _result_;
#line 63 "../ssh/key-data.vala"
	_tmp7_ = no_leading;
#line 63 "../ssh/key-data.vala"
	seahorse_ssh_key_data_set_rawdata (_tmp6_, _tmp7_);
#line 66 "../ssh/key-data.vala"
	_tmp8_ = no_leading;
#line 66 "../ssh/key-data.vala"
	_tmp10_ = _tmp9_ = g_strsplit_set (_tmp8_, " \t", 2);
#line 66 "../ssh/key-data.vala"
	type_rest = _tmp10_;
#line 66 "../ssh/key-data.vala"
	type_rest_length1 = _vala_array_length (_tmp9_);
#line 66 "../ssh/key-data.vala"
	_type_rest_size_ = type_rest_length1;
#line 67 "../ssh/key-data.vala"
	_tmp11_ = type_rest;
#line 67 "../ssh/key-data.vala"
	_tmp11__length1 = type_rest_length1;
#line 67 "../ssh/key-data.vala"
	if (_tmp11__length1 != 2) {
#line 437 "key-data.c"
		GError* _tmp12_;
#line 68 "../ssh/key-data.vala"
		_tmp12_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Can't distinguish type from data (space missing).");
#line 68 "../ssh/key-data.vala"
		_inner_error0_ = _tmp12_;
#line 68 "../ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 68 "../ssh/key-data.vala"
		type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 68 "../ssh/key-data.vala"
		_g_object_unref0 (_result_);
#line 68 "../ssh/key-data.vala"
		_g_free0 (no_leading);
#line 68 "../ssh/key-data.vala"
		return NULL;
#line 453 "key-data.c"
	}
#line 70 "../ssh/key-data.vala"
	_tmp13_ = type_rest;
#line 70 "../ssh/key-data.vala"
	_tmp13__length1 = type_rest_length1;
#line 70 "../ssh/key-data.vala"
	_tmp14_ = _tmp13_[0];
#line 70 "../ssh/key-data.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 70 "../ssh/key-data.vala"
	type = _tmp15_;
#line 71 "../ssh/key-data.vala"
	_tmp16_ = type;
#line 71 "../ssh/key-data.vala"
	if (g_strcmp0 (_tmp16_, "") == 0) {
#line 469 "key-data.c"
		GError* _tmp17_;
#line 72 "../ssh/key-data.vala"
		_tmp17_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Key doesn't have a type.");
#line 72 "../ssh/key-data.vala"
		_inner_error0_ = _tmp17_;
#line 72 "../ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 72 "../ssh/key-data.vala"
		_g_free0 (type);
#line 72 "../ssh/key-data.vala"
		type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 72 "../ssh/key-data.vala"
		_g_object_unref0 (_result_);
#line 72 "../ssh/key-data.vala"
		_g_free0 (no_leading);
#line 72 "../ssh/key-data.vala"
		return NULL;
#line 487 "key-data.c"
	}
#line 74 "../ssh/key-data.vala"
	_tmp18_ = _result_;
#line 74 "../ssh/key-data.vala"
	_tmp19_ = type;
#line 74 "../ssh/key-data.vala"
	seahorse_ssh_key_data_set_algo (_tmp18_, seahorse_ssh_algorithm_guess_from_string (_tmp19_));
#line 75 "../ssh/key-data.vala"
	_tmp20_ = _result_;
#line 75 "../ssh/key-data.vala"
	_tmp21_ = _tmp20_->priv->_algo;
#line 75 "../ssh/key-data.vala"
	if (_tmp21_ == SEAHORSE_SSH_ALGORITHM_UNKNOWN) {
#line 501 "key-data.c"
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GError* _tmp25_;
		GError* _tmp26_;
#line 76 "../ssh/key-data.vala"
		_tmp22_ = type;
#line 76 "../ssh/key-data.vala"
		_tmp23_ = g_strdup_printf ("Key doesn't have a valid type (%s).", _tmp22_);
#line 76 "../ssh/key-data.vala"
		_tmp24_ = _tmp23_;
#line 76 "../ssh/key-data.vala"
		_tmp25_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, _tmp24_);
#line 76 "../ssh/key-data.vala"
		_tmp26_ = _tmp25_;
#line 76 "../ssh/key-data.vala"
		_g_free0 (_tmp24_);
#line 76 "../ssh/key-data.vala"
		_inner_error0_ = _tmp26_;
#line 76 "../ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 76 "../ssh/key-data.vala"
		_g_free0 (type);
#line 76 "../ssh/key-data.vala"
		type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 76 "../ssh/key-data.vala"
		_g_object_unref0 (_result_);
#line 76 "../ssh/key-data.vala"
		_g_free0 (no_leading);
#line 76 "../ssh/key-data.vala"
		return NULL;
#line 533 "key-data.c"
	}
#line 79 "../ssh/key-data.vala"
	_tmp27_ = type_rest;
#line 79 "../ssh/key-data.vala"
	_tmp27__length1 = type_rest_length1;
#line 79 "../ssh/key-data.vala"
	_tmp28_ = _tmp27_[1];
#line 79 "../ssh/key-data.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 79 "../ssh/key-data.vala"
	rest = _tmp29_;
#line 80 "../ssh/key-data.vala"
	_tmp30_ = rest;
#line 80 "../ssh/key-data.vala"
	if (g_strcmp0 (_tmp30_, "") == 0) {
#line 549 "key-data.c"
		GError* _tmp31_;
#line 81 "../ssh/key-data.vala"
		_tmp31_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Key doesn't have any data.");
#line 81 "../ssh/key-data.vala"
		_inner_error0_ = _tmp31_;
#line 81 "../ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 81 "../ssh/key-data.vala"
		_g_free0 (rest);
#line 81 "../ssh/key-data.vala"
		_g_free0 (type);
#line 81 "../ssh/key-data.vala"
		type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 81 "../ssh/key-data.vala"
		_g_object_unref0 (_result_);
#line 81 "../ssh/key-data.vala"
		_g_free0 (no_leading);
#line 81 "../ssh/key-data.vala"
		return NULL;
#line 569 "key-data.c"
	}
#line 82 "../ssh/key-data.vala"
	_tmp32_ = rest;
#line 82 "../ssh/key-data.vala"
	_tmp34_ = _tmp33_ = g_strsplit_set (_tmp32_, " \t", 2);
#line 82 "../ssh/key-data.vala"
	data_comment = _tmp34_;
#line 82 "../ssh/key-data.vala"
	data_comment_length1 = _vala_array_length (_tmp33_);
#line 82 "../ssh/key-data.vala"
	_data_comment_size_ = data_comment_length1;
#line 85 "../ssh/key-data.vala"
	_tmp35_ = data_comment;
#line 85 "../ssh/key-data.vala"
	_tmp35__length1 = data_comment_length1;
#line 85 "../ssh/key-data.vala"
	_tmp36_ = _tmp35_[0];
#line 85 "../ssh/key-data.vala"
	_tmp37_ = string_strip (_tmp36_);
#line 85 "../ssh/key-data.vala"
	_tmp38_ = _tmp37_;
#line 85 "../ssh/key-data.vala"
	_tmp40_ = g_base64_decode (_tmp38_, &_tmp39_);
#line 85 "../ssh/key-data.vala"
	_tmp41_ = _tmp40_;
#line 85 "../ssh/key-data.vala"
	_tmp41__length1 = _tmp39_;
#line 85 "../ssh/key-data.vala"
	_g_free0 (_tmp38_);
#line 85 "../ssh/key-data.vala"
	bytes = _tmp41_;
#line 85 "../ssh/key-data.vala"
	bytes_length1 = _tmp41__length1;
#line 85 "../ssh/key-data.vala"
	_bytes_size_ = bytes_length1;
#line 86 "../ssh/key-data.vala"
	_tmp43_ = bytes;
#line 86 "../ssh/key-data.vala"
	_tmp43__length1 = bytes_length1;
#line 86 "../ssh/key-data.vala"
	_tmp44_ = seahorse_ssh_key_data_parse_key_blob (_tmp43_, (gint) _tmp43__length1, &_inner_error0_);
#line 86 "../ssh/key-data.vala"
	_tmp42_ = _tmp44_;
#line 86 "../ssh/key-data.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 86 "../ssh/key-data.vala"
		bytes = (g_free (bytes), NULL);
#line 86 "../ssh/key-data.vala"
		data_comment = (_vala_array_free (data_comment, data_comment_length1, (GDestroyNotify) g_free), NULL);
#line 86 "../ssh/key-data.vala"
		_g_free0 (rest);
#line 86 "../ssh/key-data.vala"
		_g_free0 (type);
#line 86 "../ssh/key-data.vala"
		type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 86 "../ssh/key-data.vala"
		_g_object_unref0 (_result_);
#line 86 "../ssh/key-data.vala"
		_g_free0 (no_leading);
#line 86 "../ssh/key-data.vala"
		return NULL;
#line 633 "key-data.c"
	}
#line 86 "../ssh/key-data.vala"
	_tmp45_ = _result_;
#line 86 "../ssh/key-data.vala"
	seahorse_ssh_key_data_set_fingerprint (_tmp45_, _tmp42_);
#line 89 "../ssh/key-data.vala"
	_tmp46_ = _result_;
#line 89 "../ssh/key-data.vala"
	_tmp47_ = _result_;
#line 89 "../ssh/key-data.vala"
	_tmp48_ = _tmp47_->priv->_algo;
#line 89 "../ssh/key-data.vala"
	_tmp49_ = bytes;
#line 89 "../ssh/key-data.vala"
	_tmp49__length1 = bytes_length1;
#line 89 "../ssh/key-data.vala"
	seahorse_ssh_key_data_set_length (_tmp46_, seahorse_ssh_key_data_calc_bits (_tmp48_, (guint) _tmp49__length1));
#line 92 "../ssh/key-data.vala"
	_tmp50_ = data_comment;
#line 92 "../ssh/key-data.vala"
	_tmp50__length1 = data_comment_length1;
#line 92 "../ssh/key-data.vala"
	if (_tmp50__length1 == 2) {
#line 657 "key-data.c"
		gchar* comment = NULL;
		gchar** _tmp51_;
		gint _tmp51__length1;
		const gchar* _tmp52_;
		gchar* _tmp53_;
		const gchar* _tmp54_;
#line 93 "../ssh/key-data.vala"
		_tmp51_ = data_comment;
#line 93 "../ssh/key-data.vala"
		_tmp51__length1 = data_comment_length1;
#line 93 "../ssh/key-data.vala"
		_tmp52_ = _tmp51_[1];
#line 93 "../ssh/key-data.vala"
		_tmp53_ = g_strdup (_tmp52_);
#line 93 "../ssh/key-data.vala"
		comment = _tmp53_;
#line 95 "../ssh/key-data.vala"
		_tmp54_ = comment;
#line 95 "../ssh/key-data.vala"
		if (!g_utf8_validate (_tmp54_, (gssize) -1, NULL)) {
#line 678 "key-data.c"
			gchar* _tmp55_ = NULL;
			const gchar* _tmp56_;
			const gchar* _tmp57_;
			gint _tmp58_;
			gint _tmp59_;
			gchar* _tmp60_;
			SeahorseSshKeyData* _tmp61_;
#line 96 "../ssh/key-data.vala"
			_tmp56_ = comment;
#line 96 "../ssh/key-data.vala"
			_tmp57_ = comment;
#line 96 "../ssh/key-data.vala"
			_tmp58_ = strlen (_tmp57_);
#line 96 "../ssh/key-data.vala"
			_tmp59_ = _tmp58_;
#line 96 "../ssh/key-data.vala"
			_tmp60_ = g_convert (_tmp56_, (gssize) _tmp59_, "UTF-8", "ISO-8859-1", NULL, NULL, &_inner_error0_);
#line 96 "../ssh/key-data.vala"
			_tmp55_ = _tmp60_;
#line 96 "../ssh/key-data.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "../ssh/key-data.vala"
				g_propagate_error (error, _inner_error0_);
#line 96 "../ssh/key-data.vala"
				_g_free0 (comment);
#line 96 "../ssh/key-data.vala"
				_g_free0 (_tmp42_);
#line 96 "../ssh/key-data.vala"
				bytes = (g_free (bytes), NULL);
#line 96 "../ssh/key-data.vala"
				data_comment = (_vala_array_free (data_comment, data_comment_length1, (GDestroyNotify) g_free), NULL);
#line 96 "../ssh/key-data.vala"
				_g_free0 (rest);
#line 96 "../ssh/key-data.vala"
				_g_free0 (type);
#line 96 "../ssh/key-data.vala"
				type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 96 "../ssh/key-data.vala"
				_g_object_unref0 (_result_);
#line 96 "../ssh/key-data.vala"
				_g_free0 (no_leading);
#line 96 "../ssh/key-data.vala"
				return NULL;
#line 722 "key-data.c"
			}
#line 96 "../ssh/key-data.vala"
			_tmp61_ = _result_;
#line 96 "../ssh/key-data.vala"
			seahorse_ssh_key_data_set_comment (_tmp61_, _tmp55_);
#line 95 "../ssh/key-data.vala"
			_g_free0 (_tmp55_);
#line 730 "key-data.c"
		} else {
			SeahorseSshKeyData* _tmp62_;
			const gchar* _tmp63_;
#line 98 "../ssh/key-data.vala"
			_tmp62_ = _result_;
#line 98 "../ssh/key-data.vala"
			_tmp63_ = comment;
#line 98 "../ssh/key-data.vala"
			seahorse_ssh_key_data_set_comment (_tmp62_, _tmp63_);
#line 740 "key-data.c"
		}
#line 92 "../ssh/key-data.vala"
		_g_free0 (comment);
#line 744 "key-data.c"
	}
#line 101 "../ssh/key-data.vala"
	result = _result_;
#line 101 "../ssh/key-data.vala"
	_g_free0 (_tmp42_);
#line 101 "../ssh/key-data.vala"
	bytes = (g_free (bytes), NULL);
#line 101 "../ssh/key-data.vala"
	data_comment = (_vala_array_free (data_comment, data_comment_length1, (GDestroyNotify) g_free), NULL);
#line 101 "../ssh/key-data.vala"
	_g_free0 (rest);
#line 101 "../ssh/key-data.vala"
	_g_free0 (type);
#line 101 "../ssh/key-data.vala"
	type_rest = (_vala_array_free (type_rest, type_rest_length1, (GDestroyNotify) g_free), NULL);
#line 101 "../ssh/key-data.vala"
	_g_free0 (no_leading);
#line 101 "../ssh/key-data.vala"
	return result;
#line 764 "key-data.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 787 "key-data.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 796 "key-data.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 815 "key-data.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 819 "key-data.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 825 "key-data.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 835 "key-data.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 843 "key-data.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 847 "key-data.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 853 "key-data.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 863 "key-data.c"
}

gchar*
seahorse_ssh_key_data_parse_key_blob (guchar* bytes,
                                      gint bytes_length1,
                                      GError** error)
{
	gchar* digest = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GString* fingerprint = NULL;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GString* _tmp6_;
	GString* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 105 "../ssh/key-data.vala"
	_tmp0_ = g_compute_checksum_for_data (G_CHECKSUM_MD5, bytes, (gint) bytes_length1);
#line 105 "../ssh/key-data.vala"
	digest = _tmp0_;
#line 106 "../ssh/key-data.vala"
	_tmp1_ = digest;
#line 106 "../ssh/key-data.vala"
	if (_tmp1_ == NULL) {
#line 892 "key-data.c"
		GError* _tmp2_;
#line 107 "../ssh/key-data.vala"
		_tmp2_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Can't calculate fingerprint from key.");
#line 107 "../ssh/key-data.vala"
		_inner_error0_ = _tmp2_;
#line 107 "../ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 107 "../ssh/key-data.vala"
		_g_free0 (digest);
#line 107 "../ssh/key-data.vala"
		return NULL;
#line 904 "key-data.c"
	}
#line 109 "../ssh/key-data.vala"
	_tmp3_ = digest;
#line 109 "../ssh/key-data.vala"
	_tmp4_ = strlen (_tmp3_);
#line 109 "../ssh/key-data.vala"
	_tmp5_ = _tmp4_;
#line 109 "../ssh/key-data.vala"
	_tmp6_ = g_string_sized_new ((gsize) ((_tmp5_ * 3) / 2));
#line 109 "../ssh/key-data.vala"
	fingerprint = _tmp6_;
#line 916 "key-data.c"
	{
		gsize i = 0UL;
#line 110 "../ssh/key-data.vala"
		i = (gsize) 0;
#line 921 "key-data.c"
		{
			gboolean _tmp7_ = FALSE;
#line 110 "../ssh/key-data.vala"
			_tmp7_ = TRUE;
#line 110 "../ssh/key-data.vala"
			while (TRUE) {
#line 928 "key-data.c"
				const gchar* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				GString* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 110 "../ssh/key-data.vala"
				if (!_tmp7_) {
#line 110 "../ssh/key-data.vala"
					i += (gsize) 2;
#line 940 "key-data.c"
				}
#line 110 "../ssh/key-data.vala"
				_tmp7_ = FALSE;
#line 110 "../ssh/key-data.vala"
				_tmp8_ = digest;
#line 110 "../ssh/key-data.vala"
				_tmp9_ = strlen (_tmp8_);
#line 110 "../ssh/key-data.vala"
				_tmp10_ = _tmp9_;
#line 110 "../ssh/key-data.vala"
				if (!(i < ((gsize) _tmp10_))) {
#line 110 "../ssh/key-data.vala"
					break;
#line 954 "key-data.c"
				}
#line 111 "../ssh/key-data.vala"
				if (i > ((gsize) 0)) {
#line 958 "key-data.c"
					GString* _tmp11_;
#line 112 "../ssh/key-data.vala"
					_tmp11_ = fingerprint;
#line 112 "../ssh/key-data.vala"
					g_string_append_c (_tmp11_, ':');
#line 964 "key-data.c"
				}
#line 113 "../ssh/key-data.vala"
				_tmp12_ = fingerprint;
#line 113 "../ssh/key-data.vala"
				_tmp13_ = digest;
#line 113 "../ssh/key-data.vala"
				_tmp14_ = string_substring (_tmp13_, (glong) i, (glong) 2);
#line 113 "../ssh/key-data.vala"
				_tmp15_ = _tmp14_;
#line 113 "../ssh/key-data.vala"
				g_string_append (_tmp12_, _tmp15_);
#line 113 "../ssh/key-data.vala"
				_g_free0 (_tmp15_);
#line 978 "key-data.c"
			}
		}
	}
#line 116 "../ssh/key-data.vala"
	_tmp16_ = fingerprint;
#line 116 "../ssh/key-data.vala"
	_tmp17_ = _tmp16_->str;
#line 116 "../ssh/key-data.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 116 "../ssh/key-data.vala"
	result = _tmp18_;
#line 116 "../ssh/key-data.vala"
	_g_string_free0 (fingerprint);
#line 116 "../ssh/key-data.vala"
	_g_free0 (digest);
#line 116 "../ssh/key-data.vala"
	return result;
#line 996 "key-data.c"
}

guint
seahorse_ssh_key_data_calc_bits (SeahorseSshAlgorithm algo,
                                 guint len)
{
	guint result;
#line 123 "../ssh/key-data.vala"
	switch (algo) {
#line 123 "../ssh/key-data.vala"
		case SEAHORSE_SSH_ALGORITHM_RSA:
#line 1008 "key-data.c"
		{
#line 126 "../ssh/key-data.vala"
			result = (len - 23) * 8;
#line 126 "../ssh/key-data.vala"
			return result;
#line 1014 "key-data.c"
		}
#line 123 "../ssh/key-data.vala"
		case SEAHORSE_SSH_ALGORITHM_DSA:
#line 1018 "key-data.c"
		{
			guint n = 0U;
			gint _tmp0_ = 0;
#line 130 "../ssh/key-data.vala"
			n = ((len - 50) * 8) / 3;
#line 131 "../ssh/key-data.vala"
			if ((n % 64) > ((guint) 32)) {
#line 131 "../ssh/key-data.vala"
				_tmp0_ = 1;
#line 1028 "key-data.c"
			} else {
#line 131 "../ssh/key-data.vala"
				_tmp0_ = 0;
#line 1032 "key-data.c"
			}
#line 131 "../ssh/key-data.vala"
			result = ((n / 64) + _tmp0_) * 64;
#line 131 "../ssh/key-data.vala"
			return result;
#line 1038 "key-data.c"
		}
#line 123 "../ssh/key-data.vala"
		case SEAHORSE_SSH_ALGORITHM_ED25519:
#line 1042 "key-data.c"
		{
#line 134 "../ssh/key-data.vala"
			result = (guint) 256;
#line 134 "../ssh/key-data.vala"
			return result;
#line 1048 "key-data.c"
		}
		default:
		{
#line 137 "../ssh/key-data.vala"
			result = (guint) 0;
#line 137 "../ssh/key-data.vala"
			return result;
#line 1056 "key-data.c"
		}
	}
}

void
seahorse_ssh_key_data_filter_file (const gchar* filename,
                                   SeahorseSshKeyData* add,
                                   SeahorseSshKeyData* remove,
                                   GError** error)
{
	gchar* contents = NULL;
	gchar* _tmp0_ = NULL;
	GString* results = NULL;
	GString* _tmp1_;
	gboolean first = FALSE;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar** lines = NULL;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GString* _tmp16_;
	const gchar* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 142 "../ssh/key-data.vala"
	g_return_if_fail (filename != NULL);
#line 144 "../ssh/key-data.vala"
	if (remove == NULL) {
#line 145 "../ssh/key-data.vala"
		remove = add;
#line 1090 "key-data.c"
	}
#line 148 "../ssh/key-data.vala"
	g_file_get_contents (filename, &_tmp0_, NULL, &_inner_error0_);
#line 148 "../ssh/key-data.vala"
	_g_free0 (contents);
#line 148 "../ssh/key-data.vala"
	contents = _tmp0_;
#line 148 "../ssh/key-data.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 148 "../ssh/key-data.vala"
		_g_free0 (contents);
#line 148 "../ssh/key-data.vala"
		return;
#line 1106 "key-data.c"
	}
#line 150 "../ssh/key-data.vala"
	_tmp1_ = g_string_new ("");
#line 150 "../ssh/key-data.vala"
	results = _tmp1_;
#line 153 "../ssh/key-data.vala"
	first = TRUE;
#line 154 "../ssh/key-data.vala"
	_tmp3_ = contents;
#line 154 "../ssh/key-data.vala"
	_tmp2_ = _tmp3_;
#line 154 "../ssh/key-data.vala"
	if (_tmp2_ == NULL) {
#line 154 "../ssh/key-data.vala"
		_tmp2_ = "";
#line 1122 "key-data.c"
	}
#line 154 "../ssh/key-data.vala"
	_tmp5_ = _tmp4_ = g_strsplit (_tmp2_, "\n", 0);
#line 154 "../ssh/key-data.vala"
	lines = _tmp5_;
#line 154 "../ssh/key-data.vala"
	lines_length1 = _vala_array_length (_tmp4_);
#line 154 "../ssh/key-data.vala"
	_lines_size_ = lines_length1;
#line 155 "../ssh/key-data.vala"
	_tmp6_ = lines;
#line 155 "../ssh/key-data.vala"
	_tmp6__length1 = lines_length1;
#line 1136 "key-data.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 155 "../ssh/key-data.vala"
		line_collection = _tmp6_;
#line 155 "../ssh/key-data.vala"
		line_collection_length1 = _tmp6__length1;
#line 155 "../ssh/key-data.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1148 "key-data.c"
			gchar* _tmp7_;
			gchar* line = NULL;
#line 155 "../ssh/key-data.vala"
			_tmp7_ = g_strdup (line_collection[line_it]);
#line 155 "../ssh/key-data.vala"
			line = _tmp7_;
#line 1155 "key-data.c"
			{
				gboolean _tmp8_ = FALSE;
				GString* _tmp11_;
				const gchar* _tmp12_;
#line 156 "../ssh/key-data.vala"
				if (remove != NULL) {
#line 1162 "key-data.c"
					const gchar* _tmp9_;
#line 156 "../ssh/key-data.vala"
					_tmp9_ = line;
#line 156 "../ssh/key-data.vala"
					_tmp8_ = seahorse_ssh_key_data_match (remove, _tmp9_);
#line 1168 "key-data.c"
				} else {
#line 156 "../ssh/key-data.vala"
					_tmp8_ = FALSE;
#line 1172 "key-data.c"
				}
#line 156 "../ssh/key-data.vala"
				if (_tmp8_) {
#line 157 "../ssh/key-data.vala"
					_g_free0 (line);
#line 157 "../ssh/key-data.vala"
					continue;
#line 1180 "key-data.c"
				}
#line 159 "../ssh/key-data.vala"
				if (!first) {
#line 1184 "key-data.c"
					GString* _tmp10_;
#line 160 "../ssh/key-data.vala"
					_tmp10_ = results;
#line 160 "../ssh/key-data.vala"
					g_string_append_c (_tmp10_, '\n');
#line 1190 "key-data.c"
				}
#line 161 "../ssh/key-data.vala"
				first = FALSE;
#line 162 "../ssh/key-data.vala"
				_tmp11_ = results;
#line 162 "../ssh/key-data.vala"
				_tmp12_ = line;
#line 162 "../ssh/key-data.vala"
				g_string_append (_tmp11_, _tmp12_);
#line 155 "../ssh/key-data.vala"
				_g_free0 (line);
#line 1202 "key-data.c"
			}
		}
	}
#line 166 "../ssh/key-data.vala"
	if (add != NULL) {
#line 1208 "key-data.c"
		GString* _tmp14_;
		const gchar* _tmp15_;
#line 167 "../ssh/key-data.vala"
		if (!first) {
#line 1213 "key-data.c"
			GString* _tmp13_;
#line 168 "../ssh/key-data.vala"
			_tmp13_ = results;
#line 168 "../ssh/key-data.vala"
			g_string_append_c (_tmp13_, '\n');
#line 1219 "key-data.c"
		}
#line 169 "../ssh/key-data.vala"
		_tmp14_ = results;
#line 169 "../ssh/key-data.vala"
		_tmp15_ = add->priv->_rawdata;
#line 169 "../ssh/key-data.vala"
		g_string_append (_tmp14_, _tmp15_);
#line 1227 "key-data.c"
	}
#line 172 "../ssh/key-data.vala"
	_tmp16_ = results;
#line 172 "../ssh/key-data.vala"
	_tmp17_ = _tmp16_->str;
#line 172 "../ssh/key-data.vala"
	g_file_set_contents (filename, _tmp17_, (gssize) -1, &_inner_error0_);
#line 172 "../ssh/key-data.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 172 "../ssh/key-data.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 172 "../ssh/key-data.vala"
		_g_string_free0 (results);
#line 172 "../ssh/key-data.vala"
		_g_free0 (contents);
#line 172 "../ssh/key-data.vala"
		return;
#line 1247 "key-data.c"
	}
#line 142 "../ssh/key-data.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 142 "../ssh/key-data.vala"
	_g_string_free0 (results);
#line 142 "../ssh/key-data.vala"
	_g_free0 (contents);
#line 1255 "key-data.c"
}

gchar*
seahorse_ssh_key_data_get_location (SeahorseSshKeyData* self)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* _tmp4_;
	gchar* result;
#line 175 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 176 "../ssh/key-data.vala"
	_tmp1_ = self->priv->_privfile;
#line 176 "../ssh/key-data.vala"
	if (_tmp1_ != NULL) {
#line 1271 "key-data.c"
		const gchar* _tmp2_;
#line 176 "../ssh/key-data.vala"
		_tmp2_ = self->priv->_privfile;
#line 176 "../ssh/key-data.vala"
		_tmp0_ = _tmp2_;
#line 1277 "key-data.c"
	} else {
		const gchar* _tmp3_;
#line 176 "../ssh/key-data.vala"
		_tmp3_ = self->priv->_pubfile;
#line 176 "../ssh/key-data.vala"
		_tmp0_ = _tmp3_;
#line 1284 "key-data.c"
	}
#line 176 "../ssh/key-data.vala"
	_tmp4_ = g_strdup (_tmp0_);
#line 176 "../ssh/key-data.vala"
	result = _tmp4_;
#line 176 "../ssh/key-data.vala"
	return result;
#line 1292 "key-data.c"
}

SeahorseSshKeyData*
seahorse_ssh_key_data_construct (GType object_type)
{
	SeahorseSshKeyData * self = NULL;
#line 21 "../ssh/key-data.vala"
	self = (SeahorseSshKeyData*) g_object_new (object_type, NULL);
#line 21 "../ssh/key-data.vala"
	return self;
#line 1303 "key-data.c"
}

SeahorseSshKeyData*
seahorse_ssh_key_data_new (void)
{
#line 21 "../ssh/key-data.vala"
	return seahorse_ssh_key_data_construct (SEAHORSE_SSH_TYPE_KEY_DATA);
#line 1311 "key-data.c"
}

const gchar*
seahorse_ssh_key_data_get_privfile (SeahorseSshKeyData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../ssh/key-data.vala"
	_tmp0_ = self->priv->_privfile;
#line 24 "../ssh/key-data.vala"
	result = _tmp0_;
#line 24 "../ssh/key-data.vala"
	return result;
#line 1327 "key-data.c"
}

void
seahorse_ssh_key_data_set_privfile (SeahorseSshKeyData* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 24 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 24 "../ssh/key-data.vala"
	old_value = seahorse_ssh_key_data_get_privfile (self);
#line 24 "../ssh/key-data.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1341 "key-data.c"
		gchar* _tmp0_;
#line 24 "../ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../ssh/key-data.vala"
		_g_free0 (self->priv->_privfile);
#line 24 "../ssh/key-data.vala"
		self->priv->_privfile = _tmp0_;
#line 24 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY]);
#line 1351 "key-data.c"
	}
}

const gchar*
seahorse_ssh_key_data_get_pubfile (SeahorseSshKeyData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../ssh/key-data.vala"
	_tmp0_ = self->priv->_pubfile;
#line 25 "../ssh/key-data.vala"
	result = _tmp0_;
#line 25 "../ssh/key-data.vala"
	return result;
#line 1368 "key-data.c"
}

void
seahorse_ssh_key_data_set_pubfile (SeahorseSshKeyData* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 25 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 25 "../ssh/key-data.vala"
	old_value = seahorse_ssh_key_data_get_pubfile (self);
#line 25 "../ssh/key-data.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1382 "key-data.c"
		gchar* _tmp0_;
#line 25 "../ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../ssh/key-data.vala"
		_g_free0 (self->priv->_pubfile);
#line 25 "../ssh/key-data.vala"
		self->priv->_pubfile = _tmp0_;
#line 25 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY]);
#line 1392 "key-data.c"
	}
}

gboolean
seahorse_ssh_key_data_get_partial (SeahorseSshKeyData* self)
{
	gboolean result;
#line 26 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "../ssh/key-data.vala"
	result = self->priv->_partial;
#line 26 "../ssh/key-data.vala"
	return result;
#line 1406 "key-data.c"
}

void
seahorse_ssh_key_data_set_partial (SeahorseSshKeyData* self,
                                   gboolean value)
{
	gboolean old_value;
#line 26 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/key-data.vala"
	old_value = seahorse_ssh_key_data_get_partial (self);
#line 26 "../ssh/key-data.vala"
	if (old_value != value) {
#line 26 "../ssh/key-data.vala"
		self->priv->_partial = value;
#line 26 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY]);
#line 1424 "key-data.c"
	}
}

gboolean
seahorse_ssh_key_data_get_authorized (SeahorseSshKeyData* self)
{
	gboolean result;
#line 27 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../ssh/key-data.vala"
	result = self->priv->_authorized;
#line 27 "../ssh/key-data.vala"
	return result;
#line 1438 "key-data.c"
}

void
seahorse_ssh_key_data_set_authorized (SeahorseSshKeyData* self,
                                      gboolean value)
{
	gboolean old_value;
#line 27 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 27 "../ssh/key-data.vala"
	old_value = seahorse_ssh_key_data_get_authorized (self);
#line 27 "../ssh/key-data.vala"
	if (old_value != value) {
#line 27 "../ssh/key-data.vala"
		self->priv->_authorized = value;
#line 27 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY]);
#line 1456 "key-data.c"
	}
}

const gchar*
seahorse_ssh_key_data_get_rawdata (SeahorseSshKeyData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../ssh/key-data.vala"
	_tmp0_ = self->priv->_rawdata;
#line 30 "../ssh/key-data.vala"
	result = _tmp0_;
#line 30 "../ssh/key-data.vala"
	return result;
#line 1473 "key-data.c"
}

void
seahorse_ssh_key_data_set_rawdata (SeahorseSshKeyData* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 30 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 30 "../ssh/key-data.vala"
	old_value = seahorse_ssh_key_data_get_rawdata (self);
#line 30 "../ssh/key-data.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1487 "key-data.c"
		gchar* _tmp0_;
#line 30 "../ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../ssh/key-data.vala"
		_g_free0 (self->priv->_rawdata);
#line 30 "../ssh/key-data.vala"
		self->priv->_rawdata = _tmp0_;
#line 30 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY]);
#line 1497 "key-data.c"
	}
}

const gchar*
seahorse_ssh_key_data_get_comment (SeahorseSshKeyData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../ssh/key-data.vala"
	_tmp0_ = self->priv->_comment;
#line 31 "../ssh/key-data.vala"
	result = _tmp0_;
#line 31 "../ssh/key-data.vala"
	return result;
#line 1514 "key-data.c"
}

void
seahorse_ssh_key_data_set_comment (SeahorseSshKeyData* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 31 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 31 "../ssh/key-data.vala"
	old_value = seahorse_ssh_key_data_get_comment (self);
#line 31 "../ssh/key-data.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1528 "key-data.c"
		gchar* _tmp0_;
#line 31 "../ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../ssh/key-data.vala"
		_g_free0 (self->priv->_comment);
#line 31 "../ssh/key-data.vala"
		self->priv->_comment = _tmp0_;
#line 31 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY]);
#line 1538 "key-data.c"
	}
}

const gchar*
seahorse_ssh_key_data_get_fingerprint (SeahorseSshKeyData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../ssh/key-data.vala"
	_tmp0_ = self->priv->_fingerprint;
#line 32 "../ssh/key-data.vala"
	result = _tmp0_;
#line 32 "../ssh/key-data.vala"
	return result;
#line 1555 "key-data.c"
}

void
seahorse_ssh_key_data_set_fingerprint (SeahorseSshKeyData* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 32 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 32 "../ssh/key-data.vala"
	old_value = seahorse_ssh_key_data_get_fingerprint (self);
#line 32 "../ssh/key-data.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1569 "key-data.c"
		gchar* _tmp0_;
#line 32 "../ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../ssh/key-data.vala"
		_g_free0 (self->priv->_fingerprint);
#line 32 "../ssh/key-data.vala"
		self->priv->_fingerprint = _tmp0_;
#line 32 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY]);
#line 1579 "key-data.c"
	}
}

guint
seahorse_ssh_key_data_get_length (SeahorseSshKeyData* self)
{
	guint result;
#line 33 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 33 "../ssh/key-data.vala"
	result = self->priv->_length;
#line 33 "../ssh/key-data.vala"
	return result;
#line 1593 "key-data.c"
}

void
seahorse_ssh_key_data_set_length (SeahorseSshKeyData* self,
                                  guint value)
{
	guint old_value;
#line 33 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 33 "../ssh/key-data.vala"
	old_value = seahorse_ssh_key_data_get_length (self);
#line 33 "../ssh/key-data.vala"
	if (old_value != value) {
#line 33 "../ssh/key-data.vala"
		self->priv->_length = value;
#line 33 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY]);
#line 1611 "key-data.c"
	}
}

SeahorseSshAlgorithm
seahorse_ssh_key_data_get_algo (SeahorseSshKeyData* self)
{
	SeahorseSshAlgorithm result;
#line 34 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "../ssh/key-data.vala"
	result = self->priv->_algo;
#line 34 "../ssh/key-data.vala"
	return result;
#line 1625 "key-data.c"
}

void
seahorse_ssh_key_data_set_algo (SeahorseSshKeyData* self,
                                SeahorseSshAlgorithm value)
{
	SeahorseSshAlgorithm old_value;
#line 34 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 34 "../ssh/key-data.vala"
	old_value = seahorse_ssh_key_data_get_algo (self);
#line 34 "../ssh/key-data.vala"
	if (old_value != value) {
#line 34 "../ssh/key-data.vala"
		self->priv->_algo = value;
#line 34 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY]);
#line 1643 "key-data.c"
	}
}

static void
seahorse_ssh_key_data_class_init (SeahorseSshKeyDataClass * klass,
                                  gpointer klass_data)
{
#line 21 "../ssh/key-data.vala"
	seahorse_ssh_key_data_parent_class = g_type_class_peek_parent (klass);
#line 21 "../ssh/key-data.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseSshKeyData_private_offset);
#line 21 "../ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_ssh_key_data_get_property;
#line 21 "../ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_ssh_key_data_set_property;
#line 21 "../ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_ssh_key_data_finalize;
#line 21 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY] = g_param_spec_string ("privfile", "privfile", "privfile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY] = g_param_spec_string ("pubfile", "pubfile", "pubfile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY] = g_param_spec_boolean ("partial", "partial", "partial", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY] = g_param_spec_boolean ("authorized", "authorized", "authorized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY] = g_param_spec_string ("rawdata", "rawdata", "rawdata", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY] = g_param_spec_string ("fingerprint", "fingerprint", "fingerprint", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY] = g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY, seahorse_ssh_key_data_properties[SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY] = g_param_spec_enum ("algo", "algo", "algo", SEAHORSE_SSH_TYPE_ALGORITHM, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1679 "key-data.c"
}

static void
seahorse_ssh_key_data_instance_init (SeahorseSshKeyData * self,
                                     gpointer klass)
{
#line 21 "../ssh/key-data.vala"
	self->priv = seahorse_ssh_key_data_get_instance_private (self);
#line 27 "../ssh/key-data.vala"
	self->priv->_authorized = FALSE;
#line 1690 "key-data.c"
}

static void
seahorse_ssh_key_data_finalize (GObject * obj)
{
	SeahorseSshKeyData * self;
#line 21 "../ssh/key-data.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_KEY_DATA, SeahorseSshKeyData);
#line 24 "../ssh/key-data.vala"
	_g_free0 (self->priv->_privfile);
#line 25 "../ssh/key-data.vala"
	_g_free0 (self->priv->_pubfile);
#line 30 "../ssh/key-data.vala"
	_g_free0 (self->priv->_rawdata);
#line 31 "../ssh/key-data.vala"
	_g_free0 (self->priv->_comment);
#line 32 "../ssh/key-data.vala"
	_g_free0 (self->priv->_fingerprint);
#line 21 "../ssh/key-data.vala"
	G_OBJECT_CLASS (seahorse_ssh_key_data_parent_class)->finalize (obj);
#line 1711 "key-data.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_ssh_key_data_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseSshKeyDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_ssh_key_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseSshKeyData), 0, (GInstanceInitFunc) seahorse_ssh_key_data_instance_init, NULL };
	GType seahorse_ssh_key_data_type_id;
	seahorse_ssh_key_data_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorseSshKeyData", &g_define_type_info, 0);
	SeahorseSshKeyData_private_offset = g_type_add_instance_private (seahorse_ssh_key_data_type_id, sizeof (SeahorseSshKeyDataPrivate));
	return seahorse_ssh_key_data_type_id;
}

GType
seahorse_ssh_key_data_get_type (void)
{
	static volatile gsize seahorse_ssh_key_data_type_id__once = 0;
	if (g_once_init_enter (&seahorse_ssh_key_data_type_id__once)) {
		GType seahorse_ssh_key_data_type_id;
		seahorse_ssh_key_data_type_id = seahorse_ssh_key_data_get_type_once ();
		g_once_init_leave (&seahorse_ssh_key_data_type_id__once, seahorse_ssh_key_data_type_id);
	}
	return seahorse_ssh_key_data_type_id__once;
}

static void
_vala_seahorse_ssh_key_data_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	SeahorseSshKeyData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_KEY_DATA, SeahorseSshKeyData);
#line 21 "../ssh/key-data.vala"
	switch (property_id) {
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY:
#line 21 "../ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_key_data_get_privfile (self));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY:
#line 21 "../ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_key_data_get_pubfile (self));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY:
#line 21 "../ssh/key-data.vala"
		g_value_set_boolean (value, seahorse_ssh_key_data_get_partial (self));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY:
#line 21 "../ssh/key-data.vala"
		g_value_set_boolean (value, seahorse_ssh_key_data_get_authorized (self));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY:
#line 21 "../ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_key_data_get_rawdata (self));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY:
#line 21 "../ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_key_data_get_comment (self));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY:
#line 21 "../ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_key_data_get_fingerprint (self));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY:
#line 21 "../ssh/key-data.vala"
		g_value_set_uint (value, seahorse_ssh_key_data_get_length (self));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY:
#line 21 "../ssh/key-data.vala"
		g_value_set_enum (value, seahorse_ssh_key_data_get_algo (self));
#line 21 "../ssh/key-data.vala"
		break;
#line 1800 "key-data.c"
		default:
#line 21 "../ssh/key-data.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../ssh/key-data.vala"
		break;
#line 1806 "key-data.c"
	}
}

static void
_vala_seahorse_ssh_key_data_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	SeahorseSshKeyData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_KEY_DATA, SeahorseSshKeyData);
#line 21 "../ssh/key-data.vala"
	switch (property_id) {
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PRIVFILE_PROPERTY:
#line 21 "../ssh/key-data.vala"
		seahorse_ssh_key_data_set_privfile (self, g_value_get_string (value));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PUBFILE_PROPERTY:
#line 21 "../ssh/key-data.vala"
		seahorse_ssh_key_data_set_pubfile (self, g_value_get_string (value));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_PARTIAL_PROPERTY:
#line 21 "../ssh/key-data.vala"
		seahorse_ssh_key_data_set_partial (self, g_value_get_boolean (value));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_AUTHORIZED_PROPERTY:
#line 21 "../ssh/key-data.vala"
		seahorse_ssh_key_data_set_authorized (self, g_value_get_boolean (value));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_RAWDATA_PROPERTY:
#line 21 "../ssh/key-data.vala"
		seahorse_ssh_key_data_set_rawdata (self, g_value_get_string (value));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_COMMENT_PROPERTY:
#line 21 "../ssh/key-data.vala"
		seahorse_ssh_key_data_set_comment (self, g_value_get_string (value));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_FINGERPRINT_PROPERTY:
#line 21 "../ssh/key-data.vala"
		seahorse_ssh_key_data_set_fingerprint (self, g_value_get_string (value));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_LENGTH_PROPERTY:
#line 21 "../ssh/key-data.vala"
		seahorse_ssh_key_data_set_length (self, g_value_get_uint (value));
#line 21 "../ssh/key-data.vala"
		break;
#line 21 "../ssh/key-data.vala"
		case SEAHORSE_SSH_KEY_DATA_ALGO_PROPERTY:
#line 21 "../ssh/key-data.vala"
		seahorse_ssh_key_data_set_algo (self, g_value_get_enum (value));
#line 21 "../ssh/key-data.vala"
		break;
#line 1874 "key-data.c"
		default:
#line 21 "../ssh/key-data.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../ssh/key-data.vala"
		break;
#line 1880 "key-data.c"
	}
}

static inline gpointer
seahorse_ssh_sec_data_get_instance_private (SeahorseSshSecData* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseSshSecData_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 1906 "key-data.c"
}

gboolean
seahorse_ssh_sec_data_contains_private_key (const gchar* data)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 197 "../ssh/key-data.vala"
	g_return_val_if_fail (data != NULL, FALSE);
#line 198 "../ssh/key-data.vala"
	if (string_contains (data, SEAHORSE_SSH_SEC_DATA_SSH_KEY_SECRET_SIG)) {
#line 198 "../ssh/key-data.vala"
		_tmp0_ = TRUE;
#line 1920 "key-data.c"
	} else {
#line 198 "../ssh/key-data.vala"
		_tmp0_ = string_contains (data, SEAHORSE_SSH_SEC_DATA_SSH_PRIVATE_BEGIN);
#line 1924 "key-data.c"
	}
#line 198 "../ssh/key-data.vala"
	result = _tmp0_;
#line 198 "../ssh/key-data.vala"
	return result;
#line 1930 "key-data.c"
}

/**
     * Finds the first occurence of a private key in the given string and parses it if found.
     * NOTE: after parsing, it will *remove* the data with the private key from the string.
     *
     * @param data The data that contains a private key.
     */
SeahorseSshSecData*
seahorse_ssh_sec_data_parse_data (GString* data,
                                  GError** error)
{
	SeahorseSshSecData* secdata = NULL;
	SeahorseSshSecData* _tmp0_;
	const gchar* _tmp1_;
	gchar* rawdata = NULL;
	gchar* _tmp17_;
	gboolean _tmp18_ = FALSE;
	const gchar* _tmp19_;
	SeahorseSshSecData* _tmp22_;
	const gchar* _tmp23_;
	SeahorseSshSecData* _tmp24_;
	const gchar* _tmp25_;
	GError* _inner_error0_ = NULL;
	SeahorseSshSecData* result;
#line 207 "../ssh/key-data.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 208 "../ssh/key-data.vala"
	_tmp0_ = seahorse_ssh_sec_data_new ();
#line 208 "../ssh/key-data.vala"
	secdata = _tmp0_;
#line 211 "../ssh/key-data.vala"
	_tmp1_ = data->str;
#line 211 "../ssh/key-data.vala"
	if (g_str_has_prefix (_tmp1_, SEAHORSE_SSH_SEC_DATA_SSH_KEY_SECRET_SIG)) {
#line 1966 "key-data.c"
		gchar* comment = NULL;
		const gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		SeahorseSshSecData* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 212 "../ssh/key-data.vala"
		_tmp2_ = data->str;
#line 212 "../ssh/key-data.vala"
		_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 2);
#line 212 "../ssh/key-data.vala"
		_tmp5_ = _tmp4_;
#line 212 "../ssh/key-data.vala"
		_tmp5__length1 = _vala_array_length (_tmp3_);
#line 212 "../ssh/key-data.vala"
		_tmp6_ = _tmp5_[0];
#line 212 "../ssh/key-data.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 212 "../ssh/key-data.vala"
		_tmp8_ = _tmp7_;
#line 212 "../ssh/key-data.vala"
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 212 "../ssh/key-data.vala"
		comment = _tmp8_;
#line 213 "../ssh/key-data.vala"
		_tmp9_ = secdata;
#line 213 "../ssh/key-data.vala"
		_tmp10_ = comment;
#line 213 "../ssh/key-data.vala"
		_tmp11_ = strlen (SEAHORSE_SSH_SEC_DATA_SSH_KEY_SECRET_SIG);
#line 213 "../ssh/key-data.vala"
		_tmp12_ = _tmp11_;
#line 213 "../ssh/key-data.vala"
		_tmp13_ = string_substring (_tmp10_, (glong) _tmp12_, (glong) -1);
#line 213 "../ssh/key-data.vala"
		_tmp14_ = _tmp13_;
#line 213 "../ssh/key-data.vala"
		_tmp15_ = string_strip (_tmp14_);
#line 213 "../ssh/key-data.vala"
		_tmp16_ = _tmp15_;
#line 213 "../ssh/key-data.vala"
		seahorse_ssh_sec_data_set_comment (_tmp9_, _tmp16_);
#line 213 "../ssh/key-data.vala"
		_g_free0 (_tmp16_);
#line 213 "../ssh/key-data.vala"
		_g_free0 (_tmp14_);
#line 211 "../ssh/key-data.vala"
		_g_free0 (comment);
#line 2026 "key-data.c"
	}
#line 217 "../ssh/key-data.vala"
	_tmp17_ = seahorse_ssh_sec_data_parse_lines_block (data, SEAHORSE_SSH_SEC_DATA_SSH_PRIVATE_BEGIN, SEAHORSE_SSH_SEC_DATA_SSH_PRIVATE_END);
#line 217 "../ssh/key-data.vala"
	rawdata = _tmp17_;
#line 218 "../ssh/key-data.vala"
	_tmp19_ = rawdata;
#line 218 "../ssh/key-data.vala"
	if (_tmp19_ == NULL) {
#line 218 "../ssh/key-data.vala"
		_tmp18_ = TRUE;
#line 2038 "key-data.c"
	} else {
		const gchar* _tmp20_;
#line 218 "../ssh/key-data.vala"
		_tmp20_ = rawdata;
#line 218 "../ssh/key-data.vala"
		_tmp18_ = g_strcmp0 (_tmp20_, "") == 0;
#line 2045 "key-data.c"
	}
#line 218 "../ssh/key-data.vala"
	if (_tmp18_) {
#line 2049 "key-data.c"
		GError* _tmp21_;
#line 219 "../ssh/key-data.vala"
		_tmp21_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Private key contains no data.");
#line 219 "../ssh/key-data.vala"
		_inner_error0_ = _tmp21_;
#line 219 "../ssh/key-data.vala"
		g_propagate_error (error, _inner_error0_);
#line 219 "../ssh/key-data.vala"
		_g_free0 (rawdata);
#line 219 "../ssh/key-data.vala"
		_g_object_unref0 (secdata);
#line 219 "../ssh/key-data.vala"
		return NULL;
#line 2063 "key-data.c"
	}
#line 221 "../ssh/key-data.vala"
	_tmp22_ = secdata;
#line 221 "../ssh/key-data.vala"
	_tmp23_ = rawdata;
#line 221 "../ssh/key-data.vala"
	seahorse_ssh_sec_data_set_rawdata (_tmp22_, _tmp23_);
#line 224 "../ssh/key-data.vala"
	_tmp24_ = secdata;
#line 224 "../ssh/key-data.vala"
	_tmp25_ = rawdata;
#line 224 "../ssh/key-data.vala"
	seahorse_ssh_sec_data_set_algo (_tmp24_, seahorse_ssh_algorithm_guess_from_string (_tmp25_));
#line 226 "../ssh/key-data.vala"
	result = secdata;
#line 226 "../ssh/key-data.vala"
	_g_free0 (rawdata);
#line 226 "../ssh/key-data.vala"
	return result;
#line 2083 "key-data.c"
}

/**
     * Takes everything between the start and end pattern and returns it.
     * NOTE: The string (if found will) be removed from the argument.
     */
static gchar*
seahorse_ssh_sec_data_parse_lines_block (GString* data,
                                         const gchar* start,
                                         const gchar* end)
{
	GString* _result_ = NULL;
	GString* _tmp0_;
	gboolean start_found = FALSE;
	gchar** lines = NULL;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GString* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* result;
#line 233 "../ssh/key-data.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 233 "../ssh/key-data.vala"
	g_return_val_if_fail (start != NULL, NULL);
#line 233 "../ssh/key-data.vala"
	g_return_val_if_fail (end != NULL, NULL);
#line 234 "../ssh/key-data.vala"
	_tmp0_ = g_string_new ("");
#line 234 "../ssh/key-data.vala"
	_result_ = _tmp0_;
#line 236 "../ssh/key-data.vala"
	start_found = FALSE;
#line 237 "../ssh/key-data.vala"
	_tmp1_ = data->str;
#line 237 "../ssh/key-data.vala"
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, "\n", 0);
#line 237 "../ssh/key-data.vala"
	lines = _tmp3_;
#line 237 "../ssh/key-data.vala"
	lines_length1 = _vala_array_length (_tmp2_);
#line 237 "../ssh/key-data.vala"
	_lines_size_ = lines_length1;
#line 238 "../ssh/key-data.vala"
	_tmp4_ = lines;
#line 238 "../ssh/key-data.vala"
	_tmp4__length1 = lines_length1;
#line 2136 "key-data.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 238 "../ssh/key-data.vala"
		line_collection = _tmp4_;
#line 238 "../ssh/key-data.vala"
		line_collection_length1 = _tmp4__length1;
#line 238 "../ssh/key-data.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 2148 "key-data.c"
			gchar* _tmp5_;
			gchar* line = NULL;
#line 238 "../ssh/key-data.vala"
			_tmp5_ = g_strdup (line_collection[line_it]);
#line 238 "../ssh/key-data.vala"
			line = _tmp5_;
#line 2155 "key-data.c"
			{
#line 240 "../ssh/key-data.vala"
				if (!start_found) {
#line 2159 "key-data.c"
					const gchar* _tmp6_;
#line 241 "../ssh/key-data.vala"
					_tmp6_ = line;
#line 241 "../ssh/key-data.vala"
					if (string_contains (_tmp6_, start)) {
#line 2165 "key-data.c"
						GString* _tmp7_;
						const gchar* _tmp8_;
						GString* _tmp9_;
						const gchar* _tmp10_;
						gint _tmp11_;
						gint _tmp12_;
#line 242 "../ssh/key-data.vala"
						_tmp7_ = _result_;
#line 242 "../ssh/key-data.vala"
						_tmp8_ = line;
#line 242 "../ssh/key-data.vala"
						g_string_append_printf (_tmp7_, "%s\n", _tmp8_);
#line 243 "../ssh/key-data.vala"
						_tmp9_ = _result_;
#line 243 "../ssh/key-data.vala"
						_tmp10_ = line;
#line 243 "../ssh/key-data.vala"
						_tmp11_ = strlen (_tmp10_);
#line 243 "../ssh/key-data.vala"
						_tmp12_ = _tmp11_;
#line 243 "../ssh/key-data.vala"
						g_string_erase (_tmp9_, (gssize) 0, (gssize) (_tmp12_ + 1));
#line 244 "../ssh/key-data.vala"
						start_found = TRUE;
#line 245 "../ssh/key-data.vala"
						_g_free0 (line);
#line 245 "../ssh/key-data.vala"
						continue;
#line 2194 "key-data.c"
					}
				} else {
					GString* _tmp13_;
					const gchar* _tmp14_;
					GString* _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					const gchar* _tmp19_;
#line 249 "../ssh/key-data.vala"
					_tmp13_ = _result_;
#line 249 "../ssh/key-data.vala"
					_tmp14_ = line;
#line 249 "../ssh/key-data.vala"
					g_string_append_printf (_tmp13_, "%s\n", _tmp14_);
#line 250 "../ssh/key-data.vala"
					_tmp15_ = _result_;
#line 250 "../ssh/key-data.vala"
					_tmp16_ = line;
#line 250 "../ssh/key-data.vala"
					_tmp17_ = strlen (_tmp16_);
#line 250 "../ssh/key-data.vala"
					_tmp18_ = _tmp17_;
#line 250 "../ssh/key-data.vala"
					g_string_erase (_tmp15_, (gssize) 0, (gssize) (_tmp18_ + 1));
#line 251 "../ssh/key-data.vala"
					_tmp19_ = line;
#line 251 "../ssh/key-data.vala"
					if (string_contains (_tmp19_, end)) {
#line 252 "../ssh/key-data.vala"
						_g_free0 (line);
#line 252 "../ssh/key-data.vala"
						break;
#line 2228 "key-data.c"
					}
				}
#line 238 "../ssh/key-data.vala"
				_g_free0 (line);
#line 2233 "key-data.c"
			}
		}
	}
#line 256 "../ssh/key-data.vala"
	_tmp20_ = _result_;
#line 256 "../ssh/key-data.vala"
	_tmp21_ = _tmp20_->str;
#line 256 "../ssh/key-data.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 256 "../ssh/key-data.vala"
	result = _tmp22_;
#line 256 "../ssh/key-data.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 256 "../ssh/key-data.vala"
	_g_string_free0 (_result_);
#line 256 "../ssh/key-data.vala"
	return result;
#line 2251 "key-data.c"
}

SeahorseSshSecData*
seahorse_ssh_sec_data_construct (GType object_type)
{
	SeahorseSshSecData * self = NULL;
#line 183 "../ssh/key-data.vala"
	self = (SeahorseSshSecData*) g_object_new (object_type, NULL);
#line 183 "../ssh/key-data.vala"
	return self;
#line 2262 "key-data.c"
}

SeahorseSshSecData*
seahorse_ssh_sec_data_new (void)
{
#line 183 "../ssh/key-data.vala"
	return seahorse_ssh_sec_data_construct (SEAHORSE_SSH_TYPE_SEC_DATA);
#line 2270 "key-data.c"
}

const gchar*
seahorse_ssh_sec_data_get_rawdata (SeahorseSshSecData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 191 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "../ssh/key-data.vala"
	_tmp0_ = self->priv->_rawdata;
#line 191 "../ssh/key-data.vala"
	result = _tmp0_;
#line 191 "../ssh/key-data.vala"
	return result;
#line 2286 "key-data.c"
}

void
seahorse_ssh_sec_data_set_rawdata (SeahorseSshSecData* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 191 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 191 "../ssh/key-data.vala"
	old_value = seahorse_ssh_sec_data_get_rawdata (self);
#line 191 "../ssh/key-data.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2300 "key-data.c"
		gchar* _tmp0_;
#line 191 "../ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 191 "../ssh/key-data.vala"
		_g_free0 (self->priv->_rawdata);
#line 191 "../ssh/key-data.vala"
		self->priv->_rawdata = _tmp0_;
#line 191 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY]);
#line 2310 "key-data.c"
	}
}

const gchar*
seahorse_ssh_sec_data_get_comment (SeahorseSshSecData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 193 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 193 "../ssh/key-data.vala"
	_tmp0_ = self->priv->_comment;
#line 193 "../ssh/key-data.vala"
	result = _tmp0_;
#line 193 "../ssh/key-data.vala"
	return result;
#line 2327 "key-data.c"
}

void
seahorse_ssh_sec_data_set_comment (SeahorseSshSecData* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 193 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 193 "../ssh/key-data.vala"
	old_value = seahorse_ssh_sec_data_get_comment (self);
#line 193 "../ssh/key-data.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2341 "key-data.c"
		gchar* _tmp0_;
#line 193 "../ssh/key-data.vala"
		_tmp0_ = g_strdup (value);
#line 193 "../ssh/key-data.vala"
		_g_free0 (self->priv->_comment);
#line 193 "../ssh/key-data.vala"
		self->priv->_comment = _tmp0_;
#line 193 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY]);
#line 2351 "key-data.c"
	}
}

SeahorseSshAlgorithm
seahorse_ssh_sec_data_get_algo (SeahorseSshSecData* self)
{
	SeahorseSshAlgorithm result;
#line 195 "../ssh/key-data.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 195 "../ssh/key-data.vala"
	result = self->priv->_algo;
#line 195 "../ssh/key-data.vala"
	return result;
#line 2365 "key-data.c"
}

void
seahorse_ssh_sec_data_set_algo (SeahorseSshSecData* self,
                                SeahorseSshAlgorithm value)
{
	SeahorseSshAlgorithm old_value;
#line 195 "../ssh/key-data.vala"
	g_return_if_fail (self != NULL);
#line 195 "../ssh/key-data.vala"
	old_value = seahorse_ssh_sec_data_get_algo (self);
#line 195 "../ssh/key-data.vala"
	if (old_value != value) {
#line 195 "../ssh/key-data.vala"
		self->priv->_algo = value;
#line 195 "../ssh/key-data.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY]);
#line 2383 "key-data.c"
	}
}

static void
seahorse_ssh_sec_data_class_init (SeahorseSshSecDataClass * klass,
                                  gpointer klass_data)
{
#line 183 "../ssh/key-data.vala"
	seahorse_ssh_sec_data_parent_class = g_type_class_peek_parent (klass);
#line 183 "../ssh/key-data.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseSshSecData_private_offset);
#line 183 "../ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_ssh_sec_data_get_property;
#line 183 "../ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_ssh_sec_data_set_property;
#line 183 "../ssh/key-data.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_ssh_sec_data_finalize;
#line 2401 "key-data.c"
	/**
	     * Everything excluding the comment
	     */
#line 183 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY] = g_param_spec_string ("rawdata", "rawdata", "rawdata", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 183 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 183 "../ssh/key-data.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY, seahorse_ssh_sec_data_properties[SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY] = g_param_spec_enum ("algo", "algo", "algo", SEAHORSE_SSH_TYPE_ALGORITHM, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2411 "key-data.c"
}

static void
seahorse_ssh_sec_data_instance_init (SeahorseSshSecData * self,
                                     gpointer klass)
{
#line 183 "../ssh/key-data.vala"
	self->priv = seahorse_ssh_sec_data_get_instance_private (self);
#line 2420 "key-data.c"
}

static void
seahorse_ssh_sec_data_finalize (GObject * obj)
{
	SeahorseSshSecData * self;
#line 183 "../ssh/key-data.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_SEC_DATA, SeahorseSshSecData);
#line 191 "../ssh/key-data.vala"
	_g_free0 (self->priv->_rawdata);
#line 193 "../ssh/key-data.vala"
	_g_free0 (self->priv->_comment);
#line 183 "../ssh/key-data.vala"
	G_OBJECT_CLASS (seahorse_ssh_sec_data_parent_class)->finalize (obj);
#line 2435 "key-data.c"
}

/**
 * Represents the data in a private key.
 */
 G_GNUC_NO_INLINE static GType
seahorse_ssh_sec_data_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseSshSecDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_ssh_sec_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseSshSecData), 0, (GInstanceInitFunc) seahorse_ssh_sec_data_instance_init, NULL };
	GType seahorse_ssh_sec_data_type_id;
	seahorse_ssh_sec_data_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorseSshSecData", &g_define_type_info, 0);
	SeahorseSshSecData_private_offset = g_type_add_instance_private (seahorse_ssh_sec_data_type_id, sizeof (SeahorseSshSecDataPrivate));
	return seahorse_ssh_sec_data_type_id;
}

GType
seahorse_ssh_sec_data_get_type (void)
{
	static volatile gsize seahorse_ssh_sec_data_type_id__once = 0;
	if (g_once_init_enter (&seahorse_ssh_sec_data_type_id__once)) {
		GType seahorse_ssh_sec_data_type_id;
		seahorse_ssh_sec_data_type_id = seahorse_ssh_sec_data_get_type_once ();
		g_once_init_leave (&seahorse_ssh_sec_data_type_id__once, seahorse_ssh_sec_data_type_id);
	}
	return seahorse_ssh_sec_data_type_id__once;
}

static void
_vala_seahorse_ssh_sec_data_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	SeahorseSshSecData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_SEC_DATA, SeahorseSshSecData);
#line 183 "../ssh/key-data.vala"
	switch (property_id) {
#line 183 "../ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY:
#line 183 "../ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_sec_data_get_rawdata (self));
#line 183 "../ssh/key-data.vala"
		break;
#line 183 "../ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY:
#line 183 "../ssh/key-data.vala"
		g_value_set_string (value, seahorse_ssh_sec_data_get_comment (self));
#line 183 "../ssh/key-data.vala"
		break;
#line 183 "../ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY:
#line 183 "../ssh/key-data.vala"
		g_value_set_enum (value, seahorse_ssh_sec_data_get_algo (self));
#line 183 "../ssh/key-data.vala"
		break;
#line 2491 "key-data.c"
		default:
#line 183 "../ssh/key-data.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 183 "../ssh/key-data.vala"
		break;
#line 2497 "key-data.c"
	}
}

static void
_vala_seahorse_ssh_sec_data_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	SeahorseSshSecData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_SEC_DATA, SeahorseSshSecData);
#line 183 "../ssh/key-data.vala"
	switch (property_id) {
#line 183 "../ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_RAWDATA_PROPERTY:
#line 183 "../ssh/key-data.vala"
		seahorse_ssh_sec_data_set_rawdata (self, g_value_get_string (value));
#line 183 "../ssh/key-data.vala"
		break;
#line 183 "../ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_COMMENT_PROPERTY:
#line 183 "../ssh/key-data.vala"
		seahorse_ssh_sec_data_set_comment (self, g_value_get_string (value));
#line 183 "../ssh/key-data.vala"
		break;
#line 183 "../ssh/key-data.vala"
		case SEAHORSE_SSH_SEC_DATA_ALGO_PROPERTY:
#line 183 "../ssh/key-data.vala"
		seahorse_ssh_sec_data_set_algo (self, g_value_get_enum (value));
#line 183 "../ssh/key-data.vala"
		break;
#line 2529 "key-data.c"
		default:
#line 183 "../ssh/key-data.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 183 "../ssh/key-data.vala"
		break;
#line 2535 "key-data.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

