/* key.c generated by valac 0.56.11, the Vala compiler
 * generated from key.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2016 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-ssh.h"
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "seahorse-common.h"
#include <glib/gi18n-lib.h>
#include <gcr/gcr-base.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib/gstdio.h>

enum  {
	SEAHORSE_SSH_KEY_0_PROPERTY,
	SEAHORSE_SSH_KEY_KEY_DATA_PROPERTY,
	SEAHORSE_SSH_KEY_FINGERPRINT_PROPERTY,
	SEAHORSE_SSH_KEY_PUBKEY_PROPERTY,
	SEAHORSE_SSH_KEY_DESCRIPTION_PROPERTY,
	SEAHORSE_SSH_KEY_VALIDITY_PROPERTY,
	SEAHORSE_SSH_KEY_TRUST_PROPERTY,
	SEAHORSE_SSH_KEY_EXPIRES_PROPERTY,
	SEAHORSE_SSH_KEY_LENGTH_PROPERTY,
	SEAHORSE_SSH_KEY_NUM_PROPERTIES
};
static GParamSpec* seahorse_ssh_key_properties[SEAHORSE_SSH_KEY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _SeahorseSshKeyParseData SeahorseSshKeyParseData;
typedef struct _SeahorseSshKeyParseFileData SeahorseSshKeyParseFileData;

struct _SeahorseSshKeyPrivate {
	SeahorseSshKeyData* _keydata;
};

struct _SeahorseSshKeyParseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar* data;
	GCancellable* cancellable;
	SeahorseSshKeyKeyParseResult result;
	gboolean _tmp0_;
	GPtrArray* pubkeys;
	GPtrArray* _tmp1_;
	GPtrArray* seckeys;
	GPtrArray* _tmp2_;
	GString* toParse;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GString* _tmp5_;
	GString* _tmp6_;
	GString* _tmp7_;
	const gchar* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GString* _tmp11_;
	const gchar* _tmp12_;
	SeahorseSshSecData* secdata;
	GString* _tmp13_;
	SeahorseSshSecData* _tmp14_;
	GPtrArray* _tmp15_;
	SeahorseSshSecData* _tmp16_;
	SeahorseSshSecData* _tmp17_;
	GError* e;
	GError* _tmp18_;
	const gchar* _tmp19_;
	gchar** lines;
	GString* _tmp20_;
	const gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	gint lines_length1;
	gint _lines_size_;
	gchar* line;
	gchar** _tmp24_;
	gint _tmp24__length1;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	GString* _tmp27_;
	const gchar* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gchar** _tmp31_;
	gint _tmp31__length1;
	GString* _tmp32_;
	gboolean _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gboolean _tmp37_;
	const gchar* _tmp38_;
	SeahorseSshKeyData* keydata;
	const gchar* _tmp39_;
	SeahorseSshKeyData* _tmp40_;
	GPtrArray* _tmp41_;
	SeahorseSshKeyData* _tmp42_;
	SeahorseSshKeyData* _tmp43_;
	GError* _vala1_e;
	GError* _tmp44_;
	const gchar* _tmp45_;
	SeahorseSshKeyKeyParseResult _result_;
	GPtrArray* _tmp46_;
	gsize _tmp47_;
	gpointer* _tmp48_;
	GPtrArray* _tmp49_;
	gsize _tmp50_;
	gpointer* _tmp51_;
	GError* _inner_error0_;
};

struct _SeahorseSshKeyParseFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar* filename;
	GCancellable* cancellable;
	SeahorseSshKeyKeyParseResult result;
	gchar* contents;
	gchar* _tmp0_;
	SeahorseSshKeyKeyParseResult _tmp1_;
	const gchar* _tmp2_;
	SeahorseSshKeyKeyParseResult _tmp3_;
	SeahorseSshKeyKeyParseResult _tmp4_;
	GError* _inner_error0_;
};

static gint SeahorseSshKey_private_offset;
static gpointer seahorse_ssh_key_parent_class = NULL;
static SeahorseExportableIface * seahorse_ssh_key_seahorse_exportable_parent_iface = NULL;
static SeahorseDeletableIface * seahorse_ssh_key_seahorse_deletable_parent_iface = NULL;
static SeahorseViewableIface * seahorse_ssh_key_seahorse_viewable_parent_iface = NULL;

static gchar* seahorse_ssh_key_parse_first_word (SeahorseSshKey* self,
                                          const gchar* line);
static void seahorse_ssh_key_changed_key (SeahorseSshKey* self);
static GList* seahorse_ssh_key_real_create_exporters (SeahorseExportable* base,
                                               SeahorseExporterType type);
static SeahorseDeleter* seahorse_ssh_key_real_create_deleter (SeahorseDeletable* base);
static GtkWindow* seahorse_ssh_key_real_create_viewer (SeahorseViewable* base,
                                                GtkWindow* parent);
static void seahorse_ssh_key_parse_data_free (gpointer _data);
static gboolean seahorse_ssh_key_parse_co (SeahorseSshKeyParseData* _data_);
static void _g_object_unref0_ (gpointer var);
static void seahorse_ssh_key_parse_file_data_free (gpointer _data);
static gboolean seahorse_ssh_key_parse_file_co (SeahorseSshKeyParseFileData* _data_);
static void seahorse_ssh_key_parse_file_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_);
static SeahorseSshKeyData** _vala_array_dup3 (SeahorseSshKeyData** self,
                                       gssize length);
static SeahorseSshSecData** _vala_array_dup4 (SeahorseSshSecData** self,
                                       gssize length);
static void seahorse_ssh_key_finalize (GObject * obj);
static GType seahorse_ssh_key_get_type_once (void);
static void _vala_seahorse_ssh_key_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_seahorse_ssh_key_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
seahorse_ssh_key_get_instance_private (SeahorseSshKey* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseSshKey_private_offset);
}

SeahorseSshKey*
seahorse_ssh_key_construct (GType object_type,
                            SeahorseSshSource* source,
                            SeahorseSshKeyData* key_data)
{
	SeahorseSshKey * self = NULL;
#line 93 "../ssh/key.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 93 "../ssh/key.vala"
	g_return_val_if_fail (key_data != NULL, NULL);
#line 94 "../ssh/key.vala"
	self = (SeahorseSshKey*) g_object_new (object_type, "place", source, "key-data", key_data, NULL);
#line 93 "../ssh/key.vala"
	return self;
#line 224 "key.c"
}

SeahorseSshKey*
seahorse_ssh_key_new (SeahorseSshSource* source,
                      SeahorseSshKeyData* key_data)
{
#line 93 "../ssh/key.vala"
	return seahorse_ssh_key_construct (SEAHORSE_SSH_TYPE_KEY, source, key_data);
#line 233 "key.c"
}

static gchar*
seahorse_ssh_key_parse_first_word (SeahorseSshKey* self,
                                   const gchar* line)
{
	gchar* PARSE_CHARS = NULL;
	gchar* _tmp0_;
	gchar** words = NULL;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint words_length1;
	gint _words_size_;
	const gchar* _tmp4_ = NULL;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp8_;
	gchar* result;
#line 97 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "../ssh/key.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 98 "../ssh/key.vala"
	_tmp0_ = g_strdup ("\t \n@;,.\\?()[]{}+/");
#line 98 "../ssh/key.vala"
	PARSE_CHARS = _tmp0_;
#line 100 "../ssh/key.vala"
	_tmp1_ = PARSE_CHARS;
#line 100 "../ssh/key.vala"
	_tmp3_ = _tmp2_ = g_strsplit_set (line, _tmp1_, 2);
#line 100 "../ssh/key.vala"
	words = _tmp3_;
#line 100 "../ssh/key.vala"
	words_length1 = _vala_array_length (_tmp2_);
#line 100 "../ssh/key.vala"
	_words_size_ = words_length1;
#line 101 "../ssh/key.vala"
	_tmp5_ = words;
#line 101 "../ssh/key.vala"
	_tmp5__length1 = words_length1;
#line 101 "../ssh/key.vala"
	if (_tmp5__length1 == 2) {
#line 277 "key.c"
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
#line 101 "../ssh/key.vala"
		_tmp6_ = words;
#line 101 "../ssh/key.vala"
		_tmp6__length1 = words_length1;
#line 101 "../ssh/key.vala"
		_tmp7_ = _tmp6_[0];
#line 101 "../ssh/key.vala"
		_tmp4_ = _tmp7_;
#line 289 "key.c"
	} else {
#line 101 "../ssh/key.vala"
		_tmp4_ = NULL;
#line 293 "key.c"
	}
#line 101 "../ssh/key.vala"
	_tmp8_ = g_strdup (_tmp4_);
#line 101 "../ssh/key.vala"
	result = _tmp8_;
#line 101 "../ssh/key.vala"
	words = (_vala_array_free (words, words_length1, (GDestroyNotify) g_free), NULL);
#line 101 "../ssh/key.vala"
	_g_free0 (PARSE_CHARS);
#line 101 "../ssh/key.vala"
	return result;
#line 305 "key.c"
}

static void
seahorse_ssh_key_changed_key (SeahorseSshKey* self)
{
	gboolean _tmp0_ = FALSE;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshKeyData* _tmp2_;
	SeahorseSshKeyData* _tmp7_;
	SeahorseSshKeyData* _tmp8_;
	SeahorseSshKeyData* _tmp32_;
	SeahorseSshKeyData* _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	SeahorseSshKeyData* _tmp38_;
	SeahorseSshKeyData* _tmp39_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp48_ = NULL;
	SeahorseSshKeyData* _tmp49_;
	SeahorseSshKeyData* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gchar* filename = NULL;
	gchar* _tmp57_;
	const gchar* _tmp58_;
	const gchar* _tmp59_;
	const gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	SeahorseSshKeyData* _tmp63_;
	SeahorseSshKeyData* _tmp64_;
	const gchar* _tmp65_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
	gchar* _tmp68_;
#line 104 "../ssh/key.vala"
	g_return_if_fail (self != NULL);
#line 105 "../ssh/key.vala"
	_tmp1_ = seahorse_ssh_key_get_key_data (self);
#line 105 "../ssh/key.vala"
	_tmp2_ = _tmp1_;
#line 105 "../ssh/key.vala"
	if (_tmp2_ == NULL) {
#line 105 "../ssh/key.vala"
		_tmp0_ = TRUE;
#line 352 "key.c"
	} else {
		SeahorseSshKeyData* _tmp3_;
		SeahorseSshKeyData* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 105 "../ssh/key.vala"
		_tmp3_ = seahorse_ssh_key_get_key_data (self);
#line 105 "../ssh/key.vala"
		_tmp4_ = _tmp3_;
#line 105 "../ssh/key.vala"
		_tmp5_ = seahorse_ssh_key_data_get_fingerprint (_tmp4_);
#line 105 "../ssh/key.vala"
		_tmp6_ = _tmp5_;
#line 105 "../ssh/key.vala"
		_tmp0_ = _tmp6_ == NULL;
#line 368 "key.c"
	}
#line 105 "../ssh/key.vala"
	if (_tmp0_) {
#line 106 "../ssh/key.vala"
		seahorse_object_set_label ((SeahorseObject*) self, "");
#line 107 "../ssh/key.vala"
		seahorse_object_set_icon ((SeahorseObject*) self, NULL);
#line 108 "../ssh/key.vala"
		seahorse_object_set_usage ((SeahorseObject*) self, SEAHORSE_USAGE_NONE);
#line 109 "../ssh/key.vala"
		seahorse_object_set_nickname ((SeahorseObject*) self, "");
#line 110 "../ssh/key.vala"
		seahorse_object_set_object_flags ((SeahorseObject*) self, SEAHORSE_FLAG_DISABLED);
#line 111 "../ssh/key.vala"
		return;
#line 384 "key.c"
	}
#line 114 "../ssh/key.vala"
	_tmp7_ = seahorse_ssh_key_get_key_data (self);
#line 114 "../ssh/key.vala"
	_tmp8_ = _tmp7_;
#line 114 "../ssh/key.vala"
	if (_tmp8_ != NULL) {
#line 392 "key.c"
		SeahorseSshKeyData* _tmp9_;
		SeahorseSshKeyData* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gboolean _tmp27_ = FALSE;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
#line 116 "../ssh/key.vala"
		_tmp9_ = seahorse_ssh_key_get_key_data (self);
#line 116 "../ssh/key.vala"
		_tmp10_ = _tmp9_;
#line 116 "../ssh/key.vala"
		_tmp11_ = seahorse_ssh_key_data_get_comment (_tmp10_);
#line 116 "../ssh/key.vala"
		_tmp12_ = _tmp11_;
#line 116 "../ssh/key.vala"
		if (_tmp12_ != NULL) {
#line 410 "key.c"
			SeahorseSshKeyData* _tmp13_;
			SeahorseSshKeyData* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			SeahorseSshKeyData* _tmp17_;
			SeahorseSshKeyData* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
#line 117 "../ssh/key.vala"
			_tmp13_ = seahorse_ssh_key_get_key_data (self);
#line 117 "../ssh/key.vala"
			_tmp14_ = _tmp13_;
#line 117 "../ssh/key.vala"
			_tmp15_ = seahorse_ssh_key_data_get_comment (_tmp14_);
#line 117 "../ssh/key.vala"
			_tmp16_ = _tmp15_;
#line 117 "../ssh/key.vala"
			seahorse_object_set_label ((SeahorseObject*) self, _tmp16_);
#line 118 "../ssh/key.vala"
			_tmp17_ = seahorse_ssh_key_get_key_data (self);
#line 118 "../ssh/key.vala"
			_tmp18_ = _tmp17_;
#line 118 "../ssh/key.vala"
			_tmp19_ = seahorse_ssh_key_data_get_comment (_tmp18_);
#line 118 "../ssh/key.vala"
			_tmp20_ = _tmp19_;
#line 118 "../ssh/key.vala"
			_tmp21_ = seahorse_ssh_key_parse_first_word (self, _tmp20_);
#line 118 "../ssh/key.vala"
			_tmp22_ = _tmp21_;
#line 118 "../ssh/key.vala"
			seahorse_object_set_nickname ((SeahorseObject*) self, _tmp22_);
#line 118 "../ssh/key.vala"
			_g_free0 (_tmp22_);
#line 447 "key.c"
		} else {
			SeahorseSshKeyData* _tmp23_;
			SeahorseSshKeyData* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
#line 121 "../ssh/key.vala"
			_tmp23_ = seahorse_ssh_key_get_key_data (self);
#line 121 "../ssh/key.vala"
			_tmp24_ = _tmp23_;
#line 121 "../ssh/key.vala"
			_tmp25_ = seahorse_ssh_key_data_get_fingerprint (_tmp24_);
#line 121 "../ssh/key.vala"
			_tmp26_ = _tmp25_;
#line 121 "../ssh/key.vala"
			if (_tmp26_ == NULL) {
#line 122 "../ssh/key.vala"
				seahorse_object_set_label ((SeahorseObject*) self, _ ("(Unreadable Secure Shell Key)"));
#line 465 "key.c"
			} else {
#line 125 "../ssh/key.vala"
				seahorse_object_set_label ((SeahorseObject*) self, _ ("Secure Shell Key"));
#line 469 "key.c"
			}
		}
#line 128 "../ssh/key.vala"
		_tmp28_ = seahorse_object_get_nickname ((SeahorseObject*) self);
#line 128 "../ssh/key.vala"
		_tmp29_ = _tmp28_;
#line 128 "../ssh/key.vala"
		if (_tmp29_ == NULL) {
#line 128 "../ssh/key.vala"
			_tmp27_ = TRUE;
#line 480 "key.c"
		} else {
			const gchar* _tmp30_;
			const gchar* _tmp31_;
#line 128 "../ssh/key.vala"
			_tmp30_ = seahorse_object_get_nickname ((SeahorseObject*) self);
#line 128 "../ssh/key.vala"
			_tmp31_ = _tmp30_;
#line 128 "../ssh/key.vala"
			_tmp27_ = g_strcmp0 (_tmp31_, "") == 0;
#line 490 "key.c"
		}
#line 128 "../ssh/key.vala"
		if (_tmp27_) {
#line 129 "../ssh/key.vala"
			seahorse_object_set_nickname ((SeahorseObject*) self, _ ("Secure Shell Key"));
#line 496 "key.c"
		}
	}
#line 132 "../ssh/key.vala"
	seahorse_object_set_object_flags ((SeahorseObject*) self, SEAHORSE_FLAG_EXPORTABLE | SEAHORSE_FLAG_DELETABLE);
#line 133 "../ssh/key.vala"
	_tmp32_ = seahorse_ssh_key_get_key_data (self);
#line 133 "../ssh/key.vala"
	_tmp33_ = _tmp32_;
#line 133 "../ssh/key.vala"
	_tmp34_ = seahorse_ssh_key_data_get_authorized (_tmp33_);
#line 133 "../ssh/key.vala"
	_tmp35_ = _tmp34_;
#line 133 "../ssh/key.vala"
	if (_tmp35_) {
#line 511 "key.c"
		SeahorseFlags _tmp36_;
		SeahorseFlags _tmp37_;
#line 134 "../ssh/key.vala"
		_tmp36_ = seahorse_object_get_object_flags ((SeahorseObject*) self);
#line 134 "../ssh/key.vala"
		_tmp37_ = _tmp36_;
#line 134 "../ssh/key.vala"
		seahorse_object_set_object_flags ((SeahorseObject*) self, _tmp37_ | SEAHORSE_FLAG_TRUSTED);
#line 520 "key.c"
	}
#line 136 "../ssh/key.vala"
	_tmp38_ = seahorse_ssh_key_get_key_data (self);
#line 136 "../ssh/key.vala"
	_tmp39_ = _tmp38_;
#line 136 "../ssh/key.vala"
	_tmp40_ = seahorse_ssh_key_data_get_privfile (_tmp39_);
#line 136 "../ssh/key.vala"
	_tmp41_ = _tmp40_;
#line 136 "../ssh/key.vala"
	if (_tmp41_ != NULL) {
#line 532 "key.c"
		SeahorseFlags _tmp42_;
		SeahorseFlags _tmp43_;
		GThemedIcon* _tmp44_;
		GThemedIcon* _tmp45_;
#line 137 "../ssh/key.vala"
		seahorse_object_set_usage ((SeahorseObject*) self, SEAHORSE_USAGE_PRIVATE_KEY);
#line 138 "../ssh/key.vala"
		_tmp42_ = seahorse_object_get_object_flags ((SeahorseObject*) self);
#line 138 "../ssh/key.vala"
		_tmp43_ = _tmp42_;
#line 138 "../ssh/key.vala"
		seahorse_object_set_object_flags ((SeahorseObject*) self, _tmp43_ | (SEAHORSE_FLAG_PERSONAL | SEAHORSE_FLAG_TRUSTED));
#line 139 "../ssh/key.vala"
		_tmp44_ = (GThemedIcon*) g_themed_icon_new (GCR_ICON_KEY_PAIR);
#line 139 "../ssh/key.vala"
		_tmp45_ = _tmp44_;
#line 139 "../ssh/key.vala"
		seahorse_object_set_icon ((SeahorseObject*) self, (GIcon*) _tmp45_);
#line 139 "../ssh/key.vala"
		_g_object_unref0 (_tmp45_);
#line 553 "key.c"
	} else {
		GThemedIcon* _tmp46_;
		GThemedIcon* _tmp47_;
#line 141 "../ssh/key.vala"
		seahorse_object_set_object_flags ((SeahorseObject*) self, 0);
#line 142 "../ssh/key.vala"
		seahorse_object_set_usage ((SeahorseObject*) self, SEAHORSE_USAGE_PUBLIC_KEY);
#line 143 "../ssh/key.vala"
		_tmp46_ = (GThemedIcon*) g_themed_icon_new (GCR_ICON_KEY);
#line 143 "../ssh/key.vala"
		_tmp47_ = _tmp46_;
#line 143 "../ssh/key.vala"
		seahorse_object_set_icon ((SeahorseObject*) self, (GIcon*) _tmp47_);
#line 143 "../ssh/key.vala"
		_g_object_unref0 (_tmp47_);
#line 569 "key.c"
	}
#line 146 "../ssh/key.vala"
	_tmp49_ = seahorse_ssh_key_get_key_data (self);
#line 146 "../ssh/key.vala"
	_tmp50_ = _tmp49_;
#line 146 "../ssh/key.vala"
	_tmp51_ = seahorse_ssh_key_data_get_privfile (_tmp50_);
#line 146 "../ssh/key.vala"
	_tmp52_ = _tmp51_;
#line 146 "../ssh/key.vala"
	_tmp48_ = _tmp52_;
#line 146 "../ssh/key.vala"
	if (_tmp48_ == NULL) {
#line 583 "key.c"
		SeahorseSshKeyData* _tmp53_;
		SeahorseSshKeyData* _tmp54_;
		const gchar* _tmp55_;
		const gchar* _tmp56_;
#line 146 "../ssh/key.vala"
		_tmp53_ = seahorse_ssh_key_get_key_data (self);
#line 146 "../ssh/key.vala"
		_tmp54_ = _tmp53_;
#line 146 "../ssh/key.vala"
		_tmp55_ = seahorse_ssh_key_data_get_pubfile (_tmp54_);
#line 146 "../ssh/key.vala"
		_tmp56_ = _tmp55_;
#line 146 "../ssh/key.vala"
		_tmp48_ = _tmp56_;
#line 598 "key.c"
	}
#line 146 "../ssh/key.vala"
	_tmp57_ = g_path_get_basename (_tmp48_);
#line 146 "../ssh/key.vala"
	filename = _tmp57_;
#line 147 "../ssh/key.vala"
	_tmp58_ = seahorse_object_get_label ((SeahorseObject*) self);
#line 147 "../ssh/key.vala"
	_tmp59_ = _tmp58_;
#line 147 "../ssh/key.vala"
	_tmp60_ = filename;
#line 147 "../ssh/key.vala"
	_tmp61_ = g_markup_printf_escaped ("%s<span size='small' rise='0' foreground='#555555'>\n%s</span>", _tmp59_, _tmp60_);
#line 147 "../ssh/key.vala"
	_tmp62_ = _tmp61_;
#line 147 "../ssh/key.vala"
	seahorse_object_set_markup ((SeahorseObject*) self, _tmp62_);
#line 147 "../ssh/key.vala"
	_g_free0 (_tmp62_);
#line 150 "../ssh/key.vala"
	_tmp63_ = seahorse_ssh_key_get_key_data (self);
#line 150 "../ssh/key.vala"
	_tmp64_ = _tmp63_;
#line 150 "../ssh/key.vala"
	_tmp65_ = seahorse_ssh_key_data_get_fingerprint (_tmp64_);
#line 150 "../ssh/key.vala"
	_tmp66_ = _tmp65_;
#line 150 "../ssh/key.vala"
	_tmp67_ = seahorse_ssh_key_calc_identifier (_tmp66_);
#line 150 "../ssh/key.vala"
	_tmp68_ = _tmp67_;
#line 150 "../ssh/key.vala"
	seahorse_object_set_identifier ((SeahorseObject*) self, _tmp68_);
#line 150 "../ssh/key.vala"
	_g_free0 (_tmp68_);
#line 104 "../ssh/key.vala"
	_g_free0 (filename);
#line 636 "key.c"
}

void
seahorse_ssh_key_refresh (SeahorseSshKey* self)
{
#line 153 "../ssh/key.vala"
	g_return_if_fail (self != NULL);
#line 644 "key.c"
}

static GList*
seahorse_ssh_key_real_create_exporters (SeahorseExportable* base,
                                        SeahorseExporterType type)
{
	SeahorseSshKey * self;
	GList* exporters = NULL;
	SeahorseSshExporter* _tmp0_;
	GList* result;
#line 157 "../ssh/key.vala"
	self = (SeahorseSshKey*) base;
#line 158 "../ssh/key.vala"
	exporters = NULL;
#line 159 "../ssh/key.vala"
	_tmp0_ = seahorse_ssh_exporter_new (self, FALSE);
#line 159 "../ssh/key.vala"
	exporters = g_list_append (exporters, (SeahorseExporter*) _tmp0_);
#line 160 "../ssh/key.vala"
	result = exporters;
#line 160 "../ssh/key.vala"
	return result;
#line 667 "key.c"
}

static SeahorseDeleter*
seahorse_ssh_key_real_create_deleter (SeahorseDeletable* base)
{
	SeahorseSshKey * self;
	SeahorseSshDeleter* _tmp0_;
	SeahorseDeleter* result;
#line 163 "../ssh/key.vala"
	self = (SeahorseSshKey*) base;
#line 164 "../ssh/key.vala"
	_tmp0_ = seahorse_ssh_deleter_new (self);
#line 164 "../ssh/key.vala"
	result = (SeahorseDeleter*) _tmp0_;
#line 164 "../ssh/key.vala"
	return result;
#line 684 "key.c"
}

static GtkWindow*
seahorse_ssh_key_real_create_viewer (SeahorseViewable* base,
                                     GtkWindow* parent)
{
	SeahorseSshKey * self;
	SeahorseSshKeyProperties* properties_dialog = NULL;
	SeahorseSshKeyProperties* _tmp0_;
	GtkWindow* result;
#line 167 "../ssh/key.vala"
	self = (SeahorseSshKey*) base;
#line 168 "../ssh/key.vala"
	_tmp0_ = seahorse_ssh_key_properties_new (self, parent);
#line 168 "../ssh/key.vala"
	g_object_ref_sink (_tmp0_);
#line 168 "../ssh/key.vala"
	properties_dialog = _tmp0_;
#line 169 "../ssh/key.vala"
	gtk_widget_show ((GtkWidget*) properties_dialog);
#line 170 "../ssh/key.vala"
	result = (GtkWindow*) properties_dialog;
#line 170 "../ssh/key.vala"
	return result;
#line 709 "key.c"
}

SeahorseSshAlgorithm
seahorse_ssh_key_get_algo (SeahorseSshKey* self)
{
	SeahorseSshKeyData* _tmp0_;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshAlgorithm _tmp2_;
	SeahorseSshAlgorithm _tmp3_;
	SeahorseSshAlgorithm result;
#line 173 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 174 "../ssh/key.vala"
	_tmp0_ = seahorse_ssh_key_get_key_data (self);
#line 174 "../ssh/key.vala"
	_tmp1_ = _tmp0_;
#line 174 "../ssh/key.vala"
	_tmp2_ = seahorse_ssh_key_data_get_algo (_tmp1_);
#line 174 "../ssh/key.vala"
	_tmp3_ = _tmp2_;
#line 174 "../ssh/key.vala"
	result = _tmp3_;
#line 174 "../ssh/key.vala"
	return result;
#line 734 "key.c"
}

gchar*
seahorse_ssh_key_get_location (SeahorseSshKey* self)
{
	SeahorseSshKeyData* _tmp0_;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshKeyData* _tmp2_;
	SeahorseSshKeyData* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 177 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 178 "../ssh/key.vala"
	_tmp0_ = seahorse_ssh_key_get_key_data (self);
#line 178 "../ssh/key.vala"
	_tmp1_ = _tmp0_;
#line 178 "../ssh/key.vala"
	if (_tmp1_ == NULL) {
#line 179 "../ssh/key.vala"
		result = NULL;
#line 179 "../ssh/key.vala"
		return result;
#line 758 "key.c"
	}
#line 180 "../ssh/key.vala"
	_tmp2_ = seahorse_ssh_key_get_key_data (self);
#line 180 "../ssh/key.vala"
	_tmp3_ = _tmp2_;
#line 180 "../ssh/key.vala"
	_tmp4_ = seahorse_ssh_key_data_get_location (_tmp3_);
#line 180 "../ssh/key.vala"
	result = _tmp4_;
#line 180 "../ssh/key.vala"
	return result;
#line 770 "key.c"
}

guint
seahorse_ssh_key_get_strength (SeahorseSshKey* self)
{
	guint _tmp0_ = 0U;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshKeyData* _tmp2_;
	guint result;
#line 183 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 184 "../ssh/key.vala"
	_tmp1_ = seahorse_ssh_key_get_key_data (self);
#line 184 "../ssh/key.vala"
	_tmp2_ = _tmp1_;
#line 184 "../ssh/key.vala"
	if (_tmp2_ != NULL) {
#line 788 "key.c"
		SeahorseSshKeyData* _tmp3_;
		SeahorseSshKeyData* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
#line 184 "../ssh/key.vala"
		_tmp3_ = seahorse_ssh_key_get_key_data (self);
#line 184 "../ssh/key.vala"
		_tmp4_ = _tmp3_;
#line 184 "../ssh/key.vala"
		_tmp5_ = seahorse_ssh_key_data_get_length (_tmp4_);
#line 184 "../ssh/key.vala"
		_tmp6_ = _tmp5_;
#line 184 "../ssh/key.vala"
		_tmp0_ = _tmp6_;
#line 803 "key.c"
	} else {
#line 184 "../ssh/key.vala"
		_tmp0_ = (guint) 0;
#line 807 "key.c"
	}
#line 184 "../ssh/key.vala"
	result = _tmp0_;
#line 184 "../ssh/key.vala"
	return result;
#line 813 "key.c"
}

/**
     * Creates a valid identifier for an SSH key from a given string.
     *
     * @return A valid identifier, or null if the result is too short.
     */
static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 841 "key.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 850 "key.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 869 "key.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 873 "key.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 879 "key.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 889 "key.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 897 "key.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 901 "key.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 907 "key.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 917 "key.c"
}

gchar*
seahorse_ssh_key_calc_identifier (const gchar* id)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 192 "../ssh/key.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 927 "key.c"
	{
		GRegex* regex = NULL;
		GRegex* _tmp0_;
		gchar* _result_ = NULL;
		GRegex* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 195 "../ssh/key.vala"
		_tmp0_ = g_regex_new ("[^a-zA-Z0-9]", 0, 0, &_inner_error0_);
#line 195 "../ssh/key.vala"
		regex = _tmp0_;
#line 195 "../ssh/key.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 195 "../ssh/key.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 947 "key.c"
				goto __catch0_g_regex_error;
			}
#line 195 "../ssh/key.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 195 "../ssh/key.vala"
			g_clear_error (&_inner_error0_);
#line 195 "../ssh/key.vala"
			return NULL;
#line 956 "key.c"
		}
#line 196 "../ssh/key.vala"
		_tmp1_ = regex;
#line 196 "../ssh/key.vala"
		_tmp2_ = strlen (id);
#line 196 "../ssh/key.vala"
		_tmp3_ = _tmp2_;
#line 196 "../ssh/key.vala"
		_tmp4_ = g_regex_replace (_tmp1_, id, (gssize) _tmp3_, 0, "", 0, &_inner_error0_);
#line 196 "../ssh/key.vala"
		_result_ = _tmp4_;
#line 196 "../ssh/key.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../ssh/key.vala"
			_g_regex_unref0 (regex);
#line 196 "../ssh/key.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 974 "key.c"
				goto __catch0_g_regex_error;
			}
#line 196 "../ssh/key.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 196 "../ssh/key.vala"
			g_clear_error (&_inner_error0_);
#line 196 "../ssh/key.vala"
			return NULL;
#line 983 "key.c"
		}
#line 198 "../ssh/key.vala"
		_tmp5_ = _result_;
#line 198 "../ssh/key.vala"
		_tmp6_ = strlen (_tmp5_);
#line 198 "../ssh/key.vala"
		_tmp7_ = _tmp6_;
#line 198 "../ssh/key.vala"
		if (_tmp7_ >= SEAHORSE_SSH_KEY_SSH_IDENTIFIER_SIZE) {
#line 993 "key.c"
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gchar* _tmp12_;
#line 199 "../ssh/key.vala"
			_tmp8_ = _result_;
#line 199 "../ssh/key.vala"
			_tmp9_ = _result_;
#line 199 "../ssh/key.vala"
			_tmp10_ = strlen (_tmp9_);
#line 199 "../ssh/key.vala"
			_tmp11_ = _tmp10_;
#line 199 "../ssh/key.vala"
			_tmp12_ = string_substring (_tmp8_, (glong) 0, (glong) _tmp11_);
#line 199 "../ssh/key.vala"
			result = _tmp12_;
#line 199 "../ssh/key.vala"
			_g_free0 (_result_);
#line 199 "../ssh/key.vala"
			_g_regex_unref0 (regex);
#line 199 "../ssh/key.vala"
			return result;
#line 1017 "key.c"
		}
#line 194 "../ssh/key.vala"
		_g_free0 (_result_);
#line 194 "../ssh/key.vala"
		_g_regex_unref0 (regex);
#line 1023 "key.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 194 "../ssh/key.vala"
		e = _inner_error0_;
#line 194 "../ssh/key.vala"
		_inner_error0_ = NULL;
#line 201 "../ssh/key.vala"
		_tmp13_ = e;
#line 201 "../ssh/key.vala"
		_tmp14_ = _tmp13_->message;
#line 201 "../ssh/key.vala"
		_tmp15_ = g_strdup_printf ("Couldn't create regex for calc_identifier. Message: %s", _tmp14_);
#line 201 "../ssh/key.vala"
		_tmp16_ = _tmp15_;
#line 201 "../ssh/key.vala"
		g_warning ("key.vala:201: %s", _tmp16_);
#line 201 "../ssh/key.vala"
		_g_free0 (_tmp16_);
#line 194 "../ssh/key.vala"
		_g_error_free0 (e);
#line 1051 "key.c"
	}
	__finally0:
#line 194 "../ssh/key.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 194 "../ssh/key.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 194 "../ssh/key.vala"
		g_clear_error (&_inner_error0_);
#line 194 "../ssh/key.vala"
		return NULL;
#line 1062 "key.c"
	}
#line 204 "../ssh/key.vala"
	result = NULL;
#line 204 "../ssh/key.vala"
	return result;
#line 1068 "key.c"
}

/**
     * Sometimes keys loaded later on have more information (e.g. keys loaded
     * from authorized_keys), so propagate that up to the previously loaded key.
     */
void
seahorse_ssh_key_merge_keydata (SeahorseSshKey* self,
                                SeahorseSshKeyData* keydata)
{
	gboolean _tmp0_ = FALSE;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshKeyData* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 211 "../ssh/key.vala"
	g_return_if_fail (self != NULL);
#line 211 "../ssh/key.vala"
	g_return_if_fail (keydata != NULL);
#line 212 "../ssh/key.vala"
	_tmp1_ = seahorse_ssh_key_get_key_data (self);
#line 212 "../ssh/key.vala"
	_tmp2_ = _tmp1_;
#line 212 "../ssh/key.vala"
	_tmp3_ = seahorse_ssh_key_data_get_authorized (_tmp2_);
#line 212 "../ssh/key.vala"
	_tmp4_ = _tmp3_;
#line 212 "../ssh/key.vala"
	if (!_tmp4_) {
#line 1098 "key.c"
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 212 "../ssh/key.vala"
		_tmp5_ = seahorse_ssh_key_data_get_authorized (keydata);
#line 212 "../ssh/key.vala"
		_tmp6_ = _tmp5_;
#line 212 "../ssh/key.vala"
		_tmp0_ = _tmp6_;
#line 1107 "key.c"
	} else {
#line 212 "../ssh/key.vala"
		_tmp0_ = FALSE;
#line 1111 "key.c"
	}
#line 212 "../ssh/key.vala"
	if (_tmp0_) {
#line 1115 "key.c"
		SeahorseSshKeyData* _tmp7_;
		SeahorseSshKeyData* _tmp8_;
		SeahorseSshKeyData* _tmp9_;
		SeahorseSshKeyData* _tmp10_;
#line 213 "../ssh/key.vala"
		_tmp7_ = seahorse_ssh_key_get_key_data (self);
#line 213 "../ssh/key.vala"
		_tmp8_ = _tmp7_;
#line 213 "../ssh/key.vala"
		seahorse_ssh_key_data_set_authorized (_tmp8_, TRUE);
#line 216 "../ssh/key.vala"
		_tmp9_ = seahorse_ssh_key_get_key_data (self);
#line 216 "../ssh/key.vala"
		_tmp10_ = _tmp9_;
#line 216 "../ssh/key.vala"
		seahorse_ssh_key_set_key_data (self, _tmp10_);
#line 1132 "key.c"
	}
}

static void
seahorse_ssh_key_parse_data_free (gpointer _data)
{
	SeahorseSshKeyParseData* _data_;
	_data_ = _data;
#line 25 "../ssh/key.vala"
	_g_free0 (_data_->data);
#line 25 "../ssh/key.vala"
	_g_object_unref0 (_data_->cancellable);
#line 25 "../ssh/key.vala"
	seahorse_ssh_key_key_parse_result_destroy (&_data_->result);
#line 25 "../ssh/key.vala"
	g_slice_free (SeahorseSshKeyParseData, _data_);
#line 1149 "key.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 25 "../ssh/key.vala"
	return self ? g_object_ref (self) : NULL;
#line 1157 "key.c"
}

void
seahorse_ssh_key_parse (const gchar* data,
                        GCancellable* cancellable,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	SeahorseSshKeyParseData* _data_;
	gchar* _tmp0_;
	GCancellable* _tmp1_;
#line 25 "../ssh/key.vala"
	g_return_if_fail (data != NULL);
#line 25 "../ssh/key.vala"
	_data_ = g_slice_new0 (SeahorseSshKeyParseData);
#line 25 "../ssh/key.vala"
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
#line 25 "../ssh/key.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_key_parse_data_free);
#line 25 "../ssh/key.vala"
	_tmp0_ = g_strdup (data);
#line 25 "../ssh/key.vala"
	_g_free0 (_data_->data);
#line 25 "../ssh/key.vala"
	_data_->data = _tmp0_;
#line 25 "../ssh/key.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 25 "../ssh/key.vala"
	_g_object_unref0 (_data_->cancellable);
#line 25 "../ssh/key.vala"
	_data_->cancellable = _tmp1_;
#line 25 "../ssh/key.vala"
	seahorse_ssh_key_parse_co (_data_);
#line 1191 "key.c"
}

void
seahorse_ssh_key_parse_finish (GAsyncResult* _res_,
                               SeahorseSshKeyKeyParseResult* result,
                               GError** error)
{
	SeahorseSshKeyParseData* _data_;
	SeahorseSshKeyKeyParseResult _tmp0_;
	SeahorseSshKeyKeyParseResult _tmp1_ = {0};
#line 25 "../ssh/key.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 25 "../ssh/key.vala"
	if (NULL == _data_) {
#line 25 "../ssh/key.vala"
		return;
#line 1208 "key.c"
	}
#line 25 "../ssh/key.vala"
	_tmp0_ = _data_->result;
#line 25 "../ssh/key.vala"
	seahorse_ssh_key_key_parse_result_copy (&_tmp0_, &_tmp1_);
#line 25 "../ssh/key.vala"
	*result = _tmp1_;
#line 1216 "key.c"
}

/**
     * Parses a string into public/private keys.
     *
     * @param data The string that needs to be parsed.
     * @param cancellable Can be used to cancel the parsing.
     */
static void
_g_object_unref0_ (gpointer var)
{
#line 235 "../ssh/key.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1230 "key.c"
}

static gchar*
string_chug (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strchug (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 1251 "key.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 1272 "key.c"
}

static gboolean
seahorse_ssh_key_parse_co (SeahorseSshKeyParseData* _data_)
{
#line 231 "../ssh/key.vala"
	switch (_data_->_state_) {
#line 231 "../ssh/key.vala"
		case 0:
#line 1282 "key.c"
		goto _state_0;
		default:
#line 231 "../ssh/key.vala"
		g_assert_not_reached ();
#line 1287 "key.c"
	}
	_state_0:
#line 233 "../ssh/key.vala"
	if (_data_->data != NULL) {
#line 233 "../ssh/key.vala"
		_data_->_tmp0_ = TRUE;
#line 1294 "key.c"
	} else {
#line 233 "../ssh/key.vala"
		_data_->_tmp0_ = g_strcmp0 (_data_->data, "") != 0;
#line 1298 "key.c"
	}
#line 233 "../ssh/key.vala"
	g_return_if_fail (_data_->_tmp0_);
#line 235 "../ssh/key.vala"
	_data_->_tmp1_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 235 "../ssh/key.vala"
	_data_->pubkeys = _data_->_tmp1_;
#line 236 "../ssh/key.vala"
	_data_->_tmp2_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 236 "../ssh/key.vala"
	_data_->seckeys = _data_->_tmp2_;
#line 238 "../ssh/key.vala"
	_data_->_tmp3_ = string_chug (_data_->data);
#line 238 "../ssh/key.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 238 "../ssh/key.vala"
	_data_->_tmp5_ = g_string_new (_data_->_tmp4_);
#line 238 "../ssh/key.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 238 "../ssh/key.vala"
	_g_free0 (_data_->_tmp4_);
#line 238 "../ssh/key.vala"
	_data_->toParse = _data_->_tmp6_;
#line 239 "../ssh/key.vala"
	while (TRUE) {
#line 239 "../ssh/key.vala"
		_data_->_tmp7_ = _data_->toParse;
#line 239 "../ssh/key.vala"
		_data_->_tmp8_ = _data_->_tmp7_->str;
#line 239 "../ssh/key.vala"
		_data_->_tmp9_ = strlen (_data_->_tmp8_);
#line 239 "../ssh/key.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 239 "../ssh/key.vala"
		if (!(_data_->_tmp10_ > 0)) {
#line 239 "../ssh/key.vala"
			break;
#line 1336 "key.c"
		}
#line 241 "../ssh/key.vala"
		_data_->_tmp11_ = _data_->toParse;
#line 241 "../ssh/key.vala"
		_data_->_tmp12_ = _data_->_tmp11_->str;
#line 241 "../ssh/key.vala"
		if (seahorse_ssh_sec_data_contains_private_key (_data_->_tmp12_)) {
#line 1344 "key.c"
			{
#line 243 "../ssh/key.vala"
				_data_->_tmp13_ = _data_->toParse;
#line 243 "../ssh/key.vala"
				_data_->_tmp14_ = seahorse_ssh_sec_data_parse_data (_data_->_tmp13_, &_data_->_inner_error0_);
#line 243 "../ssh/key.vala"
				_data_->secdata = _data_->_tmp14_;
#line 243 "../ssh/key.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1354 "key.c"
					goto __catch0_g_error;
				}
#line 244 "../ssh/key.vala"
				_data_->_tmp15_ = _data_->seckeys;
#line 244 "../ssh/key.vala"
				_data_->_tmp16_ = _data_->secdata;
#line 244 "../ssh/key.vala"
				_data_->_tmp17_ = _g_object_ref0 (_data_->_tmp16_);
#line 244 "../ssh/key.vala"
				g_ptr_array_add (_data_->_tmp15_, _data_->_tmp17_);
#line 245 "../ssh/key.vala"
				_g_object_unref0 (_data_->secdata);
#line 245 "../ssh/key.vala"
				continue;
#line 1369 "key.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 242 "../ssh/key.vala"
				_data_->e = _data_->_inner_error0_;
#line 242 "../ssh/key.vala"
				_data_->_inner_error0_ = NULL;
#line 247 "../ssh/key.vala"
				_data_->_tmp18_ = _data_->e;
#line 247 "../ssh/key.vala"
				_data_->_tmp19_ = _data_->_tmp18_->message;
#line 247 "../ssh/key.vala"
				g_warning ("key.vala:247: %s", _data_->_tmp19_);
#line 242 "../ssh/key.vala"
				_g_error_free0 (_data_->e);
#line 1386 "key.c"
			}
			__finally0:
#line 242 "../ssh/key.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 242 "../ssh/key.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 242 "../ssh/key.vala"
				_g_string_free0 (_data_->toParse);
#line 242 "../ssh/key.vala"
				_g_ptr_array_unref0 (_data_->seckeys);
#line 242 "../ssh/key.vala"
				_g_ptr_array_unref0 (_data_->pubkeys);
#line 242 "../ssh/key.vala"
				g_object_unref (_data_->_async_result);
#line 242 "../ssh/key.vala"
				return FALSE;
#line 1403 "key.c"
			}
		}
#line 252 "../ssh/key.vala"
		_data_->_tmp20_ = _data_->toParse;
#line 252 "../ssh/key.vala"
		_data_->_tmp21_ = _data_->_tmp20_->str;
#line 252 "../ssh/key.vala"
		_data_->_tmp23_ = _data_->_tmp22_ = g_strsplit (_data_->_tmp21_, "\n", 2);
#line 252 "../ssh/key.vala"
		_data_->lines = _data_->_tmp23_;
#line 252 "../ssh/key.vala"
		_data_->lines_length1 = _vala_array_length (_data_->_tmp22_);
#line 252 "../ssh/key.vala"
		_data_->_lines_size_ = _data_->lines_length1;
#line 253 "../ssh/key.vala"
		_data_->_tmp24_ = _data_->lines;
#line 253 "../ssh/key.vala"
		_data_->_tmp24__length1 = _data_->lines_length1;
#line 253 "../ssh/key.vala"
		_data_->_tmp25_ = _data_->_tmp24_[0];
#line 253 "../ssh/key.vala"
		_data_->_tmp26_ = g_strdup (_data_->_tmp25_);
#line 253 "../ssh/key.vala"
		_data_->line = _data_->_tmp26_;
#line 254 "../ssh/key.vala"
		_data_->_tmp27_ = _data_->toParse;
#line 254 "../ssh/key.vala"
		_data_->_tmp28_ = _data_->line;
#line 254 "../ssh/key.vala"
		_data_->_tmp29_ = strlen (_data_->_tmp28_);
#line 254 "../ssh/key.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 254 "../ssh/key.vala"
		g_string_erase (_data_->_tmp27_, (gssize) 0, (gssize) _data_->_tmp30_);
#line 255 "../ssh/key.vala"
		_data_->_tmp31_ = _data_->lines;
#line 255 "../ssh/key.vala"
		_data_->_tmp31__length1 = _data_->lines_length1;
#line 255 "../ssh/key.vala"
		if (_data_->_tmp31__length1 == 2) {
#line 256 "../ssh/key.vala"
			_data_->_tmp32_ = _data_->toParse;
#line 256 "../ssh/key.vala"
			g_string_erase (_data_->_tmp32_, (gssize) 0, (gssize) 1);
#line 1448 "key.c"
		}
#line 259 "../ssh/key.vala"
		_data_->_tmp34_ = _data_->line;
#line 259 "../ssh/key.vala"
		_data_->_tmp35_ = string_strip (_data_->_tmp34_);
#line 259 "../ssh/key.vala"
		_data_->_tmp36_ = _data_->_tmp35_;
#line 259 "../ssh/key.vala"
		_data_->_tmp37_ = g_strcmp0 (_data_->_tmp36_, "") == 0;
#line 259 "../ssh/key.vala"
		_g_free0 (_data_->_tmp36_);
#line 259 "../ssh/key.vala"
		if (_data_->_tmp37_) {
#line 259 "../ssh/key.vala"
			_data_->_tmp33_ = TRUE;
#line 1464 "key.c"
		} else {
#line 259 "../ssh/key.vala"
			_data_->_tmp38_ = _data_->line;
#line 259 "../ssh/key.vala"
			_data_->_tmp33_ = g_str_has_prefix (_data_->_tmp38_, "#");
#line 1470 "key.c"
		}
#line 259 "../ssh/key.vala"
		if (_data_->_tmp33_) {
#line 260 "../ssh/key.vala"
			_g_free0 (_data_->line);
#line 260 "../ssh/key.vala"
			_data_->lines = (_vala_array_free (_data_->lines, _data_->lines_length1, (GDestroyNotify) g_free), NULL);
#line 260 "../ssh/key.vala"
			continue;
#line 1480 "key.c"
		}
		{
#line 264 "../ssh/key.vala"
			_data_->_tmp39_ = _data_->line;
#line 264 "../ssh/key.vala"
			_data_->_tmp40_ = seahorse_ssh_key_data_parse_line (_data_->_tmp39_, &_data_->_inner_error0_);
#line 264 "../ssh/key.vala"
			_data_->keydata = _data_->_tmp40_;
#line 264 "../ssh/key.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1491 "key.c"
				goto __catch1_g_error;
			}
#line 265 "../ssh/key.vala"
			_data_->_tmp41_ = _data_->pubkeys;
#line 265 "../ssh/key.vala"
			_data_->_tmp42_ = _data_->keydata;
#line 265 "../ssh/key.vala"
			_data_->_tmp43_ = _g_object_ref0 (_data_->_tmp42_);
#line 265 "../ssh/key.vala"
			g_ptr_array_add (_data_->_tmp41_, _data_->_tmp43_);
#line 263 "../ssh/key.vala"
			_g_object_unref0 (_data_->keydata);
#line 1504 "key.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 263 "../ssh/key.vala"
			_data_->_vala1_e = _data_->_inner_error0_;
#line 263 "../ssh/key.vala"
			_data_->_inner_error0_ = NULL;
#line 267 "../ssh/key.vala"
			_data_->_tmp44_ = _data_->_vala1_e;
#line 267 "../ssh/key.vala"
			_data_->_tmp45_ = _data_->_tmp44_->message;
#line 267 "../ssh/key.vala"
			g_warning ("key.vala:267: %s", _data_->_tmp45_);
#line 263 "../ssh/key.vala"
			_g_error_free0 (_data_->_vala1_e);
#line 1521 "key.c"
		}
		__finally1:
#line 263 "../ssh/key.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 263 "../ssh/key.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 263 "../ssh/key.vala"
			_g_free0 (_data_->line);
#line 263 "../ssh/key.vala"
			_data_->lines = (_vala_array_free (_data_->lines, _data_->lines_length1, (GDestroyNotify) g_free), NULL);
#line 263 "../ssh/key.vala"
			_g_string_free0 (_data_->toParse);
#line 263 "../ssh/key.vala"
			_g_ptr_array_unref0 (_data_->seckeys);
#line 263 "../ssh/key.vala"
			_g_ptr_array_unref0 (_data_->pubkeys);
#line 263 "../ssh/key.vala"
			g_object_unref (_data_->_async_result);
#line 263 "../ssh/key.vala"
			return FALSE;
#line 1542 "key.c"
		}
#line 239 "../ssh/key.vala"
		_g_free0 (_data_->line);
#line 239 "../ssh/key.vala"
		_data_->lines = (_vala_array_free (_data_->lines, _data_->lines_length1, (GDestroyNotify) g_free), NULL);
#line 1548 "key.c"
	}
#line 271 "../ssh/key.vala"
	memset (&_data_->_result_, 0, sizeof (SeahorseSshKeyKeyParseResult));
#line 272 "../ssh/key.vala"
	_data_->_tmp46_ = _data_->pubkeys;
#line 272 "../ssh/key.vala"
	_data_->_tmp47_ = 0;
#line 272 "../ssh/key.vala"
	_data_->_tmp48_ = g_ptr_array_steal (_data_->_tmp46_, &_data_->_tmp47_);
#line 272 "../ssh/key.vala"
	_data_->_result_.public_keys = (_vala_array_free (_data_->_result_.public_keys, _data_->_result_.public_keys_length1, (GDestroyNotify) g_object_unref), NULL);
#line 272 "../ssh/key.vala"
	_data_->_result_.public_keys = _data_->_tmp48_;
#line 272 "../ssh/key.vala"
	_data_->_result_.public_keys_length1 = _data_->_tmp47_;
#line 273 "../ssh/key.vala"
	_data_->_tmp49_ = _data_->seckeys;
#line 273 "../ssh/key.vala"
	_data_->_tmp50_ = 0;
#line 273 "../ssh/key.vala"
	_data_->_tmp51_ = g_ptr_array_steal (_data_->_tmp49_, &_data_->_tmp50_);
#line 273 "../ssh/key.vala"
	_data_->_result_.secret_keys = (_vala_array_free (_data_->_result_.secret_keys, _data_->_result_.secret_keys_length1, (GDestroyNotify) g_object_unref), NULL);
#line 273 "../ssh/key.vala"
	_data_->_result_.secret_keys = _data_->_tmp51_;
#line 273 "../ssh/key.vala"
	_data_->_result_.secret_keys_length1 = _data_->_tmp50_;
#line 274 "../ssh/key.vala"
	_data_->result = _data_->_result_;
#line 274 "../ssh/key.vala"
	_g_string_free0 (_data_->toParse);
#line 274 "../ssh/key.vala"
	_g_ptr_array_unref0 (_data_->seckeys);
#line 274 "../ssh/key.vala"
	_g_ptr_array_unref0 (_data_->pubkeys);
#line 274 "../ssh/key.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 274 "../ssh/key.vala"
	if (_data_->_state_ != 0) {
#line 274 "../ssh/key.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 274 "../ssh/key.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1592 "key.c"
		}
	}
#line 274 "../ssh/key.vala"
	g_object_unref (_data_->_async_result);
#line 274 "../ssh/key.vala"
	return FALSE;
#line 1599 "key.c"
}

static void
seahorse_ssh_key_parse_file_data_free (gpointer _data)
{
	SeahorseSshKeyParseFileData* _data_;
	_data_ = _data;
#line 25 "../ssh/key.vala"
	_g_free0 (_data_->filename);
#line 25 "../ssh/key.vala"
	_g_object_unref0 (_data_->cancellable);
#line 25 "../ssh/key.vala"
	seahorse_ssh_key_key_parse_result_destroy (&_data_->result);
#line 25 "../ssh/key.vala"
	g_slice_free (SeahorseSshKeyParseFileData, _data_);
#line 1615 "key.c"
}

void
seahorse_ssh_key_parse_file (const gchar* filename,
                             GCancellable* cancellable,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	SeahorseSshKeyParseFileData* _data_;
	gchar* _tmp0_;
	GCancellable* _tmp1_;
#line 25 "../ssh/key.vala"
	g_return_if_fail (filename != NULL);
#line 25 "../ssh/key.vala"
	_data_ = g_slice_new0 (SeahorseSshKeyParseFileData);
#line 25 "../ssh/key.vala"
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
#line 25 "../ssh/key.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_key_parse_file_data_free);
#line 25 "../ssh/key.vala"
	_tmp0_ = g_strdup (filename);
#line 25 "../ssh/key.vala"
	_g_free0 (_data_->filename);
#line 25 "../ssh/key.vala"
	_data_->filename = _tmp0_;
#line 25 "../ssh/key.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 25 "../ssh/key.vala"
	_g_object_unref0 (_data_->cancellable);
#line 25 "../ssh/key.vala"
	_data_->cancellable = _tmp1_;
#line 25 "../ssh/key.vala"
	seahorse_ssh_key_parse_file_co (_data_);
#line 1649 "key.c"
}

void
seahorse_ssh_key_parse_file_finish (GAsyncResult* _res_,
                                    SeahorseSshKeyKeyParseResult* result,
                                    GError** error)
{
	SeahorseSshKeyParseFileData* _data_;
	SeahorseSshKeyKeyParseResult _tmp0_;
	SeahorseSshKeyKeyParseResult _tmp1_ = {0};
#line 25 "../ssh/key.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 25 "../ssh/key.vala"
	if (NULL == _data_) {
#line 25 "../ssh/key.vala"
		return;
#line 1666 "key.c"
	}
#line 25 "../ssh/key.vala"
	_tmp0_ = _data_->result;
#line 25 "../ssh/key.vala"
	seahorse_ssh_key_key_parse_result_copy (&_tmp0_, &_tmp1_);
#line 25 "../ssh/key.vala"
	*result = _tmp1_;
#line 1674 "key.c"
}

/**
     * Parses the contents of the given file into public/private keys.
     *
     * @param data The file that will be parsed.
     * @param cancellable Can be used to cancel the parsing.
     */
static void
seahorse_ssh_key_parse_file_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_)
{
	SeahorseSshKeyParseFileData* _data_;
#line 288 "../ssh/key.vala"
	_data_ = _user_data_;
#line 288 "../ssh/key.vala"
	_data_->_source_object_ = source_object;
#line 288 "../ssh/key.vala"
	_data_->_res_ = _res_;
#line 288 "../ssh/key.vala"
	seahorse_ssh_key_parse_file_co (_data_);
#line 1697 "key.c"
}

static gboolean
seahorse_ssh_key_parse_file_co (SeahorseSshKeyParseFileData* _data_)
{
#line 283 "../ssh/key.vala"
	switch (_data_->_state_) {
#line 283 "../ssh/key.vala"
		case 0:
#line 1707 "key.c"
		goto _state_0;
#line 283 "../ssh/key.vala"
		case 1:
#line 1711 "key.c"
		goto _state_1;
		default:
#line 283 "../ssh/key.vala"
		g_assert_not_reached ();
#line 1716 "key.c"
	}
	_state_0:
#line 286 "../ssh/key.vala"
	_data_->_tmp0_ = NULL;
#line 286 "../ssh/key.vala"
	g_file_get_contents (_data_->filename, &_data_->_tmp0_, NULL, &_data_->_inner_error0_);
#line 286 "../ssh/key.vala"
	_g_free0 (_data_->contents);
#line 286 "../ssh/key.vala"
	_data_->contents = _data_->_tmp0_;
#line 286 "../ssh/key.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 286 "../ssh/key.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 286 "../ssh/key.vala"
		_g_free0 (_data_->contents);
#line 286 "../ssh/key.vala"
		g_object_unref (_data_->_async_result);
#line 286 "../ssh/key.vala"
		return FALSE;
#line 1737 "key.c"
	}
#line 288 "../ssh/key.vala"
	_data_->_tmp2_ = _data_->contents;
#line 288 "../ssh/key.vala"
	memset (&_data_->_tmp3_, 0, sizeof (SeahorseSshKeyKeyParseResult));
#line 288 "../ssh/key.vala"
	_data_->_state_ = 1;
#line 288 "../ssh/key.vala"
	seahorse_ssh_key_parse (_data_->_tmp2_, _data_->cancellable, seahorse_ssh_key_parse_file_ready, _data_);
#line 288 "../ssh/key.vala"
	return FALSE;
#line 1749 "key.c"
	_state_1:
#line 288 "../ssh/key.vala"
	seahorse_ssh_key_parse_finish (_data_->_res_, &_data_->_tmp3_, &_data_->_inner_error0_);
#line 288 "../ssh/key.vala"
	_data_->_tmp1_ = _data_->_tmp3_;
#line 288 "../ssh/key.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 288 "../ssh/key.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 288 "../ssh/key.vala"
		_g_free0 (_data_->contents);
#line 288 "../ssh/key.vala"
		g_object_unref (_data_->_async_result);
#line 288 "../ssh/key.vala"
		return FALSE;
#line 1765 "key.c"
	}
#line 288 "../ssh/key.vala"
	_data_->_tmp4_ = _data_->_tmp1_;
#line 288 "../ssh/key.vala"
	memset (&_data_->_tmp1_, 0, sizeof (SeahorseSshKeyKeyParseResult));
#line 288 "../ssh/key.vala"
	_data_->result = _data_->_tmp4_;
#line 288 "../ssh/key.vala"
	seahorse_ssh_key_key_parse_result_destroy (&_data_->_tmp1_);
#line 288 "../ssh/key.vala"
	_g_free0 (_data_->contents);
#line 288 "../ssh/key.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 288 "../ssh/key.vala"
	if (_data_->_state_ != 0) {
#line 288 "../ssh/key.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 288 "../ssh/key.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1785 "key.c"
		}
	}
#line 288 "../ssh/key.vala"
	g_object_unref (_data_->_async_result);
#line 288 "../ssh/key.vala"
	return FALSE;
#line 1792 "key.c"
}

SeahorseSshKeyData*
seahorse_ssh_key_get_key_data (SeahorseSshKey* self)
{
	SeahorseSshKeyData* result;
	SeahorseSshKeyData* _tmp0_;
#line 30 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../ssh/key.vala"
	_tmp0_ = self->priv->_keydata;
#line 30 "../ssh/key.vala"
	result = _tmp0_;
#line 30 "../ssh/key.vala"
	return result;
#line 1808 "key.c"
}

void
seahorse_ssh_key_set_key_data (SeahorseSshKey* self,
                               SeahorseSshKeyData* value)
{
	SeahorseSshKeyData* _tmp0_;
#line 31 "../ssh/key.vala"
	g_return_if_fail (self != NULL);
#line 31 "../ssh/key.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 31 "../ssh/key.vala"
	_g_object_unref0 (self->priv->_keydata);
#line 31 "../ssh/key.vala"
	self->priv->_keydata = _tmp0_;
#line 31 "../ssh/key.vala"
	seahorse_ssh_key_changed_key (self);
#line 31 "../ssh/key.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_properties[SEAHORSE_SSH_KEY_KEY_DATA_PROPERTY]);
#line 1828 "key.c"
}

const gchar*
seahorse_ssh_key_get_fingerprint (SeahorseSshKey* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshKeyData* _tmp2_;
#line 38 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../ssh/key.vala"
	_tmp1_ = seahorse_ssh_key_get_key_data (self);
#line 38 "../ssh/key.vala"
	_tmp2_ = _tmp1_;
#line 38 "../ssh/key.vala"
	if (_tmp2_ != NULL) {
#line 1846 "key.c"
		SeahorseSshKeyData* _tmp3_;
		SeahorseSshKeyData* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 38 "../ssh/key.vala"
		_tmp3_ = seahorse_ssh_key_get_key_data (self);
#line 38 "../ssh/key.vala"
		_tmp4_ = _tmp3_;
#line 38 "../ssh/key.vala"
		_tmp5_ = seahorse_ssh_key_data_get_fingerprint (_tmp4_);
#line 38 "../ssh/key.vala"
		_tmp6_ = _tmp5_;
#line 38 "../ssh/key.vala"
		_tmp0_ = _tmp6_;
#line 1861 "key.c"
	} else {
#line 38 "../ssh/key.vala"
		_tmp0_ = NULL;
#line 1865 "key.c"
	}
#line 38 "../ssh/key.vala"
	result = _tmp0_;
#line 38 "../ssh/key.vala"
	return result;
#line 1871 "key.c"
}

const gchar*
seahorse_ssh_key_get_pubkey (SeahorseSshKey* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshKeyData* _tmp2_;
#line 45 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../ssh/key.vala"
	_tmp1_ = seahorse_ssh_key_get_key_data (self);
#line 45 "../ssh/key.vala"
	_tmp2_ = _tmp1_;
#line 45 "../ssh/key.vala"
	if (_tmp2_ != NULL) {
#line 1889 "key.c"
		SeahorseSshKeyData* _tmp3_;
		SeahorseSshKeyData* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 45 "../ssh/key.vala"
		_tmp3_ = seahorse_ssh_key_get_key_data (self);
#line 45 "../ssh/key.vala"
		_tmp4_ = _tmp3_;
#line 45 "../ssh/key.vala"
		_tmp5_ = seahorse_ssh_key_data_get_rawdata (_tmp4_);
#line 45 "../ssh/key.vala"
		_tmp6_ = _tmp5_;
#line 45 "../ssh/key.vala"
		_tmp0_ = _tmp6_;
#line 1904 "key.c"
	} else {
#line 45 "../ssh/key.vala"
		_tmp0_ = NULL;
#line 1908 "key.c"
	}
#line 45 "../ssh/key.vala"
	result = _tmp0_;
#line 45 "../ssh/key.vala"
	return result;
#line 1914 "key.c"
}

const gchar*
seahorse_ssh_key_get_description (SeahorseSshKey* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	SeahorseUsage _tmp1_;
	SeahorseUsage _tmp2_;
#line 52 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../ssh/key.vala"
	_tmp1_ = seahorse_object_get_usage ((SeahorseObject*) self);
#line 52 "../ssh/key.vala"
	_tmp2_ = _tmp1_;
#line 52 "../ssh/key.vala"
	if (_tmp2_ == SEAHORSE_USAGE_PRIVATE_KEY) {
#line 52 "../ssh/key.vala"
		_tmp0_ = _ ("Personal SSH key");
#line 1934 "key.c"
	} else {
#line 52 "../ssh/key.vala"
		_tmp0_ = _ ("SSH key");
#line 1938 "key.c"
	}
#line 52 "../ssh/key.vala"
	result = _tmp0_;
#line 52 "../ssh/key.vala"
	return result;
#line 1944 "key.c"
}

SeahorseValidity
seahorse_ssh_key_get_validity (SeahorseSshKey* self)
{
	SeahorseValidity result;
	gboolean _tmp0_ = FALSE;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshKeyData* _tmp2_;
#line 59 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 60 "../ssh/key.vala"
	_tmp1_ = seahorse_ssh_key_get_key_data (self);
#line 60 "../ssh/key.vala"
	_tmp2_ = _tmp1_;
#line 60 "../ssh/key.vala"
	if (_tmp2_ != NULL) {
#line 1962 "key.c"
		SeahorseSshKeyData* _tmp3_;
		SeahorseSshKeyData* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 60 "../ssh/key.vala"
		_tmp3_ = seahorse_ssh_key_get_key_data (self);
#line 60 "../ssh/key.vala"
		_tmp4_ = _tmp3_;
#line 60 "../ssh/key.vala"
		_tmp5_ = seahorse_ssh_key_data_get_privfile (_tmp4_);
#line 60 "../ssh/key.vala"
		_tmp6_ = _tmp5_;
#line 60 "../ssh/key.vala"
		_tmp0_ = _tmp6_ != NULL;
#line 1977 "key.c"
	} else {
#line 60 "../ssh/key.vala"
		_tmp0_ = FALSE;
#line 1981 "key.c"
	}
#line 60 "../ssh/key.vala"
	if (_tmp0_) {
#line 61 "../ssh/key.vala"
		result = SEAHORSE_VALIDITY_ULTIMATE;
#line 61 "../ssh/key.vala"
		return result;
#line 1989 "key.c"
	}
#line 62 "../ssh/key.vala"
	result = 0;
#line 62 "../ssh/key.vala"
	return result;
#line 1995 "key.c"
}

SeahorseValidity
seahorse_ssh_key_get_trust (SeahorseSshKey* self)
{
	SeahorseValidity result;
	SeahorseSshKeyData* _tmp0_;
	SeahorseSshKeyData* _tmp1_;
	gboolean _tmp2_ = FALSE;
	SeahorseSshKeyData* _tmp3_;
	SeahorseSshKeyData* _tmp4_;
#line 70 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 71 "../ssh/key.vala"
	_tmp0_ = seahorse_ssh_key_get_key_data (self);
#line 71 "../ssh/key.vala"
	_tmp1_ = _tmp0_;
#line 71 "../ssh/key.vala"
	if (_tmp1_ == NULL) {
#line 72 "../ssh/key.vala"
		g_warning ("key.vala:72: key_data is null");
#line 2017 "key.c"
	}
#line 73 "../ssh/key.vala"
	_tmp3_ = seahorse_ssh_key_get_key_data (self);
#line 73 "../ssh/key.vala"
	_tmp4_ = _tmp3_;
#line 73 "../ssh/key.vala"
	if (_tmp4_ != NULL) {
#line 2025 "key.c"
		SeahorseSshKeyData* _tmp5_;
		SeahorseSshKeyData* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 73 "../ssh/key.vala"
		_tmp5_ = seahorse_ssh_key_get_key_data (self);
#line 73 "../ssh/key.vala"
		_tmp6_ = _tmp5_;
#line 73 "../ssh/key.vala"
		_tmp7_ = seahorse_ssh_key_data_get_authorized (_tmp6_);
#line 73 "../ssh/key.vala"
		_tmp8_ = _tmp7_;
#line 73 "../ssh/key.vala"
		_tmp2_ = _tmp8_;
#line 2040 "key.c"
	} else {
#line 73 "../ssh/key.vala"
		_tmp2_ = FALSE;
#line 2044 "key.c"
	}
#line 73 "../ssh/key.vala"
	if (_tmp2_) {
#line 74 "../ssh/key.vala"
		result = SEAHORSE_VALIDITY_FULL;
#line 74 "../ssh/key.vala"
		return result;
#line 2052 "key.c"
	}
#line 75 "../ssh/key.vala"
	result = 0;
#line 75 "../ssh/key.vala"
	return result;
#line 2058 "key.c"
}

gulong
seahorse_ssh_key_get_expires (SeahorseSshKey* self)
{
	gulong result;
#line 83 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 83 "../ssh/key.vala"
	result = (gulong) 0;
#line 83 "../ssh/key.vala"
	return result;
#line 2071 "key.c"
}

guint
seahorse_ssh_key_get_length (SeahorseSshKey* self)
{
	guint result;
	guint _tmp0_ = 0U;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshKeyData* _tmp2_;
#line 90 "../ssh/key.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 90 "../ssh/key.vala"
	_tmp1_ = seahorse_ssh_key_get_key_data (self);
#line 90 "../ssh/key.vala"
	_tmp2_ = _tmp1_;
#line 90 "../ssh/key.vala"
	if (_tmp2_ != NULL) {
#line 2089 "key.c"
		SeahorseSshKeyData* _tmp3_;
		SeahorseSshKeyData* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
#line 90 "../ssh/key.vala"
		_tmp3_ = seahorse_ssh_key_get_key_data (self);
#line 90 "../ssh/key.vala"
		_tmp4_ = _tmp3_;
#line 90 "../ssh/key.vala"
		_tmp5_ = seahorse_ssh_key_data_get_length (_tmp4_);
#line 90 "../ssh/key.vala"
		_tmp6_ = _tmp5_;
#line 90 "../ssh/key.vala"
		_tmp0_ = _tmp6_;
#line 2104 "key.c"
	} else {
#line 90 "../ssh/key.vala"
		_tmp0_ = (guint) 0;
#line 2108 "key.c"
	}
#line 90 "../ssh/key.vala"
	result = _tmp0_;
#line 90 "../ssh/key.vala"
	return result;
#line 2114 "key.c"
}

static SeahorseSshKeyData**
_vala_array_dup3 (SeahorseSshKeyData** self,
                  gssize length)
{
#line 220 "../ssh/key.vala"
	if (length >= 0) {
#line 2123 "key.c"
		SeahorseSshKeyData** result;
		gssize i;
#line 220 "../ssh/key.vala"
		result = g_new0 (SeahorseSshKeyData*, length + 1);
#line 220 "../ssh/key.vala"
		for (i = 0; i < length; i++) {
#line 2130 "key.c"
			SeahorseSshKeyData* _tmp0_;
#line 220 "../ssh/key.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 220 "../ssh/key.vala"
			result[i] = _tmp0_;
#line 2136 "key.c"
		}
#line 220 "../ssh/key.vala"
		return result;
#line 2140 "key.c"
	}
#line 220 "../ssh/key.vala"
	return NULL;
#line 2144 "key.c"
}

static SeahorseSshSecData**
_vala_array_dup4 (SeahorseSshSecData** self,
                  gssize length)
{
#line 220 "../ssh/key.vala"
	if (length >= 0) {
#line 2153 "key.c"
		SeahorseSshSecData** result;
		gssize i;
#line 220 "../ssh/key.vala"
		result = g_new0 (SeahorseSshSecData*, length + 1);
#line 220 "../ssh/key.vala"
		for (i = 0; i < length; i++) {
#line 2160 "key.c"
			SeahorseSshSecData* _tmp0_;
#line 220 "../ssh/key.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 220 "../ssh/key.vala"
			result[i] = _tmp0_;
#line 2166 "key.c"
		}
#line 220 "../ssh/key.vala"
		return result;
#line 2170 "key.c"
	}
#line 220 "../ssh/key.vala"
	return NULL;
#line 2174 "key.c"
}

void
seahorse_ssh_key_key_parse_result_copy (const SeahorseSshKeyKeyParseResult* self,
                                        SeahorseSshKeyKeyParseResult* dest)
{
	SeahorseSshKeyData** _tmp0_;
	gint _tmp0__length1;
	SeahorseSshKeyData** _tmp1_;
	gint _tmp1__length1;
	SeahorseSshSecData** _tmp2_;
	gint _tmp2__length1;
	SeahorseSshSecData** _tmp3_;
	gint _tmp3__length1;
#line 220 "../ssh/key.vala"
	_tmp0_ = (*self).public_keys;
#line 220 "../ssh/key.vala"
	_tmp0__length1 = (*self).public_keys_length1;
#line 220 "../ssh/key.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup3 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 220 "../ssh/key.vala"
	_tmp1__length1 = _tmp0__length1;
#line 220 "../ssh/key.vala"
	(*dest).public_keys = (_vala_array_free ((*dest).public_keys, (*dest).public_keys_length1, (GDestroyNotify) g_object_unref), NULL);
#line 220 "../ssh/key.vala"
	(*dest).public_keys = _tmp1_;
#line 220 "../ssh/key.vala"
	(*dest).public_keys_length1 = _tmp1__length1;
#line 220 "../ssh/key.vala"
	_tmp2_ = (*self).secret_keys;
#line 220 "../ssh/key.vala"
	_tmp2__length1 = (*self).secret_keys_length1;
#line 220 "../ssh/key.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup4 (_tmp2_, _tmp2__length1) : _tmp2_;
#line 220 "../ssh/key.vala"
	_tmp3__length1 = _tmp2__length1;
#line 220 "../ssh/key.vala"
	(*dest).secret_keys = (_vala_array_free ((*dest).secret_keys, (*dest).secret_keys_length1, (GDestroyNotify) g_object_unref), NULL);
#line 220 "../ssh/key.vala"
	(*dest).secret_keys = _tmp3_;
#line 220 "../ssh/key.vala"
	(*dest).secret_keys_length1 = _tmp3__length1;
#line 2217 "key.c"
}

void
seahorse_ssh_key_key_parse_result_destroy (SeahorseSshKeyKeyParseResult* self)
{
#line 221 "../ssh/key.vala"
	(*self).public_keys = (_vala_array_free ((*self).public_keys, (*self).public_keys_length1, (GDestroyNotify) g_object_unref), NULL);
#line 222 "../ssh/key.vala"
	(*self).secret_keys = (_vala_array_free ((*self).secret_keys, (*self).secret_keys_length1, (GDestroyNotify) g_object_unref), NULL);
#line 2227 "key.c"
}

SeahorseSshKeyKeyParseResult*
seahorse_ssh_key_key_parse_result_dup (const SeahorseSshKeyKeyParseResult* self)
{
	SeahorseSshKeyKeyParseResult* dup;
#line 220 "../ssh/key.vala"
	dup = g_new0 (SeahorseSshKeyKeyParseResult, 1);
#line 220 "../ssh/key.vala"
	seahorse_ssh_key_key_parse_result_copy (self, dup);
#line 220 "../ssh/key.vala"
	return dup;
#line 2240 "key.c"
}

void
seahorse_ssh_key_key_parse_result_free (SeahorseSshKeyKeyParseResult* self)
{
#line 220 "../ssh/key.vala"
	seahorse_ssh_key_key_parse_result_destroy (self);
#line 220 "../ssh/key.vala"
	g_free (self);
#line 2250 "key.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_ssh_key_key_parse_result_get_type_once (void)
{
	GType seahorse_ssh_key_key_parse_result_type_id;
	seahorse_ssh_key_key_parse_result_type_id = g_boxed_type_register_static ("SeahorseSshKeyKeyParseResult", (GBoxedCopyFunc) seahorse_ssh_key_key_parse_result_dup, (GBoxedFreeFunc) seahorse_ssh_key_key_parse_result_free);
	return seahorse_ssh_key_key_parse_result_type_id;
}

GType
seahorse_ssh_key_key_parse_result_get_type (void)
{
	static volatile gsize seahorse_ssh_key_key_parse_result_type_id__once = 0;
	if (g_once_init_enter (&seahorse_ssh_key_key_parse_result_type_id__once)) {
		GType seahorse_ssh_key_key_parse_result_type_id;
		seahorse_ssh_key_key_parse_result_type_id = seahorse_ssh_key_key_parse_result_get_type_once ();
		g_once_init_leave (&seahorse_ssh_key_key_parse_result_type_id__once, seahorse_ssh_key_key_parse_result_type_id);
	}
	return seahorse_ssh_key_key_parse_result_type_id__once;
}

static void
seahorse_ssh_key_class_init (SeahorseSshKeyClass * klass,
                             gpointer klass_data)
{
#line 25 "../ssh/key.vala"
	seahorse_ssh_key_parent_class = g_type_class_peek_parent (klass);
#line 25 "../ssh/key.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseSshKey_private_offset);
#line 25 "../ssh/key.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_ssh_key_get_property;
#line 25 "../ssh/key.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_ssh_key_set_property;
#line 25 "../ssh/key.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_ssh_key_finalize;
#line 25 "../ssh/key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_KEY_DATA_PROPERTY, seahorse_ssh_key_properties[SEAHORSE_SSH_KEY_KEY_DATA_PROPERTY] = g_param_spec_object ("key-data", "key-data", "key-data", SEAHORSE_SSH_TYPE_KEY_DATA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2289 "key.c"
	/**
	     * Unique fingerprint for this key
	     */
#line 25 "../ssh/key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_FINGERPRINT_PROPERTY, seahorse_ssh_key_properties[SEAHORSE_SSH_KEY_FINGERPRINT_PROPERTY] = g_param_spec_string ("fingerprint", "fingerprint", "fingerprint", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2295 "key.c"
	/**
	     * Public data for this key
	     */
#line 25 "../ssh/key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_PUBKEY_PROPERTY, seahorse_ssh_key_properties[SEAHORSE_SSH_KEY_PUBKEY_PROPERTY] = g_param_spec_string ("pubkey", "pubkey", "pubkey", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2301 "key.c"
	/**
	     * Description
	     */
#line 25 "../ssh/key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_DESCRIPTION_PROPERTY, seahorse_ssh_key_properties[SEAHORSE_SSH_KEY_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2307 "key.c"
	/**
	     * Validity of this key
	     */
#line 25 "../ssh/key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_VALIDITY_PROPERTY, seahorse_ssh_key_properties[SEAHORSE_SSH_KEY_VALIDITY_PROPERTY] = g_param_spec_enum ("validity", "validity", "validity", SEAHORSE_TYPE_VALIDITY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2313 "key.c"
	/**
	     * Trust in this key
	     */
#line 25 "../ssh/key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_TRUST_PROPERTY, seahorse_ssh_key_properties[SEAHORSE_SSH_KEY_TRUST_PROPERTY] = g_param_spec_enum ("trust", "trust", "trust", SEAHORSE_TYPE_VALIDITY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2319 "key.c"
	/**
	     * Date this key expires on (0 if never)
	     */
#line 25 "../ssh/key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_EXPIRES_PROPERTY, seahorse_ssh_key_properties[SEAHORSE_SSH_KEY_EXPIRES_PROPERTY] = g_param_spec_ulong ("expires", "expires", "expires", 0, G_MAXULONG, 0UL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2325 "key.c"
	/**
	     * The length of this key
	     */
#line 25 "../ssh/key.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_LENGTH_PROPERTY, seahorse_ssh_key_properties[SEAHORSE_SSH_KEY_LENGTH_PROPERTY] = g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2331 "key.c"
}

static void
seahorse_ssh_key_seahorse_exportable_interface_init (SeahorseExportableIface * iface,
                                                     gpointer iface_data)
{
#line 25 "../ssh/key.vala"
	seahorse_ssh_key_seahorse_exportable_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "../ssh/key.vala"
	iface->create_exporters = (GList* (*) (SeahorseExportable*, SeahorseExporterType)) seahorse_ssh_key_real_create_exporters;
#line 25 "../ssh/key.vala"
	iface->get_exportable = (gboolean (*) (SeahorseObject*)) seahorse_object_get_exportable;
#line 2344 "key.c"
}

static void
seahorse_ssh_key_seahorse_deletable_interface_init (SeahorseDeletableIface * iface,
                                                    gpointer iface_data)
{
#line 25 "../ssh/key.vala"
	seahorse_ssh_key_seahorse_deletable_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "../ssh/key.vala"
	iface->create_deleter = (SeahorseDeleter* (*) (SeahorseDeletable*)) seahorse_ssh_key_real_create_deleter;
#line 25 "../ssh/key.vala"
	iface->get_deletable = (gboolean (*) (SeahorseObject*)) seahorse_object_get_deletable;
#line 2357 "key.c"
}

static void
seahorse_ssh_key_seahorse_viewable_interface_init (SeahorseViewableIface * iface,
                                                   gpointer iface_data)
{
#line 25 "../ssh/key.vala"
	seahorse_ssh_key_seahorse_viewable_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "../ssh/key.vala"
	iface->create_viewer = (GtkWindow* (*) (SeahorseViewable*, GtkWindow*)) seahorse_ssh_key_real_create_viewer;
#line 2368 "key.c"
}

static void
seahorse_ssh_key_instance_init (SeahorseSshKey * self,
                                gpointer klass)
{
#line 25 "../ssh/key.vala"
	self->priv = seahorse_ssh_key_get_instance_private (self);
#line 2377 "key.c"
}

static void
seahorse_ssh_key_finalize (GObject * obj)
{
	SeahorseSshKey * self;
#line 25 "../ssh/key.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_KEY, SeahorseSshKey);
#line 28 "../ssh/key.vala"
	_g_object_unref0 (self->priv->_keydata);
#line 25 "../ssh/key.vala"
	G_OBJECT_CLASS (seahorse_ssh_key_parent_class)->finalize (obj);
#line 2390 "key.c"
}

/**
 * Represents an SSH key, consisting of a public/private pair.
 */
 G_GNUC_NO_INLINE static GType
seahorse_ssh_key_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseSshKeyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_ssh_key_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseSshKey), 0, (GInstanceInitFunc) seahorse_ssh_key_instance_init, NULL };
	static const GInterfaceInfo seahorse_exportable_info = { (GInterfaceInitFunc) seahorse_ssh_key_seahorse_exportable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo seahorse_deletable_info = { (GInterfaceInitFunc) seahorse_ssh_key_seahorse_deletable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo seahorse_viewable_info = { (GInterfaceInitFunc) seahorse_ssh_key_seahorse_viewable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType seahorse_ssh_key_type_id;
	seahorse_ssh_key_type_id = g_type_register_static (SEAHORSE_TYPE_OBJECT, "SeahorseSshKey", &g_define_type_info, 0);
	g_type_add_interface_static (seahorse_ssh_key_type_id, SEAHORSE_TYPE_EXPORTABLE, &seahorse_exportable_info);
	g_type_add_interface_static (seahorse_ssh_key_type_id, SEAHORSE_TYPE_DELETABLE, &seahorse_deletable_info);
	g_type_add_interface_static (seahorse_ssh_key_type_id, SEAHORSE_TYPE_VIEWABLE, &seahorse_viewable_info);
	SeahorseSshKey_private_offset = g_type_add_instance_private (seahorse_ssh_key_type_id, sizeof (SeahorseSshKeyPrivate));
	return seahorse_ssh_key_type_id;
}

GType
seahorse_ssh_key_get_type (void)
{
	static volatile gsize seahorse_ssh_key_type_id__once = 0;
	if (g_once_init_enter (&seahorse_ssh_key_type_id__once)) {
		GType seahorse_ssh_key_type_id;
		seahorse_ssh_key_type_id = seahorse_ssh_key_get_type_once ();
		g_once_init_leave (&seahorse_ssh_key_type_id__once, seahorse_ssh_key_type_id);
	}
	return seahorse_ssh_key_type_id__once;
}

static void
_vala_seahorse_ssh_key_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	SeahorseSshKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_KEY, SeahorseSshKey);
#line 25 "../ssh/key.vala"
	switch (property_id) {
#line 25 "../ssh/key.vala"
		case SEAHORSE_SSH_KEY_KEY_DATA_PROPERTY:
#line 25 "../ssh/key.vala"
		g_value_set_object (value, seahorse_ssh_key_get_key_data (self));
#line 25 "../ssh/key.vala"
		break;
#line 25 "../ssh/key.vala"
		case SEAHORSE_SSH_KEY_FINGERPRINT_PROPERTY:
#line 25 "../ssh/key.vala"
		g_value_set_string (value, seahorse_ssh_key_get_fingerprint (self));
#line 25 "../ssh/key.vala"
		break;
#line 25 "../ssh/key.vala"
		case SEAHORSE_SSH_KEY_PUBKEY_PROPERTY:
#line 25 "../ssh/key.vala"
		g_value_set_string (value, seahorse_ssh_key_get_pubkey (self));
#line 25 "../ssh/key.vala"
		break;
#line 25 "../ssh/key.vala"
		case SEAHORSE_SSH_KEY_DESCRIPTION_PROPERTY:
#line 25 "../ssh/key.vala"
		g_value_set_string (value, seahorse_ssh_key_get_description (self));
#line 25 "../ssh/key.vala"
		break;
#line 25 "../ssh/key.vala"
		case SEAHORSE_SSH_KEY_VALIDITY_PROPERTY:
#line 25 "../ssh/key.vala"
		g_value_set_enum (value, seahorse_ssh_key_get_validity (self));
#line 25 "../ssh/key.vala"
		break;
#line 25 "../ssh/key.vala"
		case SEAHORSE_SSH_KEY_TRUST_PROPERTY:
#line 25 "../ssh/key.vala"
		g_value_set_enum (value, seahorse_ssh_key_get_trust (self));
#line 25 "../ssh/key.vala"
		break;
#line 25 "../ssh/key.vala"
		case SEAHORSE_SSH_KEY_EXPIRES_PROPERTY:
#line 25 "../ssh/key.vala"
		g_value_set_ulong (value, seahorse_ssh_key_get_expires (self));
#line 25 "../ssh/key.vala"
		break;
#line 25 "../ssh/key.vala"
		case SEAHORSE_SSH_KEY_LENGTH_PROPERTY:
#line 25 "../ssh/key.vala"
		g_value_set_uint (value, seahorse_ssh_key_get_length (self));
#line 25 "../ssh/key.vala"
		break;
#line 2482 "key.c"
		default:
#line 25 "../ssh/key.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../ssh/key.vala"
		break;
#line 2488 "key.c"
	}
}

static void
_vala_seahorse_ssh_key_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	SeahorseSshKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_KEY, SeahorseSshKey);
#line 25 "../ssh/key.vala"
	switch (property_id) {
#line 25 "../ssh/key.vala"
		case SEAHORSE_SSH_KEY_KEY_DATA_PROPERTY:
#line 25 "../ssh/key.vala"
		seahorse_ssh_key_set_key_data (self, g_value_get_object (value));
#line 25 "../ssh/key.vala"
		break;
#line 2508 "key.c"
		default:
#line 25 "../ssh/key.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../ssh/key.vala"
		break;
#line 2514 "key.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

